  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% a function to fit a thermal cloud 2-D
function [rbecbimodal,Anal] = DoubleGauss2DFast(directory,number,tof,fx,fy,fz,U,angle,comment);

global TabErrorU TabErrorL

%% F = image

%%%trap frequencies%%%%%%%%%%
%specify for cell mode
% fx = 220;
% fy = 220;%horizontal axial 
% fz = 540;%vertical axial
% directory='c:\SrBEC\Data\12Mar15';
% number=65;
% %comment='';
% tof = 5; %ms
% %U=0;
% angle=45*(2*pi/360);


%theta = 0;
%theta =  angle you want to rotate image by (+ means
%          counterclocksize and angle is in degrees)
a = directory;
%%%% vertical imaging ***********
%d = 'A';%vertical imaging
%e = '0';%vertical imaging
%xcalSr = 3.15;  %camera resolution um/pix (vertical imaging)

%%%% horizontal imaging ***********
d = 'B';%horizontal imaging
e = '1';%horizontal imaging
xcalSr = 3.86;  %camera resolution um/pix (horizontal imaging)
ycalSr = 3.86;

wrSr = 2*pi*fx; %rad, cross
waSr = 2*pi*fy; %horizontal axial 
wzSr = 2*pi*fz; %vertical axial
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%help=cos(angle);
wxyaverage= 2*pi*(cos(angle)^2/(fx^2)+sin(angle)^2/(fy^2))^(-0.5);
t=0.001*tof;
SizeRatioThermal=1/(((t^2+1/wzSr^2)/(t^2+1/wxyaverage^2))^0.5); % ratio of sx and sy in Gauss fit for equal temp in all directions
SizeRatioBEC=35.612/44.931;

b = '\P000';
if number < 10
    b = '\P000';
    filename = [a,b,num2str(number),d];       
    else if number < 100
        b = '\P00';
        filename = [a,b,num2str(number),d];            
        else
            b = '\P0';
            filename = [a,b,num2str(number),d];            
        end
end

[success1,imA]=function_LoadTGA([filename,'A',e,'.TGA']);
[success2,imP]=function_LoadTGA([filename,'P',e,'.TGA']);
[success3,imN]=function_LoadTGA([filename,'N',e,'.TGA']);
[success4,imO]=function_LoadTGA([filename,'O',e,'.TGA']);

MaxOD=5;
MaxODForDisplay=5;
if (success1+success2+success3+success4==4)
    Foriginal=min(MaxOD,-log(max(0.00000001,(imA-imN)./(imP-imO))));
else
    fprintf(1, 'file not found\n');
end
%[F,map] = imread(filename);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%rotate and crop image
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% for imcrop, coordinates goes as xlow, ylow, yhigh,xhigh
%use cell mode to adapt
cropsizex = 500;
cropsizey =600;
imagex=100; %
%imagex=U;
imagey=300; % (before 50, for short tof)
% imagex=320; %15ms
% imagey=190; %15ms
%imagex=230;%10ms
%imagey=245;%10ms
F = imcrop(Foriginal,[imagex imagey cropsizex cropsizey]); % for K as second image in Frame Transfer Mode
m = double(F);
%m = imrotate(F,theta);
figure(1)
subplot(1,1,1)
imshow(m,[ ])
options = optimset('MaxFunEvals',100000,'TolX',0.000000001,'MaxIter',10000);
m = double(m);

%% fit

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% we sum all the columns to get an integrated x
% direction profile. This allows us to easily find
% the center in th
% good intial values for the
% 2 D fits
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% atomic parameters
h = 6.626*10.^(-34); %Js
hbar = h/(2*pi); %Js

mSr =  84*1.67*10^(-27); %kg
kB =  1.3806503*10^(-23); %m^2 kg/s^2 K
lamdaSr = 461*10.^(-9); %m
abscrosSr = (3*(lamdaSr.^2))./(2*pi); %m^2
%a0 = 0.052917721086*10^-9;
%a8686 = 798*a0;

Nparam = 1;
% Initial Values

%cx = 687; % full image
%cy = 650; % full image
cx = cropsizex/2; % cropped image
cy = cropsizey/2; % cropped image
sx = cropsizex/8;
sy = cropsizey/8;
Total = sum(sum(m)); %total optical density in the image
pODm = max(max(m)); %peak optical density in the image
[sizey sizex] = size(m);
pODx = pODm*sizey;
pODy = pODm*sizex; %peak of optical density
offx = Total/sizex;
offy = Total/sizey;

% Integrated x profile
lb = [1 1 0 -5*abs(offx)];
ub = [sizex sizex 50*pODx 5*abs(offx)];
mx = sum(m);
x1D = 1:sizex;
ip1D = [cx,sx,pODx,offx];
fp1Dx = lsqcurvefit(@fitgaussian1D,ip1D,x1D,mx,lb,ub,options);
cx = fp1Dx(1);
sx = fp1Dx(2);

% subplot(1,1,1)
% plot(mx,'*b');
% hold off 

% Integrated y profile
lb = [1 1 0 -5*abs(offy)];
ub = [sizey sizey 50*pODy 5*abs(offy)];
my = sum(m');
y1D = 1:sizey;
ip1D = [cy,sy,pODy,offy];
fp1Dy = lsqcurvefit(@fitgaussian1D,ip1D,y1D,my,lb,ub,options);
cy = fp1Dy(1);
sy = fp1Dy(2);
pOD = max(m(round(cy),:)); % takes a slice in x direction and uses this as initial pOD
off = fp1Dy(4)/sizex;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 2D fits
% Note: we must first prepare the X,Y, and m as 
%       vectors and not matrices; we cannot
%       use 2D Meshgrid's for the 2D fitting 
%       routine, i.e. the X,Y, and m must be 
%       vectors and not matrices.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%lb = [1 1 0 0 off 0];
[X,Y] = meshgrid(1:sizex,1:sizey);
xy2D(:,1) = X(:);
xy2D(:,2) = Y(:);
m2D = m(:);

%good param for TOF = 5ms bimodal 2 gaussians
ub = [sizex, sizey, 20*sx, 1.5, 60*pOD, 60*abs(off), 20*sx, 10, 20*pOD, 10*sx, 10*sy,1];
lb = [1, 1, 0, 0.3, 0,-100*abs(off), 0, 0, -0.01, -10*sx, -10*sy,-1];
sxgauss1= 1*sx;
ARgauss1= 1.1*sy/sx;
sxgauss2= 1.7*sx;
ARgauss2= 0.8*sy/sx;
Agauss1=1*pOD;
Agauss2=0.1*pOD;
fixedAngle = -0.06;
initpar = [cx,cy,sxgauss1,ARgauss1,Agauss1,off,sxgauss2,ARgauss2,Agauss2,1,1,fixedAngle];

% ub = [sizex, sizey, 3*sx, 3*sy, 0.15*pOD, 40*abs(off), 2*sx, 2*sy, 2*pOD, 1*sx, 1*sy,1];
% lb = [1, 1, 0, 0, 0, -40*abs(off), 0, 0, -0.01, -1*sx, -1*sy,-1];
% sxgauss1=1*sx;
% sygauss1=1.1*sy;
% sxgauss2=2*sx;
% sygauss2=0.1*sy;
% Agauss1=1.1*pOD;
% Agauss2=0.01*pOD;
% fixedAngle = 0.0525;
% initpar = [cx,cy,sxgauss2,sygauss2,Agauss2,off,sxgauss1,sygauss1,Agauss1,0,0,fixedAngle];


% sxGaussDimple=0.8*sx;
% ARGaussDimple=1;
% AGaussDimple=0.5*pOD;
% sxGaussReservoir=1.4*sx;
% ARGaussReservoir=3.5;
% AGaussReservoir=0.5*pOD;
% fixedAngle = 0.08;
% initpar = [cx,cy,sxGaussDimple,ARGaussDimple,AGaussDimple,off,1,1,sxGaussReservoir,ARGaussReservoir,AGaussReservoir,1,1,fixedAngle];


%Center shift:
dxFix=0;%2.82267/3.86;
dyFix=0;%-8.10522/3.86;
[rbecbimodalGaussFree,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitDoubleGauss2DWithAngleAR(x,xdata,SizeRatioThermal,SizeRatioBEC,dxFix,dyFix),initpar,xy2D,m2D,lb,ub,options);
%[rbecbimodalGaussFree,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitDoubleGauss2DWithFixedAngle(x,xdata,SizeRatioThermal,SizeRatioBEC,dxFix,dyFix,fixedAngle),initpar,xy2D,m2D,lb,ub,options);
constrainedHigh = min(abs(rbecbimodalGaussFree - ub));
constrainedLow = min(abs(rbecbimodalGaussFree - lb));
TabErrorU(1,number) = constrainedHigh;
TabErrorL(1,number) = constrainedLow;
 rbecbimodalGaussFree
 ub
 lb
 rbecbimodalGaussFree ./ initpar

%rbecbimodalGaussFree(12)=fixedAngle;
%Centers shifted, fixed:
%rbecbimodal(10)=dxFix;
%rbecbimodal(11)=dyFix;
%Next two code lines: For fixed Gauss size ratio:
%Next code line: For calculation of Size Ratio from fit to data with non fixed ratio:
%SizeRatioThermal=1/(1.16477-0.00943*rbecbimodal(7));%=rbecbimodal(8)/rbecbimodal(7)=sy/sx
%rbecbimodal(8)=rbecbimodal(7)*SizeRatioThermal;
%For fixed BEC ratio:
%rbecbimodal(4)=rbecbimodal(3)*SizeRatioBEC;
% ub2 = [sizex, sizey, 15*sx, 15*sy, 80*pOD, 40*abs(off)];
% lb2 = [1, 1, 0, 0, 0, -40*abs(off)];
% ub3 = [ub2,1];
% lb3 = [lb2,-1];
% initpar2 = [cx,cy,sx,sy,pOD,off];
% initpar3 = [initpar2,rbecbimodalGaussFree(12)];
% %rbec(10)=0;
% %rbec(11)=0;
% %[r,resnormGauss,residualGauss] = lsqcurvefit(@fitgaussian2DWithAngle,initpar,xy2D,m2D,lb,ub,options);
% [r,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitgaussian2DWithAngle(x,xdata),initpar3,xy2D,m2D,lb3,ub3,options);
% foundAngle = r(7);
% %[rbec,resnormGauss,residualGauss] = lsqcurvefit(@fitBEC2D,initpar,xy2D,m2D,lb,ub,options);
% [rbec,resnormBEC,residualBEC] = lsqcurvefit(@(x,xdata) fitBEC2DWithFixedAngle(x,xdata,foundAngle),initpar2,xy2D,m2D,lb2,ub2,options);
% rbec(7) = foundAngle;
% %[FfitDoubleGaussBimodalNoOffset] = CreateDoubleGaussComponentOneNoOffset2DWithAngle(rbecbimodalGaussFree, sizex,sizey);

rbecbimodal=rbecbimodalGaussFree;
rbecbimodal(4) = rbecbimodal(3)*rbecbimodal(4);
rbecbimodal(8) = rbecbimodal(7)*rbecbimodal(8);
%rGaussWing=r;
%%%%%%%%%%%%%%%%%%%
% Fit Gauss only to wings, then bimodal with Gauss size fix
%%%%%%%%%%%%%%%%%%
%j=1;
%for i = 1:1:(sizex*sizey)
%    if (FfitBECbimodal2DonlyBECnoOffset2D(i)==0)
%        xy2DnoCenter(j,1) = xy2D(i,1);
%        xy2DnoCenter(j,2) = xy2D(i,2);
%        m2DnoCenter(j) = m2D(i);
%        j=j+1;
%    end;
%end

%[rGaussWing,resnormGauss,residualGauss] = lsqcurvefit(@fitgaussian2D,initpar,xy2DnoCenter,m2DnoCenter',lb,ub,options);

%Sx=rGaussWing(3);
%Sy=rGaussWing(4);
%[rbecbimodalGaussFix,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitBECbimodal2DGaussSizeFix(x,xdata,Sx,Sy),initpar,xy2D,m2D,lb,ub,options);
%rbecbimodalGaussFix(7)=Sx;
%rbecbimodalGaussFix(8)=Sy;
%rbecbimodal=rbecbimodalGaussFix;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%
%Nint%
%%%%%%

Total = sum(sum(m));
mbackground = m;
ymin = round(cy-3*sy);
ymax = round(cy+3*sy);
xmin = round(cx-3*sx);
xmax = round(cx+3*sx);

if ymin <= 1
    ymin = 1;
    fprintf(1, 'ymin <= 1\n');
else
    ymin = ymin;
end

if ymax >= sizey
    ymax = sizey;
    fprintf(1, 'ymax >= sizey\n');
else
    ymax = ymax;
end

if xmin <= 1
    xmin = 1;
    fprintf(1, 'xmin <= 1\n');
else
    xmin = xmin;
end

if xmax >= sizex
    xmax = sizex;
    fprintf(1, 'xmax >= sizex\n');
else
    xmax = xmax;
end

matoms = m(ymin:ymax,xmin:xmax);
[a b] = size(mbackground);
[c d] = size(matoms);
mbackground(ymin:ymax,xmin:xmax)=zeros(size(mbackground(ymin:ymax,xmin:xmax)));
avback = sum(sum(mbackground))/(a*b - c*d);
mbackground(ymin:ymax,xmin:xmax)=avback.*ones(size(mbackground(ymin:ymax,xmin:xmax)));
Background = sum(sum(mbackground));
NumberCal=(xcalSr^2*(10^(-12)))*Nparam/abscrosSr;

Nint = NumberCal*(Total - Background);
%NGauss =NumberCal*(2*pi).*(r(3).*r(4)).*(r(5));%atom number
NGaussBimodal2 = NumberCal*(2*pi).*(rbecbimodal(7).*rbecbimodal(8)).*(rbecbimodal(9));%atom number thermal bimodal component 2
NGaussBimodal1 = NumberCal*(2*pi).*(rbecbimodal(3).*rbecbimodal(4)).*(rbecbimodal(5));%atom number thermal bimodal component 1
NGaussBi1overNtot=NGaussBimodal1/(NGaussBimodal1+NGaussBimodal2);

CoordAuxX = 1:1:sizex;
CoordAuxY = 1:1:sizey;
%-(rbecbimodal(2)-rbecbimodal(11))
%-(rbecbimodal(1)-rbecbimodal(10))
EnergyPerPartRaw = NumberCal*(xcalSr*10^(-6))^4 * ((CoordAuxY-10000).^2) * (m - mbackground) * ((CoordAuxX'-10000).^2) / Nint;
EnergyPerPartFit = 2*pi*NumberCal*(xcalSr*10^(-6))^4*(rbecbimodal(5) * (rbecbimodal(3)*rbecbimodal(4))^3 + rbecbimodal(9) * (rbecbimodal(7)*rbecbimodal(8))^3 )/ (NGaussBimodal1 + NGaussBimodal2);

TeffRaw =  10^9*mSr*(wrSr*waSr*wzSr)^(2/3)/kB * EnergyPerPartRaw * Nint; % effective temperature, by 2nd order momentum calculation of "raw" image
TeffFit = 10^9*mSr*(wrSr*waSr*wzSr)^(2/3)/kB *EnergyPerPartFit *(NGaussBimodal2+NGaussBimodal1); % effective temperature, by 2nd order momentum calculation of fit results

Tc = (10^9)*(hbar*((wrSr*waSr*wzSr).^(1/3))/kB).*(Nint/1.202).^(1/3);%critical Temperature, nk
%Tgaussx = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*r(3).*xcalSr).^2;% hor axial Temperature from Gauss Fit, nk
%SigmaYGauss=0.000001*r(4).*xcalSr;
%Tgaussy = 10^9*(mSr/(kB*(0.001*tof)^2)).*(SigmaYGauss).^2;% vertical Temperature from Gauss Fit, nk
%TGaussYFiniteExpansion = 10^9*(mSr/kB)*(SigmaYGauss)^2 / ( 1/(wxyaverage^2) + (0.001*tof)^2);

Tbimodalx1 = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(3).*xcalSr).^2;% hor axial Temperature from bimodal Fit, Component 1, nk
Tbimodaly1 = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(4).*xcalSr).^2;% vertical Temperature from bimodal Fit, Component 1, nk

Tbimodalx2 = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(7).*xcalSr).^2;% hor axial Temperature from bimodal Fit, Component 2, nk
Tbimodaly2 = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(8).*xcalSr).^2;% vertical Temperature from bimodal Fit, Component 2, nk

SigmaYGaussBi=0.000001*rbecbimodal(8).*xcalSr;
TbimodalY2FiniteExpansion = 10^9*(mSr/kB)*(SigmaYGaussBi)^2 / ( 1/(wxyaverage^2) + (0.001*tof)^2);


%fmean=(fx*fy*fz)^(1/3);
%aho = (hbar/(mSr*2*pi*fmean))^(1/2);
%ChemPotBEC=(10^9/kB)*0.5*hbar*2*pi*fmean*(15*NBEC*a8686/aho)^(2/5);
%ChemPotBECBimodal=(10^9/kB)*0.5*hbar*2*pi*fmean*(15*NBECBimodal*a8686/aho)^(2/5);

% (rbecbimodal(7).*xcalSr)
% (rbecbimodal(8).*xcalSr)
% (rbecbimodal(3).*xcalSr)
% (rbecbimodal(4).*xcalSr)
% rbecbimodal(5)
% ub(5)

%create image centered around cloud
%SizeCutX=2.5*rbecbimodal(7);
%SizeCutY=2*rbecbimodal(8);
%F = imcrop(Foriginal,[imagex+r(1)-SizeCutX imagey+r(2)-SizeCutY 2*SizeCutX 2*SizeCutY]); % for K as second image in Frame Transfer Mode

%F=Foriginal;
SizeCutX=cropsizex/2;
SizeCutY=cropsizey/2;

mCut = double(F);
mCutx = sum(mCut);
mCuty = sum(mCut');
[sizeyCut sizexCut] = size(mCut);

    figure1handle=figure(1);
    hold off
    %rCut=r;
    %rCut(1)=SizeCutX;
    %rCut(2)=SizeCutY;
    %rCut(7)=r(12); %angle
    %rbecCut=rbec;
    %rbecCut(1)=SizeCutX-r(1)+rbec(1);
    %rbecCut(2)=SizeCutY-r(2)+rbec(2);
    %[FfitpureGauss] = CreateGaussianWithAngle(rCut,sizexCut,sizeyCut);
    %[FfitpureBEC] = CreateBEC2DWithAngle(rbecCut, sizexCut,sizeyCut);
    %rgaussbimodal= [SizeCutX-r(1)+rbecbimodal(1),SizeCutY-r(2)+rbecbimodal(2),rbecbimodal(7),rbecbimodal(8),rbecbimodal(9),rbecbimodal(6),rbecbimodal(12)];
    rgaussbimodal= [rbecbimodal(1),rbecbimodal(2),rbecbimodal(7),rbecbimodal(8),rbecbimodal(9),rbecbimodal(6),rbecbimodal(12)];
    [FfitGaussbimodal] = CreateGaussianWithAngle(rgaussbimodal,sizexCut,sizeyCut);
    %[FfitGaussWing1D] = CreateGaussian1D(fgausswing, 2*rhoMax+1);
    rbecbimodalCut=rbecbimodal;
    %rbecbimodalCut(1)=SizeCutX-r(1)+rbecbimodal(1);
    %rbecbimodalCut(2)=SizeCutY-r(2)+rbecbimodal(2);
    [FfitBEC2D] = CreateDoubleGaussComponentOne2DWithAngle(rbecbimodalCut, sizexCut,sizeyCut);
    [FfitBECbimodal2D] = CreateDoubleGauss2DWithAngle(rbecbimodalCut, sizexCut,sizeyCut);
    
    becbimodal1Dx = sum(FfitBECbimodal2D);
    becbimodal1Dy = sum(FfitBECbimodal2D');
    bec1Dx = sum(FfitBEC2D);
    bec1Dy = sum(FfitBEC2D');
    %purebec1Dx = sum(FfitpureBEC);
    %purebec1Dy = sum(FfitpureBEC');
    GaussBimodal1Dx = sum(FfitGaussbimodal);
    GaussBimodal1Dy = sum(FfitGaussbimodal');
    
    MinOD=min(mCut(:));
    MaxOD=min(MaxODForDisplay,max(mCut(:)));
    
    mResidueBimodalFit=mCut-FfitBECbimodal2D;
    mOnlyBEC=mCut-FfitGaussbimodal;
    mOnlyThermal=mCut-FfitBEC2D;
    ResidueBimodalFit=sqrt(sum(sum(mResidueBimodalFit.^2))/(2*sizexCut*2*sizexCut));
    
    %mResidueGaussFit=mCut-FfitpureGauss;
    %ResidueGaussFit=sqrt(sum(sum(mResidueGaussFit.^2))/(2*SizeCutX*2*SizeCutY));
     
    %subplot(4,5,3);
    %imshow(FfitpureGauss,[MinOD MaxOD]);
    %title('Gauss fit');
     
    %subplot(4,5,8);
    %MinODGausRes=min(mResidueGaussFit(:));
    %MaxODGausRes=min(MaxODForDisplay,max(mResidueGaussFit(:)));
    %imshow(mResidueGaussFit,[MinODGausRes MaxODGausRes]);
    %title(['P',num2str(number),' - Gauss fit']);
    
    %mResidueBECFit=mCut-FfitpureBEC;
    %ResidueBECFit=sqrt(sum(sum(mResidueBECFit.^2))/(2*SizeCutX*2*SizeCutY));
     
    %ResidueAverage=(ResidueBimodalFit+ResidueBECFit+ResidueGaussFit)/3;
    %ResidueBimodalFit=ResidueBimodalFit/ResidueAverage;
    %ResidueBECFit=ResidueBECFit/ResidueAverage;
    %ResidueGaussFit=ResidueGaussFit/ResidueAverage;
     
    %subplot(4,5,13);
    %imshow(FfitpureBEC,[MinOD MaxOD]);
    %title('BEC fit');
    
    %subplot(4,5,18);
    %imshow(mResidueBECFit,[]);
    %title(['P',num2str(number),' - BEC fit']);

    hold off;

    subplot(4,5,1);
    imshow(mCut,[MinOD MaxOD]);
    title(['P',num2str(number)])
     
    subplot(4,5,2);
    imshow(FfitBECbimodal2D,[MinOD MaxOD]);
    title('bimodal fit');
    
    subplot(4,5,17);
    imshow(mResidueBimodalFit,[]);
    title(['P',num2str(number),' - bimodal fit']);
    
   
    subplot(4,5,6);
      
    MinODBEC=min(mOnlyBEC(:));
    MaxODBEC=min(MaxODForDisplay,max(mOnlyBEC(:)));
    imshow(mOnlyBEC,[MinODBEC MaxODBEC]);
    title(['P',num2str(number),' - thermal component (BEC scale)']);
   
    
    subplot(4,5,7);
    imshow(FfitBEC2D,[MinODBEC MaxODBEC]); 
    title('BEC component (BEC scale)');
    
    
    subplot(4,5,11);
    imshow(mOnlyThermal,[MinOD MaxOD]);
    title(['P',num2str(number),' - BEC component']);
    
    
    subplot(4,5,12);
    imshow(FfitGaussbimodal,[MinOD MaxOD]);  
    title('thermal component');
    
    subplot(4,5,16);
    imshow(mCut,[MinOD MaxOD]);
    title(['P',num2str(number)])
   
    start = get(gca,'clim');
    hold on;
    imcontour(FfitBECbimodal2D,5,'r');
    set(gca,'clim', start);

    [a b] = size(FfitBECbimodal2D);

    hold off;

    PlotLineWidth=2;
    PlotMarkerWidth=4;
    subplot(4,5,[4 5 9 10])
    x = 1:1:b;
    plot(x,mCutx,'ob','MarkerFaceColor','k','MarkerSize',PlotMarkerWidth);
    hold on
    %fit1dxpgauss = sum(FfitpureGauss);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %fit1dxp = sum(Ffit);
    %fit1dxpgauss = sum(FfitGauss);
  %  fprintf(1,'poly = %.10f\tgauss = %.10f\t',fit1dxp,fit1dxpgauss)
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    
    plot(x,bec1Dx,'k-','LineWidth',PlotLineWidth);
    %plot(x,purebec1Dx,'cyan','LineWidth',PlotLineWidth);
    plot(x,GaussBimodal1Dx,'b-','LineWidth',PlotLineWidth);
    %plot(x,fit1dxpgauss,'g-','LineWidth',PlotLineWidth);
    plot(x,becbimodal1Dx,'r-','LineWidth',PlotLineWidth);
    xlabel('x axis in pixels');
    ylabel('');

    hold off
    subplot(4,5,[14 15 19 20])
    y = 1:1:a;
    plot(y,mCuty,'ob','MarkerFaceColor','k','MarkerSize',PlotMarkerWidth);
    hold on
   %  fit1dyp = Ffit(:,round(pt(3)));
   %  fit1dypgauss = FfitGauss(:,round(r(1)));
    %fit1dypgauss = sum(FfitpureGauss');
    plot(y,bec1Dy,'k-','LineWidth',PlotLineWidth);
    %plot(y,purebec1Dy,'cyan','LineWidth',PlotLineWidth);
    plot(y,GaussBimodal1Dy,'b-','LineWidth',PlotLineWidth);
    %plot(y,fit1dypgauss,'g-','LineWidth',PlotLineWidth);
    plot(y,becbimodal1Dy,'r-','LineWidth',PlotLineWidth');
    xlabel('y axis in pixels');
    ylabel('');
  
    hold off

    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%output data

%print -dpsc2 -f1 -append Figures.ps
    
Anal = [ Tc, Tbimodalx1, Tbimodaly1, Tbimodalx2, Tbimodaly2, TbimodalY2FiniteExpansion, TeffRaw, TeffFit, Nint, NGaussBimodal1, NGaussBimodal2, NGaussBi1overNtot, ResidueBimodalFit*100];

[c d] = size(my);
ofile2= [directory,'P',num2str(number),'ProfileX.dat'];       
outfile = fopen(ofile2, 'w');
fprintf(outfile, 'Original image from %s\n', filename);
fprintf(outfile, 'position(um)\n');
fprintf(outfile, '2nd column is the integrated profile over y.\n');
fprintf(outfile, '3nd column is the fitted bimodal integrated profile over y.\n');

fprintf(outfile, '\n\nTOF = %.0f ms\t\tfx = %0.1f Hz\tfy = %0.1f Hz\tfz = %0.1f Hz\n', tof, fx, fy, fz);
fprintf(outfile, 'Nint = %.0f\tNGaussBimodal1 = %.0f\tNGaussBimodal2 = %.0f\tNGaussBi1/Ntot = %.0f', Nint,NGaussBimodal1,NGaussBimodal2,NGaussBi1overNtot);
fprintf(outfile, '\tTc = %.3f uK\tTbimodalX1 = %.3f uK\tTbimodalY1 = %.3f uK\tTbimodalX2 = %.3f uK\tTbimodalY2 = %.3f uK',Tc,Tbimodalx1,Tbimodaly1,Tbimodalx2,Tbimodaly2);
fprintf(outfile, '\tTbimodalX/Tc = %.3f\tTbimodalY/Tc = %.3f\n', Tbimodalx1/Tc,Tbimodaly1/Tc);

Cx=rbecbimodal(1);
Cy=rbecbimodal(2);
fprintf(outfile, 'position(um)\tODx(Expt)\tODx(GaussBimodal1)\tODx(GaussBimodal2)\tODx(BimodalTot)\n');
[c SizeX] = size(mx);
[c SizeY] = size(my);
Offset=rbecbimodal(6)*sizeyCut;
for i = 1:1:sizexCut-1;
    fprintf(outfile, '%f\t%f\t%f\t%f\t%f\n', (i-1-SizeCutX)*xcalSr, mCutx(i)-Offset, bec1Dx(i)-Offset, GaussBimodal1Dx(i)-Offset, becbimodal1Dx(i)-Offset);
end

fclose(outfile);
ofile2= [directory,'P',num2str(number),'ProfileY.dat'];       
outfile = fopen(ofile2, 'w');
fprintf(outfile, 'position(um)\tODy(Expt)\tODy(GaussBimodal1)\tODy(GaussBimodal2)\tODy(BimodalTot)\n');
Offset=rbecbimodal(6)*sizexCut;
for i = 1:1:sizeyCut-1;
    fprintf(outfile, '%f\t%f\t%f\t%f\t%f\n', (i-1-SizeCutY)*ycalSr, mCuty(i)-Offset, bec1Dy(i)-Offset, GaussBimodal1Dy(i)-Offset, becbimodal1Dy(i)-Offset);
end
fclose(outfile);

ofile3= [directory,'P',num2str(number),'Fit.png'];
saveas(figure1handle,ofile3);

% r(1)=r(1)*xcalSr;
% r(2)=r(2)*ycalSr;
% r(3)=r(3)*xcalSr;
% r(4)=r(4)*ycalSr;
% 
% rGaussWing(1)=rGaussWing(1)*xcalSr;
% rGaussWing(2)=rGaussWing(2)*ycalSr;
% rGaussWing(3)=rGaussWing(3)*xcalSr;
% rGaussWing(4)=rGaussWing(4)*ycalSr;
% 
% rbec(1)=rbec(1)*xcalSr;
% rbec(2)=rbec(2)*ycalSr;
% rbec(3)=rbec(3)*xcalSr;
% rbec(4)=rbec(4)*ycalSr;

rbecbimodal(1)=rbecbimodal(1)*xcalSr; %Cx
rbecbimodal(2)=rbecbimodal(2)*ycalSr; %Cy
rbecbimodal(3)=rbecbimodal(3)*xcalSr; %Rx
rbecbimodal(4)=rbecbimodal(4)*ycalSr; %Ry
rbecbimodal(7)=rbecbimodal(7)*xcalSr; %Gauss x
rbecbimodal(8)=rbecbimodal(8)*ycalSr; %Gauss y
rbecbimodal(10)=rbecbimodal(10)*xcalSr; %Dx
rbecbimodal(11)=rbecbimodal(11)*ycalSr; %Dy

fprintf(1, '\nNint = %.0f\tNGaussBimodal1 = %.0f\tNGaussBimodal2 = %.0f\tNGaussBi1/Ntot= %.3f\t\n', Nint,NGaussBimodal1,NGaussBimodal2,NGaussBi1overNtot);
fprintf(1, 'Tc = %.3f nK\tTbimodalX1 = %.3f nK\tTbimodalY1 = %.3f nK\tTbimodalX2 = %.3f nK\tTbimodalY2 = %.3f nK\tTbimodalCorrY = %.3f nK\n',Tc,Tbimodalx1,Tbimodaly1,Tbimodalx2,Tbimodaly2,TbimodalY2FiniteExpansion);
%fprintf(1, 'TbimodalCorrY/Tc = %.3f\n', TbimodalY2FiniteExpansion/Tc);
%fprintf(1,'RxBECBi = %.3f m\tRyBECBi = %.3f m\tdxBECBi = %.3f m\tdyBECBi = %.3f m\n',rbecbimodal(3),rbecbimodal(4),rbecbimodal(10),rbecbimodal(11));
%fprintf(1,'StandDevBimodal = %.2f\n',ResidueBimodalFit*100);
%fprintf(1,'cx = %.2f\tcy = %.2f\tsx = %.2f\tsy = %.2f\tAmp = %.2f\tOffs = %.2f\t\n',r(1),r(2),r(3),r(4),r(5),r(6));
%fprintf(1,'cx = %.2f\tcy = %.2f\tsx = %.2f\tsy = %.2f\tAmp = %.2f\tOffs = %.2f\t',rGaussWing(1),rGaussWing(2),rGaussWing(3),rGaussWing(4),rGaussWing(5),rGaussWing(6));