close all

%Fit fermions 
%Does not run from network folder
CurrentScriptPath = mfilename('fullpath');
CurrentDirectory = CurrentScriptPath(1:end-6);
addpath([CurrentDirectory,'tools'])
DataDirectory = [CurrentScriptPath(1:end-27),'Data\'];

%Loading S16 data. This data is located inside Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Data\200911\S16
SeriesDate = '200911';
series = 'S16'
PictureS = [20,21,22,23];



Results1Dx = {};Results1Dy = {};expSigmay = {};expSigmax = {};
for ind = 1:length(PictureS)
    
SeriesDataFolder = [DataDirectory,SeriesDate,'\',series];

PictureNumber = PictureS(ind);
TOF = 0.1;
[Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D] = MyGaussfit1D(SeriesDataFolder,PictureNumber,TOF);

figure (4)


subplot(2,length(PictureS)/2,ind);
piclegend =['picture', num2str(PictureS(ind))]
plotIntegratedy (Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,piclegend)

figure(5)

subplot(2,length(PictureS)/2,ind);
piclegend =['picture', num2str(PictureS(ind))]
plotIntegratedx (Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,piclegend)

end



% pause(1);
% 
% %Loading s41 data. This data is located inside the current folder.
% %S41 is the bosonic MOT data.
% series = 'S41'
% SeriesDataFolder = [CurrentDirectory,series]
% PictureNumber = 18;
% TOF = 0.1;
% MyGaussfit1D(SeriesDataFolder,PictureNumber,TOF);