function [xdata,ydata]=FermiMOTAnalazideData(seriesnumber,inputdatetouse,plotparam)
%%Shaynes Matalba vision plotting code % Does Fiting and plots the data

% % Plot options % %

    % params.datasection=params.dataparameters+11;
    % plotparam.logyscale =  1 Sets log scale
    % plotparm.Testimate = 1 Calculates Temperature like vision

% % Fit options % %

    % params.xfitmax=[8000];
    % params.xfitmin=[200];
    % params.dofit=15;   
    % params.polyfitorder=1;
    
% % Fit functions % 
% case 1   % linear fit
% case 5   % linear fit with scaling
% case 2   % exponential fit, no background
% case 3   % exponential fit, no background, t offset
% case 4   % exponential fit with background
% case 6   % exponential fall fit with nobackground
% case 9   % exponential fall fit with background   --- !!! DO NOT USE !!!
% case 11  % lorentzian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% case 7   % gaussian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% case 8   % gaussian fit with no background
% case 10  % sectional average
% case 12  % sinusoidal fit with background  yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);
% case 13  % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4);
% CASE 15  % exponential fit not backround  yfit=x(1)*exp(-t/x(2))

% % Analysis Options %% 
%Selected by setting params.analysis == 
% case 0 Using vision raw data
% case 13 PSD
% case 16 YPSD
% case 22 % updated principle component analysis 20191226

c=2.99792458e8;
h=6.62606896e-34;
lambda=460.862369e-9;
gamma=2*pi*30.2e6;
NSTD=1.5;
dSTD=0.02;

if plotparam.averageseries == 0 ;
    plotparam.averageseries = zeros(1,length(seriesnumber));
end

if isempty(plotparam.title)
    plotparam.title=['Series ',num2str(seriesnumber)];
end



if (length(seriesnumber)> length(plotparam.legendstext))
    error('Please add mising legend entries')
end
for k = 1 : length(seriesnumber)

    
    if isa(inputdatetouse,'cell') % If there is more than one date run this one
        seriesname{k} =[char(inputdatetouse(k)),' S',num2str(seriesnumber(k)),'     ',char(plotparam.legendstext(k))] ;           % Cell Array
    else % If there is only one date run this one
        seriesname{k} =[char(inputdatetouse),' S',num2str(seriesnumber(k)),'     ',char(plotparam.legendstext(k))]      ;      % Cell Array
    end 
end

plotparam.legendtext = seriesname;

for ind=1:length(seriesnumber)

    if iscell(inputdatetouse)
        inputdate=inputdatetouse{ind};
    else
        inputdate=inputdatetouse;
    end

    if plotparam.analysis==0 % use vision data
        [xdata{ind},ydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        if plotparam.displayseriesparameters
            extractparameters(inputdate,seriesnumber(ind),plotparam.parameterstoprint);
        end
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        if plotparam.interleve~=1
            xdata{ind}=xdata{ind}(1:plotparam.interleve:end);
            ydata{ind}=ydata{ind}(1:plotparam.interleve:end);
        end
        if plotparam.selectivex
            goodpoints=find((xdata{ind}<=plotparam.selectivexrange(2))&(xdata{ind}>=plotparam.selectivexrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        if plotparam.selectivey
            goodpoints=find((ydata{ind}<=plotparam.selectiveyrange(2))&(ydata{ind}>=plotparam.selectiveyrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        xdataAverage{ind} = [];
        if plotparam.averagerepetions
            counter = 1 ;
            
            for k=1:length(xdata{ind})
            a = find(xdata{ind}==xdata{ind}(k));
            meanval=mean(ydata{ind}(a));
            stdval=std(ydata{ind}(a));
            if ~(ismember(xdata{ind}(k), xdataAverage{ind}))
                ydataAverage{ind}(counter) = meanval;
                YdataErrorBar{ind}(counter) = stdval;
                xdataAverage{ind}(counter) = xdata{ind}(k);
                counter = counter +1;
            end
            end
            
            ydata{ind} =  ydataAverage{ind};
            err{ind} = YdataErrorBar{ind}/2;
            xdata{ind} =  xdataAverage{ind};
        end

    elseif plotparam.analysis==13 % PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},Sxdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+5,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./Sxdata{ind}./Sydata{ind}./Sydata{ind};
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        
    elseif plotparam.analysis==15 % Y PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./Sydata{ind}.^3;
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        
    elseif plotparam.analysis==16 % Y PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./abs(Sydata{ind}).^(3/2);
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end

    elseif plotparam.analysis==17 % Y PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sxdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+5,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./Sydata{ind}./Sxdata{ind}.^(1/2);
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        
        
    elseif plotparam.analysis==18
        %   Use custum ROI
            [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
 
            visionPictNbCount = 1;
            ydata{ind}= zeros(1,length(xdata{ind}));
            
            if ind ==1 
                makeROIBool = true;
            else
               makeROIBool =false;
            end
           
            if ~isempty(strfind(plotparam.RunningFolder, 'Scripts\Scripts')) % % If running from Scripts folder used previous loaded roi
                makeROIBool =false;
            end
            
            % Load ROI
            if  ( makeROIBool  )
                [croppedPic,filenameVision] = LoadVisionDataTGA (directory,seriesnumber(ind),22,plotparam,makeROIBool);
                makeROIBool = false
            end
            for i = 1:length(xdata{ind})
                
                 [croppedPic,filenameVision] = LoadVisionDataTGA (directory,seriesnumber(ind),imagenumbers{ind}(i),plotparam,makeROIBool);
                 [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab ] = calculateExperimentalValues (filenameVision,croppedPic);
                 visionPictNbCount =visionPictNbCount +1 ;
                 ydata{ind}(i) = atomNumberTab;
            end
            
            
    elseif plotparam.analysis==19 % compare data from 2 cameras
        [xdata{ind},camdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),4,2,plotparam.cameranumber(ind),plotparam.datafilename);
        [xdata{ind},ydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,2,plotparam.cameranumber(ind),plotparam.datafilename);
        thiscam=find(camdata{ind}==(plotparam.cameranumber(ind)-1));
        xdata{ind}=xdata{ind}(thiscam);
        ydata{ind}=ydata{ind}(thiscam);
        
        if plotparam.displayseriesparameters
            extractparameters(inputdate,seriesnumber(ind),plotparam.parameterstoprint);
        end
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        if plotparam.interleve~=1
            xdata{ind}=xdata{ind}(1:plotparam.interleve:end);
            ydata{ind}=ydata{ind}(1:plotparam.interleve:end);
        end
        if plotparam.selectivex
            goodpoints=find((xdata{ind}<=plotparam.selectivexrange(2))&(xdata{ind}>=plotparam.selectivexrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        if plotparam.selectivey
            goodpoints=find((ydata{ind}<=plotparam.selectiveyrange(2))&(ydata{ind}>=plotparam.selectiveyrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
    elseif plotparam.analysis==21 % principle component analysis
        PCAmatrix=PCAmatrix-repmat(mean(PCAmatrix,1),[size(PCAmatrix,1),1]);
        PCATransp=transpose(PCAmatrix);
        PCAmatSum=PCAmatrix*PCATransp/(size(PCAmatrix,1)-1);
        NUMBEROFFIGURES=0;

        [eigVect,eigVal]= eig(PCAmatSum); % standard eigenvalue solver
        
        for modenumindex=1:length(plotparam.PCAmodeNumber)
            modenum=plotparam.PCAmodeNumber(modenumindex);
    %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
            PCAmodeX = reshape(PCATransp*eigVect(:,modenum),size(croppedreference));
            vectPlot = PCAmatrix*(PCATransp*eigVect(:,modenum));
            if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
                figure;
                lastfignum=get(gcf,'Number');
                NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                subplotnum=1;
                PCAfilename='Modes';
            end
            subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
%             imagesc(PCAmodeX);
%             colormap jet
            imshow(PCAmodeX,[ ])
            title(['Mode ',num2str(modenum)])
            subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
            plot(vectPlot,'*')
%             title(['Evolution of mode number: ',num2str(modenum)]);
%             ylabel('Mode amplitude');
%             xlabel('Picture number');
            PCAfilename=[PCAfilename,'-',num2str(modenum)];
            if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
                if seriesnumber>0,
                    saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
                else
                    saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
                end
            end
        end
        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        
        return        
    elseif plotparam.analysis==22 % updated principle component analysis 20191226
        
        ind=1;
        [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        imagessummed=0;
        imagessummedreported=0;
        
%         touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax)&(xdata{ind}~=700));
        touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax));
        if ~isempty(touse)
            try
                load('C:\Users\srcal\Desktop\workspace22');
            catch
                xdatagood=xdata{ind}(touse);
                imagenums=imagenumbers{ind}(touse);

                for imagenumber=imagenums
                    if imagessummed>(imagessummedreported+10)
                        display(['Loading...',num2str(imagessummed/numel(imagenums)*100),'%']);
                        imagessummedreported=imagessummed;
                    end
                    [difference,newdata,raw,probe]=loadvisionpicture(directory,seriesnumber(ind),imagenumber,plotparam.cameranumber);
                     OD=-log(max(0.00000001,raw./probe));
                     if numel(plotparam.PCAcrop)==4 % if crop rectangle is already defined
                        if newdata %ensure load data was successful
                            %imdata=imcrop(difference,plotparam.PCAcrop);
                            imdata=double(OD(plotparam.PCAcrop(1):(plotparam.PCAcrop(1)+plotparam.PCAcrop(3)-1),plotparam.PCAcrop(2):(plotparam.PCAcrop(2)+plotparam.PCAcrop(4)-1)));
                            imdata=blurdata(imdata,plotparam.blursize);
        %                     if imagessummed==0
        %                         imsum=imdata;
        %                     else
        %                         imsum=imsum+imdata;
        %                     end
                            if imagessummed==0
                                PCAmatrix=zeros(numel(imagenums),numel(imdata));
                            end
                            imagessummed=imagessummed+1;
                            PCAmatrix(imagessummed,:)=reshape(imdata,[1,numel(imdata)]);
                        end
                     end
                end
                save('C:\Users\srcal\Desktop\workspace22');
            end
            MakeTrainingData;
            PCAmatrix=[PCAmatrix;TrainingData];
%             xdatagood=[xdatagood,22e3*ones([1,size(FakeData,1)])];
            xdatagood=[xdatagood,(22e3+(1:size(TrainingData,1)))];
            
            if imagessummed>=1,
%     %             imsum=imsum/imagessummed;
%                 PCAmatrixmean=reshape(mean(PCAmatrix,1),size(imdata));
%                 PCAmatrix=PCAmatrix-repmat(mean(PCAmatrix,1),[size(PCAmatrix,1),1]);
                
                PCATransp=transpose(PCAmatrix);
                PCAmatSum=PCAmatrix*PCATransp/(size(PCAmatrix,1)-1);
                NUMBEROFFIGURES=0;

                [eigVect,eigVal]= eig(PCAmatSum); % standard eigenvalue solver
                [eigValval,indexnum]=sort(diag(eigVal),'descend');

%                 figure('Position',[500 50 1200 500]);
%                 lastfignum=get(gcf,'Number');
%                 NUMBEROFFIGURES=NUMBEROFFIGURES+1;
%                 imagesc(PCAmatrixmean);
%                 colormap jet;
%                 title('Average Mode');
%                 PCAfilename=['Average Mode'];
%                 if seriesnumber>0,
%                     saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
%                 else
%                     saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
%                 end
                
%                 plotparam.PCAmodeNumber=size(eigVect,2)-plotparam.PCAmodeNumber+1;
                
                for modenumindex=1:length(plotparam.PCAmodeNumber)
                    modenum=indexnum(plotparam.PCAmodeNumber(modenumindex));
            %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
                    PCAmodeX = reshape(PCATransp*eigVect(:,modenum),size(imdata));
                    vectPlot = PCAmatrix*(PCATransp*eigVect(:,modenum));
                    vectPlotmode{modenum}=vectPlot;
                    if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Number');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        subplotnum=1;
                        PCAfilename='Modes';
                    end
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
        %             imagesc(PCAmodeX);
        %             colormap jet
    %                 imshow(PCAmodeX,[ ])
                    imagesc(PCAmodeX);
                    
                    [~,xpeak]=max(max(abs(PCAmodeX),[],1));
                    [~,ypeak]=max(max(abs(PCAmodeX),[],2));
                    
                    [modenumindex, xpeak, ypeak, sum(sum(PCAmodeX))],
                    
                    colorbar;
                    colormap jet;
                    title(['Mode ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                     title(['Mode ',num2str(modenum)])
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
                    plot(xdatagood,vectPlot,'.')
        %             title(['Evolution of mode number: ',num2str(modenum)]);
        %             ylabel('Mode amplitude');
        %             xlabel('Picture number');
                    PCAfilename=[PCAfilename,'-',num2str(modenum)];
                    if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
                        else
                            saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
                        end
                    end
                end
                
                % add the BEC like modes together and make a movie from
                % them
                
                % I think the way I'm normalizing the coefficients must be
                % wrong so they don't add up nicely. Need to spend some
                % time to sort this out.
                
                
                
                PCABECavifilename='BECMode';
                if seriesnumber>0,
                    aviname=[directory,'\S',num2str(seriesnumber),'\',PCABECavifilename];
                else
                    aviname=[directory,'\',PCABECavifilename];
                end
                avifig=figure('Position',[500 50 1200 500]);
                Framerate=5;
                writerObj = VideoWriter([aviname,'.avi']);
                writerObj.FrameRate = Framerate;
                open(writerObj);
               
%                 includedmodes=[1,2,7,8,9,11,16];
                cleaningFilter=zeros(length(xdatagood),1);
                cleaningFilter([indexnum(1)])=1;
%                 cleaningFilter([2])=1;
                [sortedxdata,indexlist]=sort(xdatagood);
                
%                 BECmode=zeros(numel(imdata),length(imagenums));
%                 BECmode=repmat(reshape(PCAmatrixmean,[numel(imdata),1]),[1,length(imagenums)]);
                
                BECmode=eigVect*diag(cleaningFilter)*transpose(eigVect)*PCAmatrix; %vectPlotmode{modenum}(indexlist(framenumber));
%                 BECmode=BECmode/max(abs(max(max(BECmode))),abs(min(min(BECmode))))+0.5;
                BECmode=BECmode/max(abs(max(max(BECmode(1:length(imagenums),:)))),abs(min(min(BECmode(1:length(imagenums),:)))))+0.5;
                
                
%                 BECmode=(BECmode-min(min(BECmode)))/(max(max(BECmode))-min(min(BECmode)));
%                 for framenumber=1:length(xdatagood)
                for framenumber=1:length(imagenums)
                    
%                     BECmode(:,framenumber)=transpose(eigVect*diag(includedmodes)*transpose(eigVect)*vectPlotmode{modenum}(indexlist(framenumber)));
                    
%                     PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber))/sum(PCATransp*eigVect(:,modenum));
% 
%         matBcleaned = eigVect * diag(cleaningFilter) * transpose(eigVect) * matB;
%         
%         matBcleanedTransp = transpose(matBcleaned);
%         total = sum(matBcleanedTransp);
           
                    
                    
%                     for modenum=includedmodes
% %                         if modenum==includedmodes(1)
% %                             BECmode(:,framenumber)=PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber));
% %                         else
%                             BECmode(:,framenumber)=BECmode(:,framenumber)+PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber))/sum(PCATransp*eigVect(:,modenum));
% %                         end
%                     end
                    %reshape(BECmode,size(imdata));
                    image(32*reshape(BECmode(indexlist(framenumber),:),size(imdata)));
                    colormap jet;
                    colorbar;
                    title(['Time ',num2str(sortedxdata(framenumber)),'ms'])
                    frame = getframe(avifig);
                    writeVideo(writerObj,frame);
                end
                close(writerObj);
                
            end
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        end
        
        return        
    elseif plotparam.analysis==23 
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%
        %%%% complex fitting for SSBEC
        %%%%
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         
        ind=1;
        [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
%         imagessummed=0;
%         imagessummedreported=0;
        
        h = 6.626*10.^(-34); %Js
        hbar = h/(2*pi); %Js
        mSr =  84*1.67*10^(-27); %kg
        kB =  1.3806503*10^(-23); %m^2 kg/s^2 K
        lamdaSr = 461*10.^(-9); %m
        abscrosSr = (3*(lamdaSr.^2))./(2*pi); %m^2
        a0 = 0.052917721086*10^-9;
        a8686 = 798*a0;
        a8484 = 102.5*a0;
        aScat = a8484;

%         touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax)&(xdata{ind}~=700));
        touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax));
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%
        % load the image dataset for the series
        %%%%
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        if ~isempty(touse)
            xdatagood=xdata{ind}(touse);
            imagenums=imagenumbers{ind}(touse);
            
            try
%                 load('C:\Users\srcal\Desktop\workspace23');
                load([directory,'\S',num2str(seriesnumber(ind)),'\imagedataset'],'PCAmatrix','imagessummed','roilocation','imdata','blursize');
                if (max(abs(roilocation-plotparam.PCAcrop))~=0)|(blursize~=plotparam.blursize)
                    plotparam.reloadimages=true;
                end
            catch
                plotparam.reloadimages=true;
            end
            
            if plotparam.reloadimages
                imagessummed=0;
                imagessummedreported=0;
                for imagenumber=imagenums
                    if imagessummed>(imagessummedreported+10)
                        display(['Loading...',num2str(imagessummed/numel(imagenums)*100),'%']);
                        imagessummedreported=imagessummed;
                    end
                    [difference,newdata,raw,probe]=loadvisionpicture(directory,seriesnumber(ind),imagenumber,plotparam.cameranumber);
                    
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    % This bit does intensity compensation on the probe and
                    % atoms images
                    
                    edgesregion=[1:450,800:size(raw,1)];
                    
                    rawav=sum(sum(raw(edgesregion,:)))/length(edgesregion)/size(raw,2);
                    probeav=sum(sum(probe(edgesregion,:)))/length(edgesregion)/size(probe,2);
                    
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    
                    OD=-log(max(0.000001,raw./probe*probeav/rawav));
          

Detuning=0;
Gamma=2*pi*30.5e6;
Lambda=461e-9;
Clebsch=1;
SigmaX=4.48036e-6;
SigmaY=4.48036e-6;

Sigma=Clebsch*3*Lambda^2/(2*pi*(1+(Detuning/(Gamma/4/pi))^2));
% Number=2*pi*SigmaX*SigmaY*OD/Sigma;
Number=SigmaX*SigmaY*OD/Sigma;

% Numberav=sum(sum(Number(edgesregion,:)))/length(edgesregion)/size(Number,2),


% figure;
% imagesc(Number);
% colormap jet;
% colorbar;

% sum(sum(Number)),

% fred=1;







                     if numel(plotparam.PCAcrop)==4 % if crop rectangle is already defined
                        if newdata %ensure load data was successful
                            %imdata=imcrop(difference,plotparam.PCAcrop);
                            imdata=double(Number(plotparam.PCAcrop(1):(plotparam.PCAcrop(1)+plotparam.PCAcrop(3)-1),plotparam.PCAcrop(2):(plotparam.PCAcrop(2)+plotparam.PCAcrop(4)-1)));
                            if plotparam.blursize>0
                                imdata=blurdata(imdata,plotparam.blursize);
                            end

%                             sum(sum(imdata)),

                            %                     if imagessummed==0
        %                         imsum=imdata;
        %                     else
        %                         imsum=imsum+imdata;
        %                     end
                            if imagessummed==0
                                PCAmatrix=zeros(numel(imagenums)+1,numel(imdata));
                            end
                            imagessummed=imagessummed+1;
                            PCAmatrix(imagessummed+1,:)=reshape(imdata,[1,numel(imdata)]);
                        end
                    end
                end
                PCAmatrix(1,:)=sum(PCAmatrix,1)/size(PCAmatrix,1);
                imdata=reshape(PCAmatrix(1,:),size(imdata));
                roilocation=plotparam.PCAcrop;
                blursize=plotparam.blursize;
                save([directory,'\S',num2str(seriesnumber(ind)),'\imagedataset'],'PCAmatrix','imagessummed','roilocation','imdata','blursize');
            end
            
            % PCAmatrix holds all the image data
            % it is flattened to a 1D vector instead of a 2D array
            % PCAmatrix(1, :) contains the average of all the data
            % PCAmatrix(2...n+1, :) contains the data from image 1...n
            
        
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%
            % fit the thermal cloud to the data for each image
            %%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            if imagessummed>=1,
                % load the fitted results for the averaged image dataset for the series
                if ~plotparam.reloadfitting
                    try
        %                 load('C:\Users\srcal\Desktop\workspace23');
                        load([directory,'\S',num2str(seriesnumber(ind)),'\fitdataset'],'x0series','SSBECfitparam','residuals','residual');
    %                     if (max(abs(roilocation-plotparam.PCAcrop))~=0)|(blursize~=plotparam.blursize)
    %                         plotparam.reloadfitting=true;
    %                     end
                        size(x0series);
    %                     size(transportfitseries);
                    catch
                        plotparam.reloadfitting=true;
                    end
                end
                if plotparam.reloadfitting
                    x0series=zeros(size(PCAmatrix,1),18);
%                     transportfitseries=zeros(size(PCAmatrix,1),8);
                end
                SSBECfitparam.dimpleXrange=[419 521];
                SSBECfitparam.reservoirXrange1=[310 360];
                SSBECfitparam.reservoirXrange2=[560 826];
                SSBECfitparam.transportXrange1=[1 249];
                SSBECfitparam.transportXrange2=[857 958];

                SSBECfitparam.Xcal=4.48036*1e-3;
                SSBECfitparam.Ycal=4.48036*1e-3;
                SSBECfitparam.aperturex=[440 495];
                SSBECfitparam.aperturey=[170 250];
                SSBECfitparam.border=50;

                X=(1:size(imdata,2))*SSBECfitparam.Xcal;
                Y=(1:size(imdata,1))*SSBECfitparam.Ycal;

                [xx,yy]=meshgrid(X,Y);
                
                if plotparam.reloadfitting
                    residual=imdata(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border));
                    residuals=zeros(size(PCAmatrix,1),numel(residual));
                end
                
                for imagenum=1:size(PCAmatrix,1)
                    if (max(abs(x0series(imagenum,:)))==0)||(plotparam.reloadfitting)
                        imdata=reshape(PCAmatrix(imagenum,:),size(imdata));
                        if (imagenum==1)
                            x0=fitSSBECbackground2(imdata,SSBECfitparam,xx,yy,X,Y);
                        else
                            x0=fitSSBECbackground2(imdata,SSBECfitparam,xx,yy,X,Y,squeeze(x0series(1,:)));
                        end
                        x0series(imagenum,:)=x0(1:end);
                        
                        estimatedprofile=constructSSBEC4(x0,xx,yy);

                        residual=imdata(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border))-estimatedprofile(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border));
                        residuals(imagenum,:)=reshape(residual,[1,numel(residual)]);
                        save([directory,'\S',num2str(seriesnumber(ind)),'\fitdataset'],'x0series','SSBECfitparam','residuals','residual');
                        
                        if imagenum>1
                            Pval=imagenums(imagenum-1);
                        else
                            Pval=0;
                        end
                        
                        figure(300);
                        imagesc(imdata);
                        colorbar;
                        title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
%                         axis equal
                        colormap jet

                        figure(301);
                        imagesc(estimatedprofile);
                        colorbar;
                        title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
%                         axis equal
                        colormap jet

                        figure(302);
                        imagesc(residual);
                        colorbar;
                        title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
%                         axis equal
                        colormap jet

                        figure(303);
                        imagesc(imdata-estimatedprofile);
                        colorbar;
%                         axis equal
                        colormap jet
                        title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
                        drawnow
                        pause(0.1);
                    end
                end
                
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%
                % construct avis and gifs of the residuals and do a PCA
                % analysis on the residuals
            %%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                Residualsavifilename='Residuals';
                if seriesnumber>0,
                    aviname=[directory,'\S',num2str(seriesnumber),'\',Residualsavifilename];
                else
                    aviname=[directory,'\',Residualsavifilename];
                end
                avifig=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj = VideoWriter([aviname,'.avi']);
                writerObj.FrameRate = Framerate;
                open(writerObj);
               
% %                 includedmodes=[1,2,7,8,9,11,16];
%                 cleaningFilter=zeros(length(xdatagood),1);
%                 cleaningFilter([indexnum(1)])=1;
% %                 cleaningFilter([2])=1;
                [sortedxdata,indexlist]=sort(xdatagood);
                
%                 BECmode=zeros(numel(imdata),length(imagenums));
%                 BECmode=repmat(reshape(PCAmatrixmean,[numel(imdata),1]),[1,length(imagenums)]);
                
%                 BECmode=eigVect*diag(cleaningFilter)*transpose(eigVect)*PCAmatrix; %vectPlotmode{modenum}(indexlist(framenumber));
% %                 BECmode=BECmode/max(abs(max(max(BECmode))),abs(min(min(BECmode))))+0.5;
%                 BECmode=BECmode/max(abs(max(max(BECmode(1:length(imagenums),:)))),abs(min(min(BECmode(1:length(imagenums),:)))))+0.5;
                
                residuals(residuals<-8)=0;
                residualsmin=min(min(residuals));
                residualsmax=max(max(residuals));
                
                aperture=zeros(size(residual));
                aperture(40:(end-40),40:(end-40))=1;
                residualsum=sum(residuals.*repmat(reshape(aperture,[1,numel(aperture)]),[size(residuals,1),1]),2);
                
                for framenumber=2:size(residuals,1)
                    imagesc(reshape(residuals(indexlist(framenumber-1)+1,:),size(residual)),[residualsmin residualsmax]);
                    colormap jet;
                    colorbar;
                    title(['Time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')'])
                    frame = getframe(avifig);
                    writeVideo(writerObj,frame);
                    
                    im = frame2im(frame); 
                    [imind,cm] = rgb2ind(im,256); 
                    
                    % Write to the GIF File 
                    
                    if framenumber == 2 
                        imwrite(imind,cm,[aviname,'.gif'],'gif', 'Loopcount',inf); 
                    else 
                        imwrite(imind,cm,[aviname,'.gif'],'gif','WriteMode','append'); 
                    end
                end
                close(writerObj);
               
             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%
                % construct avis and gifs of the residuals PCA
                % this time sorted by time and grouped so that the frames
                % are correctly ordered
            %%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
               
                
                fitsummaryavifilename='fitsummary';
                fitsummaryfig=300;
                figure(fitsummaryfig);
                if seriesnumber>0,
                    aviname=[directory,'\S',num2str(seriesnumber),'\',fitsummaryavifilename];
                else
                    aviname=[directory,'\',fitsummaryavifilename];
                end
                avifig=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj2 = VideoWriter([aviname,'.avi']);
                writerObj2.FrameRate = Framerate;
                open(writerObj2);
                
                fitsummaryavifilename='crosssectionsummary';
                fitsummaryfig2=350;
                figure(fitsummaryfig2);
                if seriesnumber>0,
                    aviname2=[directory,'\S',num2str(seriesnumber),'\',fitsummaryavifilename];
                else
                    aviname2=[directory,'\',fitsummaryavifilename];
                end
                avifig2=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj3 = VideoWriter([aviname2,'.avi']);
                writerObj3.FrameRate = Framerate;
                open(writerObj3);
                
                for framenumber=2:size(residuals,1)
                    imdata=reshape(PCAmatrix(indexlist(framenumber-1)+1,:),size(imdata));
%                         x0series(imagenum,:)=x0(1:end);

                    [estimatedprofile,dimplefit,reservoirfit,crossoverfit,transportfit]=constructSSBEC4(squeeze(x0series(indexlist(framenumber-1)+1,:)),xx,yy);
                    
                    residual=imdata(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border))-estimatedprofile(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border));

                    figure(fitsummaryfig);
                    set(fitsummaryfig,'Position',[50 50 1800 1000]);
                    subplot(3,1,1,'replace');
                    imagesc(imdata,[0 110]);
%                     imagesc(imdata);
%                     climits=get(gca,'cLim');
                    colorbar;
                    title(['Data at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    colormap jet

                    subplot(3,1,2,'replace');
                    imagesc(estimatedprofile,[0 110]);
%                     imagesc(estimatedprofile,climits);
                    colorbar;
                    title(['Fit at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    colormap jet

                    subplot(3,1,3,'replace');
                    imagesc(imdata-estimatedprofile,[-5 20]);
                    colorbar;
%                         axis equal
                    colormap jet
                    title(['Residuals at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);

%                         figure(302);
%                         imagesc(residual);
%                         colorbar;
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(imagenum-1,'%04.0f')]);
% %                         axis equal
%                         colormap jet

%                     drawnow
%                     pause(0.1);
                    
                    datacrosssection=sum(imdata,1);
                    thermalcrosssection=sum(dimplefit+reservoirfit+crossoverfit+transportfit,1);
                    dimplecrosssection=sum(dimplefit,1);
                    reservoircrosssection=sum(reservoirfit,1);
                    crossovercrosssection=sum(crossoverfit,1);
                    transportcrosssection=sum(transportfit,1);

                    
                    figure(fitsummaryfig2);
                    set(fitsummaryfig2,'Position',[50 50 1800 1000]);
                    subplot(2,1,1,'replace');
%                     plot(X,datacrosssection,'k.',X,thermalcrosssection,'r');
                    plot(1:length(datacrosssection),datacrosssection,'k.',1:length(datacrosssection),thermalcrosssection,'r');
%                     imagesc(imdata);
%                     climits=get(gca,'cLim');
%                     colorbar;
                    title(['Data at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
%                     colormap jet

                    subplot(2,1,2,'replace');
%                     plot(X,dimplecrosssection,'k',X,reservoircrosssection,'r',X,crossovercrosssection,'b',X,transportcrosssection,'g');
                    plot(1:length(datacrosssection),dimplecrosssection,'k',1:length(datacrosssection),reservoircrosssection,'r',1:length(datacrosssection),crossovercrosssection,'b',1:length(datacrosssection),transportcrosssection,'g');
%                     imagesc(estimatedprofile,climits);
%                     colorbar;
                    title('Dimple (k), Reservoir (r), Crossover (b), Beam (g)');
%                     colormap jet

%                     subplot(3,1,3,'replace');
%                     imagesc(imdata-estimatedprofile,[-5 20]);
%                     colorbar;
% %                         axis equal
%                     colormap jet
%                     title(['Residuals at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);

%                         figure(302);
%                         imagesc(residual);
%                         colorbar;
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(imagenum-1,'%04.0f')]);
% %                         axis equal
%                         colormap jet

%                     drawnow
%                     pause(0.1);
                    
                    
                    
%                     imagesc(reshape(residuals(indexlist(framenumber-1)+1,:),size(residual)),[residualsmin residualsmax]);
%                     colormap jet;
%                     colorbar;
%                     title(['Time ',num2str(sortedxdata(framenumber-1)),'ms (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(indexlist(framenumber-1)+1,'%04.0f'),')'])
                    frame = getframe(fitsummaryfig);
                    writeVideo(writerObj2,frame);
                    im = frame2im(frame); 
                    [imind,cm] = rgb2ind(im,256); 
                    
                    frame2 = getframe(fitsummaryfig2);
                    writeVideo(writerObj3,frame2);
                    im2 = frame2im(frame2); 
                    [imind2,cm2] = rgb2ind(im2,256); 
                    
                    % Write to the GIF File 
                    
                    if framenumber == 2 
                        imwrite(imind,cm,[aviname,'.gif'],'gif', 'Loopcount',inf); 
                        imwrite(imind2,cm2,[aviname2,'.gif'],'gif', 'Loopcount',inf); 
                    else 
                        imwrite(imind,cm,[aviname,'.gif'],'gif','WriteMode','append'); 
                        imwrite(imind2,cm2,[aviname2,'.gif'],'gif','WriteMode','append'); 
                    end
                end
                close(writerObj2);
                close(writerObj3);
                
                
             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%
                % plot the integration of the central residual, the anomaly
                % vs time
            %%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                
                figure(400);
                plot(sortedxdata(1:end)/1e3,residualsum(indexlist(1:end)+1),'k.');
                xlabel('Time [s]');
                ylabel('Integrated anomaly [atoms]');
                title('Integrated anomaly');
                
                plotvals=([sortedxdata(1:end)/1e3; residualsum(indexlist(1:end)+1).']).';
                
                if seriesnumber(ind)>0,
                    saveas(400,[directory,'\S',num2str(seriesnumber),'\Anomaly.png']);
                    save([directory,'\S',num2str(seriesnumber),'\Anomaly.csv'],'plotvals','-ascii');
                else
                    saveas(400,[directory,'\Anomaly.png']);
                    save([directory,'\Anomaly.csv'],'plotvals','-ascii');
                end
                
                
                
                
x0DimpleN=squeeze(x0series(indexlist+1,1)); % Parameters(1)=DimpleN;
x0DimpleWy=squeeze(x0series(indexlist+1,2)); % Parameters(2)=DimpleWy;
x0ReservoirN=squeeze(x0series(indexlist+1,3)); % Parameters(3)=ReservoirN;
x0ReservoirWy=squeeze(x0series(indexlist+1,4)); % Parameters(4)=ReservoirWy;
x0ReservoirWx=squeeze(x0series(indexlist+1,5)); % Parameters(5)=ReservoirWx;
x0CrossoverN=squeeze(x0series(indexlist+1,6)); % Parameters(6)=CrossoverN;
x0CrossoverWy=squeeze(x0series(indexlist+1,7)); % Parameters(7)=CrossoverWy;
x0CrossoverWx=squeeze(x0series(indexlist+1,8)); % Parameters(8)=CrossoverWx;
x0Dimplex=squeeze(x0series(indexlist+1,9)); % Parameters(9)=Dimplex;
x0Dimpley=squeeze(x0series(indexlist+1,10)); % Parameters(10)=Dimpley;
x0Crossoverx=squeeze(x0series(indexlist+1,11)); % Parameters(11)=Crossoverx;
x0Reservoirx=squeeze(x0series(indexlist+1,12)); % Parameters(12)=Reservoirx;
% x0BECWx=squeeze(x0series(indexlist+1,13)); % Parameters(13)=BECWx;
% x0BECWy=squeeze(x0series(indexlist+1,14)); % Parameters(14)=BECWy;
% x0BECN=squeeze(x0series(indexlist+1,15)); % Parameters(15)=BECN;
% x0BECampl=squeeze(x0series(indexlist+1,16)); % Parameters(16)=BECampl;
x0TransportN=squeeze(x0series(indexlist+1,13)); % Parameters(13)=TransportN;
x0Transportx=squeeze(x0series(indexlist+1,14)); % Parameters(14)=Transportx;
x0TransportWx=squeeze(x0series(indexlist+1,15)); % Parameters(15)=TransportWx;
x0Transporty=squeeze(x0series(indexlist+1,16)); % Parameters(16)=Transporty;
x0TransportWy=squeeze(x0series(indexlist+1,17)); % Parameters(17)=TransportWy;
x0Background=squeeze(x0series(indexlist+1,18)); % Parameters(18)=Background;
                
ExpansionTime=18e-3;
                
% TyDimple=mSr/kB*(SigmaY/ExpansionTime)^2*1E6;
TyDimple=mSr/kB*(x0DimpleWy*1e-3/2^0.5/ExpansionTime).^2*1E6;
TyReservoir=mSr/kB*(x0ReservoirWy*1e-3/2^0.5/ExpansionTime).^2*1E6;
TyCrossover=mSr/kB*(x0CrossoverWy*1e-3/2^0.5/ExpansionTime).^2*1E6;
TyTransport=mSr/kB*(x0TransportWy*1e-3/2^0.5/ExpansionTime).^2*1E6;

                
                figure(401);
                plot(sortedxdata/1e3,TyDimple,'k.',sortedxdata/1e3,TyReservoir,'r.',sortedxdata/1e3,TyCrossover,'b.',sortedxdata/1e3,TyTransport,'g.');
                xlabel('Time [s]');
                ylabel('Fitted Temperature [uK]');
                title('Temperature evolution (from fits)');
                legend({'Ty Dimple','Ty Reservoir','Ty Crossover','Ty Transport'},'Location','SouthOutside');
                
                if seriesnumber(ind)>0,
                    saveas(401,[directory,'\S',num2str(seriesnumber),'\TemperatureEvolution.png']);
                else
                    saveas(401,[directory,'\TemperatureEvolution.png']);
                end
                
NDimple=x0DimpleN./(1/(2*pi)./(x0DimpleWy*1e-3/2^0.5)./(x0DimpleWy*1e-3/2^0.5))/(SSBECfitparam.Xcal*SSBECfitparam.Ycal*1e-6);
NReservoir=x0ReservoirN./(1/(2*pi)./(x0ReservoirWy*1e-3/2^0.5)./(x0ReservoirWx*1e-3/2^0.5))/(SSBECfitparam.Xcal*SSBECfitparam.Ycal*1e-6);
NCrossover=x0CrossoverN./(1/(2*pi)./(x0CrossoverWy*1e-3/2^0.5)./(x0CrossoverWx*1e-3/2^0.5))/(SSBECfitparam.Xcal*SSBECfitparam.Ycal*1e-6);
% NTransport=x0TransportN/(1/(2*pi)/(x0TransportWy*1e-3/2^0.5)/(x0TransportWx*1e-3/2^0.5))/(SSBECfitparam.Xcal*SSBECfitparam.Ycal*1e-6);

                figure(402);
                plot(sortedxdata/1e3,NDimple,'k.',sortedxdata/1e3,NReservoir,'r.',sortedxdata/1e3,NCrossover,'c.',sortedxdata/1e3,(NDimple+NReservoir+NCrossover),'g.',sortedxdata/1e3,residualsum(indexlist+1)*100,'b.');
                xlabel('Time [s]');
                ylabel('Fitted Number [atoms]');
                title('Number evolution (from fits)');
                legend({'N Dimple','N Reservoir','N Crossover','N Total','N BEC*100'},'Location','SouthOutside');
                axis([0 15 0 2.5e6]);
                
                if seriesnumber(ind)>0,
                    saveas(402,[directory,'\S',num2str(seriesnumber),'\NumberEvolution.png']);
                else
                    saveas(402,[directory,'\NumberEvolution.png']);
                end
                
                
                
                
             %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%
                % PCA and save all the modes
            %%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                residuals=residuals(2:end,:);
                
                residualsTransp=transpose(residuals);
                residualsSum=residuals*residualsTransp/(size(residuals,1)-1);
                NUMBEROFFIGURES=0;

                [eigVect,eigVal]= eig(residualsSum); % standard eigenvalue solver
                [eigValval,indexnum]=sort(diag(eigVal),'descend');

                for modenumindex=1:length(plotparam.PCAmodeNumber)
                    if modenumindex==1
                        modenum=indexnum(plotparam.PCAmodeNumber(modenumindex));
                %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
                        residualsmodeX = reshape(residualsTransp*eigVect(:,modenum),size(residual));
                        vectPlot = residuals*(residualsTransp*eigVect(:,modenum));
                        vectPlotmode{modenum}=vectPlot;
                        
                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Number');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        imagesc(residualsmodeX);

%                         [~,xpeak]=max(max(abs(residualsmodeX),[],1));
%                         [~,ypeak]=max(max(abs(residualsmodeX),[],2));
% 
%                         [modenumindex, xpeak, ypeak, sum(sum(residualsmodeX))],

                        colorbar;
                        colormap jet;
                        title(['PCA Mode ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                         subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;

                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\Max_PCA_Mode.png']);
                        else
                            saveas(lastfignum,[directory,'\Max_PCA_Mode.png']);
                        end
                        

                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Number');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        plot(xdatagood,vectPlot,'.')
                        title(['PCA Amplitude ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                         PCAfilename=[PCAfilename,'-',num2str(modenum)];
                        
                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\Max_PCA_Amplitude.png']);
                        else
                            saveas(lastfignum,[directory,'\Max_PCA_Amplitude.png']);
                        end
                    end
                    
                    modenum=indexnum(plotparam.PCAmodeNumber(modenumindex));
            %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
                    residualsmodeX = reshape(residualsTransp*eigVect(:,modenum),size(residual));
                    vectPlot = residuals*(residualsTransp*eigVect(:,modenum));
                    vectPlotmode{modenum}=vectPlot;
                    if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Number');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        subplotnum=1;
                        PCAfilename='Modes';
                    end
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
        %             imagesc(residualsmodeX);
        %             colormap jet
    %                 imshow(residualsmodeX,[ ])
                    imagesc(residualsmodeX);
                    
                    [~,xpeak]=max(max(abs(residualsmodeX),[],1));
                    [~,ypeak]=max(max(abs(residualsmodeX),[],2));
                    
                    [modenumindex, xpeak, ypeak, sum(sum(residualsmodeX))],
                    
                    colorbar;
                    colormap jet;
                    title(['Mode ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                     title(['Mode ',num2str(modenum)])
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
                    plot(xdatagood,vectPlot,'.')
        %             title(['Evolution of mode number: ',num2str(modenum)]);
        %             ylabel('Mode amplitude');
        %             xlabel('Picture number');
                    PCAfilename=[PCAfilename,'-',num2str(modenum)];
                    if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
                        else
                            saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
                        end
                    end
                end
                
                % add the BEC like modes together and make a movie from
                % them
                
                % I think the way I'm normalizing the coefficients must be
                % wrong so they don't add up nicely. Need to spend some
                % time to sort this out.
                
                
                
%                 PCABECavifilename='BECMode';
%                 if seriesnumber>0,
%                     aviname=[directory,'\S',num2str(seriesnumber),'\',PCABECavifilename];
%                 else
%                     aviname=[directory,'\',PCABECavifilename];
%                 end
%                 avifig=figure('Position',[500 50 1200 500]);
%                 Framerate=5;
%                 writerObj = VideoWriter([aviname,'.avi']);
%                 writerObj.FrameRate = Framerate;
%                 open(writerObj);
%                
%                 cleaningFilter=zeros(length(xdatagood),1);
%                 cleaningFilter([indexnum(1)])=1;
% %                 cleaningFilter([2])=1;
%                 [sortedxdata,indexlist]=sort(xdatagood);
%                 
%                 BECmode=eigVect*diag(cleaningFilter)*transpose(eigVect)*residuals; %vectPlotmode{modenum}(indexlist(framenumber));
%                 BECmode=BECmode/max(abs(max(max(BECmode(1:length(imagenums),:)))),abs(min(min(BECmode(1:length(imagenums),:)))))+0.5;
%                 for framenumber=1:length(imagenums)
%                     image(32*reshape(BECmode(indexlist(framenumber),:),size(imdata)));
%                     colormap jet;
%                     colorbar;
%                     title(['Time ',num2str(sortedxdata(framenumber)),'ms'])
%                     frame = getframe(avifig);
%                     writeVideo(writerObj,frame);
%                 end
%                 close(writerObj);
                
                
                
                
                
                
                
                
                
                
                
                
%                 if ~reloadresiduals
%                     try
%         %                 load('C:\Users\srcal\Desktop\workspace23');
%                         load([directory,'\S',num2str(seriesnumber(ind)),'\residuals'],'residuals');
%     %                     if (max(abs(roilocation-plotparam.PCAcrop))~=0)|(blursize~=plotparam.blursize)
%     %                         plotparam.reloadfitting=true;
%     %                     end
% %                         size(x0series);
%     %                     size(transportfitseries);
%                     catch
%                         reloadresiduals=true;
%                     end
%                 end
%                 if reloadresiduals
%                     residuals=zeros(size(PCAmatrix,1),20);
%                     
% residuals%                     transportfitseries=zeros(size(PCAmatrix,1),8);
%                 end
                
                
%                 figure(306);
%                 imagesc(abs(residual));
%                 colorbar;
%                 colormap jet
%                 drawnow
%                 pause(0.1);

%                 estimatedprofile=constructSSBEC(x0,SSBECfit);
%                 figure(310);
%                 imagesc(constructSSBEC2(x0,SSBECfit));
%                 colorbar;
%                 colormap jet;
                
                % now fit the residual for a BEC
                
%                 residual=imdata-constructSSBEC2(x0,SSBECfit);
%                 BECregion=residual(max(1,aperturey(1)-boarder):min(size(residual,1),aperturey(2)+boarder),max(1,aperturex(1)-boarder):min(size(residual,2),aperturex(2)+boarder));
%                 
%                 [x1(1),x1(2)]=max(max(BECregion,[],1));
%                 [~,x1(3)]=max(BECregion(:,x1(2)));
%                 
% %                 x1(4)=; % BEC Wy
% %                 x1(5)=; % BEC Wx
% %                 x1(6)=; % Background
%                 
%                 
%                 display('fitting BEC...');
%                 x0=fminsearch(@(x) fitSSBECerror(x,SSBECfit),x0,options);
                
                
                
                % Parameters(1)=DimpleN;
                % Parameters(2)=DimpleWy;
                % Parameters(3)=ReservoirN;
                % Parameters(4)=ReservoirWy;
                % Parameters(5)=ReservoirWx;
                % Parameters(6)=CrossoverN;
                % Parameters(7)=CrossoverWy;
                % Parameters(8)=CrossoverWx;
                % Parameters(9)=Dimplex;
                % Parameters(10)=Dimpley;
                % Parameters(11)=Crossoverx;
                % Parameters(12)=Reservoirx;
                % Parameters(13)=BECN;
                % Parameters(14)=BECampl;
                % Parameters(15)=BECWx;
                % Parameters(16)=BECWy;

            end
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        end
        
        return        
%     elseif plotparam.analysis==23 % trimodal 2D fitting
%         % based on function [rbecbimodal,Anal] = BECtrimodal2DFast(directory,number,tof,fx,fy,fz,U,angle,comment);
%         
%         ind=1;
%         [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
%         imagessummed=0;
%         imagessummedreported=0;
%         
%         touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax)&(xdata{ind}~=700));
%         if ~isempty(touse)
%             xdatagood=xdata{ind}(touse);
%             imagenums=imagenumbers{ind}(touse);
%             
%             for imagenumber=imagenums
%                 if imagessummed>(imagessummedreported+10)
%                     display(['Loading...',num2str(imagessummed/numel(imagenums)*100),'%']);
%                     imagessummedreported=imagessummed;
%                 end
%                 [difference,newdata,raw,probe]=loadvisionpicture(directory,seriesnumber(ind),imagenumber,plotparam.cameranumber);
%                 OD=-log(max(0.00000001,raw./probe));
%                 if numel(plotparam.PCAcrop)==4 % if crop rectangle is already defined
%                     if newdata %ensure load data was successful
%                         %imdata=imcrop(difference,plotparam.PCAcrop);
%                         imdata=double(OD(plotparam.PCAcrop(1):(plotparam.PCAcrop(1)+plotparam.PCAcrop(3)-1),plotparam.PCAcrop(2):(plotparam.PCAcrop(2)+plotparam.PCAcrop(4)-1)));
%                         imdata=blurdata(imdata,plotparam.blursize);
%     %                     if imagessummed==0
%     %                         imsum=imdata;
%     %                     else
%     %                         imsum=imsum+imdata;
%     %                     end
%                         if imagessummed==0
%                             PCAmatrix=zeros(numel(imagenums),numel(imdata));
%                         end
%                         imagessummed=imagessummed+1;
%                         PCAmatrix(imagessummed,:)=reshape(imdata,[1,numel(imdata)]);
%                     end
%                 end
%             end
%             if imagessummed>=1,
%                 xcalSr = 4.48036*1e-3;  %camera resolution mm/pix (horizontal imaging)
%                 ycalSr = 4.48036*1e-3;
%                 
%                 xprofile=sum(imdata,1);
%                 minxprofile=min(xprofile);
%                 [maxxprofile,maxxloc]=max(xprofile);
%                 xprofile=(xprofile-minxprofile)/(maxxprofile-minxprofile);
%                 xdataxprofile=((1:length(xprofile))-1)*xcalSr;
%                                 
%                 x0(1)=1;
%                 x0(2)=xdataxprofile(maxxloc);
%                 x0(3)=sum(xprofile/sum(xprofile).*((1:length(xprofile))-maxxloc).^2).^0.5*xcalSr;
%                 x0(4)=0;
%                 lb=[x0(1)/2,1,x0(3)/10,0];
%                 ub=[x0(1)*2,length(xprofile),x0(3)*10,1];
%                 display('fitting...');
%                 xfitted=lsqcurvefit(@gaussian,x0,1:length(xprofile),xprofile,lb,ub);
%                 fitteddata=gaussian(xfitted,xdataxprofile);
%                 
%                 figure(100);
%                 plot(xdataxprofile,xprofile,'k.',xdataxprofile,fitteddata,'r');
%                 title('X - profile');
%                 legend({'xprofile',[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')]},'location','SouthOutside');
%                 display([num2str(xfitted(1)),'*exp(-((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
%             end




%                 
%                 
%                 
%                 
%                 yfitdata{ind}=gaussian(xfitted,xdata{ind});
%                 xfitdata{ind}=xdata{ind};
%                 dofitplot=1;
%                 display([num2str(xfitted(1)),'*exp(-((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
%                 legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];
% 
%                 yprofile=sum(imdata,[],2);
%                 yprofile=yprofile/max(yprofile);
%                 
%                 
%                 
%                 m=imdata;
% 
%                 
% global TabErrorU TabErrorL TabErrorNoBecU TabErrorNoBecL
%                 
% options = optimset('MaxFunEvals',10^5,'TolX',10^(-9),'MaxIter',25);
%                 
% h = 6.626*10.^(-34); %Js
% hbar = h/(2*pi); %Js
% kB =  1.3806503*10^(-23); %m^2 kg/s^2 K
% lamdaSr = 461*10.^(-9); %m
% abscrosSr = (3*(lamdaSr.^2))./(2*pi); %m^2
% a0 = 0.052917721086*10^-9;
% a8686 = 823*a0;
% a8484 = 122.7*a0;
% mSr =  84*1.67*10^(-27); %kg
% aS = a8484;
% 
% 
% Nparam = 1;
% % Initial Values
% 
% % %cx = 687; % full image
% % %cy = 650; % full image
% % cx = cropsizex/2; % cropped image
% % cy = cropsizey/2; % cropped image
% % sx = cropsizex/8;
% % sy = cropsizey/8;
% Total = sum(sum(m)); %total optical density in the image
% pODm = max(max(m)); %peak optical density in the image
% [sizey sizex] = size(m);
% pODx = pODm*sizey;
% pODy = pODm*sizex; %peak of optical density
% offx = Total/sizex;
% offy = Total/sizey;
% 
% % Integrated x profile
% lb = [1 1 0 -25*abs(offx)];
% ub = [sizex sizex 50*pODx 25*abs(offx)];
% mx = sum(m);
% x1D = 1:sizex;
% ip1D = [cx,sx,pODx,offx];
% fp1Dx = lsqcurvefit(@fitgaussian1D,ip1D,x1D,mx,lb,ub,options);
% 
% 
% % function [yfit]=gaussian_nobackground(x,xdata)
% % 
% % yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2);
% % 
% % end
% 
% 
% min(abs(fp1Dx - ub));
% min(abs(fp1Dx - lb));
% % fp1Dx
% % ub
% % lb
% cx = fp1Dx(1);
% sx = fp1Dx(2);
%                 
% % Integrated y profile
% lb = [1 1 0 -25*abs(offy)];
% ub = [sizey sizey 50*pODy 25*abs(offy)];
% my = sum(m');
% y1D = 1:sizey;
% ip1D = [cy,sy,pODy,offy];
% fp1Dy = lsqcurvefit(@fitgaussian1D,ip1D,y1D,my,lb,ub,options);
% min(abs(fp1Dy - ub));
% min(abs(fp1Dy - lb));
% % fp1Dy
% % ub
% % lb
% cy = fp1Dy(1);
% sy = fp1Dy(2);
% pOD = max(m(round(cy),:)); % takes a slice in x direction and uses this as initial pOD
% off = fp1Dy(4)/sizex;
%                 
% 
% [X,Y] = meshgrid(1:sizex,1:sizey);
% xy2D(:,1) = X(:);
% xy2D(:,2) = Y(:);
% m2D = m(:);
% 
% % good fit parameters for tof 24ms: 2 gauss + 1 BEC (saturated)
% ub = [sizex, sizey, 1.4*sx, 0.7, 0.2*pOD, 40*abs(off), 1.5*sx, 1.3, 1.5*pOD, 0.6*sx, 0.6*sy, 1.5*sx, 5, 1.5*pOD, 0.6*sx, 0.6*sy, 0.12, 0.01];
% lb = [1, 1, 0, 0.3, 0, -40*abs(off), 0, 0.75, 0, -0.6*sx, -0.6*sy, 0, 0.7, 0, -0.6*sx, -0.6*sy, 0.03, -0.01];
% sxBEC= 0.1*sx;
% ARBEC= 0.55;
% ABEC=0.005*pOD;
% sxGaussDimple=1*sx;
% ARGaussDimple=1.1;
% AGaussDimple=0.55*pOD;
% sxGaussReservoir=0.9*sx;
% ARGaussReservoir=1.9;
% AGaussReservoir=0.3*pOD;
% fixedAngle = 0.065;
% initpar = [cx,cy,sxBEC,ARBEC,ABEC,off,sxGaussDimple,ARGaussDimple,AGaussDimple,1,1,sxGaussReservoir,ARGaussReservoir,AGaussReservoir,1,1,fixedAngle, -0.001];
% 
% %Center shift:
% dxFix=0;%2.82267/3.86;
% dyFix=0;%-8.10522/3.86;
% [rbecbimodalGaussFree,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitDoubleGaussPlusBEC2DWithAngle(x,xdata,SizeRatioThermal,SizeRatioBEC,dxFix,dyFix),initpar,xy2D,m2D,lb,ub,options);
% 
% constrainedHigh = min(abs(rbecbimodalGaussFree - ub));
% constrainedLow = min(abs(rbecbimodalGaussFree - lb));
% TabErrorU(1,number) = constrainedHigh;
% TabErrorL(1,number) = constrainedLow;
% rbecbimodalCutNoBEC = [rbecbimodalGaussFree(1),rbecbimodalGaussFree(2),rbecbimodalGaussFree(6),rbecbimodalGaussFree(7),rbecbimodalGaussFree(8),rbecbimodalGaussFree(9),rbecbimodalGaussFree(10),rbecbimodalGaussFree(11),rbecbimodalGaussFree(12),rbecbimodalGaussFree(13),rbecbimodalGaussFree(14),rbecbimodalGaussFree(15),rbecbimodalGaussFree(16),rbecbimodalGaussFree(17)];
% ubCutNoBEC = [ub(1),ub(2),ub(6),ub(7),ub(8),ub(9),ub(10),ub(11),ub(12),ub(13),ub(14),ub(15),ub(16),ub(17)];
% lbCutNoBEC = [lb(1),lb(2),lb(6),lb(7),lb(8),lb(9),lb(10),lb(11),lb(12),lb(13),lb(14),lb(15),lb(16),lb(17)];
% constrainedHighNoBEC = min(abs(rbecbimodalCutNoBEC - ubCutNoBEC));
% constrainedLowNoBEC = min(abs(rbecbimodalCutNoBEC - lbCutNoBEC));
% TabErrorNoBecU(1,number) = constrainedHighNoBEC;
% TabErrorNoBecL(1,number) = constrainedLowNoBEC;
% rbecbimodalGaussFree
% ub
% lb
% rbecbimodalGaussFree./initpar
% 
% 
% % function [rbecbimodal,Anal] = BECtrimodal2DFast(directory,number,tof,fx,fy,fz,U,angle,comment);
% % 
% % global TabErrorU TabErrorL TabErrorNoBecU TabErrorNoBecL
% % 
% % %% F = image
% % 
% % %%%trap frequencies%%%%%%%%%%
% % %specify for cell mode
% % %fx = 220;
% % %fy = 220;%horizontal axial 
% % %fz = 540;%vertical axial
% % %directory='c:\SrBEC\Data\12Mar18\S5';
% % %number=1;
% % %comment='';
% % %tof = 20; %ms
% % %U=0;
% % 
% % 
% % %theta = 0;
% % % theta =  angle you want to rotate image by (+ means
% % %          counterclocksize and angle is in degrees)
% % a = directory;
% % %%%% vertical imaging ***********
% % %d = 'A';%vertical imaging
% % %e = '0';%vertical imaging
% % %xcalSr = 3.15;  %camera resolution um/pix (vertical imaging)
% % 
% % %%%% horizontal imaging ***********
% % d = 'B';%horizontal imaging
% % e = '1';%horizontal imaging
% % xcalSr = 3.86;  %camera resolution um/pix (horizontal imaging)
% % ycalSr = 3.86;
% % 
% % wrSr = 2*pi*fx; %rad, cross
% % waSr = 2*pi*fy; %horizontal axial 
% % wzSr = 2*pi*fz; %vertical axial
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % %help=cos(angle);
% % wxyaverage= 2*pi*(cos(angle)^2/(fx^2)+sin(angle)^2/(fy^2))^(-0.5);
% % t=0.001*tof;
% % SizeRatioThermal=1/(((t^2+1/wzSr^2)/(t^2+1/wxyaverage^2))^0.5); % ratio of sx and sy in Gauss fit for equal temp in all directions
% % SizeRatioBEC=35.612/44.931;
% % 
% % b = '\P000';
% % if number < 10
% %     b = '\P000';
% %     filename = [a,b,num2str(number),d];       
% %     else if number < 100
% %         b = '\P00';
% %         filename = [a,b,num2str(number),d];            
% %         else
% %             b = '\P0';
% %             filename = [a,b,num2str(number),d];            
% %         end
% % end
% % 
% % [success1,imA]=function_LoadTGA([filename,'A',e,'.TGA']);
% % [success2,imP]=function_LoadTGA([filename,'P',e,'.TGA']);
% % [success3,imN]=function_LoadTGA([filename,'N',e,'.TGA']);
% % [success4,imO]=function_LoadTGA([filename,'O',e,'.TGA']);
% % 
% % if (success1+success2+success3+success4==4)
% %     Foriginal=-log(max(0.00000001,(imA-imN)./(imP-imO)));
% % else
% %     fprintf(1, 'file not found\n');
% % end
% % %[F,map] = imread(filename);
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % %rotate and crop image
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % 
% % % for imcrop, coordinates goes as xlow, ylow, yhigh,xhigh
% % %use cell mode to adapt
% % %cropsizex = 250; % for varying tof
% % %cropsizey = 350; % for varying tof
% % cropsizex = 550; % for tof=24ms
% % cropsizey = 450; % for tof=24ms
% % %imagex=U;
% % imagex=650; % 0-20=>tof4ms ; 650 =>tof24ms
% % imagey=20; % 80=>tof4ms ; 20 =>tof24ms
% % % imagex=320; %15ms
% % % imagey=190; %15ms
% % %imagex=230;%10ms
% % %imagey=245;%10ms
% % F = imcrop(Foriginal,[imagex imagey cropsizex cropsizey]); % for K as second image in Frame Transfer Mode
% % m = double(F);
% % %m = imrotate(F,theta);
% % figure(1)
% % subplot(1,1,1)
% % imshow(m,[ ])
% % options = optimset('MaxFunEvals',10^5,'TolX',10^(-9),'MaxIter',25);
% % m = double(m);
% % 
% %                 
% % %% fit
% % 
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % we sum all the columns to get an integrated x
% % % direction profile. This allows us to easily find
% % % the center in th
% % % good intial values for the
% % % 2 D fits
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % atomic parameters
% % h = 6.626*10.^(-34); %Js
% % hbar = h/(2*pi); %Js
% % kB =  1.3806503*10^(-23); %m^2 kg/s^2 K
% % lamdaSr = 461*10.^(-9); %m
% % abscrosSr = (3*(lamdaSr.^2))./(2*pi); %m^2
% % a0 = 0.052917721086*10^-9;
% % a8686 = 823*a0;
% % a8484 = 122.7*a0;
% % mSr =  84*1.67*10^(-27); %kg
% % aS = a8484;
% % 
% % 
% % Nparam = 1;
% % % Initial Values
% % 
% % %cx = 687; % full image
% % %cy = 650; % full image
% % cx = cropsizex/2; % cropped image
% % cy = cropsizey/2; % cropped image
% % sx = cropsizex/8;
% % sy = cropsizey/8;
% % Total = sum(sum(m)); %total optical density in the image
% % pODm = max(max(m)); %peak optical density in the image
% % [sizey sizex] = size(m);
% % pODx = pODm*sizey;
% % pODy = pODm*sizex; %peak of optical density
% % offx = Total/sizex;
% % offy = Total/sizey;
% % 
% % % Integrated x profile
% % lb = [1 1 0 -25*abs(offx)];
% % ub = [sizex sizex 50*pODx 25*abs(offx)];
% % mx = sum(m);
% % x1D = 1:sizex;
% % ip1D = [cx,sx,pODx,offx];
% % fp1Dx = lsqcurvefit(@fitgaussian1D,ip1D,x1D,mx,lb,ub,options);
% % min(abs(fp1Dx - ub));
% % min(abs(fp1Dx - lb));
% % % fp1Dx
% % % ub
% % % lb
% % cx = fp1Dx(1);
% % sx = fp1Dx(2);
% % 
% % % subplot(1,1,1)
% % % plot(mx,'*b');
% % % hold off 
% % 
% % % Integrated y profile
% % lb = [1 1 0 -25*abs(offy)];
% % ub = [sizey sizey 50*pODy 25*abs(offy)];
% % my = sum(m');
% % y1D = 1:sizey;
% % ip1D = [cy,sy,pODy,offy];
% % fp1Dy = lsqcurvefit(@fitgaussian1D,ip1D,y1D,my,lb,ub,options);
% % min(abs(fp1Dy - ub));
% % min(abs(fp1Dy - lb));
% % % fp1Dy
% % % ub
% % % lb
% % cy = fp1Dy(1);
% % sy = fp1Dy(2);
% % pOD = max(m(round(cy),:)); % takes a slice in x direction and uses this as initial pOD
% % off = fp1Dy(4)/sizex;
% % 
% % 
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % %% 2D fits
% % % Note: we must first prepare the X,Y, and m as 
% % %       vectors and not matrices; we cannot
% % %       use 2D Meshgrid's for the 2D fitting 
% % %       routine, i.e. the X,Y, and m must be 
% % %       vectors and not matrices.
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % 
% % [X,Y] = meshgrid(1:sizex,1:sizey);
% % xy2D(:,1) = X(:);
% % xy2D(:,2) = Y(:);
% % m2D = m(:);
% % 
% % 
% % % good fit parameters for tof 24ms: 2 gauss + 1 BEC (saturated)
% % % ub = [sizex, sizey, 1.4*sx, 1.1, 0.5*pOD, 40*abs(off), 1.5*sx, 1.3, 1.5*pOD, 0.6*sx, 0.6*sy, 1.5*sx, 5, 1.5*pOD, 0.3*sx, 0.3*sy, 1.2];
% % % lb = [1, 1, 0, 0.35, 0, -40*abs(off), 0, 0.70, 0, -0.6*sx, -0.6*sy, 0, 0.7, 0, -0.3*sx, -0.3*sy,0.03];
% % % sxBEC= 1.1*sx;
% % % ARBEC= 0.55;
% % % ABEC=0.03*pOD;
% % % sxGaussDimple=1*sx;
% % % ARGaussDimple=1.1;
% % % AGaussDimple=0.6*pOD;
% % % sxGaussReservoir=1.2*sx;
% % % ARGaussReservoir=1.6;
% % % AGaussReservoir=0.3*pOD;
% % % fixedAngle = 0.08;
% % % initpar = [cx,cy,sxBEC,ARBEC,ABEC,off,sxGaussDimple,ARGaussDimple,AGaussDimple,1,1,sxGaussReservoir,ARGaussReservoir,AGaussReservoir,1,1,fixedAngle];
% % 
% % % used for 4 ms?????
% % % ub = [sizex, sizey, 1.5*sx, 2, 0.001*pOD, 40*abs(off), 2*sx, 1.5, 0.27*pOD, 0.6*sx, 0.6*sy, 3*sx, 7, 2*pOD, 0.6*sx, 0.6*sy, 1];
% % % lb = [1, 1, 0, 0.5, 0, -40*abs(off), 0, 0.5, 0, -0.6*sx, -0.6*sy, 0, 0.7, 0, -0.6*sx, -0.6*sy,-1];
% % % sxBEC= 0.8*sx;
% % % ARBEC= 0.4;
% % % ABEC=0.001*pOD;
% % % sxGaussDimple=0.8*sx;
% % % ARGaussDimple=1;
% % % AGaussDimple=0.5*pOD;
% % % sxGaussReservoir=1.4*sx;
% % % ARGaussReservoir=3.5;
% % % AGaussReservoir=0.5*pOD;
% % % fixedAngle = 0.06;
% % % initpar = [cx,cy,sxBEC,ARBEC,ABEC,off,sxGaussDimple,ARGaussDimple,AGaussDimple,1,1,sxGaussReservoir,ARGaussReservoir,AGaussReservoir,1,1,fixedAngle];
% 
% % % good fit parameters for tof 24ms: 2 gauss + 1 BEC (saturated)
% % ub = [sizex, sizey, 1.4*sx, 0.7, 0.2*pOD, 40*abs(off), 1.5*sx, 1.3, 1.5*pOD, 0.6*sx, 0.6*sy, 1.5*sx, 5, 1.5*pOD, 0.6*sx, 0.6*sy, 0.12, 0.01];
% % lb = [1, 1, 0, 0.3, 0, -40*abs(off), 0, 0.75, 0, -0.6*sx, -0.6*sy, 0, 0.7, 0, -0.6*sx, -0.6*sy, 0.03, -0.01];
% % sxBEC= 0.1*sx;
% % ARBEC= 0.55;
% % ABEC=0.005*pOD;
% % sxGaussDimple=1*sx;
% % ARGaussDimple=1.1;
% % AGaussDimple=0.55*pOD;
% % sxGaussReservoir=0.9*sx;
% % ARGaussReservoir=1.9;
% % AGaussReservoir=0.3*pOD;
% % fixedAngle = 0.065;
% % initpar = [cx,cy,sxBEC,ARBEC,ABEC,off,sxGaussDimple,ARGaussDimple,AGaussDimple,1,1,sxGaussReservoir,ARGaussReservoir,AGaussReservoir,1,1,fixedAngle, -0.001];
% % 
% % %Center shift:
% % dxFix=0;%2.82267/3.86;
% % dyFix=0;%-8.10522/3.86;
% % [rbecbimodalGaussFree,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitDoubleGaussPlusBEC2DWithAngle(x,xdata,SizeRatioThermal,SizeRatioBEC,dxFix,dyFix),initpar,xy2D,m2D,lb,ub,options);
% % 
% % constrainedHigh = min(abs(rbecbimodalGaussFree - ub));
% % constrainedLow = min(abs(rbecbimodalGaussFree - lb));
% % TabErrorU(1,number) = constrainedHigh;
% % TabErrorL(1,number) = constrainedLow;
% % rbecbimodalCutNoBEC = [rbecbimodalGaussFree(1),rbecbimodalGaussFree(2),rbecbimodalGaussFree(6),rbecbimodalGaussFree(7),rbecbimodalGaussFree(8),rbecbimodalGaussFree(9),rbecbimodalGaussFree(10),rbecbimodalGaussFree(11),rbecbimodalGaussFree(12),rbecbimodalGaussFree(13),rbecbimodalGaussFree(14),rbecbimodalGaussFree(15),rbecbimodalGaussFree(16),rbecbimodalGaussFree(17)];
% % ubCutNoBEC = [ub(1),ub(2),ub(6),ub(7),ub(8),ub(9),ub(10),ub(11),ub(12),ub(13),ub(14),ub(15),ub(16),ub(17)];
% % lbCutNoBEC = [lb(1),lb(2),lb(6),lb(7),lb(8),lb(9),lb(10),lb(11),lb(12),lb(13),lb(14),lb(15),lb(16),lb(17)];
% % constrainedHighNoBEC = min(abs(rbecbimodalCutNoBEC - ubCutNoBEC));
% % constrainedLowNoBEC = min(abs(rbecbimodalCutNoBEC - lbCutNoBEC));
% % TabErrorNoBecU(1,number) = constrainedHighNoBEC;
% % TabErrorNoBecL(1,number) = constrainedLowNoBEC;
% % rbecbimodalGaussFree
% % ub
% % lb
% % rbecbimodalGaussFree./initpar
% % 
% % %rbecbimodalGaussFree(12)=fixedAngle;
% % %Centers shifted, fixed:
% % %rbecbimodal(10)=dxFix;
% % %rbecbimodal(11)=dyFix;
% % %Next two code lines: For fixed Gauss size ratio:
% % %Next code line: For calculation of Size Ratio from fit to data with non fixed ratio:
% % %SizeRatioThermal=1/(1.16477-0.00943*rbecbimodal(7));%=rbecbimodal(8)/rbecbimodal(7)=sy/sx
% % %rbecbimodal(8)=rbecbimodal(7)*SizeRatioThermal;
% % %For fixed BEC ratio:
% % %rbecbimodal(4)=rbecbimodal(3)*SizeRatioBEC;
% % % ub2 = [sizex, sizey, 15*sx, 15*sy, 80*pOD, 40*abs(off)];
% % % lb2 = [1, 1, 0, 0, 0, -40*abs(off)];
% % % ub3 = [ub2,1];
% % % lb3 = [lb2,-1];
% % % initpar2 = [cx,cy,sx,sy,pOD,off];
% % % initpar3 = [initpar2,rbecbimodalGaussFree(17)];
% % % [r,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitgaussian2DWithAngle(x,xdata),initpar3,xy2D,m2D,lb3,ub3,options);
% % % foundAngle = r(7);
% % % [rbec,resnormBEC,residualBEC] = lsqcurvefit(@(x,xdata) fitBEC2DWithFixedAngle(x,xdata,foundAngle),initpar2,xy2D,m2D,lb2,ub2,options);
% % % rbec(7) = foundAngle;
% % %FfitBECbimodal2DonlyBECnoOffset2D = FfitBECbimodal2DonlyBECnoOffset(:);
% % 
% % %FfitBECbimodal2DonlyBECnoOffset2D = FfitBECbimodal2DonlyBECnoOffset(:);
% % rbecbimodal=rbecbimodalGaussFree;
% % %rbecbimodal(4)=rbecbimodal(4)*rbecbimodal(3);
% % %rbecbimodal(8)=rbecbimodal(8)*rbecbimodal(7);
% % %rGaussWing=r;
% % 
% % %%%%%%%%%%%%%%%%%%%
% % % Fit Gauss only to wings, then bimodal with Gauss size fix
% % %%%%%%%%%%%%%%%%%%
% % %j=1;
% % %for i = 1:1:(sizex*sizey)
% % %    if (FfitBECbimodal2DonlyBECnoOffset2D(i)==0)
% % %        xy2DnoCenter(j,1) = xy2D(i,1);
% % %        xy2DnoCenter(j,2) = xy2D(i,2);
% % %        m2DnoCenter(j) = m2D(i);
% % %        j=j+1;
% % %    end;
% % %end
% % 
% % %[rGaussWing,resnormGauss,residualGauss] = lsqcurvefit(@fitgaussian2D,initpar,xy2DnoCenter,m2DnoCenter',lb,ub,options);
% % 
% % %Sx=rGaussWing(3);
% % %Sy=rGaussWing(4);
% % %[rbecbimodalGaussFix,resnormGauss,residualGauss] = lsqcurvefit(@(x,xdata) fitBECbimodal2DGaussSizeFix(x,xdata,Sx,Sy),initpar,xy2D,m2D,lb,ub,options);
% % %rbecbimodalGaussFix(7)=Sx;
% % %rbecbimodalGaussFix(8)=Sy;
% % %rbecbimodal=rbecbimodalGaussFix;
% % 
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % %Analysis
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % 
% % %%%%%%
% % %Nint%
% % %%%%%%
% 
% Total = sum(sum(m));
% mbackground = m;
% ymin = round(cy-3*sy);
% ymax = round(cy+3*sy);
% xmin = round(cx-3*sx);
% xmax = round(cx+3*sx);
% 
% if ymin <= 1
%     ymin = 1;
%     fprintf(1, 'ymin <= 1\n');
% else
%     ymin = ymin;
% end
% 
% if ymax >= sizey
%     ymax = sizey;
%     fprintf(1, 'ymax >= sizey\n');
% else
%     ymax = ymax;
% end
% 
% if xmin <= 1
%     xmin = 1;
%     fprintf(1, 'xmin <= 1\n');
% else
%     xmin = xmin;
% end
% 
% if xmax >= sizex
%     xmax = sizex;
%     fprintf(1, 'xmax >= sizex\n');
% else
%     xmax = xmax;
% end
% 
% matoms = m(ymin:ymax,xmin:xmax);
% [a b] = size(mbackground);
% [c d] = size(matoms);
% mbackground(ymin:ymax,xmin:xmax)=zeros(size(mbackground(ymin:ymax,xmin:xmax)));
% avback = sum(sum(mbackground))/(a*b - c*d);
% mbackground(ymin:ymax,xmin:xmax)=avback.*ones(size(mbackground(ymin:ymax,xmin:xmax)));
% Background = sum(sum(mbackground));
% NumberCal=(xcalSr^2*(10^(-12)))*Nparam/abscrosSr;
% 
% Nint = NumberCal*(Total - Background);
% %NGauss =NumberCal*(2*pi).*(r(3).*r(4)).*(r(5));%atom number
% NGaussBiDimple = NumberCal*(2*pi).*(rbecbimodal(7).*rbecbimodal(7).*rbecbimodal(8)).*(rbecbimodal(9));%atom number thermal bimodal dimple
% NGaussBiReservoir = NumberCal*(2*pi).*(rbecbimodal(12).*rbecbimodal(12).*rbecbimodal(13)).*(rbecbimodal(14));%atom number thermal bimodal reservoir
% %[FfitBEC2DnoOffset] = CreateBEC2DnoOffset(rbec, sizex, sizey);
% %NBEC=NumberCal*sum(sum(FfitBEC2DnoOffset));
% [FfitBECbimodal2DonlyBECnoOffset] = CreateBEC2DnoOffsetAR(rbecbimodalGaussFree, sizex,sizey);
% NBECBi=NumberCal*sum(sum(FfitBECbimodal2DonlyBECnoOffset));
% FracBECBi=NBECBi/(NBECBi+NGaussBiDimple+NGaussBiReservoir);
% 
% Tc = (10^9)*(hbar*((wrSr*waSr*wzSr).^(1/3))/kB).*(Nint/1.202).^(1/3);%critical Temperature, nk
% %Tgaussx = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*r(3).*xcalSr).^2;% hor axial Temperature from Gauss Fit, nk
% %SigmaYGauss=0.000001*r(4).*xcalSr;
% %Tgaussy = 10^9*(mSr/(kB*(0.001*tof)^2)).*(SigmaYGauss).^2;% vertical Temperature from Gauss Fit, nk
% %TGaussyFiniteExpansion = 10^9*(mSr/kB)*(SigmaYGauss)^2 / ( 1/(wxyaverage^2) + (0.001*tof)^2);
% 
% TBiXDimple = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(7).*xcalSr).^2;% hor axial Temperature from bimodal Fit, Dimple, nk
% TBiYDimple = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(7).*rbecbimodal(8).*xcalSr).^2;% vertical Temperature from bimodal Fit, Dimple, nk
% 
% TBiXReservoir = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(12).*xcalSr).^2;% hor axial Temperature from bimodal Fit, Reservoir, nk
% TBiYReservoir = 10^9*(mSr/(kB*(0.001*tof)^2)).*(0.000001*rbecbimodal(12).*rbecbimodal(13).*xcalSr).^2;% vertical Temperature from bimodal Fit, Reservoir, nk
% 
% SigmaXGaussBiDimple=0.000001*rbecbimodal(7)*xcalSr;
% SigmaYGaussBiDimple=0.000001*rbecbimodal(7)*rbecbimodal(8)*xcalSr;
% TBiXFiniteExpansionDimple = 10^9*(mSr/kB)*(SigmaXGaussBiDimple)^2 / ( 1/(wzSr)^2 + (0.001*tof)^2);
% SigmaYGaussBiReservoir=0.000001*rbecbimodal(12).*rbecbimodal(13).*xcalSr;
% TBiYFiniteExpansionReservoir = 10^9*(mSr/kB)*((SigmaYGaussBiDimple)^2 ) / ( 1/(wxyaverage)^2 + (0.001*tof)^2);
% %TBiYFiniteExpansionReservoir = 10^9*(mSr/kB)*(SigmaYGaussBiReservoir)^2 / ( 1/((2*pi*10)^2) + (0.001*tof)^2);
% 
% % fmean=(fx*fy*fz)^(1/3);
% % aho = (hbar/(mSr*2*pi*fmean))^(1/2);
% % %ChemPotBEC=(10^9/kB)*0.5*hbar*2*pi*fmean*(15*NBEC*aS/aho)^(2/5);
% % ChemPotBECBi=(10^9/kB)*0.5*hbar*2*pi*fmean*(15*NBECBi*aS/aho)^(2/5);
% 
% %create image centered around cloud
% % SizeCutX=3*rbecbimodal(7);
% % SizeCutY=3*rbecbimodal(8);
% % F = imcrop(Foriginal,[imagex+r(1)-SizeCutX imagey+r(2)-SizeCutY 2*SizeCutX 2*SizeCutY]); % for K as second image in Frame Transfer Mode
% 
% %SizeCutX=cropsizex/2;
% %SizeCutY=cropsizey/2;
% mCut = double(F);
% mCutx = sum(mCut);
% mCuty = sum(mCut');
% [sizeyCut sizexCut] = size(mCut);
% 
%     figure1handle=figure(1);
%     hold off
%     %rCut=r;
%     %rCut(1)=r(1)-(sizex - sizexCut)/2;
%     %rCut(2)=r(2)-(sizey - sizeyCut)/2;
%  %   rCut(7)=r(12); %angle
%     %rbecCut=rbec;
%     %rbecCut(1)=SizeCutX;
%     %rbecCut(2)=SizeCutY;
%     %[FfitPureGauss] = CreateGaussian2DWithAngle(rCut,sizexCut,sizeyCut);
%     %[FfitPureBEC] = CreateBEC2DWithAngle(rbecCut, sizexCut,sizeyCut);
% 
%     rgaussbimodal= [rbecbimodal(1),rbecbimodal(2),rbecbimodal(7),rbecbimodal(8),rbecbimodal(9),rbecbimodal(6),rbecbimodal(10),rbecbimodal(11),rbecbimodal(12),rbecbimodal(13),rbecbimodal(14),rbecbimodal(15),rbecbimodal(16),rbecbimodal(17)];
%     rbecbimodalCut=rbecbimodal;
%     %rbecbimodalCut(1)=SizeCutX;
%     %rbecbimodalCut(2)=SizeCutY;
%     [FfitBECbiAlone] = CreateBEC2DARWithAngle(rbecbimodalCut, sizexCut,sizeyCut);
%     [FfitGaussbiAlone] = CreateDoubleGauss2DARWithAngle(rgaussbimodal,sizexCut,sizeyCut);
% %   [FfitGaussWing1D] = CreateGaussian1D(fgausswing, 2*rhoMax+1);
%     [FfitTotalTrimodal] = CreateTrimodal2DARWithAngle(rbecbimodalCut, sizexCut,sizeyCut);
% 
% 
%     
%     
%     %pureBEC1Dx = sum(FfitPureBEC);
%     %pureBEC1Dy = sum(FfitPureBEC');
%     %pureGauss1Dx = sum(FfitPureGauss);
%     %pureGauss1Dy = sum(FfitPureGauss');
%     becBimodal1Dx = sum(FfitBECbiAlone);
%     becBimodal1Dy = sum(FfitBECbiAlone');
%     GaussBimodal1Dx = sum(FfitGaussbiAlone);
%     GaussBimodal1Dy = sum(FfitGaussbiAlone');
%     TotalTri1Dx = sum(FfitTotalTrimodal);
%     TotalTri1Dy = sum(FfitTotalTrimodal');
%     
%     MinOD=min(mCut(:));
%     MaxOD=max(mCut(:));
%     
%     mResidueTrimodalFit=mCut-FfitTotalTrimodal;
%     mOnlyBEC=mCut-FfitGaussbiAlone;
%     mOnlyThermal=mCut-FfitBECbiAlone;
%     ResidueTrimodalFit=sqrt(sum(sum(mResidueTrimodalFit.^2))/(2*sizexCut*2*sizeyCut));
%     
%     %mResiduePureGaussFit=mCut-FfitPureGauss;
%     %ResiduePureGaussFit=sqrt(sum(sum(mResiduePureGaussFit.^2))/(2*sizexCut*2*sizeyCut));
%      
% %     subplot(4,5,3);
% %     imshow(FfitPureGauss,[MinOD MaxOD]);
% %     title('Pure Gauss fit');
% %      
% %     subplot(4,5,8);
% %     imshow(mResiduePureGaussFit,[]);
% %     title(['P',num2str(number),' - Pure Gauss fit']);
% %     
% %     mResiduePureBECFit=mCut-FfitPureBEC;
% %     ResiduePureBECFit=sqrt(sum(sum(mResiduePureBECFit.^2))/(2*sizexCut*2*sizeyCut));
%      
% %    ResidueAverage=(ResidueTrimodalFit+ResiduePureBECFit+ResiduePureGaussFit)/3;
% %     ResidueTrimodalFit=ResidueTrimodalFit/ResidueAverage;
% %     ResiduePureBECFit=ResiduePureBECFit/ResidueAverage;
% %     ResiduePureGaussFit=ResiduePureGaussFit/ResidueAverage;
% 
% %     subplot(4,5,13);
% %     imshow(FfitPureBEC,[MinOD MaxOD]);
% %     title('Pure BEC fit');
% %     
% %     subplot(4,5,18);
% %     imshow(mResiduePureBECFit,[]);
% %     title(['P',num2str(number),' - Pure BEC fit']);
% 
%     hold off;
% 
%     subplot(4,5,1);
%     imshow(mCut,[MinOD MaxOD]);
%     title(['P',num2str(number)])
%      
%     subplot(4,5,2);
%     imshow(FfitTotalTrimodal,[MinOD MaxOD]);
%     title('Trimodal fit');
%     
%     subplot(4,5,17);
%     imshow(mResidueTrimodalFit,[]);
%     title(['P',num2str(number),' - Trimodal fit']);
%     
%    
%     subplot(4,5,6); 
%     MinODBEC=min(mOnlyBEC(:));
%     MaxODBEC=max(mOnlyBEC(:));
%     imshow(mOnlyBEC,[MinODBEC MaxODBEC]);
%     title(['P',num2str(number),' - thermal component (BEC scale)']);
%    
%     
%     subplot(4,5,7);
%     imshow(FfitBECbiAlone,[MinODBEC MaxODBEC]); 
%     title('BEC component (BEC scale)');
%     
%     
%     subplot(4,5,11);
%     imshow(mOnlyThermal,[MinOD MaxOD]);
%     title(['P',num2str(number),' - BEC component']);
%     
%     
%     subplot(4,5,12);
%     imshow(FfitGaussbiAlone,[MinOD MaxOD]);  
%     title('thermal component');
%     
%     subplot(4,5,16);
%     imshow(mCut,[MinOD MaxOD]);
%     title(['P',num2str(number)])
%    
%     start = get(gca,'clim');
%     hold on;
%     imcontour(FfitTotalTrimodal,5,'r');
%     set(gca,'clim', start);
% 
%     [a b] = size(m);
% 
%     hold off;
% 
%     PlotLineWidth=2;
%     PlotMarkerWidth=4;
%     subplot(4,5,[4 5 9 10])
%     x = 1:1:b;
%     plot(x,mCutx,'ob','MarkerFaceColor','k','MarkerSize',PlotMarkerWidth);
%     hold on
%   
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%     plot(x,becBimodal1Dx,'k-','LineWidth',PlotLineWidth);
%     %plot(x,pureBEC1Dx,'cyan','LineWidth',PlotLineWidth);
%     plot(x,GaussBimodal1Dx,'b-','LineWidth',PlotLineWidth);
%     %plot(x,pureGauss1Dx,'g-','LineWidth',PlotLineWidth);
%     plot(x,TotalTri1Dx,'r-','LineWidth',PlotLineWidth);
%     xlabel('x axis in pixels');
%     ylabel('');
% 
%     hold off
%     subplot(4,5,[14 15 19 20])
%     y = 1:1:a;
%     plot(y,mCuty,'ob','MarkerFaceColor','k','MarkerSize',PlotMarkerWidth);
%     hold on
% %   fit1dyp = Ffit(:,round(pt(3)));
% %   fit1dypgauss = FfitGauss(:,round(r(1)));
% %   fit1dypgauss = sum(FfitGauss');
%     plot(y,becBimodal1Dy,'k-','LineWidth',PlotLineWidth);
%     %plot(y,pureBEC1Dy,'cyan','LineWidth',PlotLineWidth);
%     plot(y,GaussBimodal1Dy,'b-','LineWidth',PlotLineWidth);
%     %plot(y,pureGauss1Dy,'g-','LineWidth',PlotLineWidth);
%     plot(y,TotalTri1Dy,'r-','LineWidth',PlotLineWidth');
%     xlabel('y axis in pixels');
%     ylabel('');
%   
%     hold off
% 
%     
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %output data
% 
% %print -dpsc2 -f1 -append Figures.ps
%     
% Anal = [TBiXDimple, TBiYDimple,TBiXFiniteExpansionDimple,TBiXReservoir, TBiYReservoir,TBiYFiniteExpansionReservoir, Nint, NGaussBiDimple, NGaussBiReservoir, NGaussBiDimple+NGaussBiReservoir, NBECBi, FracBECBi, ResidueTrimodalFit*100];
% 
% 
% [c d] = size(my);
% ofile2= [directory,'P',num2str(number),'ProfileX.dat'];       
% outfile = fopen(ofile2, 'w');
% fprintf(outfile, 'Original image from %s\n', filename);
% fprintf(outfile, 'position(um)\n');
% fprintf(outfile, '2nd column is the integrated profile over y.\n');
% fprintf(outfile, '3nd column is the fitted bimodal integrated profile over y.\n');
% 
% fprintf(outfile, '\n\nTOF = %.0f ms\t\tfx = %0.1f Hz\tfy = %0.1f Hz\tfz = %0.1f Hz\n', tof, fx, fy, fz);
% fprintf(outfile, 'Nint = %.0f\tNGaussBiDimple = %.0f\tNGaussBiReservoir = %.0f\tNBECBimodal = %.0f\tNBECBi/Ntot= %.0f\t',Nint,NGaussBiDimple,NGaussBiReservoir,NBECBi,FracBECBi);
% fprintf(outfile, 'Tc = %.3f nK\tTBiDimpleX = %.3f nK\tTBiDimpleY = %.3f nK\tTBiReservoirX = %.3f nK\tTBiReservoirY = %.3f nK\n\n',Tc,TBiXDimple,TBiYDimple,TBiXReservoir,TBiYReservoir);
% %fprintf(outfile, 'TbimodalX/Tc = %.3f\tTbimodalY/Tc = %.3f\tChemPotBEC = %.3f\tChemPotBECBimodal = %.3f\n\n', Tbimodalx/Tc,Tbimodaly/Tc,ChemPotBEC,ChemPotBECBimodal);
% 
% % Cx=rbecbimodal(1);
% % Cy=rbecbimodal(2);
% fprintf(outfile, 'position(um)\tODx(Expt)\tODx(DoubleGaussBimodal)\tODx(BECBimodal)\tODx(TotBimodal)\n');
% % [c SizeX] = size(mx);
% % [c SizeY] = size(my);
% Offset=rbecbimodal(6)*sizeyCut;  
% for i = 1:1:sizexCut-1;
%     fprintf(outfile, '%f\t%f\t%f\t%f\t%f\n', (i-1-sizeyCut)*xcalSr, mCutx(i)-Offset, GaussBimodal1Dx(i)-Offset, becBimodal1Dx(i)-Offset, TotalTri1Dx(i)-Offset);
% end
% fclose(outfile);
% ofile2= [directory,'P',num2str(number),'ProfileY.dat'];       
% outfile = fopen(ofile2, 'w');
% fprintf(outfile, 'position(um)\tODy(Expt)\tODy(DoubleGaussBimodal)\tODy(BECBimodal)\tODy(TotBimodal)\n');
% Offset=rbecbimodal(6)*sizexCut;
% for i = 1:1:sizeyCut-1;
%     fprintf(outfile, '%f\t%f\t%f\t%f\t%f\n', (i-1-sizexCut)*ycalSr, mCuty(i)-Offset, GaussBimodal1Dy(i)-Offset, becBimodal1Dy(i)-Offset, TotalTri1Dy(i)-Offset);
% end
% fclose(outfile);
% 
% ofile3= [directory,'P',num2str(number),'Fit.png'];
% saveas(figure1handle,ofile3);
% 
% % r(1)=r(1)*xcalSr;
% % r(2)=r(2)*ycalSr;
% % r(3)=r(3)*xcalSr;
% % r(4)=r(4)*ycalSr;
% % 
% % rGaussWing(1)=rGaussWing(1)*xcalSr;
% % rGaussWing(2)=rGaussWing(2)*ycalSr;
% % rGaussWing(3)=rGaussWing(3)*xcalSr;
% % rGaussWing(4)=rGaussWing(4)*ycalSr;
% % 
% % rbec(1)=rbec(1)*xcalSr;
% % rbec(2)=rbec(2)*ycalSr;
% % rbec(3)=rbec(3)*xcalSr;
% % rbec(4)=rbec(4)*ycalSr;
% 
% rbecbimodal(1)=rbecbimodal(1)*xcalSr; %Cx
% rbecbimodal(2)=rbecbimodal(2)*ycalSr; %Cy
% rbecbimodal(3)=rbecbimodal(3)*xcalSr; %Rx
% rbecbimodal(7)=rbecbimodal(7)*xcalSr; %Gauss dimplex
% rbecbimodal(10)=rbecbimodal(10)*xcalSr; %Dx1
% rbecbimodal(11)=rbecbimodal(11)*ycalSr; %Dy1
% rbecbimodal(12)=rbecbimodal(12)*xcalSr; %Gauss reservoir x
% rbecbimodal(15)=rbecbimodal(15)*xcalSr; %Dx2
% rbecbimodal(16)=rbecbimodal(16)*ycalSr; %Dy2
% 
% 
% fprintf(1, 'Nint = %.0f\tNGaussBiDimple = %.0f\tNGaussBiReservoir = %.0f\tNBECBimodal = %.3f\tNGaussBiThermal = %.0f\tNBECBi/Ntot= %.3f\t\n', Nint, NGaussBiDimple, NGaussBiReservoir, NGaussBiDimple+NGaussBiReservoir, NBECBi, FracBECBi);
% fprintf(1, 'Tc = %.3f nK\tTBiDimpleX = %.3f nK\tTBiDimpleY = %.3f nK\tTBiReservoirX = %.3f nK\tTBiReservoirY = %.3f nK\n',Tc,TBiXDimple,TBiYDimple,TBiXReservoir,TBiYReservoir);
% %fprintf(1, 'TgaussyCorr/Tc = %.3f\tTbimodalCorrY/Tc = %.3f\tChemPotBEC = %.3f\tChemPotBECBimodal = %.3f\n', TGaussyFiniteExpansion/Tc,TbimodalyFiniteExpansion/Tc,ChemPotBEC,ChemPotBECBimodal);
% %fprintf(1,'RxBEC = %.3f m\tRyBEC = %.3f m\tRxBECBi = %.3f m\tRyBECBi = %.3f m\tdxBECBi = %.3f m\tdyBECBi = %.3f m\n',rbec(3),rbec(4),rbecbimodal(3),rbecbimodal(4),rbecbimodal(10),rbecbimodal(11));
% fprintf(1,'StandDevTotBimodal = %.2f\n',ResidueTrimodalFit*100);
% %fprintf(1,'cx = %.2f\tcy = %.2f\tsx = %.2f\tsy = %.2f\tAmp = %.2f\tOffs = %.2f\t\n',r(1),r(2),r(3),r(4),r(5),r(6));
% %fprintf(1,'cx = %.2f\tcy = %.2f\tsx = %.2f\tsy = %.2f\tAmp = %.2f\tOffs = %.2f\t',rGaussWing(1),rGaussWing(2),rGaussWing(3),rGaussWing(4),rGaussWing(5),rGaussWing(6));                
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%                 
%     %             imsum=imsum/imagessummed;
%                 PCAmatrixmean=reshape(mean(PCAmatrix,1),size(imdata));
%                 PCAmatrix=PCAmatrix-repmat(mean(PCAmatrix,1),[size(PCAmatrix,1),1]);
%                 PCATransp=transpose(PCAmatrix);
%                 PCAmatSum=PCAmatrix*PCATransp/(size(PCAmatrix,1)-1);
%                 NUMBEROFFIGURES=0;
% 
%                 [eigVect,eigVal]= eig(PCAmatSum); % standard eigenvalue solver
% 
%                 figure('Position',[500 50 1200 500]);
%                 lastfignum=get(gcf,'Number');
%                 NUMBEROFFIGURES=NUMBEROFFIGURES+1;
%                 imagesc(PCAmatrixmean);
%                 colormap jet;
%                 title('Average Mode');
%                 PCAfilename=['Average Mode'];
%                 if seriesnumber>0,
%                     saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
%                 else
%                     saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
%                 end
%                 
%                 for modenumindex=1:length(plotparam.PCAmodeNumber)
%                     modenum=plotparam.PCAmodeNumber(modenumindex);
%             %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
%                     PCAmodeX = reshape(PCATransp*eigVect(:,modenum),size(imdata));
%                     vectPlot = PCAmatrix*(PCATransp*eigVect(:,modenum));
%                     vectPlotmode{modenum}=vectPlot;
%                     if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
%                         figure('Position',[500 50 1200 900]);
%                         lastfignum=get(gcf,'Number');
%                         NUMBEROFFIGURES=NUMBEROFFIGURES+1;
%                         subplotnum=1;
%                         PCAfilename='Modes';
%                     end
%                     subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
%         %             imagesc(PCAmodeX);
%         %             colormap jet
%     %                 imshow(PCAmodeX,[ ])
%                     imagesc(PCAmodeX);
%                     colormap jet;
%                     title(['Mode ',num2str(modenum)])
%                     subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
%                     plot(xdatagood,vectPlot,'.')
%         %             title(['Evolution of mode number: ',num2str(modenum)]);
%         %             ylabel('Mode amplitude');
%         %             xlabel('Picture number');
%                     PCAfilename=[PCAfilename,'-',num2str(modenum)];
%                     if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
%                         if seriesnumber>0,
%                             saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
%                         else
%                             saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
%                         end
%                     end
%                 end
%                 
%                 % add the BEC like modes together and make a movie from
%                 % them
%                 
%                 % I think the way I'm normalizing the coefficients must be
%                 % wrong so they don't add up nicely. Need to spend some
%                 % time to sort this out.
%                 
%                 
%                 
%                 PCABECavifilename='BECMode';
%                 if seriesnumber>0,
%                     aviname=[directory,'\S',num2str(seriesnumber),'\',PCABECavifilename];
%                 else
%                     aviname=[directory,'\',PCABECavifilename];
%                 end
%                 avifig=figure('Position',[500 50 1200 500]);
%                 Framerate=5;
%                 writerObj = VideoWriter([aviname,'.avi']);
%                 writerObj.FrameRate = Framerate;
%                 open(writerObj);
%                
% %                 includedmodes=[1,2,7,8,9,11,16];
%                 includedmodes=[7,8,9,11,16];
%                 [sortedxdata,indexlist]=sort(xdatagood);
%                 
%                 BECmode=zeros(numel(imdata),length(imagenums));
% %                 BECmode=repmat(reshape(PCAmatrixmean,[numel(imdata),1]),[1,length(imagenums)]);
%                 
%                 for framenumber=1:length(imagenums)
%                     for modenum=includedmodes
% %                         if modenum==includedmodes(1)
% %                             BECmode(:,framenumber)=PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber));
% %                         else
%                             BECmode(:,framenumber)=BECmode(:,framenumber)+PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber))/sum(PCATransp*eigVect(:,modenum));
% %                         end
%                     end
%                     %reshape(BECmode,size(imdata));
%                     BECmode=(BECmode-min(min(BECmode)))/(max(max(BECmode))-min(min(BECmode)));
%                     image(64*reshape(BECmode(:,framenumber),size(imdata)));
%                     colormap jet;
%                     title(['Time ',num2str(sortedxdata(framenumber)),'ms'])
%                     frame = getframe(avifig);
%                     writeVideo(writerObj,frame);
%                 end
%                 close(writerObj);
%                 
%             end
%     %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
%     %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
%         end
        
%         return        
    elseif plotparam.analysis==25 % Y PSD
                %Sy: params.datasection=params.dataparameters+6;
                %Sx: params.datasection=params.dataparameters+5;
                %NI: params.datasection=params.dataparameters+11;
                %PSD prop to NI/Sx^2/Sy;
            [xdata{ind},Sxdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+5,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
            [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
            [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
            ydata{ind}=NIdata{ind}./Sydata{ind};
            if plotparam.overridexaxiswithmeasurementnumber
                xdata{ind}=1:length(xdata{ind});
            end

% if plotparam.overridexaxiswithmeasurementnumber
%     xdata{ind}=1:length(xdata{ind});
% end
        

            
    end
    


end % Analysis options for ploting. Loading data from vision raw file etc ... Ie PSD TOF etc. Generate the data

for ind=1:length(seriesnumber) % Adds scaling to data. i.e squares y axis adds offset multpies by constant etc
    if ind ==1  
        plotparam = SetDefaultValues (plotparam ,seriesnumber); %Set offsets scale and labes to default values.
    end
    [plotparam, xdata{ind} ,ydata{ind}] = ScaleData(plotparam, xdata{ind},ydata{ind},ind,seriesnumber);
end

for ind=1:length(seriesnumber)
    goodval=find(~isnan(ydata{ind}));
    if ~isempty(goodval)
        xdata{ind}=xdata{ind}(goodval);
        ydata{ind}=ydata{ind}(goodval);
        [xdata{ind},order]=sort(xdata{ind});
        ydata{ind}=ydata{ind}(order);
    else
        display('No good data');
        xdata{ind}=[];
        ydata{ind}=[];
    end
end % RGE I think these are data quality checks 



xaveraged =0;
yaveraged =ydata{1};

% ydata{4} = ydata{1};
% xdata{4} = xdata{1};

counting = 1;

for ind=2:length(seriesnumber)
    if plotparam.averageseries(ind)
        yaveraged = ydata{ind} + yaveraged;
        counting = counting + 1;
    end

    
end
yaveraged =yaveraged/counting;
for ind=1:length(seriesnumber)
    if plotparam.averageseries(ind);
        ydata{ind} = yaveraged;
    end
end


figure;

evalstring='plot(';

for ind=1:length(seriesnumber) % does the fiting of the data  and generates the comand for the ploting
    dofitplot=0;doPlotoptions=0;
    [plotparam,evalstringErrorbar{ind}] =   GeneratePlotingComandErrorBar(plotparam,seriesnumber,ind ,dofitplot,'',doPlotoptions ); % Generates the string use for plotting errorbar
    [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,'',doPlotoptions ); % Generates the string to be used for ploting
    [plotparam,xdata{ind}] = formatfitinginputs (plotparam,xdata{ind},seriesnumber); % Formats the input options so they can be interpreted by the code
    

    if plotparam.dofit~=0
        dofitplot=0;
        pointstouseforfit=((xdata{ind}>=plotparam.xfitmin(ind))&(xdata{ind}<=plotparam.xfitmax(ind)));
        switch plotparam.dofit
            case 1 % polinomial fit
                if length(pointstouseforfit)>=(plotparam.polyfitorder+1)
                    if plotparam.polyfitorder==0
                        meanval=mean(ydata{ind}(pointstouseforfit));
                        stdval=std(ydata{ind}(pointstouseforfit));
                        xfitstart=min(xdata{ind}(pointstouseforfit));
                        xfitend=max(xdata{ind}(pointstouseforfit));
                        xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                        yfitdata{ind}=meanval*ones(size(xfitdata{ind}));
                        displaytext=[num2str(meanval),'\pm',num2str(2*stdval)];
                        if ( plotparam.extractStability )
                            stability = 100*stdval/meanval
                            legendentry=[ 'Average Value  = ',num2str(meanval,'%10.3e'),' ','\sigma = ',num2str(stdval),' \Delta',' = ',num2str(stability),'% .'];
                        else
                            legendentry=[nicenumber(meanval),'\pm',num2str(2*stdval)];
                        end
               else
                        p=polyfitn(xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),plotparam.polyfitorder);
                        xfitstart=min(xdata{ind}(pointstouseforfit));
                        xfitend=max(xdata{ind}(pointstouseforfit));
                        xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                        yfitdata{ind}=polyvaln(p,xfitdata{ind});
                        displaytext=[];
                        legendentry=[];
                        for ind2=0:plotparam.polyfitorder
                            if (ind2==0)&&p.Coefficients(plotparam.polyfitorder-ind2+1)~=0
                                if(not(plotparam.TOFmeasurement))
                                    displaytext=[displaytext,'(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                    legendentry=[legendentry,'(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                else
                                    displaytext=[displaytext,'(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                end
                            elseif (p.Coefficients(plotparam.polyfitorder-ind2+1)>0)&&(ind2==1)
                                if(not(plotparam.TOFmeasurement))
                                    displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                    legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                elseif( plotparam.cameranumber ==3 )
                                    calibrationcoeff = plotparam.cameraCalibration;
                                    displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                    legendentry=[legendentry,'T = (',nicenumber(calibrationcoeff*p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(calibrationcoeff*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')','\mu','K'];
                                end
                            elseif (p.Coefficients(plotparam.polyfitorder-ind2+1)<0)&&(ind2==1)
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                            elseif p.Coefficients(plotparam.polyfitorder-ind2+1)>0
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                            elseif p.Coefficients(plotparam.polyfitorder-ind2+1)<0
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                            end
                        end
                    end
                    dofitplot=1;
                    display(displaytext);
    %                 dofitplot=1;
                end
                        case 2 % exponential fit, no background
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                lb=[x0(1),0];
                ub=[x0(1)*10,x0(2)*10];
                display('fitting...');
                [xfitted,resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@exponential_rise_nobackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                 xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                
                yfitdata{ind}=exponential_rise_nobackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'pm',num2str(expSigma(1)),'*(1-exp(-t/',num2str(xfitted(2)),'))']);
                legendentry=['(',num2str(xfitted(1),'%0.3e'),'\pm',num2str(expSigma(1),'%0.3e'),')','*(1-exp(-t/',num2str(xfitted(2),'%0.3e'),'\pm',num2str(expSigma(2),'%0.3e'),'))'];
                
            case 3 % exponential fit, no background, t offset
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=0;
                lb=[x0(1),0,-max(xdata{ind})/10];
                ub=[x0(1)*10,x0(2)*10,max(xdata{ind})/10];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_rise_nobackground_toffset,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                
                % try to estimate uncertainties on the resulting fittd
                % values:
                p=polyfitn(exp(-xdata{ind}(pointstouseforfit)/xfitted(2)),-ydata{ind}(pointstouseforfit),1);
                p2=polyfitn(log(1-ydata{ind}(pointstouseforfit)/xfitted(1)),-xdata{ind}(pointstouseforfit),1);
                
                yfitdata{ind}=exponential_rise_nobackground_toffset(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display(['(',num2str(xfitted(1)),'\pm',num2str(2*p.ParameterStd(1)),')*(1-exp(-(t-',num2str(xfitted(3)),')/(',num2str(xfitted(2)),'\pm',num2str(2*p2.ParameterStd(1)),')))']);
                legendentry=['(',num2str(xfitted(1),'%0.3e'),'\pm',num2str(2*p.ParameterStd(1),'%0.3e'),')*(1-exp(-(t-',num2str(xfitted(3),'%0.3e'),')/(',num2str(xfitted(2),'%0.3e'),'\pm',num2str(2*p2.ParameterStd(1),'%0.3e'),')))'];

            case 4 % exponential fit with background
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(ydata{ind});
                lb=[x0(1)*0.1,0,0];
                ub=[x0(1)*10,x0(2)*10,abs(x0(3))*5];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_rise,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_rise(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*(1-exp(-t/',num2str(xfitted(2)),'))+',num2str(xfitted(3))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*(1-exp(-t/',num2str(xfitted(2),'%0.3e'),'))+',num2str(xfitted(3),'%0.3e')];
            case 5 % linear fit with scaling
                if length(pointstouseforfit)>=(plotparam.polyfitorder+1)
                    [p,~,mu]=polyfit(xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),plotparam.polyfitorder);
                    xfitstart=min(xdata{ind}(pointstouseforfit));
                    xfitend=max(xdata{ind}(pointstouseforfit));
                    xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                    yfitdata{ind}=polyval(p,xfitdata{ind},[],mu);
                    dofitplot=1;
                    legendentry=[];
                    for ind=0:length(plotparam.polyfitorder)
                        if (ind==0)&&p(plotparam.polyfitorder-ind+1)~=0
                            displaytext=[displaytext,num2str(p(plotparam.polyfitorder-ind+1))];
                            legendentry=[legendentry,nicenumber(p(plotparam.polyfitorder-ind+1))];
                        elseif (p(plotparam.polyfitorder-ind+1)>0)&&(ind==1)
                            displaytext=[displaytext,'+',num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')'];
                            legendentry=[legendentry,'+',nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')'];
                        elseif (p(plotparam.polyfitorder-ind+1)<0)&&(ind==1)
                            displaytext=[displaytext,num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')'];
                            legendentry=[legendentry,nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')'];
                        elseif p(plotparam.polyfitorder-ind+1)>0
                            displaytext=[displaytext,'+',num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')^',num2str(ind)];
                            legendentry=[legendentry,'+',nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')^',num2str(ind)];
                        elseif p(plotparam.polyfitorder-ind+1)<0
                            displaytext=[displaytext,num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')^',num2str(ind)];
                            legendentry=[legendentry,nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')^',num2str(ind)];
                        end
                    end
                    display(displaytext);
                    displaytext=[];
    %                 dofitplot=1;
                end
            
            case 6 % exponential fall fit with nobackground
                x0(1)=max(ydata{ind}); x0 = [1.6*10^5,0,2.8*10^3]
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(xdata{ind});
                lb=[x0(1)*0.1,0,0];
                ub=[x0(1)*10,x0(2)*10,x0(3)*5];
                display('fitting...');
%                 fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9,'TolX',1e-10);
%                 xfitted=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind},ydata{ind},lb,ub,fitoptions);
                xfitted=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_fall_nobackground_toffset(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-(t-',num2str(xfitted(3)),')/',num2str(xfitted(2)),')']);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-(t-',num2str(xfitted(3),'%0.3e'),')/',num2str(xfitted(2),'%0.3e'),')'];
           case 7 % gaussian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                x0(1)=max(ydata{ind})-min(ydata{ind});
                [~,maxloc]=max(ydata{ind});
                x0(2)=xdata{ind}(maxloc);
                x0(3)=sum(ydata{ind}-min(ydata{ind}))/x0(1)/2*(max(xdata{ind})-min(xdata{ind}))/length(xdata{ind});
                x0(4)=min(ydata{ind});
                lb=[x0(1)/2,min(xdata{ind}),x0(3)/10,x0(4)-(std(ydata{ind}))];
                ub=[x0(1)*2,max(xdata{ind}),x0(3)*10,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                xfitted=lsqcurvefit(@gaussian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=gaussian(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];
            case 8 % gaussian fit with no background
                x0(1)=max(ydata{ind})-min(ydata{ind});
                [~,maxloc]=max(ydata{ind});
                x0(2)=xdata{ind}(maxloc);
                x0(3)=sum(ydata{ind}-min(ydata{ind}))/x0(1)/2*(max(xdata{ind})-min(xdata{ind}))/length(xdata{ind});
                lb=[x0(1)/2,min(xdata{ind}),x0(3)/10];
                ub=[x0(1)*2,max(xdata{ind}),x0(3)*10];
                display('fitting...');
                xfitted=lsqcurvefit(@gaussian_nobackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=gaussian_nobackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)']);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)'];
             case 9 % exponential fall fit with background
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(xdata{ind});
                x0(4)=min(ydata{ind})/2;
                lb=[x0(1)*0.1,0,0,0];
                ub=[x0(1)*10,x0(2)*10,x0(3)*5,abs(x0(4))*2];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_fall_background_toffset,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                
                
                p2=polyfitn(log((ydata{ind}(pointstouseforfit)-xfitted(4))/xfitted(1)),-xdata{ind}(pointstouseforfit),1);
                
                
                yfitdata{ind}=exponential_fall_background_toffset(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                
                display([num2str(xfitted(1)),'*exp(-(t-',num2str(xfitted(3)),')/(',num2str(xfitted(2)),'\pm',num2str(p2.ParameterStd(1),'%0.3e'),'))+',num2str(xfitted(4))]);
                legendentry=['Caution Fit Sensitive to noise!!!!',num2str(xfitted(1),'%0.3e'),'*exp(-(t-',num2str(xfitted(3),'%0.3e'),')/(',num2str(xfitted(2),'%0.3e'),'\pm',num2str(p2.ParameterStd(1),'%0.3e'),'))+',num2str(xfitted(4),'%0.3e')];
                
            case 10% sectional average
                pointstouseforfit=find((xdata{ind}>=plotparam.xfitmin(ind))&(xdata{ind}<=plotparam.xfitmax(ind)));
                xfitstart=min(xdata{ind}(pointstouseforfit));
                xfitend=max(xdata{ind}(pointstouseforfit));  
                display(['Sectional average : ','x start: ',num2str(xfitstart),'; x stop: ',num2str(xfitend) ]);
                display(['Sectional Mean: S',num2str(seriesnumber(ind)),': ',num2str(mean(ydata{ind}(pointstouseforfit))/1e6,'%0.6f'),' M +/- ',num2str(std(ydata{ind}(pointstouseforfit))/1e6,'%0.6f'), ' M']);
                display(['Sectional Mean: S',num2str(seriesnumber(ind)),': ',num2str(mean(ydata{ind}(pointstouseforfit)),'%0.6f'),' +/- ',num2str(std(ydata{ind}(pointstouseforfit)),'%0.6f'), ' ']);
            
%                 legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-(t-',num2str(xfitted(3),'%0.3e'),')/',num2str(xfitted(2),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 11 % lorentzian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                x0(1)=max(ydata{ind})-min(ydata{ind});
                [~,maxloc]=max(ydata{ind});
                x0(2)=xdata{ind}(maxloc);
                x0(3)=32;
                x0(4)=min(ydata{ind});
                lb=[x0(1)/2,min(xdata{ind}),32/2,x0(4)-(std(ydata{ind}))];
                ub=[x0(1)*2,max(xdata{ind}),32*2,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                xfitted=lsqcurvefit(@lorentzian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=lorentzian(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'/(1+4*((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'/(1+4*((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];

            case 12 % sinusoidal fit with background  yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);
                fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9);
                x0(4)=median(ydata{ind}); %background
                x0(1)=mean((ydata{ind}-x0(4)).^2)^0.5*2^0.5; % amplitude
                
                if isnan(plotparam.sinfitinitialfreq(ind))
                    ac=xcorr(ydata{ind}-x0(4));
    %                 [~,locs,peakwidth,prominence]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    [~,locs,~,~]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    locs=sort(locs);
                    x0(2)=1/mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)));
%                 figure
%                 plot(xdata{ind},ydata{ind},'ko');
%                 figure
%                 plot(ac);
                    locs,
                    mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)))
%                 figure
                else
                    x0(2)=plotparam.sinfitinitialfreq(ind)/1e3;
                end
                
                x0(3)=0;
                lb=[x0(1)/2,x0(2)*0.2,-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2];
                ub=[x0(1)*2,x0(2)*5,2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2];
                display('fitting...');
                xfitted=lsqcurvefit(@sinwithbackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub,fitoptions);
                yfitdata{ind}=sinwithbackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*sin(2*\pi*',num2str(xfitted(2)*1000),'x/1000+',num2str(xfitted(3)),')+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*sin(2*\pi*',num2str(xfitted(2)*1000,'%0.2f'),'x/1000+',num2str(xfitted(3),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 13 % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4);
                fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9);
                x0(4)=median(ydata{ind}); %background
                x0(1)=mean((ydata{ind}-x0(4)).^2)^0.5*2^0.5; % amplitude
                
                if isnan(plotparam.sinfitinitialfreq(ind))
                    ac=xcorr(ydata{ind}-x0(4));
    %                 [~,locs,peakwidth,prominence]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    [~,locs,~,~]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    locs=sort(locs);
                    x0(2)=1/mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)));
%                 figure
%                 plot(xdata{ind},ydata{ind},'ko');
%                 figure
%                 plot(ac);
                    locs,
                    mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)))
%                 figure
                else
                    x0(2)=plotparam.sinfitinitialfreq(ind)/1e3;
                end
                
                x0(3)=0;

                
                x0(5)=1;
                
                lb=[x0(1)/2,x0(2)*0.2,-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2,max(xdata{ind})];
                ub=[x0(1)*2,x0(2)*5,2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2,max(xdata{ind})*20];
                display('decay fitting...');
                xfitted=lsqcurvefit(@sinwithdecayandbackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub,fitoptions);
                yfitdata{ind}=sinwithdecayandbackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-x/',num2str(xfitted(5)),')*sin(2*\pi*',num2str(xfitted(2)*1000),'x/1000+',num2str(xfitted(3)),')+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-x/',num2str(xfitted(5),'%0.3e'),')*sin(2*\pi*',num2str(xfitted(2)*1000,'%0.2f'),'x/1000+',num2str(xfitted(3),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 14 % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4); with uncertainties - version 2
                fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9);
                x0(4)=median(ydata{ind}); %background
                x0(1)=mean((ydata{ind}-x0(4)).^2)^0.5*2^0.5; % amplitude
                
                if isnan(plotparam.sinfitinitialfreq(ind))
                    ac=xcorr(ydata{ind}-x0(4));
    %                 [~,locs,peakwidth,prominence]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    [~,locs,~,~]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    locs=sort(locs);
                    x0(2)=1/mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)));
%                 figure
%                 plot(xdata{ind},ydata{ind},'ko');
%                 figure
%                 plot(ac);
                    locs,
                    mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)))
%                 figure
                else
                    x0(2)=plotparam.sinfitinitialfreq(ind)/1e3;
                end
                
                x0(3)=0;
                x0(5)=1;
                
                lb=[x0(1)/2,x0(2)*0.2,-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2,max(xdata{ind})];
                ub=[x0(1)*2,x0(2)*5,2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2,max(xdata{ind})*20];
                display('decay fitting...');
                xfitted=lsqcurvefit(@sinwithdecayandbackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub,fitoptions);
                
                % now evaluate the uncertainty
                
                lb=[x0(1)/2,max(x0(2)*0.2,xfitted(2)-plotparam.sinfreqrange/1000),-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2,max(xdata{ind})];
                ub=[x0(1)*2,min(x0(2)*5,xfitted(2)+plotparam.sinfreqrange/1000),2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2,max(xdata{ind})*20];
                for trial=1:plotparam.sintrials
                    usedpoints=rand(size(xdata{ind}))>plotparam.sinpointstokill;
                    xdataselected=xdata{ind}(usedpoints);
                    ydataselected=ydata{ind}(usedpoints);
                    
                    [xfittedtest]=lsqcurvefit(@sinwithdecayandbackground,x0,xdataselected,ydataselected,lb,ub,fitoptions);
                    freqval(trial)=xfittedtest(2)*1000;
                end
                
                meanfreq=mean(freqval);
                stdevfreq=std(freqval);
                
                p=polyfitn(1:plotparam.sintrials,freqval,0);
                xfreqfitdata=1:(plotparam.sintrials-1)/1000:plotparam.sintrials;
                yfreqfitdata=polyvaln(p,xfreqfitdata);
%                 freqdisplaytext=['(',num2str(p.Coefficients(1)),'\pm',num2str(2*p.ParameterStd(1)),')'];
%                 freqlegendentry=['(',nicenumber(p.Coefficients(1)),'\pm',num2str(2*p.ParameterStd(1)),')'];
                freqdisplaytext=['(',num2str(meanfreq),'\pm',num2str(2*stdevfreq),')'];
                freqlegendentry=['(',nicenumber(meanfreq),'\pm',num2str(2*stdevfreq),')'];
                display(freqdisplaytext);
                
                plot(1:plotparam.sintrials,freqval,'ko',xfreqfitdata,yfreqfitdata,'r');
                title(['Frequency estimates dropping ',num2str(plotparam.sinpointstokill*100),'% of points randomly']);
                xlabel('Trial');
                ylabel('Fitted Frequency [Hz]');
                freqlegend={'Fitted frequency estimates',freqlegendentry};
                legend(freqlegend,'Location','southoutside','FontSize',plotparam.legendfontsize);
                figure;
                
                yfitdata{ind}=sinwithdecayandbackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-x/',num2str(xfitted(5)),')*sin(2*\pi*',num2str(xfitted(2)*1000),'x/1000+',num2str(xfitted(3)),')+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-x/',num2str(xfitted(5),'%0.3e'),')*sin(2*\pi*',num2str(xfitted(2)*1000,'%0.2f'),'x/1000+',num2str(xfitted(3),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 15 % exponential fall fit with nobackground
                x0 = plotparam.start;
                ub=plotparam.upperbound;
                lb=plotparam.lowerbound ;
                display('fitting...');
%                 fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9,'TolX',1e-10);
%                 xfitted=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind},ydata{ind},lb,ub,fitoptions);
                [xfitted,resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@exponential_fall_nobackground_toffset_noDelay,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                
                yfitdata{ind}=exponential_fall_nobackground_toffset_noDelay(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-(t)/',num2str(xfitted(2)),')']);
                legendentry=['(',num2str(xfitted(1),'%0.3e'),'\pm',num2str(expSigma(1),'%0.3e'),')','*exp(-t/(',num2str(xfitted(2),'%0.3e'),'\pm',num2str(expSigma(2),'%0.3e'),'))'];
             case 16 % Abs spectra  yfit=-x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                [a,b] = min(ydata{ind})
                x0 = [-max(ydata{ind}), xdata{ind}(b),0.02,max(ydata{ind})] 
                lb=[x0(1)*2,min(xdata{ind}),-30002,x0(4)-(std(ydata{ind}))];
                ub=[-x0(1)*2,max(xdata{ind}),30002*2,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                 [xfitted,resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@lorentzian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                yfitdata{ind}=lorentzian(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'/(1+4*((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'/(1+4*((x-',num2str(xfitted(2),'%0.5e'),'\pm',num2str(expSigma(2),'%0.3e'),')/(',num2str(xfitted(3),'%0.3e'),'\pm',num2str(expSigma(3),'%0.3e'),'))^2)+',num2str(xfitted(4),'%0.3e')];
                xfitted(2)
            case 26
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(ydata{ind});
                lb=[x0(1)/2,0,0];
                ub=[x0(1)*10,x0(2)*10,x0(3)*5];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_fall_background_NotoffsetV22,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_rise(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*(1-exp(-t/',num2str(xfitted(2)),'))+',num2str(xfitted(3))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*(1-exp(-t/',num2str(xfitted(2),'%0.3e'),'))+',num2str(xfitted(3),'%0.3e')];
        



        end
        
  
    [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,legendentry,doPlotoptions ); % Generatews the string to display the fiting
    
    end
if ( plotparam.savedata )    
    saveData (plotparam ,ydata{ind}.',xdata{ind}.',ind,seriesnumber)
end
end


doPlotoptions=1;

[plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,'',doPlotoptions ); % Generatews the string to display the fiting

% eval(evalstring); %This bit is displaying the data. Its running a ploting comand
if (plotparam.averagerepetions)
    hold on
    for k = 1:length(evalstringErrorbar)
        eval(evalstringErrorbar{k})
    end
    hold off
else
    eval(evalstring)
end
if ~isempty(plotparam.legendtext)
    legend(plotparam.legendtext,'Location',plotparam.legendlocation,'FontSize',plotparam.legendfontsize)
end
if plotparam.logyscale
    set(gca,'YScale','log');
    
end
    



title(plotparam.title,'FontSize',plotparam.titlefontsize);
xlabel(plotparam.xlabel,'FontSize',plotparam.xaxisfontsize);
ylabel(plotparam.ylabel,'FontSize',plotparam.yaxisfontsize);

return

end




function [yfit]=exponential_rise(x,xdata)

yfit=x(1)*(1-exp(-xdata/x(2)))+x(3);

end

function [yfit]=exponential_rise_nobackground(x,xdata)

yfit=x(1)*(1-exp(-xdata/x(2)));

end

function [yfit]=gaussian(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithbackground(x,xdata)

yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithdecayandbackground(x,xdata)

yfit=x(1)*exp(-xdata/x(5)).*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=lorentzian(x,xdata)

yfit=x(1)./(1+4*((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end


function [yfit]=gaussian_nobackground(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2);

end

function [yfit]=modefit(x,model,data)

yfit=sum(sum(abs((x(1)*model+x(2)-data))));

end

function [yfit]=exponential_rise_nobackground_toffset(x,xdata)

yfit=x(1)*(1-exp(-(xdata-x(3))/x(2)));

end
function [yfit]=exponential_fall_nobackground_toffset_noDelay(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2));

end
function [yfit]=exponential_fall_nobackground_toffset(x,xdata)

yfit=x(1)*exp(-(xdata-x(3))/x(2));

end

function [yfit]=exponential_fall_background_toffset(x,xdata)

yfit=x(1)*exp(-(xdata-x(3))/x(2))+x(4);

end
function [yfit]=exponential_fall_background_Notoffset(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2))+x(4);

end

function [yfit]=exponential_fall_background_NotoffsetV22(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2))+x(3);

end
function [output]=nicenumber(value)

if (abs(value)<0.01)||(abs(value)>10000)
    output=num2str(value,'%0.3e');
else
    output=num2str(value,'%0.6f');
end

end
function [savename] = saveData (plotparams,ydata,xdata,ind,seriesnumber)
    filename = plotparams.filename;
    Selection =plotparams.datasection-1;
    path = [plotparams.filepath,'\Data'];
    
    currentfile=strcat(plotparams.RunningFolder, '.m');

    ScrDirectory = [path,'\',filename(1:end -2)]
    if ~exist(ScrDirectory, 'dir') % If target directory doesnt exist
        if isempty(strfind(currentfile,'\Scripts')) == 1 % The script is not saved on the scripts folder
            mkdir(ScrDirectory) ;  % Create directory and save the data
        end
    
    end 
    if isempty(strfind(currentfile,'\Scripts')) == 1 % The script is not saved on the scripts folder
        savedataboolean = true; 
    else
        savedataboolean = false;
    end
    filenameydata = ['YdataS',num2str(seriesnumber(ind)),'Variable',num2str(Selection),'.csv']
    filenamexdata = ['XdataS',num2str(seriesnumber(ind)),'Variable',num2str(Selection),'.csv']

    savenameydata = [ScrDirectory,'\',filenameydata]
    savenamexdata = [ScrDirectory,'\',filenamexdata]

    if ( savedataboolean )
        display(['Datay saved in /n',savenameydata]);
        display(['Datax saved in /n',savenamexdata])
        save (savenameydata,'ydata','-ascii')
        save (savenamexdata,'xdata','-ascii');
    end
end
function [croppedPic,fileName] = LoadVisionDataTGA (currentDayDirectory,seriesNumber,visionPictNbCount,plotparam,makeROIBool)
    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);
    fileName=[currentDayDirectory '\S' num2str(seriesNumber) '\P' num2str(visionPictNbCount,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.tga'];

    if exist(char(fileName),'file')
        %pause(0.5);

        % load vision data
        [referencePic, newdata, raw, probe]=loadvisionpictureTGA(currentDayDirectory, seriesNumber, visionPictNbCount, cameraNumber);
        referencePic=max(-referencePic,0);

        % determine ROIs
        backgroundROIdatafilename=[currentDayDirectory '\backgroundROIdata_' 'S' num2str(seriesNumber) '.mat'];
        configFolder = [currentDayDirectory ,'\optimizationData\','S',num2str(seriesNumber),'\'];
        [rectInner, rectOuter, croppedReferencePic, croppedReferenceOuterPic] = determineROIPictureTGA(referencePic, backgroundROIdatafilename, makeROIBool,plotparam);

        % load picture
        MaxOD = 5;
        Pic = min(MaxOD, -log(max(0.0000000000001, raw ./ probe)));
        croppedPic=Pic((rectInner(2)+1):(rectInner(2)+rectInner(4)),(rectInner(1)+1):(rectInner(1)+rectInner(3)));
        croppedOuterPic=Pic((rectOuter(2)+1):(rectOuter(2)+rectOuter(4)),(rectOuter(1)+1):(rectOuter(1)+rectOuter(3)));


        isInnerInsideOuterBool = (rectOuter(1) < rectInner(1)) && ((rectOuter(1)+rectOuter(3)) > (rectInner(1)+rectInner(3))) && (rectOuter(2) < rectInner(2)) && ((rectOuter(2)+rectOuter(4)) > (rectInner(2)+rectInner(4)));
        if isInnerInsideOuterBool
            referenceBackgroundMean=(sum(sum(croppedOuterPic))-sum(sum(croppedPic)))/(numel(croppedOuterPic)-numel(croppedPic));
        else
            isOuterAbitInsideInnerBool1 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) );
            isInnerAbitInsideOuterBool1 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) );
            isOuterAbitInsideInnerBool2 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) );
            isInnerAbitInsideOuterBool2 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) );
            if (isOuterAbitInsideInnerBool1 || isInnerAbitInsideOuterBool1 || isOuterAbitInsideInnerBool2 || isInnerAbitInsideOuterBool2)
                error('Bad choice of ROIs!');
            else
                referenceBackgroundMean= sum(sum(croppedOuterPic)) / numel(croppedOuterPic);
            end
        end
        croppedPic=max(0,croppedPic - referenceBackgroundMean);


    end


end
function [difference,newdata,raw,probe]=loadvisionpictureTGA(directory,seriesnumber,imagenumber,cameranumber)

    if seriesnumber>0
        directoryAux=[directory '\S' num2str(seriesnumber)];
    end


    atomsdata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'A' num2str(cameranumber-1) '.tga']);
    noisedata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'N' num2str(cameranumber-1) '.tga']);
    probedata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'P' num2str(cameranumber-1) '.tga']);
    otherdata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'O' num2str(cameranumber-1) '.tga']);

    if ~isempty(atomsdata)
        newdata=1;
        raw=(atomsdata-noisedata);
        probe=(probedata-noisedata);
        difference=raw-probe;
    else
        newdata=0;
end
end


function  [rectIn, rectOut, croppedRefPic, croppedRefOuterPic] = determineROIPictureTGA(refPic, bckgndROIdatafileName, mkROIBool,plotparam)

global Data;

if  mkROIBool % 0 ask for background ROI data only if no previous data available, 1 ask allways
    warning('off');
    maxPic = max(max(refPic));
    minPic = min(min(refPic));
    
    initFig=figure;
    %display('Waiting for input');
    set(initFig,'Name','Select rectange containing signal');
    [croppedRefPic, rectIn] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    set(initFig,'Name','Select rectange including background');
    [croppedRefOuterPic, rectOut] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    %display('Background region defined');
    close(initFig);

    rectIn=round(rectIn);
    rectIn(1)=max(0, min(size(refPic, 2) - 1, rectIn(1)));
    rectIn(2)=max(0, min(size(refPic, 1) - 1 , rectIn(2)));
    rectIn(3)=max(1, min(size(refPic, 2) - rectIn(1), rectIn(3)));
    rectIn(4)=max(1, min(size(refPic, 1) - rectIn(2), rectIn(4)));

    rectOut=round(rectOut);
    rectOut(1)=max(0, min(size(refPic, 2) - 1, rectOut(1)));
    rectOut(2)=max(0, min(size(refPic, 1) - 1, rectOut(2)));
    rectOut(3)=max(1, min(size(refPic, 2) - rectOut(1), rectOut(3)));
    rectOut(4)=max(1, min(size(refPic, 1) - rectOut(2), rectOut(4)));

    %oldRectIn=rectIn;
    %rectIn(1)=max(rectIn(1), rectOut(1));
    %rectIn(2)=max(rectIn(2), rectOut(2));
    %rectIn(3)=min(oldRectIn(1) + rectIn(3), rectOut(1) + rectOut(3)) - rectIn(1);
    %rectIn(4)=min(oldRectIn(2) + rectIn(4), rectOut(2) + rectOut(4)) - rectIn(2);
    warning('on');
    save(bckgndROIdatafileName,'rectIn','rectOut');
    timeOfDat = datestr(now,'dd-mmm-yyyy-HH-MM-SS');
    
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    save(Folder,'rectIn','rectOut');
    Data.rectIn = rectIn;
    Data.rectOut = rectOut;
else 
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    load(Folder);
    croppedRefPic = refPic((rectIn(2)+1):(rectIn(2)+rectIn(4)),(rectIn(1)+1):(rectIn(1)+rectIn(3)));
    croppedRefOuterPic = refPic((rectOut(2)+1):(rectOut(2)+rectOut(4)),(rectOut(1)+1):(rectOut(1)+rectOut(3)));
end




end
function [returnPath]=returnFileName(FileDirectory,Filename)

    % close all
    format shortg
    timeOfDat = clock;
    breakLoop = 0;
    version = 1;
    if ~isempty(strfind(FileDirectory, 'Scripts\Scripts'))
        filenamereturn = ['Background_',Filename,'.mat' ];
        l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l)];
        returnPath = [FileDirectoryShort,filenamereturn];  
    else
        while breakLoop == 0 

            filename =['runmme',num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1)),'Scr',num2str(version,'%04i'),'.m'];

            l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l),'Scripts\'];
            FolderName = [num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1))];
            FolderName = [FileDirectoryShort,FolderName];
            currentfile=strcat(FileDirectory, '.m');
            if ~exist(FolderName, 'dir')
                if isempty(strfind(currentfile,'\Scripts')) == 1
                    mkdir(FolderName);      
                end

            end
            FilePath = [FolderName,'\',filename];    
            if exist(FilePath, 'file') == 2
                version = version + 1;
            else
                breakLoop = 1;
            end
            filenamereturn = ['Background_',filename,'at' ];
            returnPath = [FolderName,'\',filenamereturn];   
        end
    end

end



function [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab ] = calculateExperimentalValues (filename,croppedPic)
    
    global ctePlanck hbarre cLum kB aB MuB hartree Mu0 Epsilon0 au eElec gForce Debye Na
    global ctePlanckOverAu auOverCtePlanck ctePlanckOverkB kBOverCtePlanck auOverkB kBOverAu hbarreOverAu hbarreOverkB hbarreOverMuB MuBOverHbarre
    global mSr88 mSr87 mSr86 mSr84
    
    UsefulConstants;
    if ( ~isempty(strfind(filename, 'AA'))) % USE MOT side camera calibration
        xCalSr = 4.48 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4.48 * 10^(-6);
    elseif  ( ~isempty(strfind(filename, 'BA'))) % USE MOT TOP camera calibration
        xCalSr = 4 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4 * 10^(-6);  
    elseif  ( ~isempty(strfind(filename, 'CA'))) % USE Capture MOT
        xCalSr = 4 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4 * 10^(-6);
    end
    
    effVolume = (100e-6 * 100e-6 * 100e-6); %estimation of the characteristic size of the cloud (to estimate the density) (in m^3)
    wxSr = 2 * pi * 100; %estimation of the trapping frequency
    wySr = 2 * pi * 200;
    wzSr = 2 * pi * 100;
    mAssSr = mSr88;
    lamdaSr = 461. * 10^(-9); %(in m)   

    atomNumberTab= [];
    effTemperatureTab= [];
    effTemperature1DXTab= [];
    effTemperature1DYTab= [];
    calculatedCostTab= [];
    
    
    % calculate the atom number
    absCrossSr = (3*(lamdaSr.^2))./(2*pi); % (m^2)
    numberCal = (yCalSr*xCalSr) / absCrossSr;
    TotalMatNb = sum(sum(croppedPic)); %total optical density in the image
    atomNumber = TotalMatNb * numberCal;

    % calculate the center of mass in x and y
    [sizey, sizex] = size(croppedPic);
    CoordAuxX = 1:1:sizex;
    CoordAuxY = 1:1:sizey;
    croppedPicX = sum(croppedPic,1);
    croppedPicY = sum(croppedPic,2)';
    centerOfMassX = croppedPicX * CoordAuxX' /TotalMatNb;
    centerOfMassY = croppedPicY * CoordAuxY' /TotalMatNb;

    %calculate effective temperature                
    EnergyPerPartRaw = (xCalSr * yCalSr)^2 * ((CoordAuxY-centerOfMassY).^2) * (croppedPic) * ((CoordAuxX'-centerOfMassX).^2) / TotalMatNb; % effective temperature, by 2nd order momentum calculation of image
    effTemperature = 4 / pi * mAssSr * (wxSr*wySr)^(2/2)* auOverkB * EnergyPerPartRaw * atomNumber / 2; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DX = (xCalSr)^3 * numberCal *((CoordAuxX-centerOfMassX).^2) * croppedPicX' / sizey / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DX =  4 / pi * mAssSr * wxSr^2 * auOverkB * EnergyPerPartRaw1DX * atomNumber; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DY = (yCalSr)^3 * numberCal *((CoordAuxY-centerOfMassY).^2) * croppedPicY' / sizex / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DY =  4 / pi * mAssSr * wySr^2 * auOverkB * EnergyPerPartRaw1DY * atomNumber; % effective temperature, by 2nd order momentum calculation of image


    
    
    display(['Evaluating ', filename]);
%     fprintf('Number of atoms: %.0f\n', atomNumber);
%     fprintf('Temperature: %.3f muK\n', effTemperature * 10^6);
%     fprintf('Temperature 1D in X: %.3f muK\n', effTemperature1DX * 10^6);
%     fprintf('Temperature 1D in Y: %.3f muK\n', effTemperature1DY * 10^6);




    atomNumberTab = [atomNumberTab, atomNumber];
    effTemperatureTab = [effTemperatureTab, effTemperature];
    effTemperature1DXTab = [effTemperature1DXTab, effTemperature1DX];
    effTemperature1DYTab = [effTemperature1DYTab, effTemperature1DY];
end
function [todayDirectory, fileName] = findNextFileBMP(todayDirectory,  seriesnumber, dataNumber, plotparam)

    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);



    fileName='';
    notfound=1;
    StopBoolean = false;
    try
        if seriesnumber>0
            fileName=[todayDirectory '\S' num2str(seriesnumber) '\P' num2str(dataNumber,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.bmp'];
            if ~exist(fileName,'file')
                StopBoolean = true;
            end
    %             if ~isempty(nameOverride)
    %                 fileName=[directory,'\S',num2str(seriesnumber),'\',nameOverride,'.dat'];
    %             end    
            %fid=fopen(fileName);
            %data=char(fread(fid).');
            notfound=0;
            %fclose(fid);
        else
            fileName=[todayDirectory '\P' num2str(dataNumber,'%04i') cameraLetter 'A0' '.bmp'];
    %             if ~isempty(nameOverride)
    %                 fileName=[directory,'\',nameOverride,'.dat'];
    %             end
    %             fid=fopen(fileName);
    %             data=char(fread(fid).');
            notfound=0;
    %             fclose(fid);
        end
    end


    if (notfound==1)
        error(['File note found: ',fileName]);
        
    end
end

function [parameter] = SetDefaultValues (plotparam ,seriesnumber )

    if isempty(plotparam.xlabel)
        plotparam.xlabel=lastxlabelname;
    end

    if length(plotparam.xoffset)==1
        plotparam.xoffset=plotparam.xoffset*ones(size(seriesnumber));
    end
    if length(plotparam.xscale)==1
        plotparam.xscale=plotparam.xscale*ones(size(seriesnumber));
    end
    if length(plotparam.yscale)==1
        plotparam.yscale=plotparam.yscale*ones(size(seriesnumber));
    end
    if length(plotparam.yoffset)==1
        plotparam.yoffset=plotparam.yoffset*ones(size(seriesnumber));
    end
    if length(plotparam.sinfitinitialfreq)==1
        plotparam.sinfitinitialfreq=plotparam.sinfitinitialfreq*ones(size(seriesnumber));
    end
    parameter =  plotparam;
end

function [parameter, datax ,datay] = ScaleData(plotparam, datax,datay,ind,seriesnumber)

  datax=(datax-plotparam.xoffset(ind));
    if plotparam.xscaleinvert
        datax=1./datax;
    end
    if plotparam.xscalesquare
        datax=(datax).^2;
    end
    if plotparam.yscalesquare
        datay=(datay).^2;
    end 
    if plotparam.Testimate
        datay=(datay).^2;
        datay =  datay./400;
        datay =  datay*0.010665 * 10^6;
        
    end
    
    if length(plotparam.xscale)==length(seriesnumber)
        datax=datax*plotparam.xscale(ind);
    end
    if length(plotparam.yscale)==length(seriesnumber)
        datay=datay*plotparam.yscale(ind);
    end
    if length(plotparam.yoffset)==length(seriesnumber)
        datay=datay+plotparam.yoffset(ind);
    end
    if plotparam.removenegative
        datax=datax(datay>0);
        datay=datay(datay>0);
    end   
    parameter= plotparam;
end




function [plotparam,evalstringErrorbar] =   GeneratePlotingComandErrorBar(plotparam,seriesnumber,ind ,dofitplot,legendentry ,doPlotoptions) % Generates the string use for plotting errorbar
Errorbarstring='errorbar(';
if doPlotoptions
        if isempty(plotparam.plotoptions)
            evalstringErrorbar=[Errorbarstring(1:(end-1)),');'];
        else
            evalstringErrorbar=[Errorbarstring,'''MarkerSize'',20);'];
        end
    else

        if length(plotparam.linecolour)>=length(seriesnumber)
            evalstringErrorbar=[Errorbarstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},YdataErrorBar{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linestyle,''')'];
        else
            evalstringErrorbar=[Errorbarstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},YdataErrorBar{',num2str(ind),'},''',plotparam.linestyle,''')'];
        end
                
    end
    
    





end
function [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,legendentry ,doPlotoptions) % Generates the string use for plotting

    
    

    
    if doPlotoptions
        if isempty(plotparam.plotoptions)
            evalstring=[evalstring(1:(end-1)),');'];
        else
            evalstring=[evalstring,'''MarkerSize'',20);'];
        end
    else
        if dofitplot
            if (length(plotparam.linecolour)>=length(seriesnumber))
                evalstring=[evalstring,'xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linefitstyle,''','];
            else
                evalstring=[evalstring,'xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linefitstyle,''','];
            end
            if (length(plotparam.legendtext)>=2*ind)
                for temp=length(plotparam.legendtext):-1:2*ind
                    plotparam.legendtext{temp+1}=plotparam.legendtext{temp};
                end
            end
            plotparam.legendtext{2*ind}=legendentry;
        else
            if length(plotparam.linecolour)>=length(seriesnumber)
                evalstring=[evalstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linestyle,''','];
            else
                evalstring=[evalstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},''',plotparam.linestyle,''','];
            end
        end        
    end
    
    

    
       
    
end

function [plotparam,xdata] = formatfitinginputs (plotparam,xdata,seriesnumber)
    if length(plotparam.xpolyfitval)>1;
        xnew=plotparam.xpolyfitval(end);
        for polyind=2:length(plotparam.xpolyfitval)
            xnew=xnew+xdata.^(polyind-1)*plotparam.xpolyfitval(end-polyind+1);
        end
        xdata=xnew;
    end


  
    if length(plotparam.xfitmin)==1
        plotparam.xfitmin=plotparam.xfitmin*ones(size(seriesnumber));
    end
    if length(plotparam.xfitmax)==1
        plotparam.xfitmax=plotparam.xfitmax*ones(size(seriesnumber));
    end
    
end


