function [xdata,ydata,xlabelname,directory,C,newydata]=loadvisionseriesdata(inputdate,seriesnumber,datasection,xdatasection,cameranumber,nameoverride)

basedirectorylist={'S:\Vision\','Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Data\','Q:\qgases\groups\strontium\SrCAL\Data\SSBEC\','Q:\qgases\groups\strontium\SrCAL\Papers\Fermionic MOT\DATA','Y:\Vision\','Y:\Backup\','S:\Backup\','F:\Vision\','G:\Vision\','D:\Vision\','E:\Vision\'};

if nargin<6
    nameoverride='';
end
if nargin<5
    cameranumber=1;
end
if nargin<4
    xdatasection=5;
end
if nargin<3
    datasection=12;
end

cameraletter=char('A'-1+cameranumber);
notfound=1;

for basedirectoryind=1:length(basedirectorylist)
    directory=[basedirectorylist{basedirectoryind},inputdate];
    try
        if seriesnumber>0
            filename=[directory,'\S',num2str(seriesnumber),'\Data',cameraletter,'.dat'];
            if ~isempty(nameoverride)
                filename=[directory,'\S',num2str(seriesnumber),'\',nameoverride,'.dat'];
            end    
            fid=fopen(filename);data=char(fread(fid).');
            notfound=0;
            break
        else
            filename=[directory,'\Data',cameraletter,'.dat'];
            if ~isempty(nameoverride)
                filename=[directory,'\',nameoverride,'.dat'];
            end
            fid=fopen(filename);data=char(fread(fid).');
            notfound=0;
            break
        end
    end
    notfound=1;
end
if (notfound==1)&&(basedirectoryind==length(basedirectorylist))
    error(['File note found: ',filename]);
end

fclose(fid);

BOL=find(data==13);

headers=strsplit(data((BOL(1)+1):(BOL(2))));
SequenceTitle=data(1:BOL(1));
xlabelname=headers{5};

ydata=zeros([1,length(BOL)-2]);
xdata=zeros([length(xdatasection),length(BOL)-2]);
ia=zeros(size(xdata));
ic=zeros(size(xdata));

for ind=3:length(BOL)
    thisline=strsplit(data((BOL(ind-1)+1):(BOL(ind))));
    for xsec=1:length(xdatasection),
        xdata(xsec,ind-2)=str2double(thisline{xdatasection(xsec)});
    end
    if (datasection==4)
        ydata(ind-2)=str2double(thisline{datasection}(end));
    else
        ydata(ind-2)=str2double(thisline{datasection});
        
    end
end

% meshstring1='[';
% meshstring2=']=meshgrid(';

if length(xdatasection)>1
    for ind=1:length(xdatasection)
        [C{ind},~,ic(ind,:)]=unique(xdata(ind,:));
%         meshstring1=[meshstring1,'newxdata{',num2str(ind),'},'];
%         meshstring2=[meshstring2,'C{',num2str(ind),'},'];
        newxdatasize(ind)=length(C{ind}); %#ok<AGROW>
    end
%     eval([meshstring1(1:(end-1)),meshstring2(1:(end-1)),');']);
    newydata=zeros(newxdatasize);
    newydatacount=zeros(newxdatasize);
    
    for ind2=1:length(ydata)
        newydatacount(ic(1,ind2),ic(2,ind2))=newydatacount(ic(1,ind2),ic(2,ind2))+1;
        newydata(ic(1,ind2),ic(2,ind2))=newydata(ic(1,ind2),ic(2,ind2))+ydata(ind2);
    end
    newydata(newydatacount>0)=newydata(newydatacount>0)./newydatacount(newydatacount>0);
end


return
