function [croppedPic,fileName,rectInner,rectOuter] = LoadVisionDataTGA (currentDayDirectory,seriesNumber,visionPictNbCount,plotparam,makeROIBool,rectInner,rectOuter)
    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);
    fileName=[currentDayDirectory '\S' num2str(seriesNumber) '\P' num2str(visionPictNbCount,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.tga'];

    if exist(char(fileName),'file')
        %pause(0.5);

        % load vision data
        [referencePic, newdata, raw, probe]=loadvisionpictureTGA(currentDayDirectory, seriesNumber, visionPictNbCount, cameraNumber);
        if (~plotparam.isFluoresencePic)
            referencePic=max(-referencePic,0);
        else
            referencePic=min(-referencePic,0);
        end
        % determine ROIs
        backgroundROIdatafilename=[currentDayDirectory '\backgroundROIdata_' 'S' num2str(seriesNumber) '.mat'];
        [rectInner, rectOuter, croppedReferencePic, croppedReferenceOuterPic] = determineROIPictureTGA(referencePic, backgroundROIdatafilename, makeROIBool,plotparam);

        % load picture
        MaxOD = 5;
         if (plotparam.isFluoresencePic)
             Pic =  raw - probe;
         else
            Pic = min(MaxOD, -log(max(0.0000000000001, raw ./ probe)));
         end
        croppedPic=Pic((rectInner(2)+1):(rectInner(2)+rectInner(4)),(rectInner(1)+1):(rectInner(1)+rectInner(3)));
        croppedOuterPic=Pic((rectOuter(2)+1):(rectOuter(2)+rectOuter(4)),(rectOuter(1)+1):(rectOuter(1)+rectOuter(3)));


        isInnerInsideOuterBool = (rectOuter(1) < rectInner(1)) && ((rectOuter(1)+rectOuter(3)) > (rectInner(1)+rectInner(3))) && (rectOuter(2) < rectInner(2)) && ((rectOuter(2)+rectOuter(4)) > (rectInner(2)+rectInner(4)));
        if isInnerInsideOuterBool
            referenceBackgroundMean=(sum(sum(croppedOuterPic))-sum(sum(croppedPic)))/(numel(croppedOuterPic)-numel(croppedPic));
        else
            isOuterAbitInsideInnerBool1 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) );
            isInnerAbitInsideOuterBool1 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) );
            isOuterAbitInsideInnerBool2 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) );
            isInnerAbitInsideOuterBool2 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) );
            if (isOuterAbitInsideInnerBool1 || isInnerAbitInsideOuterBool1 || isOuterAbitInsideInnerBool2 || isInnerAbitInsideOuterBool2)
                error('Bad choice of ROIs!');
            else
                referenceBackgroundMean= sum(sum(croppedOuterPic)) / numel(croppedOuterPic);
            end
        end
        croppedPic=max(0,croppedPic - referenceBackgroundMean);
        

    end


end



function  [rectIn, rectOut, croppedRefPic, croppedRefOuterPic] = determineROIPictureTGA(refPic, bckgndROIdatafileName, mkROIBool,plotparam)

global Data;

if  mkROIBool % 0 ask for background ROI data only if no previous data available, 1 ask allways
    warning('off');
    maxPic = max(max(refPic));
    minPic = min(min(refPic));
    
    initFig=figure;
    %display('Waiting for input');
    set(initFig,'Name','Select rectange containing signal');
    [croppedRefPic, rectIn] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    set(initFig,'Name','Select rectange including background');
    [croppedRefOuterPic, rectOut] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    %display('Background region defined');
    close(initFig);

    rectIn=round(rectIn);
    rectIn(1)=max(0, min(size(refPic, 2) - 1, rectIn(1)));
    rectIn(2)=max(0, min(size(refPic, 1) - 1 , rectIn(2)));
    rectIn(3)=max(1, min(size(refPic, 2) - rectIn(1), rectIn(3)));
    rectIn(4)=max(1, min(size(refPic, 1) - rectIn(2), rectIn(4)));

    rectOut=round(rectOut);
    rectOut(1)=max(0, min(size(refPic, 2) - 1, rectOut(1)));
    rectOut(2)=max(0, min(size(refPic, 1) - 1, rectOut(2)));
    rectOut(3)=max(1, min(size(refPic, 2) - rectOut(1), rectOut(3)));
    rectOut(4)=max(1, min(size(refPic, 1) - rectOut(2), rectOut(4)));

    %oldRectIn=rectIn;
    %rectIn(1)=max(rectIn(1), rectOut(1));
    %rectIn(2)=max(rectIn(2), rectOut(2));
    %rectIn(3)=min(oldRectIn(1) + rectIn(3), rectOut(1) + rectOut(3)) - rectIn(1);
    %rectIn(4)=min(oldRectIn(2) + rectIn(4), rectOut(2) + rectOut(4)) - rectIn(2);
    warning('on');
    save(bckgndROIdatafileName,'rectIn','rectOut');
    timeOfDat = datestr(now,'dd-mmm-yyyy-HH-MM-SS');
    
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    save(Folder,'rectIn','rectOut');
    Data.rectIn = rectIn;
    Data.rectOut = rectOut;
else 
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    load(Folder);
    croppedRefPic = refPic((rectIn(2)+1):(rectIn(2)+rectIn(4)),(rectIn(1)+1):(rectIn(1)+rectIn(3)));
    croppedRefOuterPic = refPic((rectOut(2)+1):(rectOut(2)+rectOut(4)),(rectOut(1)+1):(rectOut(1)+rectOut(3)));
end




end

function [returnPath]=returnFileName(FileDirectory,Filename)

    % close all
    format shortg
    timeOfDat = clock;
    breakLoop = 0;
    version = 1;
    if ~isempty(strfind(FileDirectory, 'Scripts\Scripts'))
        filenamereturn = ['Background_',Filename,'.mat' ];
        l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l)];
        returnPath = [FileDirectoryShort,filenamereturn];  
    else
        while breakLoop == 0 

            filename =['runmme',num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1)),'Scr',num2str(version,'%04i'),'.m'];

            l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l),'Scripts\'];
            FolderName = [num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1))];
            FolderName = [FileDirectoryShort,FolderName];
            currentfile=strcat(FileDirectory, '.m');
            if ~exist(FolderName, 'dir')
                if isempty(strfind(currentfile,'\Scripts')) == 1
                    mkdir(FolderName);      
                end

            end
            FilePath = [FolderName,'\',filename];    
            if exist(FilePath, 'file') == 2
                version = version + 1;
            else
                breakLoop = 1;
            end
            filenamereturn = ['Background_',filename,'at' ];
            returnPath = [FolderName,'\',filenamereturn];   
        end
    end

end

function [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab,centerOfMassX,centerOfMassY ,Spreadx,Spready ] = calculateExperimentalValues (params,filename,croppedPic)
    
    global ctePlanck hbarre cLum kB aB MuB hartree Mu0 Epsilon0 au eElec gForce Debye Na
    global ctePlanckOverAu auOverCtePlanck ctePlanckOverkB kBOverCtePlanck auOverkB kBOverAu hbarreOverAu hbarreOverkB hbarreOverMuB MuBOverHbarre
    global mSr88 mSr87 mSr86 mSr84
    
    UsefulConstants;
    BaseStrontium;
    if ( ~isempty(strfind(filename, 'AA'))) % USE MOT side camera calibration
        xCalSr = 4.48 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4.48 * 10^(-6);
    elseif  ( ~isempty(strfind(filename, 'BA'))) % USE MOT TOP camera calibration
        xCalSr = 4 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4 * 10^(-6);  
    elseif  ( ~isempty(strfind(filename, 'CA'))) % USE Capture MOT
        xCalSr = 14.32 * 10^(-6);  %camera resolution m/pix
        yCalSr = 14.32 * 10^(-6);
    end
    
    effVolume = (100e-6 * 100e-6 * 100e-6); %estimation of the characteristic size of the cloud (to estimate the density) (in m^3)
    wxSr = 2 * pi * 100; %estimation of the trapping frequency
    wySr = 2 * pi * 200;
    wzSr = 2 * pi * 100;
    mAssSr = mSr88;
    lamdaSr = 461. * 10^(-9); %(in m)   

    atomNumberTab= [];
    effTemperatureTab= [];
    effTemperature1DXTab= [];
    effTemperature1DYTab= [];

    
    
    % calculate the atom number
    cte = 1 + 4*params.lightDetunning^2;
    absCrossSr = (3*(lamdaSr.^2))./(2*pi)/cte; % (m^2)
    numberCal = (yCalSr*xCalSr) / absCrossSr;
    TotalMatNb = sum(sum(croppedPic)); %total optical density in the image

    atomNumber = TotalMatNb * numberCal;
    % calculate the center of mass in x and y
    [sizey, sizex] = size(croppedPic);
    CoordAuxX = 1:1:sizex;
    CoordAuxY = 1:1:sizey;
    croppedPicX = sum(croppedPic,1);
    croppedPicY = sum(croppedPic,2)';
    centerOfMassX = croppedPicX * CoordAuxX' /TotalMatNb ;
    centerOfMassY = croppedPicY * CoordAuxY' /TotalMatNb ;

    %calculate effective temperature                
    EnergyPerPartRaw = (xCalSr * yCalSr)^2 * ((CoordAuxY-centerOfMassY).^2) * (croppedPic) * ((CoordAuxX'-centerOfMassX).^2) / TotalMatNb; % effective temperature, by 2nd order momentum calculation of image
    effTemperature = 4 / pi * mAssSr * (wxSr*wySr)^(2/2)* auOverkB * EnergyPerPartRaw * atomNumber / 2; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DX = (xCalSr)^3 * numberCal *((CoordAuxX-centerOfMassX).^2) * croppedPicX' / sizey / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DX =  4 / pi * mAssSr * wxSr^2 * auOverkB * EnergyPerPartRaw1DX * atomNumber; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DY = (yCalSr)^3 * numberCal *((CoordAuxY-centerOfMassY).^2) * croppedPicY' / sizex / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DY =  4 / pi * mAssSr * wySr^2 * auOverkB * EnergyPerPartRaw1DY * atomNumber; % effective temperature, by 2nd order momentum calculation of image

    %Calculate spread in px
     Spreadx = sum((-centerOfMassX.^2 + (croppedPicX.* CoordAuxX).^2).^0.5)/TotalMatNb;
     Spready =sum  ( (-centerOfMassY.^2 + (croppedPicY.* CoordAuxY).^2).^0.5)/TotalMatNb;
     
    display(['Evaluating ', filename]);
%     fprintf('Number of atoms: %.0f\n', atomNumber);
%     fprintf('Temperature: %.3f muK\n', effTemperature * 10^6);
%     fprintf('Temperature 1D in X: %.3f muK\n', effTemperature1DX * 10^6);
%     fprintf('Temperature 1D in Y: %.3f muK\n', effTemperature1DY * 10^6);




    atomNumberTab = [atomNumberTab, atomNumber];
    effTemperatureTab = [effTemperatureTab, effTemperature];
    effTemperature1DXTab = [effTemperature1DXTab, effTemperature1DX];
    effTemperature1DYTab = [effTemperature1DYTab, effTemperature1DY];
   
end
