%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% a function to fit a thermal cloud 2-D
%
global TabErrorU TabErrorL
comment = '';
directory = 'C:\SrBEC\Data\12Dec20\S8\';
ofile1= [directory,'Analysis.dat']; 
numberMin = 1;
numberMax = 1;
offsetTimeSeries = 0;
stepTimeSeries = 20;


outfileFer = fopen(ofile1, 'w');
fprintf(outfileFer, 'Pic_No.\tTime\tAttenuation\tPowerHoriz\tfx\tfy\tfz\tU\tTc\tTx1_Bi (nK)\tTy1_Bi (nK)\tTx2_Bi (nK)\tTy2_Bi (nK)\tTy2_BiCorr (nK)\tTeffRaw (nK)\tTeffFit (nK)\tNint\tNGaussBi1\tNGaussBi2\tNGaussBi1overNtot\tResidueBimodal\tCxBi\tCyBi\tSxGaussBi1\tSyGaussBi1\tAGaussBi1\tOffBi\tSxGaussBi2\tSyGaussBi2\tAGaussBi2\tdx\tdy\tangle\tOriginal_File\n');

TabErrorU = ones(1,numberMax);
TabErrorL = ones(1,numberMax);

for number=numberMin:1:numberMax
    if number<200
        time=(number-1)*stepTimeSeries+offsetTimeSeries;
    else if number<21
            time=(number-12)*500+500;
        else 
            time=(number-21)*50+550;
        end
    end 
    Attenuation=number;
    Phoriz=number;
    fx=220;
    fy=220;
    fz=540;
    U=3E-6;
    %U=floor((650-20)*((number+4-1)/(24-1))^2 + 20);
    TOF=4;
    %TOF=(number-1)*1+4;
    angle=45*(2*pi/360);
    [rbecbimodal,Anal] = DoubleGauss2DFast(directory,number,TOF,fx,fy,fz,U,angle,comment);
    oriFile = [directory,'\P',num2str(number)];
    fprintf(2, '#=%.0f\tTime = %.1f\tAtt = %.1f\tTOF = %.0f ms\t\tfx = %0.1f Hz\tfy = %0.1f Hz\tfz = %0.1f Hz\tU = %0.1f nK\n',double(number),double(time),double(Attenuation), TOF, fx, fy, fz,U);
    fprintf(outfileFer, '%.0f\t%.2f\t%.2f\t%.2f\t%.3f\t%.3f\t%.3f\t%.3f',double(number),double(time),double(Attenuation),double(Phoriz),double(fx),double(fy),double(fz),double(U));
    fprintf(1, '\t%.3f',number);
    for h=1:1:13
        fprintf(outfileFer, '\t%.3f',Anal(h));
    end
%     for h=1:1:6
%         fprintf(outfileFer, '\t%.3f',r(h));
%     end
%     for h=1:1:6
%         fprintf(outfileFer, '\t%.3f',rbec(h));
%     end
    for h=1:1:12
        fprintf(outfileFer, '\t%.3f',rbecbimodal(h));
    end
    fprintf(outfileFer, '\t%s\n',oriFile);
end

TabErrorU
TabErrorL
 
fclose(outfileFer);
fprintf(1, 'Program Done!\n');
%
%