function [F] = CreateDoubleGauss2DWithAngle(x0,mx,my)

a =  x0(5);
xc = x0(1);
xw = x0(3);
yc = x0(2);
yw = x0(4);
off = x0(6);
xwg = x0(7);
ywg = x0(8);
ag = x0(9);
dx = x0(10);
dy = x0(11);
angle = x0(12);

%Individual center position:
BECPosX=xc-dx;
BECPosY=yc-dy;
%Same center position:
%BECPosX=xc;
%BECPosY=yc;

y = 1:1:my;
F = zeros(my,mx);
% Computes the Function to be fitted
for i = 1:1:mx
    x = i;  
    Xrot=(cos(angle)*x+sin(angle)*y);
    Yrot=(-sin(angle)*x+cos(angle)*y);
    F(:,i) = (a.*exp(-(Xrot - BECPosX).^2 ./ (2 * xw.^2)).* exp(- (Yrot - BECPosY).^2 ./ (2 * yw.^2)))+ (ag.*exp(-(Xrot - xc).^2 ./ (2 * xwg.^2)).* exp(- (Yrot - yc).^2 ./ (2 * ywg.^2))) + off;
end
end