function [xdata,ydata]=plotvisionseriesv6(seriesnumber,inputdatetouse,plotparam)
%%Shaynes Matalba vision plotting code % Does Fiting and plots the data

global plotheader


% % Plot options % %

    % params.datasection=params.dataparameters+11;
    % plotparam.logyscale =  1 Sets log scale
    % plotparm.Testimate = 1 Calculates Temperature like vision

% % Fit options % %

    % params.xfitmax=[8000];
    % params.xfitmin=[200];
    % params.dofit=15;   
    % params.polyfitorder=1;
    
% % Fit functions % 
% case 1   % linear fit
% case 5   % linear fit with scaling
% case 2   % exponential fit, no background
% case 3   % exponential fit, no background, t offset
% case 4   % exponential fit with background
% case 6   % exponential fall fit with nobackground
% case 9   % exponential fall fit with background   --- !!! DO NOT USE !!!
% case 11  % lorentzian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% case 7   % gaussian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% case 8   % gaussian fit with no background
% case 10  % sectional average
% case 12  % sinusoidal fit with background  yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);
% case 13  % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4);
% CASE 15  % exponential fit not backround  yfit=x(1)*exp(-t/x(2))

% % Analysis Options %% 
%Selected by setting params.analysis == 
% case 0 Using vision raw data
% case 13 PSD
% case 16 YPSD
% case 22 % updated principle component analysis 20191226

c=2.99792458e8;
h=6.62606896e-34;
lambda=460.862369e-9;
gamma=2*pi*30.2e6;
NSTD=1.5;
dSTD=0.02;

if plotparam.averageseries == 0 ;
    plotparam.averageseries = zeros(1,length(seriesnumber));
end

if isempty(plotparam.title)
    plotparam.title=['Series ',num2str(seriesnumber)];
end



if (length(seriesnumber)> length(plotparam.legendstext))
    error('Please add mising legend entries')
end
for k = 1 : length(seriesnumber)
    if isa(inputdatetouse,'cell') % If there is more than one date run this one
        seriesname{k} =[char(inputdatetouse(k)),' S',num2str(seriesnumber(k)),'     ',char(plotparam.legendstext(k))] ;           % Cell Array
    else % If there is only one date run this one
        seriesname{k} =[char(inputdatetouse),' S',num2str(seriesnumber(k)),'     ',char(plotparam.legendstext(k))]      ;      % Cell Array
    end
end

plotparam.legendtext = seriesname;

for ind=1:length(seriesnumber)

    if iscell(inputdatetouse)
        inputdate=inputdatetouse{ind};
    else
        inputdate=inputdatetouse;
    end

    if plotparam.analysis==0 % use vision data
        [xdata{ind},ydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        if plotparam.displayseriesparameters
            extractparameters(inputdate,seriesnumber(ind),plotparam.parameterstoprint);
        end
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        if plotparam.interleve~=1
            xdata{ind}=xdata{ind}(1:plotparam.interleve:end);
            ydata{ind}=ydata{ind}(1:plotparam.interleve:end);
        end
        if plotparam.selectivex
            goodpoints=find((xdata{ind}<=plotparam.selectivexrange(2))&(xdata{ind}>=plotparam.selectivexrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        if plotparam.selectivey
            goodpoints=find((ydata{ind}<=plotparam.selectiveyrange(2))&(ydata{ind}>=plotparam.selectiveyrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end

    elseif plotparam.analysis==13 % PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},Sxdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+5,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./Sxdata{ind}./Sydata{ind}./Sydata{ind};
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        
    elseif plotparam.analysis==15 % Y PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./Sydata{ind}.^3;
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        
    elseif plotparam.analysis==16 % Y PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./abs(Sydata{ind}).^(3/2);
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end

    elseif plotparam.analysis==17 % Y PSD
            %Sy: params.datasection=params.dataparameters+6;
            %Sx: params.datasection=params.dataparameters+5;
            %NI: params.datasection=params.dataparameters+11;
            %PSD prop to NI/Sx^2/Sy;
        [xdata{ind},Sxdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+5,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        ydata{ind}=NIdata{ind}./Sydata{ind}./Sxdata{ind}.^(1/2);
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        
        
    elseif plotparam.analysis==18
        %   Use custum ROI
            [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
 
            visionPictNbCount = 1;
            ydata{ind}= zeros(1,length(xdata{ind}));
            
            if ind ==1 
                makeROIBool = true;
            else
               makeROIBool =false;
            end
           
            if ~isempty(strfind(plotparam.RunningFolder, 'Scripts\Scripts')) % % If running from Scripts folder used previous loaded roi
                makeROIBool =false;
            end
            
            % Load ROI
            if  ( makeROIBool  )
                [croppedPic,filenameVision] = LoadVisionDataTGA (directory,seriesnumber(ind),22,plotparam,makeROIBool);
                makeROIBool = false
            end
            for i = 1:length(xdata{ind})
                
                 [croppedPic,filenameVision] = LoadVisionDataTGA (directory,seriesnumber(ind),imagenumbers{ind}(i),plotparam,makeROIBool);
                 [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab ] = calculateExperimentalValues (filenameVision,croppedPic);
                 visionPictNbCount =visionPictNbCount +1 ;
                 ydata{ind}(i) = atomNumberTab;
            end
            
            
    elseif plotparam.analysis==19 % compare data from 2 cameras
        [xdata{ind},camdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),4,2,plotparam.cameranumber(ind),plotparam.datafilename);
        [xdata{ind},ydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,2,plotparam.cameranumber(ind),plotparam.datafilename);
        thiscam=find(camdata{ind}==(plotparam.cameranumber(ind)-1));
        xdata{ind}=xdata{ind}(thiscam);
        ydata{ind}=ydata{ind}(thiscam);
        
        if plotparam.displayseriesparameters
            extractparameters(inputdate,seriesnumber(ind),plotparam.parameterstoprint);
        end
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        if plotparam.interleve~=1
            xdata{ind}=xdata{ind}(1:plotparam.interleve:end);
            ydata{ind}=ydata{ind}(1:plotparam.interleve:end);
        end
        if plotparam.selectivex
            goodpoints=find((xdata{ind}<=plotparam.selectivexrange(2))&(xdata{ind}>=plotparam.selectivexrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        if plotparam.selectivey
            goodpoints=find((ydata{ind}<=plotparam.selectiveyrange(2))&(ydata{ind}>=plotparam.selectiveyrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
    elseif plotparam.analysis==21 % principle component analysis
        PCAmatrix=PCAmatrix-repmat(mean(PCAmatrix,1),[size(PCAmatrix,1),1]);
        PCATransp=transpose(PCAmatrix);
        PCAmatSum=PCAmatrix*PCATransp/(size(PCAmatrix,1)-1);
        NUMBEROFFIGURES=0;

        [eigVect,eigVal]= eig(PCAmatSum); % standard eigenvalue solver
        
        for modenumindex=1:length(plotparam.PCAmodeNumber)
            modenum=plotparam.PCAmodeNumber(modenumindex);
    %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
            PCAmodeX = reshape(PCATransp*eigVect(:,modenum),size(croppedreference));
            vectPlot = PCAmatrix*(PCATransp*eigVect(:,modenum));
            if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
                figure;
                lastfignum=get(gcf,'Fulldata');
                NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                subplotnum=1;
                PCAfilename='Modes';
            end
            subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
%             imagesc(PCAmodeX);
%             colormap jet
            imshow(PCAmodeX,[ ])
            title(['Mode ',num2str(modenum)])
            subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
            plot(vectPlot,'*')
%             title(['Evolution of mode Fulldata: ',num2str(modenum)]);
%             ylabel('Mode amplitude');
%             xlabel('Picture Fulldata');
            PCAfilename=[PCAfilename,'-',num2str(modenum)];
            if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
                if seriesnumber>0,
                    saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
                else
                    saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
                end
            end
        end
        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        
        return        
    elseif plotparam.analysis==22 % updated principle component analysis 20191226
        
        ind=1;
        [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        imagessummed=0;
        imagessummedreported=0;
        
%         touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax)&(xdata{ind}~=700));
        touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax));
        if ~isempty(touse)
            try
                load('C:\Users\srcal\Desktop\workspace22');
            catch
                xdatagood=xdata{ind}(touse);
                imagenums=imagenumbers{ind}(touse);

                for imagenumber=imagenums
                    if imagessummed>(imagessummedreported+10)
                        display(['Loading...',num2str(imagessummed/numel(imagenums)*100),'%']);
                        imagessummedreported=imagessummed;
                    end
                    [difference,newdata,raw,probe]=loadvisionpicture(directory,seriesnumber(ind),imagenumber,plotparam.cameranumber);
                     OD=-log(max(0.00000001,raw./probe));
                     if numel(plotparam.PCAcrop)==4 % if crop rectangle is already defined
                        if newdata %ensure load data was successful
                            %imdata=imcrop(difference,plotparam.PCAcrop);
                            imdata=double(OD(plotparam.PCAcrop(1):(plotparam.PCAcrop(1)+plotparam.PCAcrop(3)-1),plotparam.PCAcrop(2):(plotparam.PCAcrop(2)+plotparam.PCAcrop(4)-1)));
                            imdata=blurdata(imdata,plotparam.blursize);
        %                     if imagessummed==0
        %                         imsum=imdata;
        %                     else
        %                         imsum=imsum+imdata;
        %                     end
                            if imagessummed==0
                                PCAmatrix=zeros(numel(imagenums),numel(imdata));
                            end
                            imagessummed=imagessummed+1;
                            PCAmatrix(imagessummed,:)=reshape(imdata,[1,numel(imdata)]);
                        end
                     end
                end
                save('C:\Users\srcal\Desktop\workspace22');
            end
            MakeTrainingData;
            PCAmatrix=[PCAmatrix;TrainingData];
%             xdatagood=[xdatagood,22e3*ones([1,size(FakeData,1)])];
            xdatagood=[xdatagood,(22e3+(1:size(TrainingData,1)))];
            
            if imagessummed>=1,
%     %             imsum=imsum/imagessummed;
%                 PCAmatrixmean=reshape(mean(PCAmatrix,1),size(imdata));
%                 PCAmatrix=PCAmatrix-repmat(mean(PCAmatrix,1),[size(PCAmatrix,1),1]);
                
                PCATransp=transpose(PCAmatrix);
                PCAmatSum=PCAmatrix*PCATransp/(size(PCAmatrix,1)-1);
                NUMBEROFFIGURES=0;

                [eigVect,eigVal]= eig(PCAmatSum); % standard eigenvalue solver
                [eigValval,indexnum]=sort(diag(eigVal),'descend');

%                 figure('Position',[500 50 1200 500]);
%                 lastfignum=get(gcf,'Fulldata');
%                 NUMBEROFFIGURES=NUMBEROFFIGURES+1;
%                 imagesc(PCAmatrixmean);
%                 colormap jet;
%                 title('Average Mode');
%                 PCAfilename=['Average Mode'];
%                 if seriesnumber>0,
%                     saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
%                 else
%                     saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
%                 end
                
%                 plotparam.PCAmodeNumber=size(eigVect,2)-plotparam.PCAmodeNumber+1;
                
                for modenumindex=1:length(plotparam.PCAmodeNumber)
                    modenum=indexnum(plotparam.PCAmodeNumber(modenumindex));
            %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
                    PCAmodeX = reshape(PCATransp*eigVect(:,modenum),size(imdata));
                    vectPlot = PCAmatrix*(PCATransp*eigVect(:,modenum));
                    vectPlotmode{modenum}=vectPlot;
                    if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Fulldata');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        subplotnum=1;
                        PCAfilename='Modes';
                    end
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
        %             imagesc(PCAmodeX);
        %             colormap jet
    %                 imshow(PCAmodeX,[ ])
                    imagesc(PCAmodeX);
                    
                    [~,xpeak]=max(max(abs(PCAmodeX),[],1));
                    [~,ypeak]=max(max(abs(PCAmodeX),[],2));
                    
                    [modenumindex, xpeak, ypeak, sum(sum(PCAmodeX))],
                    
                    colorbar;
                    colormap jet;
                    title(['Mode ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                     title(['Mode ',num2str(modenum)])
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
                    plot(xdatagood,vectPlot,'.')
        %             title(['Evolution of mode Fulldata: ',num2str(modenum)]);
        %             ylabel('Mode amplitude');
        %             xlabel('Picture Fulldata');
                    PCAfilename=[PCAfilename,'-',num2str(modenum)];
                    if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
                        else
                            saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
                        end
                    end
                end
                
                % add the BEC like modes together and make a movie from
                % them
                
                % I think the way I'm normalizing the coefficients must be
                % wrong so they don't add up nicely. Need to spend some
                % time to sort this out.
                
                
                
                PCABECavifilename='BECMode';
                if seriesnumber>0,
                    aviname=[directory,'\S',num2str(seriesnumber),'\',PCABECavifilename];
                else
                    aviname=[directory,'\',PCABECavifilename];
                end
                avifig=figure('Position',[500 50 1200 500]);
                Framerate=5;
                writerObj = VideoWriter([aviname,'.avi']);
                writerObj.FrameRate = Framerate;
                open(writerObj);
               
%                 includedmodes=[1,2,7,8,9,11,16];
                cleaningFilter=zeros(length(xdatagood),1);
                cleaningFilter([indexnum(1)])=1;
%                 cleaningFilter([2])=1;
                [sortedxdata,indexlist]=sort(xdatagood);
                
%                 BECmode=zeros(numel(imdata),length(imagenums));
%                 BECmode=repmat(reshape(PCAmatrixmean,[numel(imdata),1]),[1,length(imagenums)]);
                
                BECmode=eigVect*diag(cleaningFilter)*transpose(eigVect)*PCAmatrix; %vectPlotmode{modenum}(indexlist(framenumber));
%                 BECmode=BECmode/max(abs(max(max(BECmode))),abs(min(min(BECmode))))+0.5;
                BECmode=BECmode/max(abs(max(max(BECmode(1:length(imagenums),:)))),abs(min(min(BECmode(1:length(imagenums),:)))))+0.5;
                
                
%                 BECmode=(BECmode-min(min(BECmode)))/(max(max(BECmode))-min(min(BECmode)));
%                 for framenumber=1:length(xdatagood)
                for framenumber=1:length(imagenums)
                    
%                     BECmode(:,framenumber)=transpose(eigVect*diag(includedmodes)*transpose(eigVect)*vectPlotmode{modenum}(indexlist(framenumber)));
                    
%                     PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber))/sum(PCATransp*eigVect(:,modenum));
% 
%         matBcleaned = eigVect * diag(cleaningFilter) * transpose(eigVect) * matB;
%         
%         matBcleanedTransp = transpose(matBcleaned);
%         total = sum(matBcleanedTransp);
           
                    
                    
%                     for modenum=includedmodes
% %                         if modenum==includedmodes(1)
% %                             BECmode(:,framenumber)=PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber));
% %                         else
%                             BECmode(:,framenumber)=BECmode(:,framenumber)+PCATransp*eigVect(:,modenum)*vectPlotmode{modenum}(indexlist(framenumber))/sum(PCATransp*eigVect(:,modenum));
% %                         end
%                     end
                    %reshape(BECmode,size(imdata));
                    image(32*reshape(BECmode(indexlist(framenumber),:),size(imdata)));
                    colormap jet;
                    colorbar;
                    title(['Time ',num2str(sortedxdata(framenumber)),'ms'])
                    frame = getframe(avifig);
                    writeVideo(writerObj,frame);
                end
                close(writerObj);
                
            end
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        end
        
        return        
    elseif plotparam.analysis==23 
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%
        %%%% complex fitting for SSBEC
        %%%%
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         
        reloadimages=plotparam.reloadimages;
        reloadfitting=plotparam.reloadfitting;
        
        reconstructresiduals=0;
        
        ind=1;
        [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
%         imagessummed=0;
%         imagessummedreported=0;
        
        h = 6.626*10.^(-34); %Js
        hbar = h/(2*pi); %Js
        mSr =  84*1.67*10^(-27); %kg
        kB =  1.3806503*10^(-23); %m^2 kg/s^2 K
        lamdaSr = 461*10.^(-9); %m
        abscrosSr = (3*(lamdaSr.^2))./(2*pi); %m^2
        a0 = 0.052917721086*10^-9;
        a8686 = 798*a0;
        a8484 = 102.5*a0;
        aScat = a8484;
        
        MINTRANSMISSION=0.000001;
        
%         touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax)&(xdata{ind}~=700));
        touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax));
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%
        % load the image dataset for the series
        %%%%
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        if ~isempty(touse)
            xdatagood=xdata{ind}(touse);
            imagenums=imagenumbers{ind}(touse);
            
            if ~reloadimages
                try
    %                 load('C:\Users\srcal\Desktop\workspace23');
                    load([directory,'\S',num2str(seriesnumber(ind)),'\imagedataset'],'PCAmatrix','Fullmatrix','imagessummed','roilocation','Fulldata','imdata','blursize','doProbeIntensityCompensation','ProbeIntensityCompensationRegion');
                    if (max(abs(roilocation-plotparam.PCAcrop))~=0)||(blursize~=plotparam.blursize)||(plotparam.doProbeIntensityCompensation~=doProbeIntensityCompensation)||...
                            (max(abs(ProbeIntensityCompensationRegion-plotparam.ProbeIntensityCompensationRegion))~=0)
                        rerunchoice=input('Differences detected in crop region, blur settings or intensity compensation from loaded version, rerun loading and fitting? Y/[N]: ','s');
                        if max(strcmp(rerunchoice,{'Y','y'}))
                            reloadfitting=true;
                            reloadfitting=true;
                        else
                            plotparam.PCAcrop=roilocation;
                            plotparam.blursize=blursize;
                            plotparam.doProbeIntensityCompensation=doProbeIntensityCompensation;
                            plotparam.SSBECfitparam=SSBECfitparam;
                            plotparam.ProbeIntensityCompensationRegion=ProbeIntensityCompensationRegion;
                        end
                        reloadimages=true;
                    end
                catch
                    reloadimages=true;
                end
            end
            
            if reloadimages
                imagessummed=0;
                imagessummedreported=0;
                for imagenumber=imagenums
                    if imagessummed>(imagessummedreported+10)
                        display(['Loading...',num2str(imagessummed/numel(imagenums)*100),'%']);
                        imagessummedreported=imagessummed;
                    end
                    [difference,newdata,raw,probe]=loadvisionpicture(directory,seriesnumber(ind),imagenumber,plotparam.cameranumber);
                    
                    if plotparam.doProbeIntensityCompensation;
                        
                        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        % This bit does intensity compensation on the probe and
                        % atoms images
                        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                        edgesregion=[plotparam.ProbeIntensityCompensationRegion(1):plotparam.ProbeIntensityCompensationRegion(2),plotparam.ProbeIntensityCompensationRegion(3):plotparam.ProbeIntensityCompensationRegion(4)];
                        rawav=sum(sum(raw(edgesregion,:)))/length(edgesregion)/size(raw,2);
                        probeav=sum(sum(probe(edgesregion,:)))/length(edgesregion)/size(probe,2);
                        OD=-log(max(MINTRANSMISSION,raw./probe*probeav/rawav));
                    else
                        OD=-log(max(MINTRANSMISSION,raw./probe*probeav/rawav));
                    end

                    Detuning=0;
                    Gamma=2*pi*30.5e6;
                    Lambda=461e-9;
                    Clebsch=1;
                    SigmaX=4.48036e-6;
                    SigmaY=4.48036e-6;

                    Sigma=Clebsch*3*Lambda^2/(2*pi*(1+(Detuning/(Gamma/4/pi))^2));
                    % Fulldata=2*pi*SigmaX*SigmaY*OD/Sigma;
                    Fulldata=SigmaX*SigmaY*OD/Sigma;
                    % Numberav=sum(sum(Fulldata(edgesregion,:)))/length(edgesregion)/size(Fulldata,2),

                     if numel(plotparam.PCAcrop)==4 % if crop rectangle is already defined
                        if newdata %ensure load data was successful
                            %imdata=imcrop(difference,plotparam.PCAcrop);
                            imdata=double(Fulldata(plotparam.PCAcrop(1):(plotparam.PCAcrop(1)+plotparam.PCAcrop(3)-1),plotparam.PCAcrop(2):(plotparam.PCAcrop(2)+plotparam.PCAcrop(4)-1)));
                            if plotparam.blursize>0
                                imdata=blurdata(imdata,plotparam.blursize);
                                Fulldata=blurdata(Fulldata,plotparam.blursize);
                            end
                            if imagessummed==0
                                PCAmatrix=zeros(numel(imagenums)+1,numel(imdata));
                                Fullmatrix=zeros(numel(imagenums)+1,numel(Fulldata));
                            end
                            imagessummed=imagessummed+1;
                            PCAmatrix(imagessummed+1,:)=reshape(imdata,[1,numel(imdata)]);
                            Fullmatrix(imagessummed+1,:)=reshape(Fulldata,[1,numel(Fulldata)]);
                        end
                    end
                end
                PCAmatrix(1,:)=sum(PCAmatrix,1)/size(PCAmatrix,1);
                Fullmatrix(1,:)=sum(Fullmatrix,1)/size(Fullmatrix,1);
                imdata=reshape(PCAmatrix(1,:),size(imdata));
                roilocation=plotparam.PCAcrop;
                blursize=plotparam.blursize;
                ProbeIntensityCompensationRegion=plotparam.ProbeIntensityCompensationRegion;
                doProbeIntensityCompensation=plotparam.doProbeIntensityCompensation;
                
                save([directory,'\S',num2str(seriesnumber(ind)),'\imagedataset'],'PCAmatrix','Fullmatrix','imagessummed','roilocation','Fulldata','imdata','blursize','doProbeIntensityCompensation','ProbeIntensityCompensationRegion');
            end
            
            % PCAmatrix holds all the image data
            % it is flattened to a 1D vector instead of a 2D array
            % PCAmatrix(1, :) contains the average of all the data
            % PCAmatrix(2...n+1, :) contains the data from image 1...n
        
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %%%%
            % fit the thermal cloud to the data for each image
            %%%%
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            FITPARAMETERNUMBER=23;

            if imagessummed>=1,
                % load the fitted results for the averaged image dataset for the series
                if ~reloadfitting
                    try
                        load([directory,'\S',num2str(seriesnumber(ind)),'\fitdataset'],'x0series','SSBECfitparam','residuals','residual');
                        
                        if ((size(x0series,2)~=FITPARAMETERNUMBER)||(size(x0series,1)~=size(PCAmatrix,1)))
                            warning('Mismatch in x0series, reevaluating fits');
                            reloadfitting=true;
                        end
                        if ((max(abs(SSBECfitparam.dimpleXrange-plotparam.SSBECfitparam.dimpleXrange))~=0)||(max(abs(SSBECfitparam.reservoirXrange1-plotparam.SSBECfitparam.reservoirXrange1))~=0)||...
                                (max(abs(SSBECfitparam.reservoirXrange2-plotparam.SSBECfitparam.reservoirXrange2))~=0)||(max(abs(SSBECfitparam.transportXrange1-plotparam.SSBECfitparam.transportXrange1))~=0)||...
                                (max(abs(SSBECfitparam.transportXrange2-plotparam.SSBECfitparam.transportXrange2))~=0)||(max(abs(SSBECfitparam.Xcal-plotparam.SSBECfitparam.Xcal))~=0)||...
                                (max(abs(SSBECfitparam.Ycal-plotparam.SSBECfitparam.Ycal))~=0)||(max(abs(SSBECfitparam.aperturex-plotparam.SSBECfitparam.aperturex))~=0)||...
                                (max(abs(SSBECfitparam.aperturey-plotparam.SSBECfitparam.aperturey))~=0)||(max(abs(SSBECfitparam.border-plotparam.SSBECfitparam.border))~=0)||...
                                (max(abs(SSBECfitparam.fittolerance-plotparam.SSBECfitparam.fittolerance))~=0)||(max(abs(SSBECfitparam.MINBECSIZE-plotparam.SSBECfitparam.MINBECSIZE))~=0)||...
                                (max(abs(SSBECfitparam.maxiterations-plotparam.SSBECfitparam.maxiterations))~=0))
                            rerunchoice=input('Differences detected in SSBECfitparam from loaded version, rerun fitting? Y/[N]: ','s');
                            if max(strcmp(rerunchoice,{'Y','y'}))
                                reloadfitting=true;
                            else
                                plotparam.SSBECfitparam=SSBECfitparam;
                            end
                        end
                    catch
                        reloadfitting=true;
                    end
                end
                if reloadfitting
                    x0series=zeros(size(PCAmatrix,1),FITPARAMETERNUMBER);
                end
                
                X=((1:size(imdata,2))+plotparam.PCAcrop(2)-1)*plotparam.SSBECfitparam.Xcal;
                Y=((1:size(imdata,1))+plotparam.PCAcrop(1)-1)*plotparam.SSBECfitparam.Ycal;

                [xx,yy]=meshgrid(X,Y);
                
                residualrange=[max(1,plotparam.SSBECfitparam.aperturey(1)-plotparam.SSBECfitparam.border-plotparam.PCAcrop(1)+1),...
                    min(size(imdata,1),plotparam.SSBECfitparam.aperturey(2)+plotparam.SSBECfitparam.border-plotparam.PCAcrop(1)+1),...
                    max(1,plotparam.SSBECfitparam.aperturex(1)-plotparam.SSBECfitparam.border-plotparam.PCAcrop(2)+1),...
                    min(size(imdata,2),plotparam.SSBECfitparam.aperturex(2)+plotparam.SSBECfitparam.border-plotparam.PCAcrop(2)+1)];
                
                if reloadfitting
                    residual=imdata(residualrange(1):residualrange(2),residualrange(3):residualrange(4));
                    residuals=zeros(size(PCAmatrix,1),numel(residual));
                end
                if reconstructresiduals
                    residual=imdata(residualrange(1):residualrange(2),residualrange(3):residualrange(4));
                    residuals=zeros(size(PCAmatrix,1),numel(residual));
                end
                
                for imagenum=1:size(PCAmatrix,1)
                    if (max(abs(x0series(imagenum,:)))==0)||(reloadfitting)
                        imdata=reshape(PCAmatrix(imagenum,:),size(imdata));
                        
                        if imagenum>1
                            Pval=imagenums(imagenum-1);
                        else
                            Pval=0;
                        end
                        
                        plotheader=[directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')];
                        display(['Fitting: ','S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
                        if (imagenum==1)
                            x0=fitSSBECbackground3(imdata,plotparam.SSBECfitparam,xx,yy,X,Y,plotparam.PCAcrop);
                        else
                            x0=fitSSBECbackground3(imdata,plotparam.SSBECfitparam,xx,yy,X,Y,plotparam.PCAcrop,squeeze(x0series(1,:)));
                        end
                        x0series(imagenum,:)=x0(1:end);
                        
                        estimatedprofile=constructSSBEC6(x0,xx,yy);

                        residual=imdata(residualrange(1):residualrange(2),residualrange(3):residualrange(4))-estimatedprofile(residualrange(1):residualrange(2),residualrange(3):residualrange(4));
                        residuals(imagenum,:)=reshape(residual,[1,numel(residual)]);
                        SSBECfitparam=plotparam.SSBECfitparam;
                        save([directory,'\S',num2str(seriesnumber(ind)),'\fitdataset'],'x0series','SSBECfitparam','residuals','residual');
                        
%                         % Plot as we go so the user can see everything is
%                         % going OK
%                         
%                         figure(300);
%                         imagesc(imdata);
%                         colorbar;
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
% %                         axis equal
%                         colormap jet
% 
%                         figure(301);
%                         imagesc(estimatedprofile);
%                         colorbar;
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
% %                         axis equal
%                         colormap jet
% 
%                         figure(302);
%                         imagesc(residual);
%                         colorbar;
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
% %                         axis equal
%                         colormap jet
% 
%                         figure(303);
%                         imagesc(imdata-estimatedprofile);
%                         colorbar;
% %                         axis equal
%                         colormap jet
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
%                         drawnow
% %                         pause(0.1);
                    end
                    if reconstructresiduals
                        imdata=reshape(PCAmatrix(imagenum,:),size(imdata));
                        
                        if imagenum>1
                            Pval=imagenums(imagenum-1);
                        else
                            Pval=0;
                        end
                        
%                         plotheader=[directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')];
%                         display(['Fitting: ','S',num2str(seriesnumber(ind)),' P',num2str(Pval,'%04.0f')]);
                        x0=x0series(imagenum,:);
                        
                        estimatedprofile=constructSSBEC6(x0,xx,yy);

                        residual=imdata(residualrange(1):residualrange(2),residualrange(3):residualrange(4))-estimatedprofile(residualrange(1):residualrange(2),residualrange(3):residualrange(4));
                        residuals(imagenum,:)=reshape(residual,[1,numel(residual)]);
                        save([directory,'\S',num2str(seriesnumber(ind)),'\fitdataset'],'x0series','SSBECfitparam','residuals','residual');
                    end
                end
                
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %
            % construct avis and gifs of the residuals and do a PCA
            % analysis on the residuals
            %
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                Residualsavifilename='Residuals';
                if seriesnumber>0,
                    aviname=[directory,'\S',num2str(seriesnumber),'\',Residualsavifilename];
                else
                    aviname=[directory,'\',Residualsavifilename];
                end
                avifig=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj = VideoWriter([aviname,'.avi']);
                writerObj.FrameRate = Framerate;
                open(writerObj);
               
% %                 includedmodes=[1,2,7,8,9,11,16];
%                 cleaningFilter=zeros(length(xdatagood),1);
%                 cleaningFilter([indexnum(1)])=1;
% %                 cleaningFilter([2])=1;
                [sortedxdata,indexlist]=sort(xdatagood);
                
%                 BECmode=zeros(numel(imdata),length(imagenums));
%                 BECmode=repmat(reshape(PCAmatrixmean,[numel(imdata),1]),[1,length(imagenums)]);
                
%                 BECmode=eigVect*diag(cleaningFilter)*transpose(eigVect)*PCAmatrix; %vectPlotmode{modenum}(indexlist(framenumber));
% %                 BECmode=BECmode/max(abs(max(max(BECmode))),abs(min(min(BECmode))))+0.5;
%                 BECmode=BECmode/max(abs(max(max(BECmode(1:length(imagenums),:)))),abs(min(min(BECmode(1:length(imagenums),:)))))+0.5;
                
%                 residuals(residuals<-8)=0;
                residualsmin=min(min(residuals));
                residualsmax=max(max(residuals));
                
                aperture=zeros(size(residual));
                aperture(40:(end-40),40:(end-40))=1;
                residualsum=sum(residuals.*repmat(reshape(aperture,[1,numel(aperture)]),[size(residuals,1),1]),2);
                
                for framenumber=2:size(residuals,1)
                    imagesc(reshape(residuals(indexlist(framenumber-1)+1,:),size(residual)),[residualsmin residualsmax]);
                    colormap jet;
                    colorbar;
                    title(['Time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')'])
                    frame = getframe(avifig);
                    writeVideo(writerObj,frame);
                    
                    im = frame2im(frame); 
                    [imind,cm] = rgb2ind(im,256); 
                    
                    % Write to the GIF File 
                    
                    if framenumber == 2 
                        imwrite(imind,cm,[aviname,'.gif'],'gif', 'Loopcount',inf); 
                    else 
                        imwrite(imind,cm,[aviname,'.gif'],'gif','WriteMode','append'); 
                    end
                end
                close(writerObj);
                
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %
                % construct avis and gifs of the residuals PCA
                % this time sorted by time and grouped so that the frames
                % are correctly ordered
                %
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                
                
                
                
                
                
                fitsummaryavifilename='fitsummary';
                fitsummaryfig=300;
                figure(fitsummaryfig);
                if seriesnumber>0,
                    aviname=[directory,'\S',num2str(seriesnumber),'\',fitsummaryavifilename];
                    crosssectionname=[directory,'\S',num2str(seriesnumber),'\Crosssections'];
                else
                    aviname=[directory,'\',fitsummaryavifilename];
                    crosssectionname=[directory,'\Crosssections'];
                end
                avifig=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj2 = VideoWriter([aviname,'.avi']);
                writerObj2.FrameRate = Framerate;
                open(writerObj2);
                
                fitsummaryavifilename='crosssectionsummary';
                fitsummaryfig2=350;
                figure(fitsummaryfig2);
                if seriesnumber>0,
                    aviname2=[directory,'\S',num2str(seriesnumber),'\',fitsummaryavifilename];
                else
                    aviname2=[directory,'\',fitsummaryavifilename];
                end
                avifig2=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj3 = VideoWriter([aviname2,'.avi']);
                writerObj3.FrameRate = Framerate;
                open(writerObj3);
                
                fitsummaryavifilename='projectionsummary';
                fitsummaryfig3=351;
                figure(fitsummaryfig3);
                if seriesnumber>0,
                    aviname3=[directory,'\S',num2str(seriesnumber),'\',fitsummaryavifilename];
                else
                    aviname3=[directory,'\',fitsummaryavifilename];
                end
                avifig3=figure('Position',[200 50 600 500]);
                Framerate=5;
                writerObj4 = VideoWriter([aviname3,'.avi']);
                writerObj4.FrameRate = Framerate;
                open(writerObj4);
                
                for framenumber=2:size(residuals,1)
                    imdata=reshape(PCAmatrix(indexlist(framenumber-1)+1,:),size(imdata));
%                         x0series(imagenum,:)=x0(1:end);

                    [estimatedprofile,dimplefit,reservoirfit,crossoverfit,transportfit,BECfit]=constructSSBEC6(squeeze(x0series(indexlist(framenumber-1)+1,:)),xx,yy);
                    
                    residual=imdata(residualrange(1):residualrange(2),residualrange(3):residualrange(4));

                    figure(fitsummaryfig);
                    set(fitsummaryfig,'Position',[50 50 900 950]);
                    subplot(4,1,1,'replace');
                    imagesc(imdata,[0 110]);
%                     imagesc(imdata);
%                     climits=get(gca,'cLim');
                    axis equal
                    axis tight
                    colorbar;
                    title(['Data at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    colormap jet

                    subplot(4,1,2,'replace');
                    imagesc(estimatedprofile,[0 110]);
%                     imagesc(estimatedprofile,climits);
                    axis equal
                    axis tight
                    colorbar;
                    title(['Fit at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    colormap jet

                    subplot(4,1,3,'replace');
                    imagesc(estimatedprofile-BECfit,[0 110]);
%                     imagesc(estimatedprofile,climits);
                    axis equal
                    axis tight
                    colorbar;
                    title(['Thermal Fit at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    colormap jet

                    subplot(4,1,4,'replace');
                    imagesc(imdata-estimatedprofile,[-5 20]);
                    axis equal
                    axis tight
                    colorbar;
%                         axis equal
                    colormap jet
                    title(['Residuals at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);

%                         figure(302);
%                         imagesc(residual);
%                         colorbar;
%                         title(['S',num2str(seriesnumber(ind)),' P',num2str(imagenum-1,'%04.0f')]);
% %                         axis equal
%                         colormap jet

%                     drawnow
%                     pause(0.1);
                    
                    Dimpley=round(x0series(indexlist(framenumber-1)+1,10)/plotparam.SSBECfitparam.Ycal); % Parameters(10)=Dimpley;
                    if (Dimpley<(plotparam.CrosssectionHalfWidth+1))||(Dimpley>(size(imdata,1)-plotparam.CrosssectionHalfWidth))
                        Dimpley=round(size(imdata,1)/2);
                    end
                    
                    datacrosssection=sum(imdata((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);
                    thermalcrosssection=sum(dimplefit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:)+...
                        reservoirfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:)+...
                        crossoverfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:)+...
                        transportfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);
                    dimplecrosssection=sum(dimplefit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);
                    reservoircrosssection=sum(reservoirfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);
                    crossovercrosssection=sum(crossoverfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);
                    transportcrosssection=sum(transportfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);
                    BECcrosssection=sum(BECfit((Dimpley-plotparam.CrosssectionHalfWidth):(Dimpley+plotparam.CrosssectionHalfWidth),:),1);

                    dataprojection=sum(imdata,1);
                    thermalprojection=sum(dimplefit+reservoirfit+crossoverfit+transportfit,1);
                    dimpleprojection=sum(dimplefit,1);
                    reservoirprojection=sum(reservoirfit,1);
                    crossoverprojection=sum(crossoverfit,1);
                    transportprojection=sum(transportfit,1);
                    BECprojection=sum(BECfit,1);
                    
                    % plot projections

                    figure(fitsummaryfig3);
                    set(fitsummaryfig3,'Position',[50 50 900 450]);
%                     subplot(2,1,1,'replace');
%                     plot(X,datacrosssection,'k.',X,thermalcrosssection,'r');
%                     plot(1:length(dataprojection),dataprojection,'k.',1:length(dataprojection),transportprojection,'g',1:length(dataprojection),thermalprojection+BECprojection,'b',1:length(dataprojection),thermalprojection,'r');
                    plot(X,dataprojection,'k.',X,transportprojection,'g',X,thermalprojection+BECprojection,'b',X,thermalprojection,'r');
                    title(['Projections at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    ylabel('Atoms projection');
                    xlabel('Position after 18ms TOF [mm]');

%                     subplot(2,1,2,'replace');
% %                     plot(X,dimplecrosssection,'k',X,reservoircrosssection,'r',X,crossovercrosssection,'b',X,transportcrosssection,'g');
%                     plot(1:length(dataprojection),dimpleprojection,'k',1:length(dataprojection),transportprojection,'g',1:length(dataprojection),reservoirprojection+crossoverprojection+BECprojection+transportprojection,'b',1:length(dataprojection),reservoirprojection+crossoverprojection+transportprojection,'r');
%                     title('Projections: Dimple (k), Reservoir+Crossover+BEC (b), Reservoir+Crossover (r), Beam (g)');
                    
                    % plot crosssections

                    figure(fitsummaryfig2);
                    set(fitsummaryfig2,'Position',[50 50 900 450]);
%                     subplot(2,1,1,'replace');
%                     plot(X,datacrosssection,'k.',X,thermalcrosssection,'r');
%                     plot(1:length(datacrosssection),datacrosssection,'k.',1:length(datacrosssection),transportcrosssection,'g',1:length(datacrosssection),BECcrosssection+thermalcrosssection,'b',1:length(datacrosssection),thermalcrosssection,'r');
                    plot(X,datacrosssection,'k.',X,transportcrosssection,'g',X,BECcrosssection+thermalcrosssection,'b',X,thermalcrosssection,'r');
                    title(['Cross sections at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
                    ylabel('Atoms cross section');
                    xlabel('Position after 18ms TOF [mm]');

%                     subplot(2,1,2,'replace');
% %                     plot(X,dimplecrosssection,'k',X,reservoircrosssection,'r',X,crossovercrosssection,'b',X,transportcrosssection,'g');
%                     plot(1:length(datacrosssection),dimplecrosssection,'k',1:length(datacrosssection),transportcrosssection,'g',1:length(datacrosssection),reservoircrosssection+crossovercrosssection+BECcrosssection+transportcrosssection,'b',1:length(datacrosssection),reservoircrosssection+crossovercrosssection+transportcrosssection,'r');
%                     title('Cross sections: Dimple (k), Reservoir+Crossover+BEC+Beam (b), Reservoir+Crossover+Beam (r), Beam (g)');

%                     drawnow
%                     pause(0.1);
                    
%                     imagesc(reshape(residuals(indexlist(framenumber-1)+1,:),size(residual)),[residualsmin residualsmax]);
%                     colormap jet;
%                     colorbar;
%                     title(['Time ',num2str(sortedxdata(framenumber-1)),'ms (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(indexlist(framenumber-1)+1,'%04.0f'),')'])
                    frame = getframe(fitsummaryfig);
                    writeVideo(writerObj2,frame);
                    im = frame2im(frame); 
                    [imind,cm] = rgb2ind(im,256); 
                    
                    frame3 = getframe(fitsummaryfig3);
                    writeVideo(writerObj4,frame3);
                    im3 = frame2im(frame3); 
                    [imind3,cm3] = rgb2ind(im3,256); 
                    
                    frame2 = getframe(fitsummaryfig2);
                    writeVideo(writerObj3,frame2);
                    im2 = frame2im(frame2); 
                    [imind2,cm2] = rgb2ind(im2,256); 
                    
                    % Write to the GIF File and CSV file
                    
%                     plotvals=([sortedxdata/1e3; datacrosssection.';]).';
                    HeaderVals={'X [mm]','Data crosssection [atoms]','BEC fit crosssection [atoms]','Thermal fit crosssection [atoms]','Dimple fit crosssection [atoms]','Reservoir fit crosssection [atoms]',...
                        'Crossover fit crosssection [atoms]','Guide fit crosssection [atoms]','Data projection [atoms]','BEC fit projection [atoms]','Thermal fit projection [atoms]','Dimple fit projection [atoms]',...
                        'Reservoir fit projection [atoms]','Crossover fit projection [atoms]','Guide fit projection [atoms]'};
                    plotvals=([X; datacrosssection;BECcrosssection;thermalcrosssection;dimplecrosssection;reservoircrosssection;crossovercrosssection;transportcrosssection;...
                        dataprojection;BECprojection;thermalprojection;dimpleprojection;reservoirprojection;crossoverprojection;transportprojection]).';
                    
                    if framenumber == 2 
                        imwrite(imind,cm,[aviname,'.gif'],'gif', 'Loopcount',inf); 
                        imwrite(imind2,cm2,[aviname2,'.gif'],'gif', 'Loopcount',inf); 
                        imwrite(imind3,cm3,[aviname3,'.gif'],'gif', 'Loopcount',inf); 
                    else 
                        imwrite(imind,cm,[aviname,'.gif'],'gif','WriteMode','append'); 
                        imwrite(imind2,cm2,[aviname2,'.gif'],'gif','WriteMode','append'); 
                        imwrite(imind3,cm3,[aviname3,'.gif'],'gif','WriteMode','append'); 
                    end
                    fid = fopen([crosssectionname,'P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),'.csv'],'w');
                    fprintf(fid,'%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s\n',HeaderVals{:});
                    fclose(fid);
                    dlmwrite([crosssectionname,'P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),'.csv'],plotvals,'-append');
                    
                    if seriesnumber>0,
                        aviname=[directory,'\S',num2str(seriesnumber),'\',fitsummaryavifilename];
                        fitspngname=[directory,'\S',num2str(seriesnumber),'\FitsP'];
                        crosssectionpngname=[directory,'\S',num2str(seriesnumber),'\CrosssectionP'];
                        projectionpngname=[directory,'\S',num2str(seriesnumber),'\ProjectionP'];
                    else
                        aviname=[directory,'\',fitsummaryavifilename];
                        fitspngname=[directory,'\FitsP'];
                        crosssectionpngname=[directory,'\CrosssectionP'];
                        projectionpngname=[directory,'\ProjectionP'];
                    end
                    saveas(fitsummaryfig,[fitspngname,num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),'.png']);
                    saveas(fitsummaryfig2,[crosssectionpngname,num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),'.png']);
                    saveas(fitsummaryfig3,[projectionpngname,num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),'.png']);
                end
                close(writerObj2);
                close(writerObj3);
                close(writerObj4);
                
                
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %
                % plot the integration of the central residual, the anomaly
                % vs time
                %
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                
                figure(400);
                plot(sortedxdata(1:end)/1e3,residualsum(indexlist(1:end)+1),'k.');
                xlabel('Time [s]');
                ylabel('Integrated anomaly [atoms]');
                title('Integrated anomaly');
                
%                 plotvals=([sortedxdata(1:end)/1e3; residualsum(indexlist(1:end)+1).']).';
                
                if seriesnumber(ind)>0,
                    saveas(400,[directory,'\S',num2str(seriesnumber),'\Anomaly.png']);
%                     save([directory,'\S',num2str(seriesnumber),'\Anomaly.csv'],'plotvals','-ascii');
                else
                    saveas(400,[directory,'\Anomaly.png']);
%                     save([directory,'\Anomaly.csv'],'plotvals','-ascii');
                end
                
                
                
                
                x0DimpleN=squeeze(x0series(indexlist+1,1)); % Parameters(1)=DimpleN;
                x0DimpleWy=squeeze(x0series(indexlist+1,2)); % Parameters(2)=DimpleWy;
                x0ReservoirN=squeeze(x0series(indexlist+1,3)); % Parameters(3)=ReservoirN;
                x0ReservoirWy=squeeze(x0series(indexlist+1,4)); % Parameters(4)=ReservoirWy;
                x0ReservoirWx=squeeze(x0series(indexlist+1,5)); % Parameters(5)=ReservoirWx;
                x0CrossoverN=squeeze(x0series(indexlist+1,6)); % Parameters(6)=CrossoverN;
                x0CrossoverWy=squeeze(x0series(indexlist+1,7)); % Parameters(7)=CrossoverWy;
                x0CrossoverWx=squeeze(x0series(indexlist+1,8)); % Parameters(8)=CrossoverWx;
                x0Dimplex=squeeze(x0series(indexlist+1,9)); % Parameters(9)=Dimplex;
                x0Dimpley=squeeze(x0series(indexlist+1,10)); % Parameters(10)=Dimpley;
                x0Crossoverx=squeeze(x0series(indexlist+1,11)); % Parameters(11)=Crossoverx;
                x0Reservoirx=squeeze(x0series(indexlist+1,12)); % Parameters(12)=Reservoirx;
                % x0BECWx=squeeze(x0series(indexlist+1,13)); % Parameters(13)=BECWx;
                % x0BECWy=squeeze(x0series(indexlist+1,14)); % Parameters(14)=BECWy;
                % x0BECN=squeeze(x0series(indexlist+1,15)); % Parameters(15)=BECN;
                % x0BECampl=squeeze(x0series(indexlist+1,16)); % Parameters(16)=BECampl;
                x0TransportN=squeeze(x0series(indexlist+1,13)); % Parameters(13)=TransportN;
                x0Transportx=squeeze(x0series(indexlist+1,14)); % Parameters(14)=Transportx;
                x0TransportWx=squeeze(x0series(indexlist+1,15)); % Parameters(15)=TransportWx;
                x0Transporty=squeeze(x0series(indexlist+1,16)); % Parameters(16)=Transporty;
                x0TransportWy=squeeze(x0series(indexlist+1,17)); % Parameters(17)=TransportWy;
                x0Background=squeeze(x0series(indexlist+1,18)); % Parameters(18)=Background;
                x0BECN=squeeze(x0series(indexlist+1,19)); % Parameters(19)=BECN;
                x0BECwx=squeeze(x0series(indexlist+1,20)); % Parameters(20)=BECwx;
                x0BECwy=squeeze(x0series(indexlist+1,21)); % Parameters(21)=BECwy;
                x0BECX=squeeze(x0series(indexlist+1,22)); % Parameters(20)=BECwx;
                x0BECY=squeeze(x0series(indexlist+1,23)); % Parameters(21)=BECwy;
                
                x0BECN(x0BECN<=5000)=0;
                
                ExpansionTime=18e-3;

                % TyDimple=mSr/kB*(SigmaY/ExpansionTime)^2*1E6;
                TyDimple=mSr/kB*(x0DimpleWy*1e-3/2^0.5/ExpansionTime).^2*1E6;
                TyReservoir=mSr/kB*(x0ReservoirWy*1e-3/2^0.5/ExpansionTime).^2*1E6;
                TyCrossover=mSr/kB*(x0CrossoverWy*1e-3/2^0.5/ExpansionTime).^2*1E6;
                TyTransport=mSr/kB*(x0TransportWy*1e-3/2^0.5/ExpansionTime).^2*1E6;

                
                figure(401);
                plot(sortedxdata/1e3,TyDimple,'ko',sortedxdata/1e3,TyReservoir,'ro',sortedxdata/1e3,TyCrossover,'bo',sortedxdata/1e3,TyTransport,'go');
                xlabel('Time [s]');
                ylabel('Fitted Temperature [uK]');
                title('Temperature evolution (from fits)');
                legend({'Ty Dimple','Ty Reservoir','Ty Crossover','Ty Transport'},'Location','SouthOutside');
                
                if seriesnumber(ind)>0,
                    saveas(401,[directory,'\S',num2str(seriesnumber),'\TemperatureEvolution.png']);
                else
                    saveas(401,[directory,'\TemperatureEvolution.png']);
                end
                
            NDimple=x0DimpleN./(1/(2*pi)./(x0DimpleWy*1e-3/2^0.5)./(x0DimpleWy*1e-3/2^0.5))/(plotparam.SSBECfitparam.Xcal*plotparam.SSBECfitparam.Ycal*1e-6);
            NReservoir=x0ReservoirN./(1/(2*pi)./(x0ReservoirWy*1e-3/2^0.5)./(x0ReservoirWx*1e-3/2^0.5))/(plotparam.SSBECfitparam.Xcal*plotparam.SSBECfitparam.Ycal*1e-6);
            NCrossover=x0CrossoverN./(1/(2*pi)./(x0CrossoverWy*1e-3/2^0.5)./(x0CrossoverWx*1e-3/2^0.5))/(plotparam.SSBECfitparam.Xcal*plotparam.SSBECfitparam.Ycal*1e-6);
            % NTransport=x0TransportN/(1/(2*pi)/(x0TransportWy*1e-3/2^0.5)/(x0TransportWx*1e-3/2^0.5))/(plotparam.SSBECfitparam.Xcal*plotparam.SSBECfitparam.Ycal*1e-6);

            figure(402);
            plot(sortedxdata/1e3,NDimple,'ko',sortedxdata/1e3,NReservoir,'ro',sortedxdata/1e3,NCrossover,'co',sortedxdata/1e3,(NDimple+NReservoir+NCrossover),'go',sortedxdata/1e3,x0BECN*100,'bo',sortedxdata/1e3,residualsum(indexlist+1)*100,'go');
            xlabel('Time [s]');
            ylabel('Fitted Fulldata [atoms]');
            title('Fulldata evolution (from fits)');
            legend({'N Dimple','N Reservoir','N Crossover','N Total','N BEC*100','residual sum*100'},'Location','SouthOutside');
            axis([0 15 0 2.5e6]);

            if seriesnumber(ind)>0,
                saveas(402,[directory,'\S',num2str(seriesnumber),'\NumberEvolution.png']);
            else
                saveas(402,[directory,'\NumberEvolution.png']);
            end
            
            % Save a summary of the fitted data results

            ResultsSummaryHeaders={'Value','Integrated Residual','x0DimpleN','x0DimpleWy','x0ReservoirN','x0ReservoirWy','x0ReservoirWx','x0CrossoverN','x0CrossoverWy','x0CrossoverWx','x0Dimplex','x0Dimpley',...
                'x0Crossoverx','x0Reservoirx','x0TransportN','x0Transportx','x0TransportWx','x0Transporty','x0TransportWy','x0Background','x0BECN','x0BECwx','x0BECwy','x0BECX','x0BECY','TyDimple',...
                'TyReservoir','TyCrossover','TyTransport','NDimple','NReservoir','NCrossover'};

            ResultsSummary=[sortedxdata.', residualsum(indexlist(1:end)+1), x0DimpleN, x0DimpleWy, x0ReservoirN, x0ReservoirWy, x0ReservoirWx, x0CrossoverN, x0CrossoverWy, x0CrossoverWx,...
                x0Dimplex, x0Dimpley, x0Crossoverx, x0Reservoirx, x0TransportN, x0Transportx, x0TransportWx, x0Transporty, x0TransportWy, x0Background, x0BECN, x0BECwx, x0BECwy, x0BECX, x0BECY, TyDimple, TyReservoir, TyCrossover,...
                TyTransport, NDimple, NReservoir, NCrossover];
                
            if seriesnumber(ind)>0,
                fid = fopen([directory,'\S',num2str(seriesnumber),'\ResultsSummary.csv'],'w');
                fprintf(fid,'%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s\n',ResultsSummaryHeaders{:});
                fclose(fid);
                dlmwrite([directory,'\S',num2str(seriesnumber),'\ResultsSummary.csv'],ResultsSummary,'-append');
            else
                fid = fopen([directory,'\ResultsSummary.csv'],'w');
                fprintf(fid,'%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s\n',ResultsSummaryHeaders{:});
                fclose(fid);
                dlmwrite([directory,'\ResultsSummary.csv'],ResultsSummary,'-append');
            end

            
            
            
            return
            
            
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %
            % PCA and save all the modes
            %
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
                residuals=residuals(2:end,:);
                
                residualsTransp=transpose(residuals);
                residualsSum=residuals*residualsTransp/(size(residuals,1)-1);
                NUMBEROFFIGURES=0;

                [eigVect,eigVal]= eig(residualsSum); % standard eigenvalue solver
                [eigValval,indexnum]=sort(diag(eigVal),'descend');

                for modenumindex=1:length(plotparam.PCAmodeNumber)
                    if modenumindex==1
                        modenum=indexnum(plotparam.PCAmodeNumber(modenumindex));
                %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
                        residualsmodeX = reshape(residualsTransp*eigVect(:,modenum),size(residual));
                        vectPlot = residuals*(residualsTransp*eigVect(:,modenum));
                        vectPlotmode{modenum}=vectPlot;
                        
                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Fulldata');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        imagesc(residualsmodeX);

%                         [~,xpeak]=max(max(abs(residualsmodeX),[],1));
%                         [~,ypeak]=max(max(abs(residualsmodeX),[],2));
% 
%                         [modenumindex, xpeak, ypeak, sum(sum(residualsmodeX))],

                        colorbar;
                        colormap jet;
                        title(['PCA Mode ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                         subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;

                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\Max_PCA_Mode.png']);
                        else
                            saveas(lastfignum,[directory,'\Max_PCA_Mode.png']);
                        end
                        

                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Fulldata');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        plot(xdatagood,vectPlot,'.')
                        title(['PCA Amplitude ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                         PCAfilename=[PCAfilename,'-',num2str(modenum)];
                        
                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\Max_PCA_Amplitude.png']);
                        else
                            saveas(lastfignum,[directory,'\Max_PCA_Amplitude.png']);
                        end
                    end
                    
                    modenum=indexnum(plotparam.PCAmodeNumber(modenumindex));
            %         plotparam.PCAmodeNumber = 3;% 2 3 4 5 7 8 12 13
                    residualsmodeX = reshape(residualsTransp*eigVect(:,modenum),size(residual));
                    vectPlot = residuals*(residualsTransp*eigVect(:,modenum));
                    vectPlotmode{modenum}=vectPlot;
                    if ((modenumindex-1)/plotparam.PCAmodesperfigure)==floor((modenumindex-1)/plotparam.PCAmodesperfigure)
                        figure('Position',[500 50 1200 900]);
                        lastfignum=get(gcf,'Fulldata');
                        NUMBEROFFIGURES=NUMBEROFFIGURES+1;
                        subplotnum=1;
                        PCAfilename='Modes';
                    end
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
        %             imagesc(residualsmodeX);
        %             colormap jet
    %                 imshow(residualsmodeX,[ ])
                    imagesc(residualsmodeX);
                    
                    [~,xpeak]=max(max(abs(residualsmodeX),[],1));
                    [~,ypeak]=max(max(abs(residualsmodeX),[],2));
                    
                    [modenumindex, xpeak, ypeak, sum(sum(residualsmodeX))],
                    
                    colorbar;
                    colormap jet;
                    title(['Mode ',num2str(plotparam.PCAmodeNumber(modenumindex))])
%                     title(['Mode ',num2str(modenum)])
                    subplot(plotparam.PCAmodesperfigure,2,subplotnum); subplotnum=subplotnum+1;
                    plot(xdatagood,vectPlot,'o')
        %             title(['Evolution of mode Fulldata: ',num2str(modenum)]);
        %             ylabel('Mode amplitude');
        %             xlabel('Picture Fulldata');
                    PCAfilename=[PCAfilename,'-',num2str(modenum)];
                    if ((modenumindex/plotparam.PCAmodesperfigure)==floor(modenumindex/plotparam.PCAmodesperfigure))||(modenumindex==length(plotparam.PCAmodeNumber))
                        if seriesnumber>0,
                            saveas(lastfignum,[directory,'\S',num2str(seriesnumber),'\',PCAfilename,'.png']);
                        else
                            saveas(lastfignum,[directory,'\',PCAfilename,'.png']);
                        end
                    end
                end
                
            end
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
    %        arrangelastfigures(NUMBEROFFIGURES,8,1,2);
        end
        
        return        
    elseif plotparam.analysis==25 % Y PSD
                %Sy: params.datasection=params.dataparameters+6;
                %Sx: params.datasection=params.dataparameters+5;
                %NI: params.datasection=params.dataparameters+11;
                %PSD prop to NI/Sx^2/Sy;
            [xdata{ind},Sxdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+5,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
            [xdata{ind},Sydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+6,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
            [xdata{ind},NIdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.dataparameters+11,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
            ydata{ind}=NIdata{ind}./Sydata{ind};
            if plotparam.overridexaxiswithmeasurementnumber
                xdata{ind}=1:length(xdata{ind});
            end

% if plotparam.overridexaxiswithmeasurementnumber
%     xdata{ind}=1:length(xdata{ind});
% end
        

            
    end
    


end % Analysis options for ploting. Ie PSD TOF etc. Generate the data

for ind=1:length(seriesnumber) % Adds scaling to data. i.e squares y axis adds offset multpies by constant etc
    if ind ==1  
        plotparam = SetDefaultValues (plotparam ,seriesnumber); %Set offsets scale and labes to default values.
    end
    [plotparam, xdata{ind} ,ydata{ind}] = ScaleData(plotparam, xdata{ind},ydata{ind},ind,seriesnumber);
end

for ind=1:length(seriesnumber)
    goodval=find(~isnan(ydata{ind}));
    if ~isempty(goodval)
        xdata{ind}=xdata{ind}(goodval);
        ydata{ind}=ydata{ind}(goodval);
        [xdata{ind},order]=sort(xdata{ind});
        ydata{ind}=ydata{ind}(order);
    else
        display('No good data');
        xdata{ind}=[];
        ydata{ind}=[];
    end
end % RGE I think these are data quality checks 



xaveraged =0;
yaveraged =ydata{1};

% ydata{4} = ydata{1};
% xdata{4} = xdata{1};

counting = 1;

for ind=2:length(seriesnumber)
    if plotparam.averageseries(ind)
        yaveraged = ydata{ind} + yaveraged;
        counting = counting + 1;
    end

    
end
yaveraged =yaveraged/counting;
for ind=1:length(seriesnumber)
    if plotparam.averageseries(ind);
        ydata{ind} = yaveraged;
    end
end


figure;
evalstring='plot(';

for ind=1:length(seriesnumber) % does the fiting of the data  and generates the comand for the ploting
    dofitplot=0;doPlotoptions=0;
    [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,'',doPlotoptions ); % Generates the string to be used for ploting
    [plotparam,xdata{ind}] = formatfitinginputs (plotparam,xdata{ind},seriesnumber); % Formats the input options so they can be interpreted by the code
    

    if plotparam.dofit~=0
        dofitplot=0;
        pointstouseforfit=((xdata{ind}>=plotparam.xfitmin(ind))&(xdata{ind}<=plotparam.xfitmax(ind)));
        switch plotparam.dofit
            case 1 % linear fit
                if length(pointstouseforfit)>=(plotparam.polyfitorder+1)
                    if plotparam.polyfitorder==0
                        meanval=mean(ydata{ind}(pointstouseforfit));
                        stdval=std(ydata{ind}(pointstouseforfit));
                        xfitstart=min(xdata{ind}(pointstouseforfit));
                        xfitend=max(xdata{ind}(pointstouseforfit));
                        xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                        yfitdata{ind}=meanval*ones(size(xfitdata{ind}));
                        displaytext=[num2str(meanval),'\pm',num2str(2*stdval)];
                        if ( plotparam.extractStability )
                            stability = 100*stdval/meanval
                            legendentry=[ 'Average Value  = ',num2str(meanval,'%10.3e'),' ','\sigma = ',num2str(stdval),' \Delta',' = ',num2str(stability),'% .'];
                        else
                            legendentry=[nicenumber(meanval),'\pm',num2str(2*stdval)];
                        end
                                               else
                        p=polyfitn(xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),plotparam.polyfitorder);
                        xfitstart=min(xdata{ind}(pointstouseforfit));
                        xfitend=max(xdata{ind}(pointstouseforfit));
                        xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                        yfitdata{ind}=polyvaln(p,xfitdata{ind});
                        displaytext=[];
                        legendentry=[];
                        for ind2=0:plotparam.polyfitorder
                            if (ind2==0)&&p.Coefficients(plotparam.polyfitorder-ind2+1)~=0
                                displaytext=[displaytext,'(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                legendentry=[legendentry,'(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                            elseif (p.Coefficients(plotparam.polyfitorder-ind2+1)>0)&&(ind2==1)
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                            elseif (p.Coefficients(plotparam.polyfitorder-ind2+1)<0)&&(ind2==1)
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                            elseif p.Coefficients(plotparam.polyfitorder-ind2+1)>0
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                            elseif p.Coefficients(plotparam.polyfitorder-ind2+1)<0
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                            end
                        end
                    end
                    dofitplot=1;
                    display(displaytext);
    %                 dofitplot=1;
                end
                        case 2 % exponential fit, no background
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                lb=[x0(1),0];
                ub=[x0(1)*10,x0(2)*10];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_rise_nobackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_rise_nobackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*(1-exp(-t/',num2str(xfitted(2)),'))']);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*(1-exp(-t/',num2str(xfitted(2),'%0.3e'),'))'];
                
            case 3 % exponential fit, no background, t offset
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=0;
                lb=[x0(1),0,-max(xdata{ind})/10];
                ub=[x0(1)*10,x0(2)*10,max(xdata{ind})/10];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_rise_nobackground_toffset,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                
                % try to estimate uncertainties on the resulting fittd
                % values:
                p=polyfitn(exp(-xdata{ind}(pointstouseforfit)/xfitted(2)),-ydata{ind}(pointstouseforfit),1);
                p2=polyfitn(log(1-ydata{ind}(pointstouseforfit)/xfitted(1)),-xdata{ind}(pointstouseforfit),1);
                
                yfitdata{ind}=exponential_rise_nobackground_toffset(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display(['(',num2str(xfitted(1)),'\pm',num2str(2*p.ParameterStd(1)),')*(1-exp(-(t-',num2str(xfitted(3)),')/(',num2str(xfitted(2)),'\pm',num2str(2*p2.ParameterStd(1)),')))']);
                legendentry=['(',num2str(xfitted(1),'%0.3e'),'\pm',num2str(2*p.ParameterStd(1),'%0.3e'),')*(1-exp(-(t-',num2str(xfitted(3),'%0.3e'),')/(',num2str(xfitted(2),'%0.3e'),'\pm',num2str(2*p2.ParameterStd(1),'%0.3e'),')))'];

            case 4 % exponential fit with background
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(ydata{ind});
                lb=[x0(1)*0.1,0,0];
                ub=[x0(1)*10,x0(2)*10,abs(x0(3))*5];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_rise,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_rise(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*(1-exp(-t/',num2str(xfitted(2)),'))+',num2str(xfitted(3))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*(1-exp(-t/',num2str(xfitted(2),'%0.3e'),'))+',num2str(xfitted(3),'%0.3e')];
            case 5 % linear fit with scaling
                if length(pointstouseforfit)>=(plotparam.polyfitorder+1)
                    [p,~,mu]=polyfit(xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),plotparam.polyfitorder);
                    xfitstart=min(xdata{ind}(pointstouseforfit));
                    xfitend=max(xdata{ind}(pointstouseforfit));
                    xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                    yfitdata{ind}=polyval(p,xfitdata{ind},[],mu);
                    dofitplot=1;
                    legendentry=[];
                    for ind=0:length(plotparam.polyfitorder)
                        if (ind==0)&&p(plotparam.polyfitorder-ind+1)~=0
                            displaytext=[displaytext,num2str(p(plotparam.polyfitorder-ind+1))];
                            legendentry=[legendentry,nicenumber(p(plotparam.polyfitorder-ind+1))];
                        elseif (p(plotparam.polyfitorder-ind+1)>0)&&(ind==1)
                            displaytext=[displaytext,'+',num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')'];
                            legendentry=[legendentry,'+',nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')'];
                        elseif (p(plotparam.polyfitorder-ind+1)<0)&&(ind==1)
                            displaytext=[displaytext,num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')'];
                            legendentry=[legendentry,nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')'];
                        elseif p(plotparam.polyfitorder-ind+1)>0
                            displaytext=[displaytext,'+',num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')^',num2str(ind)];
                            legendentry=[legendentry,'+',nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')^',num2str(ind)];
                        elseif p(plotparam.polyfitorder-ind+1)<0
                            displaytext=[displaytext,num2str(p(plotparam.polyfitorder-ind+1)),'((x-',num2str(mu(1)),')/',num2str(mu(2)),')^',num2str(ind)];
                            legendentry=[legendentry,nicenumber(p(plotparam.polyfitorder-ind+1)),'((x-',nicenumber(mu(1)),')/',nicenumber(mu(2)),')^',num2str(ind)];
                        end
                    end
                    display(displaytext);
                    displaytext=[];
    %                 dofitplot=1;
                end
            
            case 6 % exponential fall fit with nobackground
                x0(1)=max(ydata{ind}); x0 = [1.6*10^5,0,2.8*10^3]
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(xdata{ind});
                lb=[x0(1)*0.1,0,0];
                ub=[x0(1)*10,x0(2)*10,x0(3)*5];
                display('fitting...');
%                 fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9,'TolX',1e-10);
%                 xfitted=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind},ydata{ind},lb,ub,fitoptions);
                xfitted=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_fall_nobackground_toffset(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-(t-',num2str(xfitted(3)),')/',num2str(xfitted(2)),')']);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-(t-',num2str(xfitted(3),'%0.3e'),')/',num2str(xfitted(2),'%0.3e'),')'];
           case 7 % gaussian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                x0(1)=max(ydata{ind})-min(ydata{ind});
                [~,maxloc]=max(ydata{ind});
                x0(2)=xdata{ind}(maxloc);
                x0(3)=sum(ydata{ind}-min(ydata{ind}))/x0(1)/2*(max(xdata{ind})-min(xdata{ind}))/length(xdata{ind});
                x0(4)=min(ydata{ind});
                lb=[x0(1)/2,min(xdata{ind}),x0(3)/10,x0(4)-(std(ydata{ind}))];
                ub=[x0(1)*2,max(xdata{ind}),x0(3)*10,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                xfitted=lsqcurvefit(@gaussian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=gaussian(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];
            case 8 % gaussian fit with no background
                x0(1)=max(ydata{ind})-min(ydata{ind});
                [~,maxloc]=max(ydata{ind});
                x0(2)=xdata{ind}(maxloc);
                x0(3)=sum(ydata{ind}-min(ydata{ind}))/x0(1)/2*(max(xdata{ind})-min(xdata{ind}))/length(xdata{ind});
                lb=[x0(1)/2,min(xdata{ind}),x0(3)/10];
                ub=[x0(1)*2,max(xdata{ind}),x0(3)*10];
                display('fitting...');
                xfitted=lsqcurvefit(@gaussian_nobackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=gaussian_nobackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)']);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)'];
             case 9 % exponential fall fit with background
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(xdata{ind});
                x0(4)=min(ydata{ind})/2;
                lb=[x0(1)*0.1,0,0,0];
                ub=[x0(1)*10,x0(2)*10,x0(3)*5,abs(x0(4))*2];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_fall_background_toffset,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                
                
                p2=polyfitn(log((ydata{ind}(pointstouseforfit)-xfitted(4))/xfitted(1)),-xdata{ind}(pointstouseforfit),1);
                
                
                yfitdata{ind}=exponential_fall_background_toffset(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                
                display([num2str(xfitted(1)),'*exp(-(t-',num2str(xfitted(3)),')/(',num2str(xfitted(2)),'\pm',num2str(p2.ParameterStd(1),'%0.3e'),'))+',num2str(xfitted(4))]);
                legendentry=['Caution Fit Sensitive to noise!!!!',num2str(xfitted(1),'%0.3e'),'*exp(-(t-',num2str(xfitted(3),'%0.3e'),')/(',num2str(xfitted(2),'%0.3e'),'\pm',num2str(p2.ParameterStd(1),'%0.3e'),'))+',num2str(xfitted(4),'%0.3e')];
                
            case 10% sectional average
                pointstouseforfit=find((xdata{ind}>=plotparam.xfitmin(ind))&(xdata{ind}<=plotparam.xfitmax(ind)));
                xfitstart=min(xdata{ind}(pointstouseforfit));
                xfitend=max(xdata{ind}(pointstouseforfit));  
                display(['Sectional average : ','x start: ',num2str(xfitstart),'; x stop: ',num2str(xfitend) ]);
                display(['Sectional Mean: S',num2str(seriesnumber(ind)),': ',num2str(mean(ydata{ind}(pointstouseforfit))/1e6,'%0.6f'),' M +/- ',num2str(std(ydata{ind}(pointstouseforfit))/1e6,'%0.6f'), ' M']);
                display(['Sectional Mean: S',num2str(seriesnumber(ind)),': ',num2str(mean(ydata{ind}(pointstouseforfit)),'%0.6f'),' +/- ',num2str(std(ydata{ind}(pointstouseforfit)),'%0.6f'), ' ']);
            
%                 legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-(t-',num2str(xfitted(3),'%0.3e'),')/',num2str(xfitted(2),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 11 % lorentzian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                x0(1)=max(ydata{ind})-min(ydata{ind});
                [~,maxloc]=max(ydata{ind});
                x0(2)=xdata{ind}(maxloc);
                x0(3)=32;
                x0(4)=min(ydata{ind});
                lb=[x0(1)/2,min(xdata{ind}),32/2,x0(4)-(std(ydata{ind}))];
                ub=[x0(1)*2,max(xdata{ind}),32*2,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                xfitted=lsqcurvefit(@lorentzian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=lorentzian(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'/(1+4*((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'/(1+4*((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];

            case 12 % sinusoidal fit with background  yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);
                fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9);
                x0(4)=median(ydata{ind}); %background
                x0(1)=mean((ydata{ind}-x0(4)).^2)^0.5*2^0.5; % amplitude
                
                if isnan(plotparam.sinfitinitialfreq(ind))
                    ac=xcorr(ydata{ind}-x0(4));
    %                 [~,locs,peakwidth,prominence]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    [~,locs,~,~]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    locs=sort(locs);
                    x0(2)=1/mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)));
%                 figure
%                 plot(xdata{ind},ydata{ind},'ko');
%                 figure
%                 plot(ac);
                    locs,
                    mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)))
%                 figure
                else
                    x0(2)=plotparam.sinfitinitialfreq(ind)/1e3;
                end
                
                x0(3)=0;
                lb=[x0(1)/2,x0(2)*0.2,-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2];
                ub=[x0(1)*2,x0(2)*5,2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2];
                display('fitting...');
                xfitted=lsqcurvefit(@sinwithbackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub,fitoptions);
                yfitdata{ind}=sinwithbackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*sin(2*\pi*',num2str(xfitted(2)*1000),'x/1000+',num2str(xfitted(3)),')+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*sin(2*\pi*',num2str(xfitted(2)*1000,'%0.2f'),'x/1000+',num2str(xfitted(3),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 13 % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4);
                fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9);
                x0(4)=median(ydata{ind}); %background
                x0(1)=mean((ydata{ind}-x0(4)).^2)^0.5*2^0.5; % amplitude
                
                if isnan(plotparam.sinfitinitialfreq(ind))
                    ac=xcorr(ydata{ind}-x0(4));
    %                 [~,locs,peakwidth,prominence]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    [~,locs,~,~]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    locs=sort(locs);
                    x0(2)=1/mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)));
%                 figure
%                 plot(xdata{ind},ydata{ind},'ko');
%                 figure
%                 plot(ac);
                    locs,
                    mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)))
%                 figure
                else
                    x0(2)=plotparam.sinfitinitialfreq(ind)/1e3;
                end
                
                x0(3)=0;

                
                x0(5)=1;
                
                lb=[x0(1)/2,x0(2)*0.2,-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2,max(xdata{ind})];
                ub=[x0(1)*2,x0(2)*5,2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2,max(xdata{ind})*20];
                display('decay fitting...');
                xfitted=lsqcurvefit(@sinwithdecayandbackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub,fitoptions);
                yfitdata{ind}=sinwithdecayandbackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-x/',num2str(xfitted(5)),')*sin(2*\pi*',num2str(xfitted(2)*1000),'x/1000+',num2str(xfitted(3)),')+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-x/',num2str(xfitted(5),'%0.3e'),')*sin(2*\pi*',num2str(xfitted(2)*1000,'%0.2f'),'x/1000+',num2str(xfitted(3),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 14 % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4); with uncertainties - version 2
                fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9);
                x0(4)=median(ydata{ind}); %background
                x0(1)=mean((ydata{ind}-x0(4)).^2)^0.5*2^0.5; % amplitude
                
                if isnan(plotparam.sinfitinitialfreq(ind))
                    ac=xcorr(ydata{ind}-x0(4));
    %                 [~,locs,peakwidth,prominence]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    [~,locs,~,~]=findpeaks(ac,'SortStr','descend','NPeaks',3);
                    locs=sort(locs);
                    x0(2)=1/mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)));
%                 figure
%                 plot(xdata{ind},ydata{ind},'ko');
%                 figure
%                 plot(ac);
                    locs,
                    mean(diff(locs)*(xdata{ind}(2)-xdata{ind}(1)))
%                 figure
                else
                    x0(2)=plotparam.sinfitinitialfreq(ind)/1e3;
                end
                
                x0(3)=0;
                x0(5)=1;
                
                lb=[x0(1)/2,x0(2)*0.2,-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2,max(xdata{ind})];
                ub=[x0(1)*2,x0(2)*5,2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2,max(xdata{ind})*20];
                display('decay fitting...');
                xfitted=lsqcurvefit(@sinwithdecayandbackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub,fitoptions);
                
                % now evaluate the uncertainty
                
                lb=[x0(1)/2,max(x0(2)*0.2,xfitted(2)-plotparam.sinfreqrange/1000),-2*pi,x0(4)*(1-sign(x0(4)*0.1))-x0(1)/2,max(xdata{ind})];
                ub=[x0(1)*2,min(x0(2)*5,xfitted(2)+plotparam.sinfreqrange/1000),2*pi,x0(1)*(1+sign(x0(4)*0.1))+x0(1)/2,max(xdata{ind})*20];
                for trial=1:plotparam.sintrials
                    usedpoints=rand(size(xdata{ind}))>plotparam.sinpointstokill;
                    xdataselected=xdata{ind}(usedpoints);
                    ydataselected=ydata{ind}(usedpoints);
                    
                    [xfittedtest]=lsqcurvefit(@sinwithdecayandbackground,x0,xdataselected,ydataselected,lb,ub,fitoptions);
                    freqval(trial)=xfittedtest(2)*1000;
                end
                
                meanfreq=mean(freqval);
                stdevfreq=std(freqval);
                
                p=polyfitn(1:plotparam.sintrials,freqval,0);
                xfreqfitdata=1:(plotparam.sintrials-1)/1000:plotparam.sintrials;
                yfreqfitdata=polyvaln(p,xfreqfitdata);
%                 freqdisplaytext=['(',num2str(p.Coefficients(1)),'\pm',num2str(2*p.ParameterStd(1)),')'];
%                 freqlegendentry=['(',nicenumber(p.Coefficients(1)),'\pm',num2str(2*p.ParameterStd(1)),')'];
                freqdisplaytext=['(',num2str(meanfreq),'\pm',num2str(2*stdevfreq),')'];
                freqlegendentry=['(',nicenumber(meanfreq),'\pm',num2str(2*stdevfreq),')'];
                display(freqdisplaytext);
                
                plot(1:plotparam.sintrials,freqval,'ko',xfreqfitdata,yfreqfitdata,'r');
                title(['Frequency estimates dropping ',num2str(plotparam.sinpointstokill*100),'% of points randomly']);
                xlabel('Trial');
                ylabel('Fitted Frequency [Hz]');
                freqlegend={'Fitted frequency estimates',freqlegendentry};
                legend(freqlegend,'Location','southoutside','FontSize',plotparam.legendfontsize);
                figure;
                
                yfitdata{ind}=sinwithdecayandbackground(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-x/',num2str(xfitted(5)),')*sin(2*\pi*',num2str(xfitted(2)*1000),'x/1000+',num2str(xfitted(3)),')+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-x/',num2str(xfitted(5),'%0.3e'),')*sin(2*\pi*',num2str(xfitted(2)*1000,'%0.2f'),'x/1000+',num2str(xfitted(3),'%0.3e'),')+',num2str(xfitted(4),'%0.3e')];
            case 15 % exponential fall fit with nobackground
                x0 = plotparam.start;
                ub=plotparam.upperbound;
                lb=plotparam.lowerbound ;
                display('fitting...');
%                 fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9,'TolX',1e-10);
%                 xfitted=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind},ydata{ind},lb,ub,fitoptions);
                [xfitted,resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@exponential_fall_nobackground_toffset_noDelay,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                
                yfitdata{ind}=exponential_fall_nobackground_toffset_noDelay(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*exp(-(t)/',num2str(xfitted(2)),')']);
                legendentry=['(',num2str(xfitted(1),'%0.3e'),'\pm',num2str(expSigma(1),'%0.3e'),')','*exp(-t/(',num2str(xfitted(2),'%0.3e'),'\pm',num2str(expSigma(2),'%0.3e'),'))'];
             case 16 % Abs spectra  yfit=-x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                
                x = [10^5] 
                lb=[x0(1)/2,min(xdata{ind}),32/2,x0(4)-(std(ydata{ind}))];
                ub=[x0(1)*2,max(xdata{ind}),32*2,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                xfitted=lsqcurvefit(@lorentzian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=lorentzian(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'/(1+4*((x-',num2str(xfitted(2)),')/',num2str(xfitted(3)),')^2)+',num2str(xfitted(4))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'/(1+4*((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];
            case 26
                x0(1)=max(ydata{ind});
                x0(2)=max(xdata{ind})/2;
                x0(3)=min(ydata{ind});
                lb=[x0(1)/2,0,0];
                ub=[x0(1)*10,x0(2)*10,x0(3)*5];
                display('fitting...');
                xfitted=lsqcurvefit(@exponential_fall_background_NotoffsetV22,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                yfitdata{ind}=exponential_rise(xfitted,xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted(1)),'*(1-exp(-t/',num2str(xfitted(2)),'))+',num2str(xfitted(3))]);
                legendentry=[num2str(xfitted(1),'%0.3e'),'*(1-exp(-t/',num2str(xfitted(2),'%0.3e'),'))+',num2str(xfitted(3),'%0.3e')];
        



        end
        

    [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,legendentry,doPlotoptions ); % Generatews the string to display the fiting
    
    end
if ( plotparam.savedata )    
    saveData (plotparam ,ydata{ind}.',xdata{ind}.',ind,seriesnumber)
end
end


doPlotoptions=1;
[plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,'',doPlotoptions ); % Generatews the string to display the fiting

eval(evalstring); %This bit is displaying the data. Its running a ploting comand


if ~isempty(plotparam.legendtext)
    legend(plotparam.legendtext,'Location',plotparam.legendlocation,'FontSize',plotparam.legendfontsize)
end
if plotparam.logyscale
    set(gca,'YScale','log');
    
end
    



title(plotparam.title,'FontSize',plotparam.titlefontsize);
xlabel(plotparam.xlabel,'FontSize',plotparam.xaxisfontsize);
ylabel(plotparam.ylabel,'FontSize',plotparam.yaxisfontsize);

return

end




function [yfit]=exponential_rise(x,xdata)

yfit=x(1)*(1-exp(-xdata/x(2)))+x(3);

end

function [yfit]=exponential_rise_nobackground(x,xdata)

yfit=x(1)*(1-exp(-xdata/x(2)));

end

function [yfit]=gaussian(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithbackground(x,xdata)

yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithdecayandbackground(x,xdata)

yfit=x(1)*exp(-xdata/x(5)).*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=lorentzian(x,xdata)

yfit=x(1)./(1+4*((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=gaussian_nobackground(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2);

end

function [yfit]=modefit(x,model,data)

yfit=sum(sum(abs((x(1)*model+x(2)-data))));

end

function [yfit]=exponential_rise_nobackground_toffset(x,xdata)

yfit=x(1)*(1-exp(-(xdata-x(3))/x(2)));

end
function [yfit]=exponential_fall_nobackground_toffset_noDelay(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2));

end
function [yfit]=exponential_fall_nobackground_toffset(x,xdata)

yfit=x(1)*exp(-(xdata-x(3))/x(2));

end

function [yfit]=exponential_fall_background_toffset(x,xdata)

yfit=x(1)*exp(-(xdata-x(3))/x(2))+x(4);

end
function [yfit]=exponential_fall_background_Notoffset(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2))+x(4);

end

function [yfit]=exponential_fall_background_NotoffsetV22(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2))+x(3);

end
function [output]=nicenumber(value)

if (abs(value)<0.01)||(abs(value)>10000)
    output=num2str(value,'%0.3e');
else
    output=num2str(value,'%0.6f');
end

end
function [savename] = saveData (plotparams,ydata,xdata,ind,seriesnumber)
    filename = plotparams.filename;
    Selection =plotparams.datasection-1;
    path = [plotparams.filepath,'\Data'];
    
    currentfile=strcat(plotparams.RunningFolder, '.m');

    ScrDirectory = [path,'\',filename(1:end -2)]
    if ~exist(ScrDirectory, 'dir') % If target directory doesnt exist
        if isempty(strfind(currentfile,'\Scripts')) == 1 % The script is not saved on the scripts folder
            mkdir(ScrDirectory) ;  % Create directory and save the data
        end
    
    end 
    if isempty(strfind(currentfile,'\Scripts')) == 1 % The script is not saved on the scripts folder
        savedataboolean = true; 
    else
        savedataboolean = false;
    end
    filenameydata = ['YdataS',num2str(seriesnumber(ind)),'Variable',num2str(Selection),'.csv']
    filenamexdata = ['XdataS',num2str(seriesnumber(ind)),'Variable',num2str(Selection),'.csv']
    
    savenameydata = [ScrDirectory,'\',filenameydata]
    savenamexdata = [ScrDirectory,'\',filenamexdata]
    if ( savedataboolean )
        save (savenameydata,'ydata','-ascii')
        save (savenamexdata,'xdata','-ascii');
    end
end
function [croppedPic,fileName] = LoadVisionDataTGA (currentDayDirectory,seriesNumber,visionPictNbCount,plotparam,makeROIBool)
    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);
    fileName=[currentDayDirectory '\S' num2str(seriesNumber) '\P' num2str(visionPictNbCount,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.tga'];

    if exist(char(fileName),'file')
        %pause(0.5);

        % load vision data
        [referencePic, newdata, raw, probe]=loadvisionpictureTGA(currentDayDirectory, seriesNumber, visionPictNbCount, cameraNumber);
        referencePic=max(-referencePic,0);

        % determine ROIs
        backgroundROIdatafilename=[currentDayDirectory '\backgroundROIdata_' 'S' num2str(seriesNumber) '.mat'];
        configFolder = [currentDayDirectory ,'\optimizationData\','S',num2str(seriesNumber),'\'];
        [rectInner, rectOuter, croppedReferencePic, croppedReferenceOuterPic] = determineROIPictureTGA(referencePic, backgroundROIdatafilename, makeROIBool,plotparam);

        % load picture
        MaxOD = 5;
        Pic = min(MaxOD, -log(max(0.0000000000001, raw ./ probe)));
        croppedPic=Pic((rectInner(2)+1):(rectInner(2)+rectInner(4)),(rectInner(1)+1):(rectInner(1)+rectInner(3)));
        croppedOuterPic=Pic((rectOuter(2)+1):(rectOuter(2)+rectOuter(4)),(rectOuter(1)+1):(rectOuter(1)+rectOuter(3)));


        isInnerInsideOuterBool = (rectOuter(1) < rectInner(1)) && ((rectOuter(1)+rectOuter(3)) > (rectInner(1)+rectInner(3))) && (rectOuter(2) < rectInner(2)) && ((rectOuter(2)+rectOuter(4)) > (rectInner(2)+rectInner(4)));
        if isInnerInsideOuterBool
            referenceBackgroundMean=(sum(sum(croppedOuterPic))-sum(sum(croppedPic)))/(numel(croppedOuterPic)-numel(croppedPic));
        else
            isOuterAbitInsideInnerBool1 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) );
            isInnerAbitInsideOuterBool1 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) );
            isOuterAbitInsideInnerBool2 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) );
            isInnerAbitInsideOuterBool2 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) );
            if (isOuterAbitInsideInnerBool1 || isInnerAbitInsideOuterBool1 || isOuterAbitInsideInnerBool2 || isInnerAbitInsideOuterBool2)
                error('Bad choice of ROIs!');
            else
                referenceBackgroundMean= sum(sum(croppedOuterPic)) / numel(croppedOuterPic);
            end
        end
        croppedPic=max(0,croppedPic - referenceBackgroundMean);


    end


end
function [difference,newdata,raw,probe]=loadvisionpictureTGA(directory,seriesnumber,imagenumber,cameranumber)

    if seriesnumber>0
        directoryAux=[directory '\S' num2str(seriesnumber)];
    end


    atomsdata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'A' num2str(cameranumber-1) '.tga']);
    noisedata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'N' num2str(cameranumber-1) '.tga']);
    probedata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'P' num2str(cameranumber-1) '.tga']);
    otherdata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'O' num2str(cameranumber-1) '.tga']);

    if ~isempty(atomsdata)
        newdata=1;
        raw=(atomsdata-noisedata);
        probe=(probedata-noisedata);
        difference=raw-probe;
    else
        newdata=0;
end
end


function  [rectIn, rectOut, croppedRefPic, croppedRefOuterPic] = determineROIPictureTGA(refPic, bckgndROIdatafileName, mkROIBool,plotparam)

global Data;

if  mkROIBool % 0 ask for background ROI data only if no previous data available, 1 ask allways
    warning('off');
    maxPic = max(max(refPic));
    minPic = min(min(refPic));
    
    initFig=figure;
    %display('Waiting for input');
    set(initFig,'Name','Select rectange containing signal');
    [croppedRefPic, rectIn] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    set(initFig,'Name','Select rectange including background');
    [croppedRefOuterPic, rectOut] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    %display('Background region defined');
    close(initFig);

    rectIn=round(rectIn);
    rectIn(1)=max(0, min(size(refPic, 2) - 1, rectIn(1)));
    rectIn(2)=max(0, min(size(refPic, 1) - 1 , rectIn(2)));
    rectIn(3)=max(1, min(size(refPic, 2) - rectIn(1), rectIn(3)));
    rectIn(4)=max(1, min(size(refPic, 1) - rectIn(2), rectIn(4)));

    rectOut=round(rectOut);
    rectOut(1)=max(0, min(size(refPic, 2) - 1, rectOut(1)));
    rectOut(2)=max(0, min(size(refPic, 1) - 1, rectOut(2)));
    rectOut(3)=max(1, min(size(refPic, 2) - rectOut(1), rectOut(3)));
    rectOut(4)=max(1, min(size(refPic, 1) - rectOut(2), rectOut(4)));

    %oldRectIn=rectIn;
    %rectIn(1)=max(rectIn(1), rectOut(1));
    %rectIn(2)=max(rectIn(2), rectOut(2));
    %rectIn(3)=min(oldRectIn(1) + rectIn(3), rectOut(1) + rectOut(3)) - rectIn(1);
    %rectIn(4)=min(oldRectIn(2) + rectIn(4), rectOut(2) + rectOut(4)) - rectIn(2);
    warning('on');
    save(bckgndROIdatafileName,'rectIn','rectOut');
    timeOfDat = datestr(now,'dd-mmm-yyyy-HH-MM-SS');
    
    Folder = returnFileName(plotparam.RunningFolder,plotparam.thisScriptName);
    save(Folder,'rectIn','rectOut');
    Data.rectIn = rectIn;
    Data.rectOut = rectOut;
else
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    load(Folder);
    croppedRefPic = refPic((rectIn(2)+1):(rectIn(2)+rectIn(4)),(rectIn(1)+1):(rectIn(1)+rectIn(3)));
    croppedRefOuterPic = refPic((rectOut(2)+1):(rectOut(2)+rectOut(4)),(rectOut(1)+1):(rectOut(1)+rectOut(3)));
end




end
function [returnPath]=returnFileName(FileDirectory,Filename)

    % close all
    format shortg
    timeOfDat = clock;
    breakLoop = 0;
    version = 1;
    if ~isempty(strfind(FileDirectory, 'Scripts\Scripts'))
        filenamereturn = ['Background_',Filename,'.mat' ];
        l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l)];
        returnPath = [FileDirectoryShort,filenamereturn];  
    else
        while breakLoop == 0 

            filename =['runmme',num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1)),'Scr',num2str(version,'%04i'),'.m'];

            l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l),'Scripts\'];
            FolderName = [num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1))];
            FolderName = [FileDirectoryShort,FolderName];
            currentfile=strcat(FileDirectory, '.m');
            if ~exist(FolderName, 'dir')
                if isempty(strfind(currentfile,'\Scripts')) == 1
                    mkdir(FolderName);      
                end

            end
            FilePath = [FolderName,'\',filename];    
            if exist(FilePath, 'file') == 2
                version = version + 1;
            else
                breakLoop = 1;
            end
            filenamereturn = ['Background_',filename,'at' ];
            returnPath = [FolderName,'\',filenamereturn];   
        end
    end

end



function [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab ] = calculateExperimentalValues (filename,croppedPic)
    
    global ctePlanck hbarre cLum kB aB MuB hartree Mu0 Epsilon0 au eElec gForce Debye Na
    global ctePlanckOverAu auOverCtePlanck ctePlanckOverkB kBOverCtePlanck auOverkB kBOverAu hbarreOverAu hbarreOverkB hbarreOverMuB MuBOverHbarre
    global mSr88 mSr87 mSr86 mSr84
    
    UsefulConstants;
    if ( ~isempty(strfind(filename, 'AA'))) % USE MOT side camera calibration
        xCalSr = 4.48 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4.48 * 10^(-6);
    elseif  ( ~isempty(strfind(filename, 'BA'))) % USE MOT TOP camera calibration
        xCalSr = 4 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4 * 10^(-6);
    end
    
    effVolume = (100e-6 * 100e-6 * 100e-6); %estimation of the characteristic size of the cloud (to estimate the density) (in m^3)
    wxSr = 2 * pi * 100; %estimation of the trapping frequency
    wySr = 2 * pi * 200;
    wzSr = 2 * pi * 100;
    mAssSr = mSr88;
    lamdaSr = 461. * 10^(-9); %(in m)   

    atomNumberTab= [];
    effTemperatureTab= [];
    effTemperature1DXTab= [];
    effTemperature1DYTab= [];
    calculatedCostTab= [];
    
    
    % calculate the atom Fulldata
    absCrossSr = (3*(lamdaSr.^2))./(2*pi); % (m^2)
    numberCal = (yCalSr*xCalSr) / absCrossSr;
    TotalMatNb = sum(sum(croppedPic)); %total optical density in the image
    atomNumber = TotalMatNb * numberCal;

    % calculate the center of mass in x and y
    [sizey, sizex] = size(croppedPic);
    CoordAuxX = 1:1:sizex;
    CoordAuxY = 1:1:sizey;
    croppedPicX = sum(croppedPic,1);
    croppedPicY = sum(croppedPic,2)';
    centerOfMassX = croppedPicX * CoordAuxX' /TotalMatNb;
    centerOfMassY = croppedPicY * CoordAuxY' /TotalMatNb;

    %calculate effective temperature                
    EnergyPerPartRaw = (xCalSr * yCalSr)^2 * ((CoordAuxY-centerOfMassY).^2) * (croppedPic) * ((CoordAuxX'-centerOfMassX).^2) / TotalMatNb; % effective temperature, by 2nd order momentum calculation of image
    effTemperature = 4 / pi * mAssSr * (wxSr*wySr)^(2/2)* auOverkB * EnergyPerPartRaw * atomNumber / 2; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DX = (xCalSr)^3 * numberCal *((CoordAuxX-centerOfMassX).^2) * croppedPicX' / sizey / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DX =  4 / pi * mAssSr * wxSr^2 * auOverkB * EnergyPerPartRaw1DX * atomNumber; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DY = (yCalSr)^3 * numberCal *((CoordAuxY-centerOfMassY).^2) * croppedPicY' / sizex / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DY =  4 / pi * mAssSr * wySr^2 * auOverkB * EnergyPerPartRaw1DY * atomNumber; % effective temperature, by 2nd order momentum calculation of image


    
    
    display(['Evaluating ', filename]);
%     fprintf('Fulldata of atoms: %.0f\n', atomNumber);
%     fprintf('Temperature: %.3f muK\n', effTemperature * 10^6);
%     fprintf('Temperature 1D in X: %.3f muK\n', effTemperature1DX * 10^6);
%     fprintf('Temperature 1D in Y: %.3f muK\n', effTemperature1DY * 10^6);




    atomNumberTab = [atomNumberTab, atomNumber];
    effTemperatureTab = [effTemperatureTab, effTemperature];
    effTemperature1DXTab = [effTemperature1DXTab, effTemperature1DX];
    effTemperature1DYTab = [effTemperature1DYTab, effTemperature1DY];
end
function [todayDirectory, fileName] = findNextFileBMP(todayDirectory,  seriesnumber, dataNumber, plotparam)

    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);



    fileName='';
    notfound=1;
    StopBoolean = false;
    try
        if seriesnumber>0
            fileName=[todayDirectory '\S' num2str(seriesnumber) '\P' num2str(dataNumber,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.bmp'];
            if ~exist(fileName,'file')
                StopBoolean = true;
            end
    %             if ~isempty(nameOverride)
    %                 fileName=[directory,'\S',num2str(seriesnumber),'\',nameOverride,'.dat'];
    %             end    
            %fid=fopen(fileName);
            %data=char(fread(fid).');
            notfound=0;
            %fclose(fid);
        else
            fileName=[todayDirectory '\P' num2str(dataNumber,'%04i') cameraLetter 'A0' '.bmp'];
    %             if ~isempty(nameOverride)
    %                 fileName=[directory,'\',nameOverride,'.dat'];
    %             end
    %             fid=fopen(fileName);
    %             data=char(fread(fid).');
            notfound=0;
    %             fclose(fid);
        end
    end


    if (notfound==1)
        error(['File note found: ',fileName]);
    end
end

function [parameter] = SetDefaultValues (plotparam ,seriesnumber )

    if isempty(plotparam.xlabel)
        plotparam.xlabel=lastxlabelname;
    end

    if length(plotparam.xoffset)==1
        plotparam.xoffset=plotparam.xoffset*ones(size(seriesnumber));
    end
    if length(plotparam.xscale)==1
        plotparam.xscale=plotparam.xscale*ones(size(seriesnumber));
    end
    if length(plotparam.yscale)==1
        plotparam.yscale=plotparam.yscale*ones(size(seriesnumber));
    end
    if length(plotparam.yoffset)==1
        plotparam.yoffset=plotparam.yoffset*ones(size(seriesnumber));
    end
    if length(plotparam.sinfitinitialfreq)==1
        plotparam.sinfitinitialfreq=plotparam.sinfitinitialfreq*ones(size(seriesnumber));
    end
    parameter =  plotparam;
end

function [parameter, datax ,datay] = ScaleData(plotparam, datax,datay,ind,seriesnumber)

  datax=(datax-plotparam.xoffset(ind));
    if plotparam.xscaleinvert
        datax=1./datax;
    end
    if plotparam.xscalesquare
        datax=(datax).^2;
    end
    if plotparam.yscalesquare
        datay=(datay).^2;
    end 
    if plotparam.Testimate
        datay=(datay).^2;
        datay =  datay./400;
        datay =  datay*0.010665 * 10^6;
        
    end
    
    if length(plotparam.xscale)==length(seriesnumber)
        datax=datax*plotparam.xscale(ind);
    end
    if length(plotparam.yscale)==length(seriesnumber)
        datay=datay*plotparam.yscale(ind);
    end
    if length(plotparam.yoffset)==length(seriesnumber)
        datay=datay+plotparam.yoffset(ind);
    end
    if plotparam.removenegative
        datax=datax(datay>0);
        datay=datay(datay>0);
    end   
    parameter= plotparam;
end


function [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,legendentry ,doPlotoptions) % Generates the string use for plotting

    
    

    
    if doPlotoptions
        if isempty(plotparam.plotoptions)
            evalstring=[evalstring(1:(end-1)),');'];
        else
            evalstring=[evalstring,'''MarkerSize'',20);'];
        end
    else
        if dofitplot
            if (length(plotparam.linecolour)>=length(seriesnumber))
                evalstring=[evalstring,'xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linefitstyle,''','];
            else
                evalstring=[evalstring,'xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linefitstyle,''','];
            end
            if (length(plotparam.legendtext)>=2*ind)
                for temp=length(plotparam.legendtext):-1:2*ind
                    plotparam.legendtext{temp+1}=plotparam.legendtext{temp};
                end
            end
            plotparam.legendtext{2*ind}=legendentry;
        else
            if length(plotparam.linecolour)>=length(seriesnumber)
                evalstring=[evalstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linestyle,''','];
            else
                evalstring=[evalstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},''',plotparam.linestyle,''','];
            end
        end        
    end
    
    

    
       
    
end

function [plotparam,xdata] = formatfitinginputs (plotparam,xdata,seriesnumber)
    if length(plotparam.xpolyfitval)>1;
        xnew=plotparam.xpolyfitval(end);
        for polyind=2:length(plotparam.xpolyfitval)
            xnew=xnew+xdata.^(polyind-1)*plotparam.xpolyfitval(end-polyind+1);
        end
        xdata=xnew;
    end


  
    if length(plotparam.xfitmin)==1
        plotparam.xfitmin=plotparam.xfitmin*ones(size(seriesnumber));
    end
    if length(plotparam.xfitmax)==1
        plotparam.xfitmax=plotparam.xfitmax*ones(size(seriesnumber));
    end
    
end


