close all

%Fit fermions 
%Does not run from network folder
CurrentScriptPath = mfilename('fullpath');
CurrentDirectory = CurrentScriptPath(1:end-10);
addpath([CurrentDirectory,'tools'])
DataDirectory = [CurrentScriptPath(1:end-31),'Data\'];
% Data to load %

%Loading S16 data. This data is located inside Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Data\200911\S16
SeriesDate = '200911';
series = 's29';
% PictureS = [28,29,30,31];
 PictureS = [28];

% Crop picture rectangle %
params.rectIna = [ 888 ,8     ,  894      , 1165]; %% 
params.cameranumber = 3;
params.cameraResolution = [14.32,14.32];  %camera resolution um/pix (horizontal imaging) for x and y

Results1Dx = {};Results1Dy = {};expSigmay = {};expSigmax = {};
sigmaxvector = [] ; sigmayvector = [];
Dsigmaxvecotr = [];Dsigmayvecotr = [];

for ind = 1:length(PictureS)
    
SeriesDataFolder = [DataDirectory,SeriesDate,'\',series];

PictureNumber = PictureS(ind);
TOF = 0.1;

[Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,F] = MyGaussfit1D(SeriesDataFolder,PictureNumber,params);
[resutls , sigma ,xdata ] = MyGaussfit2D2D(SeriesDataFolder,PictureNumber,params,Results1Dx,Results1Dy);

sigmaxvector = [sigmaxvector,resutls(2)];
sigmayvector = [sigmayvector,resutls(4)];
plotAllfigures (xdata,resutls,sigma,Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,F,params,PictureS,series,SeriesDate,ind)

end

meanSigmax =  mean(sigmaxvector)*params.cameraResolution(1);
meanSigmay = mean(sigmayvector)*params.cameraResolution(2);
sigmaSigmax = std(sigmaxvector)*params.cameraResolution(1);
sigmaSigmay = std(sigmayvector)*params.cameraResolution(2);

displayValue = ['\sigma_{x} =' , num2str( meanSigmax),'\pm',num2str( sigmaSigmax)];
displayValue2 = ['\sigma_{y} =' , num2str( meanSigmay),'\pm',num2str( sigmaSigmay)];
display(displayValue)
display(displayValue2)

atomnumber = 8.41*10^7;
ProducofWaist = meanSigmax^2*meanSigmay;
cte = 1/(2*pi)^3;0.040
peakDensity = cte*atomnumber/ProducofWaist;


peakDensity = 8.41*10^7