close all

%Fit fermions 
%Does not run from network folder
CurrentScriptPath = mfilename('fullpath');
CurrentDirectory = CurrentScriptPath(1:end-6);
addpath([CurrentDirectory,'tools'])
DataDirectory = 'Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Data\';


% Data to load %
params.rectIna = [1100, 47, 478, 922]; %% 
params.cameranumber = 3;
params.cameraResolution = [14.32, 14.32];  %camera resolution um/pix (horizontal imaging) for x and y


% 
SeriesDate = '200911';
picture = [1,2,16,2, 1,15];
series = {'S4','S9','S16','S4','S9','S16'};


if (~exist('imRawdata'))
    imRawdata = loadPictureData(DataDirectory, SeriesDate, series{1}, picture(1), params);
    for i  = 2:size(picture,2)
        imRawdata = loadPictureData(DataDirectory, SeriesDate, series{i}, picture(i), params) + imRawdata;
    end
    imRawdata = imRawdata/size(picture,2);
    [sizeDataY, sizeDataX]= size(imRawdata);
end

%maxPic = max(max(data))
%minPic = min(min(data));
%F = (data-minPic)/(maxPic-minPic)*256;
% imshow(F,jet(256),'Border','tight');
% Target = 'Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Matlab\MOTDimensions\InsetPic.Mat'
% save(Target,'F')




datamapinput=[0 0 0 0;...
    1/255 0 0 0;...
    22/255 0 0 1;...
    61/255 0 1 1;...
    100/255 0 1 0;...
    139/255 1 1 0;...
    180/255 1 0 0;...
    215/255 1 0 1;...
    230/255 1 0.7 1;...
    1 1 1 1];
datacolormap=makecolormap(datamapinput,256);


maxOD = 1.1;
DataTicks=[0 0.5 1];
ImDataScale=255/maxOD;
ImDataOffset=0.05;
RawOffset = 0.;
FIGSIZEX1=500;    FIGSIZEY1=500;    FIGXOFFSET1=1000;    FIGYOFFSET1=100;
figurenumber = 37;


figure(figurenumber);
clf;
set(figurenumber,'position',[FIGXOFFSET1 FIGYOFFSET1 FIGSIZEX1/2 FIGSIZEY1/2]);

ResidualsBECRGB=ind2rgb(round(max(0,min((imrotate(imRawdata,90)+ImDataOffset)*ImDataScale+RawOffset,255))),datacolormap);
image(ResidualsBECRGB);

colormap(datacolormap);
cb=colorbar('Ticks',((DataTicks+ImDataOffset)*ImDataScale+RawOffset)/255,'TickLabels',num2str(DataTicks'));
cb.Label.String = 'Optical density';
cb.FontSize = 14;
cb.TickLength = 0.03;
set(cb,'linewidth',2);

axis image
%set(gca,'linewidth',2);
set(gca,'visible','off');
set(gca,'FontSize',20,'XTickLabelMode','manual','XTickLabel',[],'YTickLabelMode','manual','YTickLabel',[]);

scaleValue = 0.005;
lengthScaleInPix = round(scaleValue/(params.cameraResolution(1) * 0.000001));
hold on
p1 = [sizeDataX*0.9, sizeDataY*0.05];
p2 = [sizeDataX*0.9, sizeDataY*0.05 + lengthScaleInPix];
plot([p1(2),p2(2)],[p1(1),p2(1)],'Color','w','LineWidth',3);
text(sizeDataY*0.05,sizeDataX*0.75, '5 mm','Color',[1 1 0.99],'FontSize',14);
hold off




filename = 'MOT_mean_absorption';
print(figurenumber,'-dpdf',filename);
print(figurenumber,'-dsvg',filename);


