close all
% 
% % 
addpath('Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Matlab\FermiMOTVisionTools');

params=visionplotparams;
params.RunningFolder = mfilename('fullpath'); 
params.filename = mfilename();
[params.filename,params.filepath] = saveScriptv2(params.RunningFolder,params.filename);
params.displayimageloadingmessages=1;

params.ROIDataFileName = 'S:\Vision\200923\backgroundROIdata_S10.mat';
%%%%%%%%%%%%%%%
% Plot style
%%%%%%%%%%%%%%%
params.linestyle='.';
params.plotoptions='''LineWidth'',10';

params.title=[params.filename,' 88Sr loading curve'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Camera # / scanned variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
params.cameranumber=3;
params.dataparameters=1;
% params.dofit = 11;
params.xlabel=' Modulation frequency [MHz] ';
params.ylabel='Capture MOT NI (5 sec loading)';
%%Aom 100 % seriesvals=[43,48,52]
%%Aom 60  % seriesvals=[42,49,53]
%%Aom 40  % seriesvals=[44,47,51]
%%Aom 20  % seriesvals= [ 55,56,57,59]
% AOM @ 60 % ,45,46,47,48,49,50,51,52,53,54];
dateval = '200923'

% %% % Modulation frequency 5 KHz 
% params.yscale = 1
params.analysis = 0





%% % Modulation frequency 15 KHz 
seriesvals=[24,25,26,28];
params.legendstext = {
'Modulation frequency mode 3 Frequency = 15 KHz'
'Modulation frequency mode 3 Frequency = 15 KHz'
'Modulation frequency mode 3 Frequency = 15 KHz'
'Modulation frequency mode 3 Frequency = 15 KHz'
'Modulation frequency mode 3 Frequency = 15 KHz'

}
params.LorentCenter = [100,166,230,280];
params.xoffset=[0,0,0,0];

params.dofit = 16
params.legendlocation='southoutside';
% params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+11;
FermiMOTAnalazideDatav2(seriesvals,dateval,params);
% axis([0 0.2 0 inf]);

% 

%% % Modulation frequency 10 KHz 
params.yscale = [1,1,1,0.8,0.8]   % I relocked the blue lasers between series 15 and series 17 so i correct with some scaling.

seriesvals=[11,15,17,18];
params.legendstext = {
'Modulation frequency mode 3 Frequency = 10 KHz'
'Modulation frequency mode 3 Frequency = 10 KHz'
'Modulation frequency mode 3 Frequency = 10 KHz'
'Modulation frequency mode 3 Frequency = 10 KHz'
'Modulation frequency mode 3 Frequency = 10 KHz'

}
params.LorentCenter = [100,200,300,400];
params.xoffset=0;

params.dofit = 16

params.legendlocation='southoutside';
% params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+11;
FermiMOTAnalazideDatav2(seriesvals,dateval,params);
% axis([0 0.2 0 inf]);

%% % Modulation frequency 20 KHz 
params.yscale = 1

seriesvals=[19,19,19,19];
params.legendstext = {
'Modulation frequency mode 3 Frequency = 20 KHz'
'Modulation frequency mode 3 Frequency = 20 KHz'
'Modulation frequency mode 3 Frequency = 20 KHz'
'Modulation frequency mode 3 Frequency = 20 KHz'


}
params.xfitmin = [92,144,194,242]

params.xfitmax = [144,194,242,295]

params.LorentCenter = [100,150,200,250];
params.dofit = 16

params.legendlocation='southoutside';
% params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+11;
FermiMOTAnalazideDatav2(seriesvals,dateval,params);
% axis([0 0.2 0 inf]);

%% % Modulation frequency 40 KHz 
params.yscale = 1

seriesvals=[20];
params.legendstext = {
'Modulation frequency mode 3 Frequency = 40 KHz'


}

params.legendlocation='southoutside';
% params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+11;
FermiMOTAnalazideDatav2(seriesvals,dateval,params);
% axis([0 0.2 0 inf]);

