close all

%%%%%%%%%%%%%%%
% Inizialization
%%%%%%%%%%%%%%%
params=visionplotparams;
params.isFluoresencePic = 1;
params.RunningFolder = mfilename('fullpath'); 
params.thisScriptName = mfilename();
[params.filename,params.filepath] = saveScriptv2(params.RunningFolder,params.thisScriptName);
params.savedata = false;
params.displayimageloadingmessages=1;
params.displayseriesparameters=1;


%%%%%%%%%%%%%%%
% Plot style
%%%%%%%%%%%%%%%
params.linestyle='.';
params.plotoptions='''LineWidth'',10';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Camera # / scanned variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
params.cameranumber=6;
params.dataparameters=1;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data informations ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%params.yscale=[1,3];
seriesvals=[21,22,23,24];
dateval='180801';
params.legendstext={...    
    'COMass mj = -1'...    
    'COMass mj = -1'...    
    'COMass mj = 0'...
    'COMass mj = 0'...
};
  params.offsets = [-0.5,0.25,1,2]
  params.widths = [0.5 ,0.5,0.5,0.5]
  params.peaks = [6,10,10,6]*10^6
  params.background = 2*10^6;


%%%%%%%%%%%%%%%
% Save data
%%%%%%%%%%%%%%%

 params.savedata = false;

%%%%%%%%%%%%%%%
% Fitting options
%%%%%%%%%%%%%%%
%  params.xfitmax=[2000];
% params.start=79.97;
% params.upperbound = 123123123123123123;
% params.lowerbound = 0;
% params.dofit=16;
% params.analysis=18;
%  params.analysis=18;


%%%%%%%%%%%%%%%
% Axes labels
%%%%%%%%%%%%%%%
params.title=[params.filename,'  B field cal '];
params.xlabel='Push beam Freq [MHz]'
params.ylabel='Cloud displacement [px]';

% PLOT displacement of cloud NUMBER %
params.legendlocation='southoutside';
params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+35;
FermiMOTAnalazideDatav2Simplified(seriesvals,dateval,params);
% axis([84 86 10 12 ]);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data informations ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%params.yscale=[1,3];
seriesvals=[21,22,23];
dateval='180720';
params.legendstext={...    
    'COMass mj = -1'...    
    'COMass mj = -1'...    
    'COMass mj = 0'...
    'COMass mj = 0'...
};



%%%%%%%%%%%%%%%
% Save data
%%%%%%%%%%%%%%%

 params.savedata = false;

%%%%%%%%%%%%%%%
% Fitting options
%%%%%%%%%%%%%%%
%  params.xfitmax=[2000];
% params.start=79.97;
% params.upperbound = 123123123123123123;
% params.lowerbound = 0;
 params.dofit=17;
 params.otherOptions =4 %Merge series into 1
% params.analysis=18;
 params.analysis=0;


%%%%%%%%%%%%%%%
% Axes labels
%%%%%%%%%%%%%%%
params.title=[params.filename,'  B field cal SEries 21, 22,23 '];
params.xlabel='Push beam Freq [MHz]'
params.ylabel='Cloud displacement [px]';

% PLOT displacement of cloud NUMBER %
params.legendlocation='southoutside';
params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+11;
FermiMOTAnalazideDatav2Simplified(seriesvals,dateval,params);
% axis([84 86 10 12 ]);





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data informations ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
params.dataparameters=1;
%params.yscale=[1,3];
seriesvals=[4,5,6];
dateval='181029';
params.legendstext={...    
    'BMVHC 0 BMVAC 0'...    
    'BMVHC 0 BMVAC 2.5'...    
    'BMVHC 0 BMVAC 5'...
};

  params.offsets = [-0.5,0.25,1,2]
  params.widths = [0.5 ,0.5,0.5,0.5]
  params.peaks = [6,10,10,6]*10^6
  params.background = 2*10^6;

%%%%%%%%%%%%%%%
% Save data
%%%%%%%%%%%%%%%

 params.savedata = false;

%%%%%%%%%%%%%%%
% Fitting options
%%%%%%%%%%%%%%%
%  params.xfitmax=[2000];
% params.start=79.97;
% params.upperbound = 123123123123123123;
% params.lowerbound = 0;
 params.dofit=0;
 params.otherOptions =0 %Merge series into 1
 params.analysis=18;
%  params.analysis=0;


%%%%%%%%%%%%%%%
% Axes labels
%%%%%%%%%%%%%%%
params.title=[params.filename,'  B field cal SEries 21, 22,23 '];
params.xlabel='Push beam Freq [MHz]'
params.ylabel='Cloud displacement [px]';

% PLOT displacement of cloud NUMBER %
params.legendlocation='southoutside';
params.removenegative=1;
params.linestyle='.';
params.datasection=params.dataparameters+11;
FermiMOTAnalazideDatav2Simplified(seriesvals,dateval,params);
% axis([84 86 10 12 ]);