cLum=2.99792458e8;

mSr88=87.9056121*au; % (* kg *)
mSr87=86.9088771*au;
mSr86=85.9092602*au;
mSr84=83.913425*au;

AbondancySr88=82.6/100;
AbondancySr87=7.0/100;
AbondancySr86=9.9/100;
AbondancySr84=0.56/100;
%  (* see Ludlow thesis *)
Lambda1S0to1P1=460.862369e-9; % (* blue Mot *)
Gamma1S0to1P1=2*pi*30.2e6;

Lambda1D2to1P1=6.5e-6; % (* spontaneous decay *)
Gamma1D2to1P1=2*pi*621.;

Lambda3P1to1D2=1.77e-6; % (* spontaneous decay *)
Gamma3P1to1D2=2*pi*350.;
Lambda3P2to1D2=1.9e-6; % (* spontaneous decay *)
Gamma3P2to1D2=2*pi*175.;

Lambda1S0to3P2=671e-9;
Gamma1S0to3P2=2*pi*0.0003;
% Lambda1S0to3P1=689.4490984e-9; % (* red Mot *)
Lambda1S0to3P1=cLum/434.8289942e12; % (* red Mot *)
Gamma1S0to3P1=2*pi*7.46e3;
Lambda1S0to3P0=698e-9;
Gamma1S0to3P0=2*pi*0.0011; % (* Sr 87 uniquement, faute? *)

Lambda3P2to3D3=496.23e-9; % (* repump not used*)
Gamma3P2to3D3=2*pi*9.8e6;
Lambda3P2to3D2=496.79e-9; % (* repump *)
Gamma3P2to3D2=2*pi*2.04e6;
Lambda3P2to3D1=497.17e-9; % (* repump not used *)
Gamma3P2to3D1=2*pi*0.21e3;

Lambda3P1to3D2=487.25e-9; % (* repump not used *)
Gamma3P1to3D2=2*pi*7.64e6; %(* A = 61 * X/X from Boyd thesis, NIST give A = 48.0 *)
Lambda3P1to3D1=487.7436364819e-9; % (* repump not used *)
Gamma3P1to3D1=2*pi*2.02e6; %(* A = 61 *5/24 from Boyd thesis, NIST give A = 26.3 *)
Lambda3P0to3D1=483.20e-9; % (* repump not used *)
Gamma3P0to3D1=2*pi*33e6;

% Lambda3P0to3S1=679.1e-9; % (* repump not used *)
Lambda3P0to3S1=cLum/441.3324519e12; % (* repump not used *)
Gamma3P0to3S1=2*pi*1.42e6;
% Lambda3P1to3S1=688.02105e-9; % (* repump not used *)
Lambda3P1to3S1=cLum/435.7315193e12; % (* repump not used *)
Gamma3P1to3S1=2*pi*1.95e6; %(* 201 *5.15/1.9 /(2 * pi) / 6 from litterature Kai Guo,Guangfu Wang and Anpei Ye J.Phys.B:At.Mol.Opt.Phys.43 (2010) 135004 *)
% Lambda3P2to3S1=707.0e-9; % (* repump not used *)
Lambda3P2to3S1=cLum/423.9133709e12; % (* repump not used *)
Gamma3P2to3S1=2*pi*0.7e6; %(* but 2*pi*1.4 according to NIST*)

Lambda1D2to1P1=448.180255947677e-9;
Gamma1D2to1P1=2*pi*3.023e6;

LambdaBlue=Lambda1S0to1P1;
GammaBlue=Gamma1S0to1P1;
LambdaRed=Lambda1S0to3P1;
GammaRed=Gamma1S0to3P1;
LambdaRepump=Lambda3P2to3D2;
GammaRepump=Gamma3P2to3D2;
a1S0iso88=-1.4*aB; %(* +/- 6 *)
a1S0iso87=96.2*aB; %(* +/- 1 *) 
a1S0iso86=823*aB; %(* +/- 24 *) 
a1S0iso84=122.7*aB; %(* +/- 3 *)

a1S0iso88vs87=55*aB; %(* +/- 2 *)
a1S0iso88vs86=97.4*aB; %(* +/- 1 *)
a1S0iso88vs84=1790*aB; %(* +/- 130 *)
a1S0iso87vs86=162.5*aB; %(* +/- 5 *)
a1S0iso87vs84=-56*aB; %(* +/- 1 *)
a1S0iso86vs84=31.9*aB; %(* +/- 3 *)
% (* Facteurs de Land *)
% (* Bosons *)
g1S0Bosons=0;

g1P1Bosons=1;

g1D2Bosons=1;

g3P0Bosons=0;
g3P1Bosons=3/2;
g3P2Bosons=3/2;

g3D1Bosons=1/2;
g3D2Bosons=7/6;
g3D3Bosons=4/3;

% (* Fermions *)
g1SOF9sur2=200/MuB; % (*200 Hz/Gauss x mF *)

g1P1F7sur2=-2/9;
g1P1F9sur2=4/99;
g1P1F11sur2=2/11;

g1D2F5sur2=-4/7;
g1D2F7sur2=-2/21;
g1D2F9sur2=4/33;
g1D2F11sur2=34/143;
g1D2F13sur2=4/13;

g3POF9sur2=200/MuB; %(*200 Hz/Gauss x mF *)

g3P1F7sur2=-1/3;
g3P1F9sur2=2/33;
g3P1F11sur2=3/11;

g3P2F5sur2=-6/7;
g3P2F7sur2=-1/7;
g3P2F9sur2=2/11;
g3P2F11sur2=51/143;
g3P2F13sur2=6/13;

TdopplerBlue=hbarre*Gamma1S0to1P1/(2*kB);
TdopplerRed=hbarre*Gamma1S0to3P1/(2*kB);

TrecoilBlue88=ctePlanck^2/(Lambda1S0to1P1^2*mSr88*kB);
TrecoilBlue86=ctePlanck^2/(Lambda1S0to1P1^2*mSr86*kB);
TrecoilBlue84=ctePlanck^2/(Lambda1S0to1P1^2*mSr84*kB);
TrecoilRed88=ctePlanck^2/(Lambda1S0to3P1^2*mSr88*kB);
TrecoilRed86=ctePlanck^2/(Lambda1S0to3P1^2*mSr86*kB);
TrecoilRed84=ctePlanck^2/(Lambda1S0to3P1^2*mSr84*kB);

VrecoilBlue88=hbarre*(2*pi/Lambda1S0to1P1)/mSr88;
VrecoilBlue87=hbarre*(2*pi/Lambda1S0to1P1)/mSr87;
VrecoilBlue86=hbarre*(2*pi/Lambda1S0to1P1)/mSr86;
VrecoilBlue84=hbarre*(2*pi/Lambda1S0to1P1)/mSr84;
VrecoilRed88=hbarre*(2*pi/Lambda1S0to3P1)/mSr88;
VrecoilRed87=hbarre*(2*pi/Lambda1S0to3P1)/mSr87;
VrecoilRed86=hbarre*(2*pi/Lambda1S0to3P1)/mSr86;
VrecoilRed84=hbarre*(2*pi/Lambda1S0to3P1)/mSr84;

ISatBlue =pi*ctePlanck*cLum*Gamma1S0to1P1/(3*Lambda1S0to1P1^3);
ISatRed =pi*ctePlanck*cLum*Gamma1S0to3P1/(3*Lambda1S0to3P1^3);


