function [x0]=fitSSBECbackground2(oldimdata,SSBECfitparam,xx,yy,X,Y,x0)

imdata=oldimdata;

if nargin<7
    xprofile=sum(imdata,1);
    xposdata=(1:length(xprofile))*SSBECfitparam.Xcal;

    transportX=[xposdata(SSBECfitparam.transportXrange1(1):SSBECfitparam.transportXrange1(2)), xposdata(SSBECfitparam.transportXrange2(1):SSBECfitparam.transportXrange2(2))];
    transportXData=[xprofile(SSBECfitparam.transportXrange1(1):SSBECfitparam.transportXrange1(2)), xprofile(SSBECfitparam.transportXrange2(1):SSBECfitparam.transportXrange2(2))];

    transportYData=sum(imdata(:,SSBECfitparam.transportXrange1),2).'/(SSBECfitparam.transportXrange1(2)-SSBECfitparam.transportXrange1(1)+1);

    yposdata=(1:length(transportYData))*SSBECfitparam.Ycal;


    % remove the transport guide signal

    transportY=yposdata;

     % gaussian fit the transport (Y direction)

    transportYx0(1)=max(transportYData)-min(transportYData);
    [~,maxloc]=max(transportYData);
    transportYx0(2)=transportY(maxloc);
    transportYx0(3)=sum(transportYData-min(transportYData))/transportYx0(1)/2*(max(transportYData)-min(transportYData))/length(transportYData);
    transportYx0(4)=min(transportYData);
    lb=[transportYx0(1)/2,min(transportY),transportYx0(3)/100,transportYx0(4)-(std(transportYData))];
    ub=[transportYx0(1)*2,max(transportY),transportYx0(3)*100,transportYx0(4)+(std(transportYData))];
    % display('fitting...');
    xfittedTransportY=lsqcurvefit(@gaussian,transportYx0,transportY,transportYData,lb,ub);
    % yfitdataTransportY=gaussian(xfittedTransportY,transportY);
    % xfitdataTransportY=transportY;
    % % dofitplot=1;
    % % display(['Transport Y: ',num2str(xfittedTransportY(1)),'*exp(-((x-',num2str(xfittedTransportY(2)),')/',num2str(xfittedTransportY(3)),')^2)+',num2str(xfittedTransportY(4))]);
    % 
    % % figure(101);
    % % plot(transportY,transportYData,'k.',xfitdataTransportY,yfitdataTransportY,'r');
    % % title('Transport Y fitting');

    imdata=imdata-xfittedTransportY(4);

    % gaussian fit the transport (X direction)

    transportXx0(1)=max(transportXData)-min(transportXData);
    [~,maxloc]=max(transportXData);
    transportXx0(2)=transportX(maxloc);
    transportXx0(3)=sum(transportXData-min(transportXData))/transportXx0(1)/2*(max(transportXData)-min(transportXData))/length(transportXData);
    transportXx0(4)=min(transportXData);
    lb=[transportXx0(1)/2,min(transportX),transportXx0(3)/100,transportXx0(4)-(std(transportXData))];
    ub=[transportXx0(1)*2,max(transportX),transportXx0(3)*100,transportXx0(4)+(std(transportXData))];
    % display('fitting...');
    xfittedTransportX=lsqcurvefit(@gaussian,transportXx0,transportX,transportXData,lb,ub);
    % yfitdataTransport=gaussian(xfittedTransport,transportX);
    % xfitdataTransport=transportX;
    % % dofitplot=1;
    % % display(['Transport X: ',num2str(xfittedTransport(1)),'*exp(-((x-',num2str(xfittedTransport(2)),')/',num2str(xfittedTransport(3)),')^2)+',num2str(xfittedTransport(4))]);
    % 
    % % figure(108);
    % % plot(transportX,transportXData,'g.',xfitdataTransport,yfitdataTransport,'g.');
    % % title('X fitting');

    % remove 2D transport fit first section

    transportfit(1:3)=xfittedTransportX(1:3);
    transportfit(4:6)=xfittedTransportY(1:3);

    transport2D=(transportfit(1)*exp(-((xx-transportfit(2))/transportfit(3)).^2)).*...
        (transportfit(4)*exp(-((yy-transportfit(5))/transportfit(6)).^2));

    transport2Dsubsection=transport2D(:,SSBECfitparam.transportXrange1(1):SSBECfitparam.transportXrange1(2));
    transport2Ddatasubsection=imdata(:,SSBECfitparam.transportXrange1(1):SSBECfitparam.transportXrange1(2));

    x0a(1)=1;
    x0a(2)=0;

    % display('fitting...');
    x0a=fminsearch(@(x) modefit(x,transport2Dsubsection,transport2Ddatasubsection),x0a);

    transportfit(7:8)=x0a(1:2);

    imdata=imdata-transportfit(8);
    transport2D=transport2D*transportfit(7);
    imdata=imdata-transport2D;

    % figure(202);
    % imagesc(imdata);
    % colorbar;
    % colormap jet;

    % next lets estimate the fitting parameters for the background fit

    xprofile=sum(imdata,1);

    reservoirX=[xposdata(SSBECfitparam.reservoirXrange1(1):SSBECfitparam.reservoirXrange1(2)), xposdata(SSBECfitparam.reservoirXrange2(1):SSBECfitparam.reservoirXrange2(2))];
    reservoirXData=[xprofile(SSBECfitparam.reservoirXrange1(1):SSBECfitparam.reservoirXrange1(2)), xprofile(SSBECfitparam.reservoirXrange2(1):SSBECfitparam.reservoirXrange2(2))];
    % dimpleX=[xposdata(SSBECfitparam.dimpleXrange(1):SSBECfitparam.dimpleXrange(2))];
    % dimpleXData=[xprofile(SSBECfitparam.dimpleXrange(1):SSBECfitparam.dimpleXrange(2))];

    dimpleYData=sum(imdata(:,SSBECfitparam.dimpleXrange),2).'/(SSBECfitparam.dimpleXrange(2)-SSBECfitparam.dimpleXrange(1)+1);
    reservoirYData=sum(imdata(:,SSBECfitparam.reservoirXrange2),2).'/(SSBECfitparam.reservoirXrange2(2)-SSBECfitparam.reservoirXrange2(1)+1);

    dimpleY=yposdata;
    reservoirY=yposdata;

    % gaussian fit the reservoir (X direction)

    reservoirXDataRes=reservoirXData; %-gaussian(xfittedTransport,reservoirX);

    % figure(102);
    % plot(reservoirX,reservoirXDataRes,'b.');


    reservoirXx0(1)=max(reservoirXDataRes)-min(reservoirXDataRes);
    [~,maxloc]=max(reservoirXDataRes);
    reservoirXx0(2)=reservoirX(maxloc);
    reservoirXx0(3)=(reservoirX(end)-reservoirX(1))/4;
    %                 reservoirXx0(3)=sum(reservoirXDataRes-min(reservoirXDataRes))/reservoirXx0(1)/2*(max(reservoirXDataRes)-min(reservoirXDataRes))/length(reservoirXDataRes);
    reservoirXx0(4)=min(reservoirXDataRes);
    lb=[reservoirXx0(1)/2,min(reservoirX),reservoirXx0(3)/10,reservoirXx0(4)-(std(reservoirXDataRes))];
    ub=[reservoirXx0(1)*2,max(reservoirX),reservoirXx0(3)*10,reservoirXx0(4)+(std(reservoirXDataRes))];
    % display('fitting...');
    xfittedReservoir=lsqcurvefit(@gaussian,reservoirXx0,reservoirX,reservoirXDataRes,lb,ub);
    % yfitdataReservoir=gaussian(xfittedReservoir,reservoirX);%+gaussian(xfittedTransport,reservoirX);
    % xfitdataReservoir=reservoirX;
    % % dofitplot=1;
    % % display(['Reservoir X: ',num2str(xfittedReservoir(1)),'*exp(-((x-',num2str(xfittedReservoir(2)),')/',num2str(xfittedReservoir(3)),')^2)+',num2str(xfittedReservoir(4))]);
    % 
    % % figure(103);
    % % plot(reservoirX,reservoirXData,'b.',dimpleX,dimpleXData,'r.',xfitdataReservoir,yfitdataReservoir,'b.');
    % % %                plot(transportX,transportXData,'g.',reservoirX,reservoirXData,'b.',dimpleX,dimpleXData,'r.',xfitdataTransport,yfitdataTransport,'g.',xfitdataReservoir,yfitdataReservoir,'b.');
    % % title('X fitting');
    % % 
    % % %                 legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];

    % gaussian fit the reservoir (Y direction)

    reservoirYx0(1)=max(reservoirYData)-min(reservoirYData);
    [~,maxloc]=max(reservoirYData);
    reservoirYx0(2)=reservoirY(maxloc);
    reservoirYx0(3)=sum(reservoirYData-min(reservoirYData))/reservoirYx0(1)/2*(max(reservoirYData)-min(reservoirYData))/length(reservoirYData);
    reservoirYx0(4)=min(reservoirYData);
    lb=[reservoirYx0(1)/2,min(reservoirY),reservoirYx0(3)/100,reservoirYx0(4)-(std(reservoirYData))];
    ub=[reservoirYx0(1)*2,max(reservoirY),reservoirYx0(3)*100,reservoirYx0(4)+(std(reservoirYData))];
    % display('fitting...');
    xfittedReservoirY=lsqcurvefit(@gaussian,reservoirYx0,reservoirY,reservoirYData,lb,ub);
    % yfitdataReservoirY=gaussian(xfittedReservoirY,reservoirY);
    % xfitdataReservoirY=reservoirY;
    % % dofitplot=1;
    % % display(['Reservoir Y: ',num2str(xfittedReservoirY(1)),'*exp(-((x-',num2str(xfittedReservoirY(2)),')/',num2str(xfittedReservoirY(3)),')^2)+',num2str(xfittedReservoirY(4))]);
    % 
    % % figure(104);
    % % plot(reservoirY,reservoirYData,'k.',xfitdataReservoirY,yfitdataReservoirY,'r');
    % % title('Reservoir Y fitting');

    % gaussian fit the dimple (Y direction)

    dimpleYx0(1)=max(dimpleYData)-min(dimpleYData);
    [~,maxloc]=max(dimpleYData);
    dimpleYx0(2)=dimpleY(maxloc);
    dimpleYx0(3)=sum(dimpleYData-min(dimpleYData))/dimpleYx0(1)/2*(max(dimpleYData)-min(dimpleYData))/length(dimpleYData);
    dimpleYx0(4)=min(dimpleYData);
    lb=[dimpleYx0(1)/2,min(dimpleY),dimpleYx0(3)/100,dimpleYx0(4)-(std(dimpleYData))];
    ub=[dimpleYx0(1)*2,max(dimpleY),dimpleYx0(3)*100,dimpleYx0(4)+(std(dimpleYData))];
    % display('fitting...');
    xfittedDimpleY=lsqcurvefit(@gaussian,dimpleYx0,dimpleY,dimpleYData,lb,ub);
    % yfitdataDimpleY=gaussian(xfittedDimpleY,dimpleY);
    % xfitdataDimpleY=reservoirY;
    % % dofitplot=1;
    % % display(['Dimple Y: ',num2str(xfittedDimpleY(1)),'*exp(-((x-',num2str(xfittedDimpleY(2)),')/',num2str(xfittedDimpleY(3)),')^2)+',num2str(xfittedDimpleY(4))]);
    % 
    % 
    % % figure(105);
    % % plot(dimpleY,dimpleYData,'k.',xfitdataDimpleY,yfitdataDimpleY,'r');
    % % title('Dimple Y fitting');

    % construct a 2D model for the Crossover+Reservoir+Dimple+BEC and fit
    % the free parameters

    [Dimpleampl,DimpleXpos]=max(max(imdata,[],1));

    x0(1)=Dimpleampl/3; % x0(1)=DimpleN;
    x0(2)=xfittedDimpleY(3); % x0(2)=DimpleWy;
    x0(3)=Dimpleampl/3; %xfittedReservoirY(1)/2; % x0(3)=ReservoirN;
    x0(4)=xfittedReservoirY(3); % x0(4)=ReservoirWy;
    x0(5)=xfittedReservoir(3)*2; % x0(5)=ReservoirWx;
    x0(6)=Dimpleampl/3; %xfittedReservoirY(1); % x0(6)=CrossoverN;
    x0(7)=xfittedReservoirY(3); % x0(7)=CrossoverWy;
    x0(8)=xfittedReservoir(3); % x0(8)=CrossoverWx;
    x0(9)=X(DimpleXpos); % x0(13)=Dimplex;
    x0(10)=xfittedDimpleY(2); % x0(14)=Dimpley;
    x0(11)=xfittedReservoir(2); % x0(15)=Crossoverx;
    x0(12)=(xfittedReservoir(2)+x0(9))/2; % x0(16)=Reservoirx;
    %                 x0(13)=2e4; % x0(10)=BECN;
    %                 x0(14)=Dimpleampl/5; % x0(9)=BECampl;
    %                 x0(15)=2*pi*310; %BECWx; % omega_x=2*pi*310; % x0(11)=BECWx;
    %                 x0(16)=2*pi*550; %BECWy; % omega_y=2*pi*550; % x0(12)=BECWy;
    x0(13)=transportfit(1)*transportfit(4)*transportfit(7);
    x0(14:15)=transportfit(2:3);
    x0(16:17)=transportfit(5:6);
    x0(18)=transportfit(8);
    
    BECN=2e4; % x0(10)=BECN;
    BECwx=2*pi*310; %BECWx; % omega_x=2*pi*310; % x0(11)=BECWx;
    BECwy=2*pi*550; %BECWy; % omega_y=2*pi*550; % x0(12)=BECWy;
    
    x0(19)=BECN;
    x0(20)=BECwx;
    x0(21)=BECwy;
end

% options=optimset('Display','iter','TolFun',0.1);
options=optimset('Display','final','TolFun',0.1,'MaxFunEvals',4000);

% display('fitting...');
x0=fminsearch(@(x) estimateSSBECfiterror2(x,xx,yy,oldimdata,SSBECfitparam.aperturex,SSBECfitparam.aperturey),x0,options);

%% START: added to show aperturning::

estimatedprofileresult=constructSSBEC4(Parameters,xx,yy);
apertured=imdata-estimatedprofileresult;
apertured(aperturey(1):aperturey(2),aperturex(1):aperturex(2))=0;
                        figure(300);
                        imagesc(apertured);
                        colorbar;
%                         title(['\S',num2str(seriesnumber(ind)),' P',num2str(imagenum-1,'%04.0f')]);
%                         axis equal
                        colormap jet

%% END: added to show aperturning::


end

function [yfit]=gaussian(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithbackground(x,xdata)

yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithdecayandbackground(x,xdata)

yfit=x(1)*exp(-xdata/x(5)).*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=lorentzian(x,xdata)

yfit=x(1)./(1+4*((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=gaussian_nobackground(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2);

end

function [yfit]=modefit(x,model,data)

yfit=sum(sum(abs((x(1)*model+x(2)-data))));

end