function [xdata,ydata]=FermiMOTAnalazideDatav2Simplified(seriesnumber,inputdatetouse,plotparam)
%%Shaynes Matalba vision plotting code % Does Fiting and plots the data

% % Plot options % %

    % params.datasection=params.dataparameters+11;
    % plotparam.logyscale =  1 Sets log scale
    % plotparm.Testimate = 1 Calculates Temperature like vision

% % Fit options % %

    % params.xfitmax=[8000];
    % params.xfitmin=[200];
    % params.dofit=15;   
    % params.polyfitorder=1;
    
% % Fit functions % 
% case 1   % linear fit
% case 5   % linear fit with scaling
% case 2   % exponential fit, no background
% case 3   % exponential fit, no background, t offset
% case 4   % exponential fit with background
% case 6   % exponential fall fit with nobackground
% case 9   % exponential fall fit with background   --- !!! DO NOT USE !!!
% case 11  % lorentzian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% case 7   % gaussian fit with background  yfit=x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% case 8   % gaussian fit with no background
% case 10  % sectional average
% case 12  % sinusoidal fit with background  yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);
% case 13  % decaying sinusoidal fit with background  yfit=x(1)*exp(-t/x(5))*sin(2*pi*x(2)*xdata+x(3))+x(4);
% CASE 15  % exponential fit not backround  yfit=x(1)*exp(-t/x(2))

% % Analysis Options %% 
%Selected by setting params.analysis == 
% case 0 Using vision raw data
% case 13 PSD
% case 16 YPSD
% case 22 % updated principle component analysis 20191226

c=2.99792458e8;
h=6.62606896e-34;
lambda=460.862369e-9;
gamma=2*pi*30.2e6;
NSTD=1.5;
dSTD=0.02;

if plotparam.averageseries == 0 ;
    plotparam.averageseries = zeros(1,length(seriesnumber));
end

if isempty(plotparam.title)
    plotparam.title=['Series ',num2str(seriesnumber)];
end



if (length(seriesnumber)> length(plotparam.legendstext))
    error('Please add mising legend entries')
end
for k = 1 : length(seriesnumber)

    
    if isa(inputdatetouse,'cell') % If there is more than one date run this one
        seriesname{k} =[char(inputdatetouse(k)),' S',num2str(seriesnumber(k)),'     ',char(plotparam.legendstext(k))] ;           % Cell Array
    else % If there is only one date run this one
        seriesname{k} =[char(inputdatetouse),' S',num2str(seriesnumber(k)),'     ',char(plotparam.legendstext(k))]      ;      % Cell Array
    end 
end

plotparam.legendtext = seriesname;
for ind=1:length(seriesnumber)
    xdataAverage{ind} = [];
end
for ind=1:length(seriesnumber)

    if iscell(inputdatetouse)
        inputdate=inputdatetouse{ind};
    else
        inputdate=inputdatetouse;
    end

    if plotparam.analysis==0 % use vision data
        [xdata{ind},ydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
        cte = 1 + 4*plotparam.lightDetunning^2;
        ydata{ind} = ydata{ind}*cte; 
        if plotparam.displayseriesparameters
            extractparameters(inputdate,seriesnumber(ind),plotparam.parameterstoprint);
        end
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        if plotparam.interleve~=1
            xdata{ind}=xdata{ind}(1:plotparam.interleve:end);
            ydata{ind}=ydata{ind}(1:plotparam.interleve:end);
        end
        if plotparam.selectivex
            goodpoints=find((xdata{ind}<=plotparam.selectivexrange(2))&(xdata{ind}>=plotparam.selectivexrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        if plotparam.selectivey
            goodpoints=find((ydata{ind}<=plotparam.selectiveyrange(2))&(ydata{ind}>=plotparam.selectiveyrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end

        if plotparam.averagerepetions
            counter = 1 ;
            
            for k=1:length(xdata{ind})
            a = find(xdata{ind}==xdata{ind}(k));
            meanval=mean(ydata{ind}(a));
            stdval=std(ydata{ind}(a));
            if ~(ismember(xdata{ind}(k), xdataAverage{ind}))
                ydataAverage{ind}(counter) = meanval;
                YdataErrorBar{ind}(counter) = stdval;
                xdataAverage{ind}(counter) = xdata{ind}(k);
                counter = counter +1;
            end
            end
            
            ydata{ind} =  ydataAverage{ind};
            err{ind} = YdataErrorBar{ind};
            xdata{ind} =  xdataAverage{ind};
        end


        
    elseif plotparam.analysis==18
          [~,ydata123{ind},~,~]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
          [~,index] = max(ydata123{ind});
        %   Use custum ROI
            [xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);
 
            visionPictNbCount = 1;
            ydata{ind}= zeros(1,length(xdata{ind}));
            
            if ind ==1 
                makeROIBool = true;
            else
               makeROIBool =false;
            end
           
            if ~isempty(strfind(plotparam.RunningFolder, 'Scripts\Scripts')) % % If running from Scripts folder used previous loaded roi
                makeROIBool =false;
            end
            
            % Load ROI
            if  ( makeROIBool  )
                [croppedPic,filenameVision] = LoadVisionDataTGA (directory,seriesnumber(ind),index,plotparam,makeROIBool);
                makeROIBool = false
            end
            for i = 1:length(xdata{ind})
                
                 [croppedPic,filenameVision] = LoadVisionDataTGA (directory,seriesnumber(ind),imagenumbers{ind}(i),plotparam,makeROIBool);
                 [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab,CenterOfMassX ,CenterOfMassY ,SpreadX,SpreadY] = calculateExperimentalValues (plotparam,filenameVision,croppedPic);
                 visionPictNbCount =visionPictNbCount +1 ;
                 if ( plotparam.datasection == 12)
                     ydata{ind}(i) = atomNumberTab;
                 elseif (plotparam.datasection == 36)
                     ydata{ind}(i) = CenterOfMassX;
                 end
 ydata{ind}(i) = CenterOfMassX;
            end
            
            
    elseif plotparam.analysis==19 % compare data from 2 cameras
        [xdata{ind},camdata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),4,2,plotparam.cameranumber(ind),plotparam.datafilename);
        [xdata{ind},ydata{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),plotparam.datasection,2,plotparam.cameranumber(ind),plotparam.datafilename);
        thiscam=find(camdata{ind}==(plotparam.cameranumber(ind)-1));
        xdata{ind}=xdata{ind}(thiscam);
        ydata{ind}=ydata{ind}(thiscam);
        
        if plotparam.displayseriesparameters
            extractparameters(inputdate,seriesnumber(ind),plotparam.parameterstoprint);
        end
        if plotparam.overridexaxiswithmeasurementnumber
            xdata{ind}=1:length(xdata{ind});
        end
        if plotparam.interleve~=1
            xdata{ind}=xdata{ind}(1:plotparam.interleve:end);
            ydata{ind}=ydata{ind}(1:plotparam.interleve:end);
        end
        if plotparam.selectivex
            goodpoints=find((xdata{ind}<=plotparam.selectivexrange(2))&(xdata{ind}>=plotparam.selectivexrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end
        if plotparam.selectivey
            goodpoints=find((ydata{ind}<=plotparam.selectiveyrange(2))&(ydata{ind}>=plotparam.selectiveyrange(1)));
            if ~isempty(goodpoints)
                xdata{ind}=xdata{ind}(goodpoints);
                ydata{ind}=ydata{ind}(goodpoints);
            end
        end       


         
    end
    


end % Analysis options for ploting. Loading data from vision raw file etc ... Ie PSD TOF etc. Generate the data

for ind=1:length(seriesnumber) % Adds scaling to data. i.e squares y axis adds offset multpies by constant etc
    if ind ==1  
        plotparam = SetDefaultValues (plotparam ,seriesnumber); %Set offsets scale and labes to default values.
    end
    [plotparam, xdata{ind} ,ydata{ind}] = ScaleData(plotparam, xdata{ind},ydata{ind},ind,seriesnumber);
end

for ind=1:length(seriesnumber)
    goodval=find(~isnan(ydata{ind}));
    if ~isempty(goodval)
        xdataoriginal{ind} = xdata{ind};
        ydataoriginal{ind}  = ydata{ind};
        xdata{ind}=xdata{ind}(goodval);
        ydata{ind}=ydata{ind}(goodval);
        [xdata{ind},order{ind}]=sort(xdata{ind});
        ydata{ind}=ydata{ind}(order{ind});
    else
        display('No good data');
        xdata{ind}=[];
        ydata{ind}=[];
    end
end % RGE I think these are data quality checks 

% % % % Other options for the plot % % % % 

if plotparam.otherOptions == 0
    %Do nothing
    
elseif    plotparam.otherOptions ==1 %average all series
         ydatafit =[];
         xdatafit = [];
         xdataAverage = [];
         
        for ind=1:length(xdata)
            xdataAverage= [xdataAverage,xdata{ind}];     
            xdatafit = [xdatafit,xdata{ind}];
            ydatafit = [ydatafit,ydata{ind}];
        end
        xdataAverage = unique (xdataAverage);
       for k = 1:length(xdataAverage)
        yaverage = [];    
        for ind=1:length(xdata)
                a = find(xdata{ind}==xdataAverage(k));
                yaverage = [yaverage,ydata{ind}(a)];
        end
         meanval=mean(yaverage);
         stdval=std(yaverage);
         ydataAverage (k)  =  meanval;
         ydataErrorBar (k) =stdval;
         
         SeriesLegend = arrayfun(@num2str,seriesnumber,'un',0)

      end

        SeriesLegend =  strjoin(['Average of Series',SeriesLegend],', s')
        plotparam.legendtext = {SeriesLegend};      
        ydataAvg =  {ydataAverage};
        YdataErrorBar = {ydataErrorBar};
        xdataAvg =  {xdataAverage};
        ydata = {ydatafit};
        xdata = {xdatafit};
elseif plotparam.otherOptions ==2
        [vector,originalorder{ind}]=sort(order{ind});
        ydata{ind}=ydata{ind}(originalorder{ind});   
        xdata{ind} = xdata{ind}(originalorder{ind});
        
  xdataAverage{ind} = [];
elseif plotparam.otherOptions ==3
    for ind=1:length(seriesnumber)
            counter = 1 ;
            
            for k=1:length(xdata{ind})
            a = find(xdata{ind}==xdata{ind}(k));
            meanval=mean(ydata{ind}(a));
            stdval=std(ydata{ind}(a));
            if ~(ismember(xdata{ind}(k), xdataAverage{ind}))
                ydataAverage{ind}(counter) = meanval;
                YdataErrorBar{ind}(counter) = stdval;
                xdataAverage{ind}(counter) = xdata{ind}(k);
                counter = counter +1;
            end
            end
            
            ydataAvg{ind} =  ydataAverage{ind};
            YdataErrorBar{ind} = YdataErrorBar{ind}/2;
            xdataAvg{ind} =  xdataAverage{ind};
    end
    elseif plotparam.otherOptions ==4
        ydata = {cell2mat(ydata)};
        xdata = {cell2mat(xdata)};
    elseif plotparam.otherOptions ==5
         ydatafit =[];
         xdatafit = [];
         xdataAverage = [];
         
        for ind=1:length(xdata)
            xdataAverage= [xdataAverage,xdata{ind}];     
            xdatafit = [xdatafit,xdata{ind}];
            ydatafit = [ydatafit,ydata{ind}];
        end
        xdataAverage = unique (xdataAverage);
           for k = 1:length(xdataAverage)
            yaverage = [];    
            for ind=1:length(xdata)
                    a = find(xdata{ind}==xdataAverage(k));
                    yaverage = [yaverage,ydata{ind}(a)];
            end
             meanval=mean(yaverage);
             stdval=std(yaverage);
             ydataAverage (k)  =  meanval;
             ydataErrorBar (k) =stdval;

             SeriesLegend = arrayfun(@num2str,seriesnumber,'un',0)

           end

        SeriesLegend =  strjoin(['Average of Series',SeriesLegend],', s')
        plotparam.legendtext = {SeriesLegend};      
        ydataAvg =  {ydataAverage};
        YdataErrorBar = {ydataErrorBar};
        xdataAvg =  {xdataAverage};
        
        ydataAvg = {(ydataErrorBar./ydataAverage)}
        YdataErrorBar ={ zeros(size(ydataAvg{1}))}
        
        ydata = ydataAvg;
        xdata = xdataAvg;        


        
               
    
end


            

figure;

evalstring='plot(';

for ind=1:length(ydata) % does the fiting of the data  and generates the comand for the ploting
    dofitplot=0;doPlotoptions=0;
    [plotparam,evalstringErrorbar{ind}] =   GeneratePlotingComandErrorBar(plotparam,seriesnumber,ind ,dofitplot,'',doPlotoptions ); % Generates the string use for plotting errorbar
    [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,'',doPlotoptions ); % Generates the string to be used for ploting
    [plotparam,xdata{ind}] = formatfitinginputs (plotparam,xdata{ind},seriesnumber); % Formats the input options so they can be interpreted by the code
    

    if plotparam.dofit~=0
        dofitplot=0;
        pointstouseforfit=((xdata{ind}>=plotparam.xfitmin(ind))&(xdata{ind}<=plotparam.xfitmax(ind)));
        switch plotparam.dofit
           case 1 % polinomial fit
                if length(pointstouseforfit)>=(plotparam.polyfitorder+1)
                    if plotparam.polyfitorder==0 || plotparam.extractStability
                        meanval=mean(ydata{ind}(pointstouseforfit));
                        stdval=std(ydata{ind}(pointstouseforfit));
                        xfitstart=min(xdata{ind}(pointstouseforfit));
                        xfitend=max(xdata{ind}(pointstouseforfit));
                        xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                        yfitdata{ind}=meanval*ones(size(xfitdata{ind}));
                        displaytext=[num2str(meanval),'\pm',num2str(2*stdval)];
                        if ( plotparam.extractStability )
                            stability = 100*stdval/meanval
                            legendentry=[ 'Average Value  = ',num2str(meanval,'%10.3e'),' ','\sigma = ',num2str(stdval),' \Delta',' = ',num2str(stability),'% .'];
                        else
                            legendentry=[nicenumber(meanval),'\pm',num2str(2*stdval)];
                        end
                        xfitted {ind} =meanval;
               else
                        p=polyfitn(xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),plotparam.polyfitorder);
                        xfitstart=min(xdata{ind}(pointstouseforfit));
                        xfitend=max(xdata{ind}(pointstouseforfit));
                        xfitdata{ind}=xfitstart:(xfitend-xfitstart)/1000:xfitend;
                        yfitdata{ind}=polyvaln(p,xfitdata{ind});
                        displaytext=[];
                        legendentry=[];
                        for ind2=0:plotparam.polyfitorder
                            if (ind2==0)&&p.Coefficients(plotparam.polyfitorder-ind2+1)~=0
                                if(not(plotparam.TOFmeasurement))
                                    displaytext=[displaytext,'(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                    legendentry=[legendentry,'(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                else
                                    displaytext=[displaytext,'(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')'];
                                end
                            elseif (p.Coefficients(plotparam.polyfitorder-ind2+1)>0)&&(ind2==1)
                                if(not(plotparam.TOFmeasurement))
                                    displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                    legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                elseif( plotparam.cameranumber ==3 )
                                    calibrationcoeff = plotparam.cameraCalibration;
                                    displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                    legendentry=[legendentry,'T = (',nicenumber(calibrationcoeff*p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(calibrationcoeff*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')','\mu','K'];
                                end
                            elseif (p.Coefficients(plotparam.polyfitorder-ind2+1)<0)&&(ind2==1)
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x'];
                            elseif p.Coefficients(plotparam.polyfitorder-ind2+1)>0
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                            elseif p.Coefficients(plotparam.polyfitorder-ind2+1)<0
                                displaytext=[displaytext,'+(',num2str(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',num2str(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                                legendentry=[legendentry,'+(',nicenumber(p.Coefficients(plotparam.polyfitorder-ind2+1)),'\pm',nicenumber(2*p.ParameterStd(plotparam.polyfitorder-ind2+1)),')x^',num2str(ind2)];
                            end
                        end
                    end
                    dofitplot=1;
                    display(displaytext);
    %                 dofitplot=1;
                end
             case 2 % exponential fit, no background
                    x0(1)=max(ydata{ind});
                    x0(2)=max(xdata{ind})/2;
                    lb=[x0(1),0];
                    ub=[x0(1)*10,x0(2)*10];
                    display('fitting...');
                    [xfitted{ind},resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@exponential_rise_nobackground,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                     xCovariance = inv(J.'*J)*var(residual);
                    [expSigma,ExpCorrC] = cov2corr(xCovariance);
                    yfitdata{ind}=exponential_rise_nobackground(xfitted{ind},xdata{ind});
                    xfitdata{ind}=xdata{ind};
                    dofitplot=1;
                    display([num2str(xfitted{ind}(1)),'pm',num2str(expSigma(1)),'*(1-exp(-t/',num2str(xfitted{ind}(2)),'))']);
                    legendentry=['(',num2str(xfitted{ind}(1),'%0.3e'),'\pm',num2str(expSigma(1),'%0.3e'),')','*(1-exp(-t/',num2str(xfitted{ind}(2),'%0.3e'),'\pm',num2str(expSigma(2),'%0.3e'),'))'];
                    
             case 15 % exponential fall fit with nobackground
                x0 = plotparam.start;
                ub=plotparam.upperbound;
                lb=plotparam.lowerbound ;
                display('fitting...');
%                 fitoptions=optimoptions('lsqcurvefit','TolFun',1e-9,'TolX',1e-10);
%                 xfitted{ind}=lsqcurvefit(@exponential_fall_nobackground_toffset,x0,xdata{ind},ydata{ind},lb,ub,fitoptions);
                [xfitted{ind},resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@exponential_fall_nobackground_toffset_noDelay,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                
                yfitdata{ind}=exponential_fall_nobackground_toffset_noDelay(xfitted{ind},xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted{ind}(1)),'*exp(-(t)/',num2str(xfitted{ind}(2)),')']);
                legendentry=['(',num2str(xfitted{ind}(1),'%0.3e'),'\pm',num2str(expSigma(1),'%0.3e'),')','*exp(-t/(',num2str(xfitted{ind}(2),'%0.3e'),'\pm',num2str(expSigma(2),'%0.3e'),'))'];

             case 16 % Abs spectra  yfit=-x(1)/(1+4*((xdata-x(2))/x(3)).^2)+x(4);
                [a,b] = min(ydata{ind})
                x0 = [-max(ydata{ind}), xdata{ind}(b),0.02,max(ydata{ind})] 
                lb=[x0(1)*2,min(xdata{ind}),-30002,x0(4)-(std(ydata{ind}))];
                ub=[-x0(1)*2,max(xdata{ind}),30002*2,x0(4)+(std(ydata{ind}))];
                display('fitting...');
                 [xfitted{ind},resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@lorentzian,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                yfitdata{ind}=lorentzian(xfitted{ind},xdata{ind});
                xfitdata{ind}=xdata{ind};
                dofitplot=1;
                display([num2str(xfitted{ind}(1)),'/(1+4*((x-',num2str(xfitted{ind}(2)),')/',num2str(xfitted{ind}(3)),')^2)+',num2str(xfitted{ind}(4))]);
                legendentry=[num2str(xfitted{ind}(1),'%0.3e'),'/(1+4*((x-',num2str(xfitted{ind}(2),'%0.5e'),'\pm',num2str(expSigma(2),'%0.3e'),')/(',num2str(xfitted{ind}(3),'%0.3e'),'\pm',num2str(expSigma(3),'%0.3e'),'))^2)+',num2str(xfitted{ind}(4),'%0.3e')];
                xfitted{ind}(2)
             case 17 % Abs spectra n lorenzian   ;
                offsets =  plotparam.offsets
                widths = plotparam.widths
                peaks = plotparam.peaks
                background = plotparam.background
                
                x0 = [offsets',widths',peaks'];
                x0 = reshape(x0',3*length(peaks),[]);
                x0 = [x0',background];
                ub = 2*abs(x0);
                lb = -2*abs(x0);
                display('fitting...');
                 [xfitted{ind},resnorm,residual,exitflag,output,lambda,J]=lsqcurvefit(@lorentziannx,x0,xdata{ind}(pointstouseforfit),ydata{ind}(pointstouseforfit),lb,ub);
                toplotinfo =  reshape(xfitted{ind}(1:end-1),3,[]);
                 B = mean(diff(toplotinfo(1,:)))/  plotparam.DeltaMf 
                 xCovariance = inv(J.'*J)*var(residual);
                [expSigma,ExpCorrC] = cov2corr(xCovariance);
                yfitdata{ind}=lorentziannx(xfitted{ind},xdata{ind});
                xfitdata{ind}=xdata{ind};
               
                dofitplot=1;
                legendentry = @(x) [num2str(x(3)),'/(1+4*((x-',num2str(x(1)),')/',num2str(x(2)),')^2)'];
                stringplot = '';
                for i = 1:size(toplotinfo,2)
                    l{i} = legendentry(toplotinfo(:,i))
                    stringplot = [stringplot,10,l{i}, ' +']
                end
               
                display([num2str(xfitted{ind}(1)),'/(1+4*((x-',num2str(xfitted{ind}(2)),')/',num2str(xfitted{ind}(3)),')^2)+',num2str(xfitted{ind}(4))]);
                legendentry= ['Estimated B field  = ',num2str(B),'Gauss',stringplot]



        end
        [xfitdata{ind},index] = sort(xfitdata{ind}); 
        yfitdata{ind} = yfitdata{ind}(index);  
        [plotparam,evalstringFitErrorBar] =  GeneratePlotingComandErrorBar(plotparam,seriesnumber,ind ,dofitplot,legendentry ,doPlotoptions) 
        [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,legendentry,doPlotoptions ); % Generatews the string to display the fiting
    
    end
if ( plotparam.savedata )   
    if plotparam.otherOptions == 1   || plotparam.otherOptions == 3 || plotparam.otherOptions == 5
        datats.y = ydataAvg{ind}.';
        datats.x = xdataAvg{ind}.';
        datats.error = YdataErrorBar{1}.';
        if (plotparam.dofit ~= 0 )
            datats.yfit = yfitdata{1}
            datats.xfit = xfitdata{1};
            datats.fittparam = xfitted{1}
        end
        saveData (plotparam ,datats,ind,seriesnumber)
        
    else
        datats.y = ydata{ind}.';
        datats.x = xdata{ind}.';
        if (plotparam.dofit ~=0)
        datats.yfit = yfitdata{ind}
        datats.xfit = xfitdata{ind};
        datats.fittparam = xfitted{ind}
        end
         saveData (plotparam ,datats,ind,seriesnumber)
    end

end
end


doPlotoptions=1;

[plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,'',doPlotoptions ); % Generatews the string to display the fiting
if plotparam.LoadingTimeScale
    ydata{ind} =  xfitted{ind}(1)-ydata{ind};
    yfitdata{ind} = xfitted{ind}(1)-yfitdata{ind};
end
if plotparam.otherOptions == 1 || plotparam.otherOptions == 5
    hold on
    eval(evalstringErrorbar{1})
    if (plotparam.dofit ~=0 )
    eval (evalstringFitErrorBar)
    end
    hold off

elseif plotparam.otherOptions == 3 
    for i = 1:size(ydataAvg,2)
        hold on
        eval(evalstringErrorbar{i})
        if (plotparam.dofit ~=0 )
        eval (evalstringFitErrorBar)
        end
        hold off
    end
else
    eval(evalstring)
end

if ~isempty(plotparam.legendtext)
    legend(plotparam.legendtext,'Location',plotparam.legendlocation,'FontSize',plotparam.legendfontsize)
end
if plotparam.logyscale
    set(gca,'YScale','log');
    
end
    



title(plotparam.title,'FontSize',plotparam.titlefontsize);
xlabel(plotparam.xlabel,'FontSize',plotparam.xaxisfontsize);
ylabel(plotparam.ylabel,'FontSize',plotparam.yaxisfontsize);

return

end




function [yfit]=exponential_rise(x,xdata)

yfit=x(1)*(1-exp(-xdata/x(2)))+x(3);

end

function [yfit]=exponential_rise_nobackground(x,xdata)

yfit=x(1)*(1-exp(-xdata/x(2)));

end

function [yfit]=gaussian(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithbackground(x,xdata)

yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=sinwithdecayandbackground(x,xdata)

yfit=x(1)*exp(-xdata/x(5)).*sin(2*pi*x(2)*xdata+x(3))+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=lorentzian(x,xdata)

yfit=x(1)./(1+4*((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end
function [yfit]=lorentzianv2(x,xdata)

yfit=x(:,3)./(1+4*((xdata-x(:,1))./x(:,2)).^2);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=lorentziannx(x,xdata)
xp = reshape(x(1:end-1),3,[]);

yfit1 = @(x) lorentzianv2(xp',x);
yfit2 =@(x) sum(yfit1(x)) ;
yfit = arrayfun(yfit2,xdata)+ x(end);


%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end



function [yfit]=gaussian_nobackground(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2);

end

function [yfit]=modefit(x,model,data)

yfit=sum(sum(abs((x(1)*model+x(2)-data))));

end

function [yfit]=exponential_rise_nobackground_toffset(x,xdata)

yfit=x(1)*(1-exp(-(xdata-x(3))/x(2)));

end
function [yfit]=exponential_fall_nobackground_toffset_noDelay(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2));

end
function [yfit]=exponential_fall_nobackground_toffset(x,xdata)

yfit=x(1)*exp(-(xdata-x(3))/x(2));

end

function [yfit]=exponential_fall_background_toffset(x,xdata)

yfit=x(1)*exp(-(xdata-x(3))/x(2))+x(4);

end
function [yfit]=exponential_fall_background_Notoffset(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2))+x(4);

end

function [yfit]=exponential_fall_background_NotoffsetV22(x,xdata)

yfit=x(1)*exp(-(xdata)/x(2))+x(3);

end
function [output]=nicenumber(value)

if (abs(value)<0.01)||(abs(value)>10000)
    output=num2str(value,'%0.3e');
else
    output=num2str(value,'%1.6f');
end

end
function [savename] = saveData (plotparams,data,ind,seriesnumber)

    filename = plotparams.filename;
    Selection =plotparams.datasection-1;
    path = [plotparams.Datapath,'\Data'];
    
    currentfile=strcat(plotparams.RunningFolder, '.m');

    ScrDirectory = [path,'\']
    if ~exist(ScrDirectory, 'dir') % If target directory doesnt exist
        if isempty(strfind(currentfile,'\Scripts')) == 1 % The script is not saved on the scripts folder
            mkdir(ScrDirectory) ;  % Create directory and save the data
        end
    
    end 
    if isempty(strfind(currentfile,'\Scripts')) == 1 % The script is not saved on the scripts folder
        savedataboolean = true; 
    else
        savedataboolean = false;
    end
seriesn = num2str(seriesnumber(1:end));
seriesn = strrep(seriesn,' ','-')
if plotparams.otherOptions ==0  || plotparams.otherOptions ==3 
    filename = ['data',plotparams.FileNameData(1:end-2),'s',num2str(seriesnumber(ind)),'.mat']
else
    filename = ['data',plotparams.FileNameData(1:end-2),seriesn,'.mat']
end
savename = [ScrDirectory,'\',filename]
    if ( savedataboolean )
        
        display(['Data saved in /n',savename]);
        save (savename,'data')
    end
end
function [croppedPic,fileName] = LoadVisionDataTGA (currentDayDirectory,seriesNumber,visionPictNbCount,plotparam,makeROIBool)
    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);
    fileName=[currentDayDirectory '\S' num2str(seriesNumber) '\P' num2str(visionPictNbCount,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.tga'];

    if exist(char(fileName),'file')
        %pause(0.5);

        % load vision data
        [referencePic, newdata, raw, probe]=loadvisionpictureTGA(currentDayDirectory, seriesNumber, visionPictNbCount, cameraNumber);
        if (~plotparam.isFluoresencePic)
            referencePic=max(-referencePic,0);
        else
            referencePic=min(-referencePic,0);
        end
        % determine ROIs
        backgroundROIdatafilename=[currentDayDirectory '\backgroundROIdata_' 'S' num2str(seriesNumber) '.mat'];
        configFolder = [currentDayDirectory ,'\optimizationData\','S',num2str(seriesNumber),'\'];
        [rectInner, rectOuter, croppedReferencePic, croppedReferenceOuterPic] = determineROIPictureTGA(referencePic, backgroundROIdatafilename, makeROIBool,plotparam);

        % load picture
        MaxOD = 5;
         if (plotparam.isFluoresencePic)
             Pic =  raw - probe;
         else
            Pic = min(MaxOD, -log(max(0.0000000000001, raw ./ probe)));
         end
        croppedPic=Pic((rectInner(2)+1):(rectInner(2)+rectInner(4)),(rectInner(1)+1):(rectInner(1)+rectInner(3)));
        croppedOuterPic=Pic((rectOuter(2)+1):(rectOuter(2)+rectOuter(4)),(rectOuter(1)+1):(rectOuter(1)+rectOuter(3)));


        isInnerInsideOuterBool = (rectOuter(1) < rectInner(1)) && ((rectOuter(1)+rectOuter(3)) > (rectInner(1)+rectInner(3))) && (rectOuter(2) < rectInner(2)) && ((rectOuter(2)+rectOuter(4)) > (rectInner(2)+rectInner(4)));
        if isInnerInsideOuterBool
            referenceBackgroundMean=(sum(sum(croppedOuterPic))-sum(sum(croppedPic)))/(numel(croppedOuterPic)-numel(croppedPic));
        else
            isOuterAbitInsideInnerBool1 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) );
            isInnerAbitInsideOuterBool1 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) );
            isOuterAbitInsideInnerBool2 = ( (rectInner(1)+rectInner(3) > rectOuter(1) && rectOuter(1) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2)+rectOuter(4) && rectOuter(2)+rectOuter(4) > rectInner(2)) ) || ( (rectInner(1)+rectInner(3) > rectOuter(1)+rectOuter(3) && rectOuter(1)+rectOuter(3) > rectInner(1)) && (rectInner(2)+rectInner(4) > rectOuter(2) && rectOuter(2) > rectInner(2)) );
            isInnerAbitInsideOuterBool2 = ( (rectOuter(1)+rectOuter(3) > rectInner(1) && rectInner(1) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2)+rectInner(4) && rectInner(2)+rectInner(4) > rectOuter(2)) ) || ( (rectOuter(1)+rectOuter(3) > rectInner(1)+rectInner(3) && rectInner(1)+rectInner(3) > rectOuter(1)) && (rectOuter(2)+rectOuter(4) > rectInner(2) && rectInner(2) > rectOuter(2)) );
            if (isOuterAbitInsideInnerBool1 || isInnerAbitInsideOuterBool1 || isOuterAbitInsideInnerBool2 || isInnerAbitInsideOuterBool2)
                error('Bad choice of ROIs!');
            else
                referenceBackgroundMean= sum(sum(croppedOuterPic)) / numel(croppedOuterPic);
            end
        end
        croppedPic=max(0,croppedPic - referenceBackgroundMean);


    end


end
function [difference,newdata,raw,probe]=loadvisionpictureTGA(directory,seriesnumber,imagenumber,cameranumber)

    if seriesnumber>0
        directoryAux=[directory '\S' num2str(seriesnumber)];
    end


    atomsdata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'A' num2str(cameranumber-1) '.tga']);
    noisedata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'N' num2str(cameranumber-1) '.tga']);
    probedata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'P' num2str(cameranumber-1) '.tga']);
    otherdata=loadtga([directoryAux '\P' num2str(imagenumber,'%04i') char(64+cameranumber) 'O' num2str(cameranumber-1) '.tga']);

    if ~isempty(atomsdata)
        newdata=1;
        raw=(atomsdata-noisedata);
        probe=(probedata-noisedata);
        difference=raw-probe;
    else
        newdata=0;
end
end


function  [rectIn, rectOut, croppedRefPic, croppedRefOuterPic] = determineROIPictureTGA(refPic, bckgndROIdatafileName, mkROIBool,plotparam)

global Data;

if  mkROIBool % 0 ask for background ROI data only if no previous data available, 1 ask allways
    warning('off');
    maxPic = max(max(refPic));
    minPic = min(min(refPic));
    
    initFig=figure;
    %display('Waiting for input');
    set(initFig,'Name','Select rectange containing signal');
    [croppedRefPic, rectIn] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    set(initFig,'Name','Select rectange including background');
    [croppedRefOuterPic, rectOut] = imcrop((refPic-minPic)/(maxPic-minPic)*256,jet(256));
    %display('Background region defined');
    close(initFig);

    rectIn=round(rectIn);
    rectIn(1)=max(0, min(size(refPic, 2) - 1, rectIn(1)));
    rectIn(2)=max(0, min(size(refPic, 1) - 1 , rectIn(2)));
    rectIn(3)=max(1, min(size(refPic, 2) - rectIn(1), rectIn(3)));
    rectIn(4)=max(1, min(size(refPic, 1) - rectIn(2), rectIn(4)));

    rectOut=round(rectOut);
    rectOut(1)=max(0, min(size(refPic, 2) - 1, rectOut(1)));
    rectOut(2)=max(0, min(size(refPic, 1) - 1, rectOut(2)));
    rectOut(3)=max(1, min(size(refPic, 2) - rectOut(1), rectOut(3)));
    rectOut(4)=max(1, min(size(refPic, 1) - rectOut(2), rectOut(4)));

    %oldRectIn=rectIn;
    %rectIn(1)=max(rectIn(1), rectOut(1));
    %rectIn(2)=max(rectIn(2), rectOut(2));
    %rectIn(3)=min(oldRectIn(1) + rectIn(3), rectOut(1) + rectOut(3)) - rectIn(1);
    %rectIn(4)=min(oldRectIn(2) + rectIn(4), rectOut(2) + rectOut(4)) - rectIn(2);
    warning('on');
    save(bckgndROIdatafileName,'rectIn','rectOut');
    timeOfDat = datestr(now,'dd-mmm-yyyy-HH-MM-SS');
    
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    save(Folder,'rectIn','rectOut');
    Data.rectIn = rectIn;
    Data.rectOut = rectOut;
else 
    Folder = returnFileName(plotparam.RunningFolder,plotparam.filename);
    load(Folder);
    croppedRefPic = refPic((rectIn(2)+1):(rectIn(2)+rectIn(4)),(rectIn(1)+1):(rectIn(1)+rectIn(3)));
    croppedRefOuterPic = refPic((rectOut(2)+1):(rectOut(2)+rectOut(4)),(rectOut(1)+1):(rectOut(1)+rectOut(3)));
end




end
function [returnPath]=returnFileName(FileDirectory,Filename)

    % close all
    format shortg
    timeOfDat = clock;
    breakLoop = 0;
    version = 1;
    if ~isempty(strfind(FileDirectory, 'Scripts\Scripts'))
        filenamereturn = ['Background_',Filename,'.mat' ];
        l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l)];
        returnPath = [FileDirectoryShort,filenamereturn];  
    else
        while breakLoop == 0 

            filename =['runmme',num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1)),'Scr',num2str(version,'%04i'),'.m'];

            l = length(Filename);FileDirectoryShort = [FileDirectory(1:end-l),'Scripts\'];
            FolderName = [num2str(timeOfDat(3),'%02i'),num2str(timeOfDat(2),'%02i'),num2str(timeOfDat(1))];
            FolderName = [FileDirectoryShort,FolderName];
            currentfile=strcat(FileDirectory, '.m');
            if ~exist(FolderName, 'dir')
                if isempty(strfind(currentfile,'\Scripts')) == 1
                    mkdir(FolderName);      
                end

            end
            FilePath = [FolderName,'\',filename];    
            if exist(FilePath, 'file') == 2
                version = version + 1;
            else
                breakLoop = 1;
            end
            filenamereturn = ['Background_',filename,'at' ];
            returnPath = [FolderName,'\',filenamereturn];   
        end
    end

end



function [atomNumberTab,effTemperatureTab,effTemperature1DXTab,effTemperature1DYTab,centerOfMassX,centerOfMassY ,Spreadx,Spready ] = calculateExperimentalValues (params,filename,croppedPic)
    
    global ctePlanck hbarre cLum kB aB MuB hartree Mu0 Epsilon0 au eElec gForce Debye Na
    global ctePlanckOverAu auOverCtePlanck ctePlanckOverkB kBOverCtePlanck auOverkB kBOverAu hbarreOverAu hbarreOverkB hbarreOverMuB MuBOverHbarre
    global mSr88 mSr87 mSr86 mSr84
    
    UsefulConstants;
    BaseStrontium;
    if ( ~isempty(strfind(filename, 'AA'))) % USE MOT side camera calibration
        xCalSr = 4.48 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4.48 * 10^(-6);
    elseif  ( ~isempty(strfind(filename, 'BA'))) % USE MOT TOP camera calibration
        xCalSr = 4 * 10^(-6);  %camera resolution m/pix
        yCalSr = 4 * 10^(-6);  
    elseif  ( ~isempty(strfind(filename, 'CA'))) % USE Capture MOT
        xCalSr = 14.32 * 10^(-6);  %camera resolution m/pix
        yCalSr = 14.32 * 10^(-6);
    end
    
    effVolume = (100e-6 * 100e-6 * 100e-6); %estimation of the characteristic size of the cloud (to estimate the density) (in m^3)
    wxSr = 2 * pi * 100; %estimation of the trapping frequency
    wySr = 2 * pi * 200;
    wzSr = 2 * pi * 100;
    mAssSr = mSr88;
    lamdaSr = 461. * 10^(-9); %(in m)   

    atomNumberTab= [];
    effTemperatureTab= [];
    effTemperature1DXTab= [];
    effTemperature1DYTab= [];

    
    
    % calculate the atom number
    cte = 1 + 4*params.lightDetunning^2;
    absCrossSr = (3*(lamdaSr.^2))./(2*pi)/cte; % (m^2)
    numberCal = (yCalSr*xCalSr) / absCrossSr;
    TotalMatNb = sum(sum(croppedPic)); %total optical density in the image

    atomNumber = TotalMatNb * numberCal;
    % calculate the center of mass in x and y
    [sizey, sizex] = size(croppedPic);
    CoordAuxX = 1:1:sizex;
    CoordAuxY = 1:1:sizey;
    croppedPicX = sum(croppedPic,1);
    croppedPicY = sum(croppedPic,2)';
    centerOfMassX = croppedPicX * CoordAuxX' /TotalMatNb ;
    centerOfMassY = croppedPicY * CoordAuxY' /TotalMatNb ;

    %calculate effective temperature                
    EnergyPerPartRaw = (xCalSr * yCalSr)^2 * ((CoordAuxY-centerOfMassY).^2) * (croppedPic) * ((CoordAuxX'-centerOfMassX).^2) / TotalMatNb; % effective temperature, by 2nd order momentum calculation of image
    effTemperature = 4 / pi * mAssSr * (wxSr*wySr)^(2/2)* auOverkB * EnergyPerPartRaw * atomNumber / 2; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DX = (xCalSr)^3 * numberCal *((CoordAuxX-centerOfMassX).^2) * croppedPicX' / sizey / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DX =  4 / pi * mAssSr * wxSr^2 * auOverkB * EnergyPerPartRaw1DX * atomNumber; % effective temperature, by 2nd order momentum calculation of image

    EnergyPerPartRaw1DY = (yCalSr)^3 * numberCal *((CoordAuxY-centerOfMassY).^2) * croppedPicY' / sizex / atomNumber; % effective temperature, by 2nd order momentum calculation of image
    effTemperature1DY =  4 / pi * mAssSr * wySr^2 * auOverkB * EnergyPerPartRaw1DY * atomNumber; % effective temperature, by 2nd order momentum calculation of image

    %Calculate spread in px
     Spreadx = sum((-centerOfMassX.^2 + (croppedPicX.* CoordAuxX).^2).^0.5)/TotalMatNb;
     Spready =sum  ( (-centerOfMassY.^2 + (croppedPicY.* CoordAuxY).^2).^0.5)/TotalMatNb;
     
    display(['Evaluating ', filename]);
%     fprintf('Number of atoms: %.0f\n', atomNumber);
%     fprintf('Temperature: %.3f muK\n', effTemperature * 10^6);
%     fprintf('Temperature 1D in X: %.3f muK\n', effTemperature1DX * 10^6);
%     fprintf('Temperature 1D in Y: %.3f muK\n', effTemperature1DY * 10^6);




    atomNumberTab = [atomNumberTab, atomNumber];
    effTemperatureTab = [effTemperatureTab, effTemperature];
    effTemperature1DXTab = [effTemperature1DXTab, effTemperature1DX];
    effTemperature1DYTab = [effTemperature1DYTab, effTemperature1DY];
   
end
function [todayDirectory, fileName] = findNextFileBMP(todayDirectory,  seriesnumber, dataNumber, plotparam)

    cameraNumber = plotparam.cameranumber;
    cameraLetter=char('A'-1+cameraNumber);



    fileName='';
    notfound=1;
    StopBoolean = false;
    try
        if seriesnumber>0
            fileName=[todayDirectory '\S' num2str(seriesnumber) '\P' num2str(dataNumber,'%04i') cameraLetter,'A',num2str(cameraNumber-1), '.bmp'];
            if ~exist(fileName,'file')
                StopBoolean = true;
            end
    %             if ~isempty(nameOverride)
    %                 fileName=[directory,'\S',num2str(seriesnumber),'\',nameOverride,'.dat'];
    %             end    
            %fid=fopen(fileName);
            %data=char(fread(fid).');
            notfound=0;
            %fclose(fid);
        else
            fileName=[todayDirectory '\P' num2str(dataNumber,'%04i') cameraLetter 'A0' '.bmp'];
    %             if ~isempty(nameOverride)
    %                 fileName=[directory,'\',nameOverride,'.dat'];
    %             end
    %             fid=fopen(fileName);
    %             data=char(fread(fid).');
            notfound=0;
    %             fclose(fid);
        end
    end


    if (notfound==1)
        error(['File note found: ',fileName]);
    end
end

function [parameter] = SetDefaultValues (plotparam ,seriesnumber )

    if isempty(plotparam.xlabel)
        plotparam.xlabel=lastxlabelname;
    end

    if length(plotparam.xoffset)==1
        plotparam.xoffset=plotparam.xoffset*ones(size(seriesnumber));
    end
    if length(plotparam.xscale)==1
        plotparam.xscale=plotparam.xscale*ones(size(seriesnumber));
    end
    if length(plotparam.yscale)==1
        plotparam.yscale=plotparam.yscale*ones(size(seriesnumber));
    end
    if length(plotparam.yoffset)==1
        plotparam.yoffset=plotparam.yoffset*ones(size(seriesnumber));
    end
    if length(plotparam.sinfitinitialfreq)==1
        plotparam.sinfitinitialfreq=plotparam.sinfitinitialfreq*ones(size(seriesnumber));
    end
    parameter =  plotparam;
end

function [parameter, datax ,datay] = ScaleData(plotparam, datax,datay,ind,seriesnumber)

  datax=(datax-plotparam.xoffset(ind));
    if plotparam.xscaleinvert
        datax=1./datax;
    end
    if plotparam.xscalesquare
        datax=(datax).^2;
    end
    if plotparam.doPowerCAL  
        p = polyfit (plotparam.MolassesPowerCalX,plotparam.MolassesPowerCalY,length(plotparam.MolassesPowerCalY)-1)

        
        newdatax=polyval(p,plotparam.MolassesPowerCalX)
        datax=polyval(p,datax)
%         hold on
%             scatter(plotparam.MolassesPowerCalX,plotparam.MolassesPowerCalY)
%             plot(plotparam.MolassesPowerCalX,newdatax)
%         hold off
    end
    if plotparam.yscalesquare
        datay=(datay).^2;
    end 
    if plotparam.Testimate
        datay=(datay).^2;
        datay =  datay./400;
        datay =  datay*0.010665 * 10^6;
        
    end
    
    if length(plotparam.xscale)==length(seriesnumber)
        datax=datax*plotparam.xscale(ind);
    end
    if length(plotparam.yscale)==length(seriesnumber)
        datay=datay*plotparam.yscale(ind);
    end
    if length(plotparam.yoffset)==length(seriesnumber)
        datay=datay+plotparam.yoffset(ind);
    end
    if plotparam.removenegative
        datax=datax(datay>0);
        datay=datay(datay>0);
    end   
    parameter= plotparam;
end




function [plotparam,evalstringErrorbar] =   GeneratePlotingComandErrorBar(plotparam,seriesnumber,ind ,dofitplot,legendentry ,doPlotoptions) % Generates the string use for plotting errorbar
Errorbarstring='errorbar(';
if doPlotoptions
        if isempty(plotparam.plotoptions)
            evalstringErrorbar=[Errorbarstring(1:(end-1)),');'];
        else
            evalstringErrorbar=[Errorbarstring,'''MarkerSize'',20);'];
        end
else
    if (dofitplot && (plotparam.otherOptions == 1 || plotparam.otherOptions == 5) )
                if (length(plotparam.linecolour)>=length(seriesnumber))
                    evalstringErrorbar=['xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linefitstyle,''','];
                else
                    evalstringErrorbar=['plot(','xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linefitstyle,''')'];
                end
                if (length(plotparam.legendtext)>=2*ind)
                    for temp=length(plotparam.legendtext):-1:2*ind
                        plotparam.legendtext{temp+1}=plotparam.legendtext{temp};
                    end
                end
                plotparam.legendtext{2*ind}=legendentry;
    else
        if length(plotparam.linecolour)>=length(seriesnumber)
            evalstringErrorbar=[Errorbarstring,'xdataAvg{',num2str(ind),'},ydataAvg{',num2str(ind),'},YdataErrorBar{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linestyle,''')'];
        else
            evalstringErrorbar=[Errorbarstring,'xdataAvg{',num2str(ind),'},ydataAvg{',num2str(ind),'},YdataErrorBar{',num2str(ind),'},''',plotparam.linestyle,''')'];
        end

        end
end
    
 
end
function [plotparam,evalstring] = GeneratePlotingComand (plotparam,seriesnumber,ind ,evalstring,dofitplot,legendentry ,doPlotoptions) % Generates the string use for plotting

    
    

    
    if doPlotoptions
        if isempty(plotparam.plotoptions)
            evalstring=[evalstring(1:(end-1)),');'];
        else
            evalstring=[evalstring,'''MarkerSize'',20);'];
        end
    else
        if dofitplot
            if (length(plotparam.linecolour)>=length(seriesnumber))
                evalstring=[evalstring,'xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linefitstyle,''','];
            else
                evalstring=[evalstring,'xfitdata{',num2str(ind),'},yfitdata{',num2str(ind),'},''',plotparam.linefitstyle,''','];
            end
            if (length(plotparam.legendtext)>=2*ind)
                for temp=length(plotparam.legendtext):-1:2*ind
                    plotparam.legendtext{temp+1}=plotparam.legendtext{temp};
                end
            end
            plotparam.legendtext{2*ind}=legendentry;
        else
            if length(plotparam.linecolour)>=length(seriesnumber)
                evalstring=[evalstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},''',plotparam.linecolour{ind},plotparam.linestyle,''','];
            else
                evalstring=[evalstring,'xdata{',num2str(ind),'},ydata{',num2str(ind),'},''',plotparam.linestyle,''','];
            end
        end        
    end
    
    

    
       
    
end

function [plotparam,xdata] = formatfitinginputs (plotparam,xdata,seriesnumber)
    if length(plotparam.xpolyfitval)>1;
        xnew=plotparam.xpolyfitval(end);
        for polyind=2:length(plotparam.xpolyfitval)
            xnew=xnew+xdata.^(polyind-1)*plotparam.xpolyfitval(end-polyind+1);
        end
        xdata=xnew;
    end


  
    if length(plotparam.xfitmin)==1
        plotparam.xfitmin=plotparam.xfitmin*ones(size(seriesnumber));
    end
    if length(plotparam.xfitmax)==1
        plotparam.xfitmax=plotparam.xfitmax*ones(size(seriesnumber));
    end
    
end


