function data =  loadPictureData (DataDirectory, SeriesDate,series ,PictureNumber,params)

%Loading S16 data. This data is located inside Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Data\200911\S16






directory = [DataDirectory,SeriesDate ,'\',series];

%% F = image
a = directory;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%Camera settings%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cameranumber = 3;
d=  char(64+cameranumber);
e = '2';%horizontal imaging
xcal =14.32;  %camera resolution um/pix (horizontal imaging) Imaged area Rb
ycal =14.32;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%LoadingImages%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



if PictureNumber < 10
    b = '\P000';
    filename = [a,b,num2str(PictureNumber),d];       
    else if PictureNumber < 100
        b = '\P00';
        filename = [a,b,num2str(PictureNumber),d];            
        else
            b = '\P0';
            filename = [a,b,num2str(PictureNumber),d];            
        end
end

atomsdata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'A',num2str(cameranumber-1),'.tga']);
noisedata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'N',num2str(cameranumber-1),'.tga']);
probedata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'P',num2str(cameranumber-1),'.tga']);
otherdata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'O',num2str(cameranumber-1),'.tga']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% END LoadingImages  %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%  Calculate optical density %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if ~isempty(atomsdata)
    newdata=1;
    raw=(atomsdata-noisedata);
    probe=(probedata-noisedata);
    difference=raw-probe;
else
    newdata=0;
end




imA = atomsdata;
imP = probedata;
imN = noisedata;
imO = otherdata;


 MaxOD=5;
 Foriginal=min(MaxOD,-log(max(0.00000001,(imA)./(imP))));
maxPic = max(max(Foriginal));
minPic = min(min(Foriginal));
imshow((Foriginal-minPic)/(maxPic-minPic)*256,jet(256),'Border','tight');



rectIna = params.rectIna;
% SelectedColorMap= load('myCmap');

xmin1=rectIna(1);
ymin1=rectIna(2);
xwidth1=rectIna(3);
ywidth1=rectIna(4);

xmax1= xmin1 + xwidth1 ;
ymax1=ymin1 + ywidth1;



% fig = figure(3);
display(['Loading....' ,num2str(SeriesDate),' Series ',num2str(series),'Picture ',num2str(PictureNumber)])
F = imcrop(Foriginal,[xmin1 ymin1  xwidth1 ywidth1]);

data= F;
Foriginal=data;
maxPic = max(max(Foriginal));
minPic = min(min(Foriginal));
imshow((Foriginal-minPic)/(maxPic-minPic)*256,jet(256),'Border','tight');


end
