function [opticalDensity] = GetPictureOD (directory,PictureNumber,params)

a = directory;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%Camera settings%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cameranumber = 3;
d=  char(64+cameranumber);
e = '2';%horizontal imaging
xcal =14.32;  %camera resolution um/pix (horizontal imaging) Imaged area Rb
ycal =14.32;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%LoadingImages%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



if PictureNumber < 10
    b = '\P000';
    filename = [a,b,num2str(PictureNumber),d];       
    else if PictureNumber < 100
        b = '\P00';
        filename = [a,b,num2str(PictureNumber),d];            
        else
            b = '\P0';
            filename = [a,b,num2str(PictureNumber),d];            
        end
end

atomsdata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'A',num2str(cameranumber-1),'.tga']);
noisedata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'N',num2str(cameranumber-1),'.tga']);
probedata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'P',num2str(cameranumber-1),'.tga']);
otherdata=loadtga([directory,'\P',num2str(PictureNumber,'%04i'),char(64+cameranumber),'O',num2str(cameranumber-1),'.tga']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% END LoadingImages  %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%  Calculate optical density %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if ~isempty(atomsdata)
    newdata=1;
    raw=(atomsdata-noisedata);
    probe=(probedata-noisedata);
    difference=raw-probe;
else
    newdata=0;
end

difference=max(-difference,0);


imA = atomsdata;
imP = probedata;
imN = noisedata;
imO = otherdata;


MaxOD=5;
opticalDensity=min(MaxOD,-log(max(0.00000001,(imA)./(imP))));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% end  Calculate optical density %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end