function [FullParameters]=fitSSBECbackground3(oldimdata,SSBECfitparam,xx,yy,X,~,PCAcrop,x0)

global plotcounter
global plotheader

imdata=oldimdata;

if nargin<8
    xprofile=sum(imdata,1);
    xposdata=((1:length(xprofile))+PCAcrop(2)-1)*SSBECfitparam.Xcal;
    
    lsqoptions=optimset('Display','none');
    
    transportXrange1=SSBECfitparam.transportXrange1-PCAcrop(2)+1;
    transportXrange2=SSBECfitparam.transportXrange2-PCAcrop(2)+1;
    reservoirXrange1=SSBECfitparam.reservoirXrange1-PCAcrop(2)+1;
    reservoirXrange2=SSBECfitparam.reservoirXrange2-PCAcrop(2)+1;
    dimpleXrange=SSBECfitparam.dimpleXrange-PCAcrop(2)+1;
    
    transportX=[xposdata(transportXrange1(1):transportXrange1(2)), xposdata(transportXrange2(1):transportXrange2(2))];
    transportXData=[xprofile(transportXrange1(1):transportXrange1(2)), xprofile(transportXrange2(1):transportXrange2(2))];

    transportYData=sum(imdata(:,transportXrange1(1):transportXrange1(2)),2).'/(transportXrange1(2)-transportXrange1(1)+1);

    yposdata=((1:length(transportYData))+PCAcrop(1)-1)*SSBECfitparam.Ycal;

    % remove the transport guide signal

    transportY=yposdata;

     % gaussian fit the transport (Y direction)

    transportYx0(1)=max(transportYData)-min(transportYData);
    [~,maxloc]=max(transportYData);
    transportYx0(2)=transportY(maxloc);
    transportYx0(3)=sum(transportYData-min(transportYData))/transportYx0(1)/2*(max(transportYData)-min(transportYData))/length(transportYData);
    transportYx0(4)=min(transportYData);
    lb=[transportYx0(1)/2,min(transportY),transportYx0(3)/100,transportYx0(4)-(std(transportYData))];
    ub=[transportYx0(1)*2,max(transportY),transportYx0(3)*100,transportYx0(4)+(std(transportYData))];
    % display('fitting...');
    xfittedTransportY=lsqcurvefit(@gaussian,transportYx0,transportY,transportYData,lb,ub,lsqoptions);
    beamNy=xfittedTransportY(1);
    beamY=xfittedTransportY(2);
    beamWy=xfittedTransportY(3);
    
%     imdata=imdata-xfittedTransportY(4);
% 
%     % gaussian fit the transport (X direction)
% 
%     transportXx0(1)=max(transportXData)-min(transportXData);
%     [~,maxloc]=max(transportXData);
%     transportXx0(2)=transportX(maxloc);
%     transportXx0(3)=sum(transportXData-min(transportXData))/transportXx0(1)/2*(max(transportXData)-min(transportXData))/length(transportXData);
%     transportXx0(4)=min(transportXData);
%     lb=[transportXx0(1)/2,min(transportX),transportXx0(3)/100,transportXx0(4)-(std(transportXData))];
%     ub=[transportXx0(1)*2,max(transportX),transportXx0(3)*100,transportXx0(4)+(std(transportXData))];
%     % display('fitting...');
%     xfittedTransportX=lsqcurvefit(@gaussian,transportXx0,transportX,transportXData,lb,ub);
%     
%     % remove 2D transport fit first section
% 
%     beamNx=xfittedTransportX(1);
%     beamX=xfittedTransportX(2);
%     beamWx=xfittedTransportX(3);
% 
%     beam2D=(beamNx*exp(-((xx-beamX)/beamWx).^2)).*...
%         (beamNy*exp(-((yy-beamY)/beamWy).^2));
% 
%     transport2Dsubsection=beam2D(:,transportXrange1(1):transportXrange1(2));
%     transport2Ddatasubsection=imdata(:,transportXrange1(1):transportXrange1(2));
%     
%     % lets fit the amplitude and background in 2D
% 
%     x0a(1)=1;
%     x0a(2)=0;
% 
%     % display('fitting...');
%     x0a=fminsearch(@(x) modefit(x,transport2Dsubsection,transport2Ddatasubsection),x0a);
% 
%     beamN=x0a(1);
%     Background=x0a(2);
% 
%     imdata=imdata-Background;
%     beam2D=beam2D*beamN;
%     imdata=imdata-beam2D;

    % next let's estimate the fitting parameters for the thermal background fit

    xprofile=sum(imdata,1);

    reservoirX=[xposdata(reservoirXrange1(1):reservoirXrange1(2)), xposdata(reservoirXrange2(1):reservoirXrange2(2))];
    reservoirXData=[xprofile(reservoirXrange1(1):reservoirXrange1(2)), xprofile(reservoirXrange2(1):reservoirXrange2(2))];
    % dimpleX=[xposdata(dimpleXrange(1):dimpleXrange(2))];
    % dimpleXData=[xprofile(dimpleXrange(1):dimpleXrange(2))];

    dimpleYData=sum(imdata(:,dimpleXrange(1):dimpleXrange(2)),2).'/(dimpleXrange(2)-dimpleXrange(1)+1);
    reservoirYData=sum(imdata(:,reservoirXrange2(1):reservoirXrange2(2)),2).'/(reservoirXrange2(2)-reservoirXrange2(1)+1);

    dimpleY=yposdata;
    reservoirY=yposdata;

    % gaussian fit the reservoir (X direction)

    reservoirXDataRes=reservoirXData; %-gaussian(xfittedTransport,reservoirX);

    % figure(102);
    % plot(reservoirX,reservoirXDataRes,'b.');

    reservoirXx0(1)=max(reservoirXDataRes)-min(reservoirXDataRes);
    [~,maxloc]=max(reservoirXDataRes);
    reservoirXx0(2)=reservoirX(maxloc);
    reservoirXx0(3)=(reservoirX(end)-reservoirX(1))/4;
    %                 reservoirXx0(3)=sum(reservoirXDataRes-min(reservoirXDataRes))/reservoirXx0(1)/2*(max(reservoirXDataRes)-min(reservoirXDataRes))/length(reservoirXDataRes);
    reservoirXx0(4)=min(reservoirXDataRes);
    lb=[reservoirXx0(1)/2,min(reservoirX),reservoirXx0(3)/10,reservoirXx0(4)-(std(reservoirXDataRes))];
    ub=[reservoirXx0(1)*2,max(reservoirX),reservoirXx0(3)*10,reservoirXx0(4)+(std(reservoirXDataRes))];
    % display('fitting...');
    xfittedReservoir=lsqcurvefit(@gaussian,reservoirXx0,reservoirX,reservoirXDataRes,lb,ub,lsqoptions);

    % gaussian fit the reservoir (Y direction)

    reservoirYx0(1)=max(reservoirYData)-min(reservoirYData);
    [~,maxloc]=max(reservoirYData);
    reservoirYx0(2)=reservoirY(maxloc);
    reservoirYx0(3)=sum(reservoirYData-min(reservoirYData))/reservoirYx0(1)/2*(max(reservoirYData)-min(reservoirYData))/length(reservoirYData);
    reservoirYx0(4)=min(reservoirYData);
    lb=[reservoirYx0(1)/2,min(reservoirY),reservoirYx0(3)/100,reservoirYx0(4)-(std(reservoirYData))];
    ub=[reservoirYx0(1)*2,max(reservoirY),reservoirYx0(3)*100,reservoirYx0(4)+(std(reservoirYData))];
    % display('fitting...');
    xfittedReservoirY=lsqcurvefit(@gaussian,reservoirYx0,reservoirY,reservoirYData,lb,ub,lsqoptions);
    
    % gaussian fit the dimple (Y direction)

    dimpleYx0(1)=max(dimpleYData)-min(dimpleYData);
    [~,maxloc]=max(dimpleYData);
    dimpleYx0(2)=dimpleY(maxloc);
    dimpleYx0(3)=sum(dimpleYData-min(dimpleYData))/dimpleYx0(1)/2*(max(dimpleYData)-min(dimpleYData))/length(dimpleYData);
    dimpleYx0(4)=min(dimpleYData);
    lb=[dimpleYx0(1)/2,min(dimpleY),dimpleYx0(3)/100,dimpleYx0(4)-(std(dimpleYData))];
    ub=[dimpleYx0(1)*2,max(dimpleY),dimpleYx0(3)*100,dimpleYx0(4)+(std(dimpleYData))];
    % display('fitting...');
    xfittedDimpleY=lsqcurvefit(@gaussian,dimpleYx0,dimpleY,dimpleYData,lb,ub,lsqoptions);

    if SSBECfitparam.plotseedingfits
        yfitdataTransportY=gaussian(xfittedTransportY,transportY);
        xfitdataTransportY=transportY;
        display(['Beam Y: ',num2str(xfittedTransportY(1)),'*exp(-((x-',num2str(xfittedTransportY(2)),')/',num2str(xfittedTransportY(3)),')^2)+',num2str(xfittedTransportY(4))]);
        figure(801);
        plot(transportY,transportYData,'k.',xfitdataTransportY,yfitdataTransportY,'r');
        title('Beam Y fitting');
        
%         yfitdataTransport=gaussian(xfittedTransportX,transportX);
%         xfitdataTransport=transportX;
%         display(['Beam X: ',num2str(xfittedTransportX(1)),'*exp(-((x-',num2str(xfittedTransportX(2)),')/',num2str(xfittedTransportX(3)),')^2)+',num2str(xfittedTransportX(4))]);
%         figure(802);
%         plot(transportX,transportXData,'g.',xfitdataTransport,yfitdataTransport,'g.');
%         title('Beam X fitting');
        
        yfitdataReservoir=gaussian(xfittedReservoir,reservoirX);%+gaussian(xfittedTransport,reservoirX);
        xfitdataReservoir=reservoirX;
        display(['Reservoir X: ',num2str(xfittedReservoir(1)),'*exp(-((x-',num2str(xfittedReservoir(2)),')/',num2str(xfittedReservoir(3)),')^2)+',num2str(xfittedReservoir(4))]);
        figure(803);
        plot(reservoirX,reservoirXData,'b.',xfitdataReservoir,yfitdataReservoir,'b.');
%         plot(reservoirX,reservoirXData,'b.',dimpleX,dimpleXData,'r.',xfitdataReservoir,yfitdataReservoir,'b.');
        title('Reservoir X fitting');
        %                plot(transportX,transportXData,'g.',reservoirX,reservoirXData,'b.',dimpleX,dimpleXData,'r.',xfitdataTransport,yfitdataTransport,'g.',xfitdataReservoir,yfitdataReservoir,'b.');
        %                 legendentry=[num2str(xfitted(1),'%0.3e'),'*exp(-((x-',num2str(xfitted(2),'%0.3e'),')/',num2str(xfitted(3),'%0.3e'),')^2)+',num2str(xfitted(4),'%0.3e')];

        yfitdataReservoirY=gaussian(xfittedReservoirY,reservoirY);
        xfitdataReservoirY=reservoirY;
        display(['Reservoir Y: ',num2str(xfittedReservoirY(1)),'*exp(-((x-',num2str(xfittedReservoirY(2)),')/',num2str(xfittedReservoirY(3)),')^2)+',num2str(xfittedReservoirY(4))]);
        figure(804);
        plot(reservoirY,reservoirYData,'k.',xfitdataReservoirY,yfitdataReservoirY,'r');
        title('Reservoir Y fitting');

        yfitdataDimpleY=gaussian(xfittedDimpleY,dimpleY);
        xfitdataDimpleY=reservoirY;
        display(['Dimple Y: ',num2str(xfittedDimpleY(1)),'*exp(-((x-',num2str(xfittedDimpleY(2)),')/',num2str(xfittedDimpleY(3)),')^2)+',num2str(xfittedDimpleY(4))]);
        figure(805);
        plot(dimpleY,dimpleYData,'k.',xfitdataDimpleY,yfitdataDimpleY,'r');
        title('Dimple Y fitting');
    end


    % construct a 2D model for the Crossover+Reservoir+Dimple+BEC and fit
    % the free parameters

    [Dimpleampl,DimpleXpos]=max(max(imdata,[],1));

    x0(1)=xfittedDimpleY(1);                     % x0(1)=DimpleN;
    x0(2)=xfittedDimpleY(3);                % x0(2)=DimpleWy;
    x0(3)=xfittedReservoirY(1)/2;             % x0(3)=ReservoirN; % xfittedReservoirY(1)/2;
    x0(4)=xfittedReservoirY(3);             % x0(4)=ReservoirWy;
    x0(5)=xfittedReservoir(3)*2;            % x0(5)=ReservoirWx;
    x0(6)=xfittedReservoirY(1)/4;                     % x0(6)=CrossoverN; % xfittedReservoirY(1); 
    x0(7)=xfittedReservoirY(3);             % x0(7)=CrossoverWy;
    x0(8)=xfittedReservoir(3);              % x0(8)=CrossoverWx;
    x0(9)=X(DimpleXpos);                    % x0(9)=Dimplex;
    x0(10)=xfittedDimpleY(2);               % x0(10)=Dimpley;
    x0(11)=xfittedReservoir(2);             % x0(11)=Crossoverx;
    x0(12)=(xfittedReservoir(2)+x0(9))/2;   % x0(12)=Reservoirx;
    x0(13)=beamNy;                           % x0(13)=Beam Amplitude;
%     x0(13)=beamNx*beamNy*beamN;             % x0(13)=Beam Amplitude;
%     x0(14)=beamX;                           % x0(14)=Beam x0;
%     x0(15)=beamWx;                          % x0(15)=Beam Wx;
    x0(14)=x0(11);                           % x0(14)=Beam x0;
    x0(15)=x0(8);                          % x0(15)=Beam Wx;
    x0(16)=beamY;                           % x0(16)=Beam y0;
    x0(17)=beamWy;                          % x0(17)=Beam Wy;
%     x0(18)=Background;                      % x0(18)=Background;
    x0(18)=0;                      % x0(18)=Background;
    
    BECN=1.5e4;                               % x0(10)=BECN;
    BECwx=2*pi*310*2;                         %BECWx; % omega_x=2*pi*310; % x0(11)=BECWx;
    BECwy=2*pi*550*2;                         %BECWy; % omega_y=2*pi*550; % x0(12)=BECWy;
    BECX=x0(9);                             % x0(9)=Dimplex;
    BECY=x0(10);                            % x0(10)=Dimpley;
    
    x0(19)=BECN;
    x0(20)=BECwx;
    x0(21)=BECwy;
    x0(22)=BECX;
    x0(23)=BECY;
end

% if the parametrers stray outside these limits inflict a heavy error to
% force it back

fittype.limits(1,1:2)=[0 200];                                      % Parameters(1)=DimpleN;
fittype.limits(2,1:2)=[0.1 0.5];                                    % Parameters(2)=DimpleWy;
fittype.limits(3,1:2)=[0 200];                                      % Parameters(3)=ReservoirN;
fittype.limits(4,1:2)=[0.1 0.5];                                    % Parameters(4)=ReservoirWy;
fittype.limits(5,1:2)=[0.1 2];                                      % Parameters(5)=ReservoirWx;
fittype.limits(6,1:2)=[0 200];                                      % Parameters(6)=CrossoverN;
fittype.limits(7,1:2)=[0.1 0.5];                                    % Parameters(7)=CrossoverWy;
fittype.limits(8,1:2)=[0.1 1];                                      % Parameters(8)=CrossoverWx;
fittype.limits(9,1:2)=SSBECfitparam.aperturex*SSBECfitparam.Xcal;   % Parameters(9)=Dimplex;
fittype.limits(10,1:2)=SSBECfitparam.aperturey*SSBECfitparam.Ycal;  % Parameters(10)=Dimpley;
fittype.limits(11,1:2)=[SSBECfitparam.reservoirXrange1(1) SSBECfitparam.reservoirXrange2(2)]*SSBECfitparam.Xcal;      % Parameters(11)=Crossoverx;
fittype.limits(12,1:2)=[SSBECfitparam.reservoirXrange1(1) SSBECfitparam.reservoirXrange2(2)]*SSBECfitparam.Xcal;      % Parameters(12)=Reservoirx;
fittype.limits(13,1:2)=[0 50];                                      % Parameters(13)=transportN;
fittype.limits(14,1:2)=[SSBECfitparam.reservoirXrange1(1) SSBECfitparam.transportXrange2(2)]*SSBECfitparam.Xcal;      % Parameters(14)=transportX;
fittype.limits(15,1:2)=[0.2 10];                                    % Parameters(15)=transportWx;
fittype.limits(16,1:2)=SSBECfitparam.aperturey*SSBECfitparam.Ycal;  % Parameters(16)=transportY;
fittype.limits(17,1:2)=[0.1 0.5];                                   % Parameters(17)=transportWy;
fittype.limits(18,1:2)=[-10 10];                                    % Parameters(18)=Background;
fittype.limits(19,1:2)=[-1e1 1e5];                                  % Parameters(19)=BECN;
fittype.limits(20,1:2)=[2*pi*200 2*pi*900];                         % Parameters(20)=BECwx;
fittype.limits(21,1:2)=[2*pi*400 2*pi*1500];                         % Parameters(21)=BECwy;
fittype.limits(22,1:2)=SSBECfitparam.aperturex*SSBECfitparam.Xcal;  % Parameters(22)=BECX;
fittype.limits(23,1:2)=SSBECfitparam.aperturey*SSBECfitparam.Ycal;  % Parameters(23)=BECY;

% do a first fit for the thermal cloud based on the apertured data

fittype.useaperture=1;
fittype.aperturey=SSBECfitparam.aperturey-PCAcrop(1)+1;
fittype.aperturex=SSBECfitparam.aperturex-PCAcrop(2)+1;
plotcounter=0;
fittype.parameterstouse=1:18;
fittype.FullParameters=zeros(size(x0));
fittype.functionnorm=sum(sum(imdata));
fittype.showinterationplots=SSBECfitparam.showinterationplots;
fittype.MINBECSIZE=SSBECfitparam.MINBECSIZE;

% display('fitting...');
fittype.x0norm=x0(fittype.parameterstouse);
fittype.x0norm(18)=1;
Parameters=x0(fittype.parameterstouse)./fittype.x0norm;

if fittype.showinterationplots~=0;
    figure(386);
    subplot(3,1,1,'replace');
    imagesc(oldimdata);
    fittype.climits=get(gca,'cLim');
    title(plotheader);
    colorbar;
    colormap jet
end
% options=optimset('Display','iter','TolX',SSBECfitparam.fittolerance,'TolFun',10,'MaxFunEvals',8000);
% options=optimset('Display','final','TolX',SSBECfitparam.fittolerance,'TolFun',10,'MaxFunEvals',8000,'MaxIter',8000);
options=optimset('Display','notify','TolX',SSBECfitparam.fittolerance,'TolFun',10,'MaxFunEvals',SSBECfitparam.maxiterations,'MaxIter',SSBECfitparam.maxiterations);

Parameters=fminsearch(@(x) estimateSSBECfiterror3(x,xx,yy,oldimdata,fittype),Parameters,options).*fittype.x0norm;

% calculate the residuals and estimate the BEC atom number

fittype.FullParameters(fittype.parameterstouse)=Parameters(1:end);
[estimatedprofile]=constructSSBEC6(fittype.FullParameters,xx,yy);
residual=imdata-estimatedprofile;

fittype.FullParameters(19)=sum(sum(residual(fittype.aperturey(1):fittype.aperturey(2),fittype.aperturex(1):fittype.aperturex(2)))); % estimate the BEC atom number
fittype.FullParameters(20:21)=x0(20:21);
fittype.FullParameters(22)=x0(9);           % x0(9)=Dimplex;
fittype.FullParameters(23)=x0(10);          % x0(10)=Dimpley;

fittype.useaperture=0;
plotcounter=0;
fittype.parameterstouse=1:21;

fittype.x0norm=fittype.FullParameters(fittype.parameterstouse);
fittype.x0norm(18)=1;
fittype.x0norm(19)=1.5e4;
Parameters=fittype.FullParameters(fittype.parameterstouse)./fittype.x0norm;

if fittype.showinterationplots~=0;
    figure(386);
    subplot(3,1,1,'replace');
    imagesc(oldimdata);
    fittype.climits=get(gca,'cLim');
    title(plotheader);
    colorbar;
    colormap jet
end

% options=optimset('Display','iter','TolX',SSBECfitparam.fittolerance,'TolFun',10,'MaxFunEvals',8000);
% options=optimset('Display','final','TolX',SSBECfitparam.fittolerance,'TolFun',10,'MaxFunEvals',8000,'MaxIter',8000);
options=optimset('Display','notify','TolX',SSBECfitparam.fittolerance,'TolFun',10,'MaxFunEvals',SSBECfitparam.maxiterations,'MaxIter',SSBECfitparam.maxiterations);

Parameters=fminsearch(@(x) estimateSSBECfiterror3(x,xx,yy,oldimdata,fittype),Parameters,options).*fittype.x0norm;
FullParameters(fittype.parameterstouse)=Parameters(1:end);
FullParameters(22)=FullParameters(9);           % x0(9)=Dimplex;
FullParameters(23)=FullParameters(10);          % x0(10)=Dimpley;
if (FullParameters(19)<fittype.MINBECSIZE)
    FullParameters(19)=0;
end

if SSBECfitparam.showaperture
    estimatedprofileresult=constructSSBEC6(FullParameters,xx,yy);
    apertured=imdata-estimatedprofileresult;
    apertured(fittype.aperturey(1):fittype.aperturey(2),fittype.aperturex(1):fittype.aperturex(2))=0;
    
    figure(387);
    imagesc(apertured);
    colorbar;
%                         title(['\S',num2str(seriesnumber(ind)),' P',num2str(imagenum-1,'%04.0f')]);
%                         axis equal
    colormap jet
end


end

function [yfit]=gaussian(x,xdata)

yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2)+x(4);

%                                     figure(22);
%                                     plot(xdata,yfit,'r-');
% pause(0.1);

end

function [yfit]=modefit(x,model,data)

yfit=sum(sum(abs((x(1)*model+x(2)-data))));

end

% function [yfit]=sinwithbackground(x,xdata)
% 
% yfit=x(1)*sin(2*pi*x(2)*xdata+x(3))+x(4);
% 
% %                                     figure(22);
% %                                     plot(xdata,yfit,'r-');
% % pause(0.1);
% 
% end
% 
% function [yfit]=sinwithdecayandbackground(x,xdata)
% 
% yfit=x(1)*exp(-xdata/x(5)).*sin(2*pi*x(2)*xdata+x(3))+x(4);
% 
% %                                     figure(22);
% %                                     plot(xdata,yfit,'r-');
% % pause(0.1);
% 
% end
% 
% function [yfit]=lorentzian(x,xdata)
% 
% yfit=x(1)./(1+4*((xdata-x(2))/x(3)).^2)+x(4);
% 
% %                                     figure(22);
% %                                     plot(xdata,yfit,'r-');
% % pause(0.1);
% 
% end
% 
% function [yfit]=gaussian_nobackground(x,xdata)
% 
% yfit=x(1)*exp(-((xdata-x(2))/x(3)).^2);
% 
% end

