close all

%Fit fermions 
%Does not run from network folder
CurrentScriptPath = mfilename('fullpath');
CurrentDirectory = CurrentScriptPath(1:end-6);
addpath([CurrentDirectory,'tools'])
DataDirectory = [CurrentScriptPath(1:end-27),'Data\'];
% Data to load %

%Loading S16 data. This data is located inside Q:\qgases\groups\strontium\SrCAL\Data\Sr87\Data\200911\S16
SeriesDate = '200911';
series = 'S16'
PictureS = [20,21];

% Crop picture rectangle %
params.rectIna = [ 1144 ,47     ,  478      , 922] %% 
params.cameranumber = 3;
params.cameraResolution = [14.32,14.32];  %camera resolution um/pix (horizontal imaging) for x and y

Results1Dx = {};Results1Dy = {};expSigmay = {};expSigmax = {};

for ind = 1:length(PictureS)
    
SeriesDataFolder = [DataDirectory,SeriesDate,'\',series];

PictureNumber = PictureS(ind);
TOF = 0.1;

[Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,F] = MyGaussfit1D(SeriesDataFolder,PictureNumber,params);
[resutls , sigma ,xdata ] = MyGaussfit2D2D(SeriesDataFolder,PictureNumber,params,Results1Dx,Results1Dy);



xcal  = params.cameraResolution(1);
ycal  = params.cameraResolution(2);
figure2DGausian = figure(6)
subplot(2,length(PictureS),ind);
FitResult = gaussian2Dfn(resutls,xdata);
maxPic = max(max(FitResult));
minPic = min(min(FitResult));
imshow((FitResult-minPic)/(maxPic-minPic)*256,jet(256),'Border','tight');
PlotLegend = ['\sigma','y','=',num2str(ycal*Results1Dy(2)),'\pm',num2str(ycal*expSigmay(2))]

subplot(2,length(PictureS),ind+length(PictureS));
maxPic = max(max(F));
minPic = min(min(F));
imshow((F-minPic)/(maxPic-minPic)*256,jet(256),'Border','tight');
set(figure2DGausian,'NumberTitle', 'off', 'Name', '2D Gausian Fit results')




figureIntegratedy = figure (4)
subplot(2,ceil(length(PictureS)/2),ind);
piclegend =['picture', num2str(PictureS(ind))]
plotIntegratedy (Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,piclegend)
set(figureIntegratedy,'NumberTitle', 'off', 'Name', 'Integrated y profiles')

figureIntegratedx = figure(5)
subplot(2,ceil(length(PictureS)/2),ind);
piclegend =['picture', num2str(PictureS(ind))]
plotIntegratedx (Results1Dx,Results1Dy,expSigmax,expSigmay,mx,my,y1D,x1D,piclegend)

set(figureIntegratedx,'NumberTitle', 'off', 'Name', 'Integrated y profiles')


end



 




% pause(1);
% var(residualGauss2D);
% %Loading s41 data. This data is located inside the current folder.
% %S41 is the bosonic MOT data.
% series = 'S41'
% SeriesDataFolder = [CurrentDirectory,series]
% PictureNumber = 18;
% TOF = 0.1;
% MyGaussfit1D(SeriesDataFolder,PictureNumber,TOF);