if ~exist('PCAmatrix')
    load('Y:\Vision\191226\S1018\imagedataset.mat');
    load('Y:\Vision\191226\S1018\fitdataset.mat');
end
inputdate='191226';
seriesnumber=[1018];
% imagenumberlist=[120,121,102,104,84];
imagenumberlist=[84,121];

plotparam.cameranumber=1;
plotparam.dataparameters=1;
plotparam.datasection=plotparam.dataparameters+11;
plotparam.xdatasection=5;
plotparam.datafilename='';
plotparam.xfitmax=inf;
plotparam.xfitmin=-inf;

fitsummaryfig=1;

ind=1;
[xdata{ind},imagenumbers{ind},lastxlabelname,directory]=loadvisionseriesdata(inputdate,seriesnumber(ind),2,plotparam.xdatasection,plotparam.cameranumber,plotparam.datafilename);

% h = 6.626*10.^(-34); %Js
% hbar = h/(2*pi); %Js
% mSr =  84*1.67*10^(-27); %kg
% kB =  1.3806503*10^(-23); %m^2 kg/s^2 K
% lamdaSr = 461*10.^(-9); %m
% abscrosSr = (3*(lamdaSr.^2))./(2*pi); %m^2
% a0 = 0.052917721086*10^-9;
% a8686 = 798*a0;
% a8484 = 102.5*a0;
% aScat = a8484;

touse=find((xdata{ind}>plotparam.xfitmin)&(xdata{ind}<plotparam.xfitmax));

xdatagood=xdata{ind}(touse);
imagenums=imagenumbers{ind}(touse);

[sortedxdata,indexlist]=sort(xdatagood);


for imagenumber=imagenumberlist
    framenumber=find(indexlist==imagenumber)+1;
framenumber=2; %FS, 24.1.2020:something is weird with framenumber, I need to give it
%%explixitly, otherwise the program stalls.
    imdata=reshape(PCAmatrix(indexlist(framenumber-1)+1,:),size(imdata));

    X=((1:size(imdata,2))+roilocation(2)-1)*SSBECfitparam.Xcal;
    Y=((1:size(imdata,1))+roilocation(1)-1)*SSBECfitparam.Ycal;

    [xx,yy]=meshgrid(X,Y);

    estimatedprofile=constructSSBEC6(squeeze(x0series(indexlist(framenumber-1)+1,:)),xx,yy);

    residual=imdata(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border))-estimatedprofile(max(1,SSBECfitparam.aperturey(1)-SSBECfitparam.border):min(size(imdata,1),SSBECfitparam.aperturey(2)+SSBECfitparam.border),max(1,SSBECfitparam.aperturex(1)-SSBECfitparam.border):min(size(imdata,2),SSBECfitparam.aperturex(2)+SSBECfitparam.border));

    datatoplot=imdata;
    figure(fitsummaryfig);
    set(fitsummaryfig,'Position',[50 50 1800 950]);
    subplot(3,1,1,'replace');
    imagesc(imdata,[0 110]);
    colorbar;
    title(['Data at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
    colormap jet

    Datafilename='ResultData';
    if seriesnumber(ind)>0,
        imagename=[directory,'\S',num2str(seriesnumber),'\',Datafilename,directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f')];
    else
        imagename=[directory,'\',Datafilename,directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f')];
    end
    imwrite((datatoplot+10)/128,[imagename,'.tif'],'tiff'); 
    imwrite((datatoplot+10)/128,[imagename,'.bmp'],'bmp'); 
    [min(min((datatoplot+10)/128)),max(max((datatoplot+10)/128))],

    datatoplot=estimatedprofile;
    subplot(3,1,2,'replace');
    imagesc(estimatedprofile,[0 110]);
    colorbar;
    title(['Fit at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
    colormap jet

    Datafilename='ResultFit';
    if seriesnumber(ind)>0,
        imagename=[directory,'\S',num2str(seriesnumber),'\',Datafilename,directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f')];
    else
        imagename=[directory,'\',Datafilename,directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f')];
    end
    imwrite((datatoplot+10)/128,[imagename,'.tif'],'tiff'); 
    imwrite((datatoplot+10)/128,[imagename,'.bmp'],'bmp');
    [min(min((datatoplot+10)/128)),max(max((datatoplot+10)/128))],

    datatoplot=imdata-estimatedprofile;
    subplot(3,1,3,'replace');
    imagesc(datatoplot,[-5 20]);
    colorbar;
    colormap jet
    title(['Residuals at time ',num2str(sortedxdata(framenumber-1)/1000),'s (',directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f'),')']);
    
    Datafilename='ResultResidual';
    if seriesnumber(ind)>0,
        imagename=[directory,'\S',num2str(seriesnumber),'\',Datafilename,directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f')];
    else
        imagename=[directory,'\',Datafilename,directory((end-5):end),' S',num2str(seriesnumber(ind)),' P',num2str(imagenums(indexlist(framenumber-1)),'%04.0f')];
    end
    imwrite((datatoplot+10)/128,[imagename,'.tif'],'tiff'); 
    imwrite((datatoplot+10)/128,[imagename,'.bmp'],'bmp'); 
    [min(min((datatoplot+10)/128)),max(max((datatoplot+10)/128))],
end
