function [K,sigmamult2,v,vfn,sigmamult2dfn,mat] = ConstructDecayOperators (params)


for i = 1 :params.ProblemDim/2
    for j = (params.ProblemDim/2 +1) :  (params.ProblemDim )
         Strengh (i,j)= StrenghFunction (i,j,params);
    end
end

counter = 1;
aux = eye(params.ProblemDim);
K = zeros(params.ProblemDim,params.ProblemDim);
sigmamult2dfn= [];
for i = 1 :params.ProblemDim/2
    for j = (params.ProblemDim/2+1) :  (params.ProblemDim)        
           if  Strengh(i,j)~=0
               decayoperator= sparse(aux(i,:)'*aux(j,:));  
               cte = sqrt(params.Gamma)*Strengh(i,j);
               sigma{counter} = cte*decayoperator;
               sigmamult2{counter} = (cte^2)*(decayoperator*decayoperator');               
               v{counter} =sparse( aux(j,:)');
               sigmamult=(cte^2)*(decayoperator'*decayoperator);
               K = K -1/2*sigmamult;
               sigmamult2dfn (counter,:) =  diag((cte^2)*(decayoperator*decayoperator'));
               counter = counter+ 1;
               
           end
    end
end
vfn = zeros(params.ProblemDim,counter);
for i = 1:(counter-1)
vfn (:,i) = v{i};
end
vfn = sparse(vfn);
sigmamult2dfn = (sigmamult2dfn);
K = sparse(K);

unos = ones(params.ProblemDim/2,params.ProblemDim/2);
ceros = zeros(params.ProblemDim/2,params.ProblemDim/2);

UpperRightMatrix = [ceros,-unos/2 ; ceros , ceros];
BottomLeft = [ceros,ceros ; ceros,-unos];
mat = triu(UpperRightMatrix + BottomLeft);
mat = mat+mat' - diag(diag(mat));
mat = params.Gamma*mat;
end





function retunr = auxFn (state,densityMatrix,params)
    for j = (params.ProblemDim/2 +1) : params.ProblemDim
    vec (j) = densityMatrix(i,j)* StrenghFunction(i,j)^2;
    end
    retunr = params.Gamma*Sum( vec (j) )  ;  
end

function Strenght = StrenghFunction(state1,State2,params) 
ProblemDim = params.ProblemDim;
Pstates = params.pstates;
    if (State2 == state1 + ProblemDim/2 )
        Strenght = StrengthPiTrans(state1,params);
    elseif (State2 == state1 + ProblemDim/2 + Pstates )
        Strenght =  StrengthSigmaPlus(state1,params);
    elseif (State2 == state1 + ProblemDim/2 - Pstates )
        Strenght =  StrengthSigmaMinus(state1,params);
    else
        Strenght = 0 ;
    end

end
function StrengthPiTrans = StrengthPiTrans(State,params)
F =  params.F;Fp =  params.Fp;
pstates = params.pstates;
    if (F==0 &  Fp ==0)
        StrengthPiTrans = 1;
    else
        mf = floor((State-1)/pstates) - F;
        mfp = floor((State-1)/pstates) - Fp;
       StrengthPiTrans =  ClebschGordan(F,mf,1,0,Fp,mfp);
       if (mf>F)
            error('mf state is unfisical, mf>F');
       end
    end
end

function StrengthSigmaPlus = StrengthSigmaPlus(State,params)
F =  params.F;Fp =  params.Fp;
pstates = params.pstates;
    if (F==0 &  Fp ==0)
        StrengthSigmaPlus = 1;
    else
        mf = floor((State-1)/pstates) - F;
        mfp = floor((State-1)/pstates) - Fp + 1;
       StrengthSigmaPlus =  ClebschGordan(F,mf,1,1,Fp,mfp);
    end
end


function StrengthSigmaMinus = StrengthSigmaMinus(State,params)
F =  params.F;Fp =  params.Fp;
pstates = params.pstates;
    if (F==0 &  Fp ==0)
        StrengthSigmaMinus = 1;
    else
        mf = floor((State-1)/pstates) - F;
        mfp = floor((State-1)/pstates) - Fp - 1;
       StrengthSigmaMinus =  ClebschGordan(F,mf,1,-1,Fp,mfp);
    end
end
