function [Hnot] = MakeHnot (params)
    Energy = params.hbar*GetInternalStateEnergies (params);
    Hnot = makeHnotfn(params,Energy);
end




function [Energy] = GetInternalStateEnergies (params)
F=params.F;
Fp = params.Fp;
DeltaBGround = params.DeltaBGround;
DeltaBexcited = params.DeltaBexcited;
    for i = 1: (2*F + 1) 
        EnergyGround (i) = DeltaBGround*(i - F - 1);
    end
    Fp=params.Fp;    
    for i = 1: (2*Fp + 1) 
        EnergyExcited (i) = DeltaBexcited*(i - F - 1);
    end
    
    Energy = horzcat ( EnergyGround , EnergyExcited );
    
end
    


function Hnot = makeHnotfn (params,Energy)
    for i = 1:params.InternalStates;
        for j = 1:params.InternalStates;
            if i==j
                Hnot{i,j} = MakeInternalStateHnot (params,Energy (i));
            else
                Hnot{i,j} = zeros(params.pstates);
            end

        end
    end
    Hnot =cell2mat(Hnot); 
end

 function Hnot = MakeInternalStateHnot (params,Energy)
    p = params.p;
    hbar = params.hbar;
    k = params.k;
    m = params.m;
    for i = 1:params.pstates     
        Diagonal ( i ) = (p - hbar*(i - 1)*k)^2/(2*m) + Energy;
        
    end
    Hnot= diag ( Diagonal );
end





