function SWAPOBEtest()


%%% Testing hamiltonian creation

%%% testing for pstates = 2 ,Fp = 1/2, Fp = 1/2
values.pstates = 2;
values.Fp = 1/2;
values.F = 1/2;

paramstest = setTestparams(paramclass ,values);
Operators = OperatorClass(paramstest);


Hfortest =@(delta) getHmat1_2(paramstest,delta);
H =  @(delta) Operators.H + Operators.getHt(paramstest,delta);

detunings = linspace(-1e6,1e6,100);
for delta = detunings
    tolerance = abs(H(delta) -  Hfortest(delta))<=(1/2^32);
    result = isequal(tolerance,ones(size(tolerance)));
    assert( result, 'Problem with hamiltonian operator')
end

%%% testing for pstates = 2 ,Fp = 1/2, Fp = 1/2 and SI UNIts
values.pstates = 2;
values.Fp = 1/2;
values.F = 1/2;

paramstest = setTestparams(paramclass ,values);
paramstest =paramstest.getSIUnits();
Operators = OperatorClass(paramstest);


Hfortest =@(delta) getHmat1_2(paramstest,delta);
H =  @(delta) Operators.H + Operators.getHt(paramstest,delta);

detunings = linspace(-1e6,1e6,100);
for delta = detunings
    tolerance = abs(H(delta) -  Hfortest(delta))<=(1/2^32);
    result = isequal(tolerance,ones(size(tolerance)));
    assert( result, 'Problem with hamiltonian operator')
end

%% testing for pstates = 4 ,Fp = 1/2, Fp = 1/2
values.pstates = 4;
values.Fp = 1/2;
values.F = 1/2;

paramstest = setTestparams(paramclass ,values);
Operators = OperatorClass(paramstest);

Hfortest =@(delta) getHmat1_2v2(paramstest,delta);
H =  @(delta) Operators.H + Operators.getHt(paramstest,delta);

detunings = linspace(-50,50,100);
for delta = detunings
    tolerance = abs(H(delta) -  Hfortest(delta))<=(1/2^32);
    result = isequal(tolerance,ones(size(tolerance)));
    assert( result, 'Problem with hamiltonian operator')
end


%% testing for pstates = 4 ,Fp = 3/2, Fp = 3/2
values.pstates = 3;
values.Fp = 3/2;
values.F = 3/2;

paramstest = setTestparams(paramstest ,values);
Operators = OperatorClass(paramstest);

Hfortest =@(delta) getHmat3_2(paramstest,delta);
H =  @(delta) Operators.H + Operators.getHt(paramstest,delta);

detunings = linspace(-50,50,100);
for delta = detunings
    tolerance = abs(H(delta) -  Hfortest(delta))<=(1/2^32);
    result = isequal(tolerance,ones(size(tolerance)));
    assert( result, 'Problem with hamiltonian operator')
end

paramstest = setTestparams(paramclass ,values);
paramstest = paramstest.getSIUnits();
Operators = OperatorClass(paramstest);

Hfortest =@(delta) getHmat3_2(paramstest,delta);
H =  @(delta) Operators.H + Operators.getHt(paramstest,delta);

detunings = linspace(-1e10,1e10,100);
for delta = detunings
    tolerance = abs(H(delta) -  Hfortest(delta))<=(1/2^32);
    result = isequal(tolerance,ones(size(tolerance)));
    assert( result, 'Problem with hamiltonian operator when using SI units')
end

%Testing Louvilian creation 
%For F = 1/2 Fp = 1/2 and 3 momentum staets
values.pstates = 3;
values.Fp = 1/2;
values.F =  1/2;

paramstest = setTestparams(paramstest ,values);
Operators = OperatorClass(paramstest);


for i = 1:20
    randomMatrix = rand(paramstest.ProblemDim,paramstest.ProblemDim) + j*rand(paramstest.ProblemDim,paramstest.ProblemDim);
    randomMatrix = randomMatrix + randomMatrix';
    Operators.rho = randomMatrix;

    L = getL1_2 ( paramstest,Operators.rho );
    L2 = Operators.MakeL2(paramstest);
    result = isequal(L,L2);
    assert( result, 'Problem with Lovillian')
end

%Testing Louvilian creation 
%For F = 3/2 Fp = 3/2 and 5 momentum staets

values.pstates = 5;
values.Fp = 3/2;
values.F =  3/2;

paramstest = setTestparams(paramstest ,values);
Operators = OperatorClass(paramstest);
    for i = 1:100
        randomMatrix = rand(paramstest.ProblemDim,paramstest.ProblemDim);
        randomMatrix = randomMatrix + randomMatrix';
        Operators.rho = randomMatrix;
        L1 = getL3_2(paramstest,Operators.rho);
        L3 = Operators.MakeL2(paramstest);
        tolerance2 = abs(L1 -  L3)<=(1/2^32);
        result = isequal(tolerance2,ones(size(tolerance2)));
        assert( result, 'Problem with Lovillian')
    end
 
%Testing Louvilian creation 
%For F = 3/2 Fp = 3/2 and 5 momentum staets and SI units   
values.pstates = 5;
values.Fp = 3/2;
values.F =  3/2;

paramstest = setTestparams(paramstest ,values);

paramstest = paramstest.getSIUnits();
Operators = OperatorClass(paramstest);
    for i = 1:100
        randomMatrix = rand(paramstest.ProblemDim,paramstest.ProblemDim);
        randomMatrix = randomMatrix + randomMatrix';
        Operators.rho = ones(size(randomMatrix));
        L1 = getL3_2(paramstest,Operators.rho);
        L3 = Operators.MakeL2(paramstest);
        tolerance2 = abs(L1 -  L3)<=(1/2^32);
        result = isequal(tolerance2,ones(size(tolerance2)));
        assert( result, 'Problem with Lovillian')
    end    
end



function H = getHmat1_2(params,delta)

%Hardcoded hamiltonian for F = 0.5 and Fp = 0.5 , and 2 momentum states
hbar = params.hbar;
m = params.m;
p = params.p;
k = params.k;
Omega = params.Omega;
Poltab = params.Poltab;
DeltaBexited = params.DeltaBexcited;
F = 0.5;
Fp = 0.5;
Strengh = @(mf,mfp,q) ClebschGordan(F,mf,1,q,Fp,mfp);


%Diagonal elements for FP = 1/2 & F = 1/2
H(1,1) = p^2/(2*m) + hbar*delta/2;
H(2,2) = (p-hbar*k)^2/(2*m) + hbar*delta/2;
H(3,3) = p^2/(2*m) + hbar*delta/2;
H(4,4) = (p-hbar*k)^2/(2*m) + hbar*delta/2;


H(5,5) = p^2/(2*m) - hbar*delta/2 -hbar*DeltaBexited/2  ;
H(6,6) = (p-hbar*k)^2/(2*m) - hbar*delta/2 - hbar*DeltaBexited/2;
H(7,7) = p^2/(2*m) - hbar*delta/2 + hbar*DeltaBexited/2;
H(8,8) = (p-hbar*k)^2/(2*m) - hbar*delta/2 + hbar*DeltaBexited/2;


Hod(1,2) = Poltab(2)*Strengh(-0.5,-0.5,0);
Hod(1,4) = Poltab(1)*Strengh(-0.5,+0.5,1);

Hod(2,1) = Poltab(2)*Strengh(-0.5,-0.5,0);
Hod(2,3) = Poltab(1)*Strengh(-0.5,+0.5,+1);
Hod(3,2) = Poltab(3)*Strengh(0.5,-0.5,-1);
Hod(3,4) = Poltab(2)*Strengh(0.5,0.5,0);
Hod(4,1) = Poltab(3)*Strengh(0.5,-0.5,-1);
Hod(4,3) = Poltab(2)*Strengh(0.5,0.5,0);

zerosmat = zeros(size(Hod));
Hod = Hod*hbar*Omega/2;
Hod = [   zerosmat Hod ; Hod' zerosmat ];
H = H + Hod;
% Off Diagonal elements for FP = 1/2 & F = 1/2 and polarization sigma +
% ,sigma -1
end

function H = getHmat1_2v2(params,delta)
%Hardcoded hamiltonian for F = 0.5 and Fp = 0.5 , and 4 momentum states
hbar = params.hbar;
m = params.m;
p = params.p;
k = params.k;
Omega = params.Omega;
Poltab = params.Poltab;
DeltaBexited = params.DeltaBexcited;
F = 0.5;
Fp = 0.5;
Strengh = @(mf,mfp) ClebschGordan(F,mf,1,mfp-mf,Fp,mfp);


%Diagonal elements for FP = 1/2 & F = 1/2
H(1,1) = p^2/(2*m) + hbar*delta/2;
H(2,2) = (p-hbar*k)^2/(2*m) + hbar*delta/2;
H(3,3) = (p-2*hbar*k)^2/(2*m) + hbar*delta/2;
H(4,4) = (p-3*hbar*k)^2/(2*m) + hbar*delta/2;

%Diagonal elements for FP = 1/2 & F = 1/2
H(5,5) = p^2/(2*m) + hbar*delta/2;
H(6,6) = (p-hbar*k)^2/(2*m) + hbar*delta/2;
H(7,7) = (p-2*hbar*k)^2/(2*m) + hbar*delta/2;
H(8,8) = (p-3*hbar*k)^2/(2*m) + hbar*delta/2;

H(9,9) = p^2/(2*m) - hbar*delta/2 -hbar*DeltaBexited/2  ;
H(10,10) = (p-hbar*k)^2/(2*m) - hbar*delta/2 - hbar*DeltaBexited/2;
H(11,11) = (p - 2*hbar*k)^2/(2*m) - hbar*delta/2 - hbar*DeltaBexited/2;
H(12,12) = (p - 3*hbar*k)^2/(2*m) - hbar*delta/2 - hbar*DeltaBexited/2;

H(13,13) = p^2/(2*m) - hbar*delta/2 + hbar*DeltaBexited/2  ;
H(14,14) = (p-hbar*k)^2/(2*m) - hbar*delta/2 + hbar*DeltaBexited/2;
H(15,15) = (p - 2*hbar*k)^2/(2*m) - hbar*delta/2 + hbar*DeltaBexited/2;
H(16,16) = (p - 3*hbar*k)^2/(2*m) - hbar*delta/2 + hbar*DeltaBexited/2;

Hod(1,2) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(1,6) = Poltab(1)*Strengh(-0.5,+0.5);

Hod(2,1) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(2,3) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(2,5) = Poltab(1)*Strengh(-0.5,+0.5);
Hod(2,7) = Poltab(1)*Strengh(-0.5,+0.5);

Hod(3,2) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(3,4) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(3,6) = Poltab(1)*Strengh(-0.5,+0.5);
Hod(3,8) = Poltab(1)*Strengh(-0.5,+0.5);

Hod(4,3) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(4,7) = Poltab(1)*Strengh(-0.5,0.5);


Hod(5,2) = Poltab(3)*Strengh(0.5,-0.5);
Hod(5,6) = Poltab(2)*Strengh(0.5,+0.5);

Hod(6,1) = Poltab(3)*Strengh(0.5,-0.5);
Hod(6,3) = Poltab(3)*Strengh(0.5,-0.5);
Hod(6,5) = Poltab(2)*Strengh(0.5,+0.5);
Hod(6,7) = Poltab(2)*Strengh(0.5,+0.5);

Hod(7,2) = Poltab(3)*Strengh(0.5,-0.5);
Hod(7,4) = Poltab(3)*Strengh(0.5,-0.5);
Hod(7,6) = Poltab(2)*Strengh(0.5,+0.5);
Hod(7,8) = Poltab(2)*Strengh(0.5,+0.5);

Hod(8,3) = Poltab(3)*Strengh(0.5,-0.5);
Hod(8,7) = Poltab(2)*Strengh(0.5,+0.5);

zerosmat = zeros(size(Hod));

Hod = Hod*hbar*Omega/2;
Hod = [   zerosmat Hod ; Hod' zerosmat ];
H = H + Hod;
% Off Diagonal elements for FP = 1/2 & F = 1/2 and polarization sigma +
% ,sigma -1
end

function H = getHmat3_2(params,delta)
%Hardcoded hamiltonian for F = 0.5 and Fp = 0.5 , and 4 momentum states
hbar = params.hbar;
m = params.m;
p = params.p;
k = params.k;
Omega = params.Omega;
Poltab = params.Poltab;
DeltaBexited = params.DeltaBexcited;
F = 1.5;
Fp = 1.5;
Strengh = @(mf,mfp) ClebschGordan(F,mf,1,mfp-mf,Fp,mfp);


%Diagonal elements for FP = 3/2 & F = 3/2
%Ground states
H(1,1) = p^2/(2*m)            + hbar*delta/2;
H(2,2) = (p-hbar*k)^2/(2*m)   + hbar*delta/2;
H(3,3) = (p-2*hbar*k)^2/(2*m) + hbar*delta/2;

H(4,4) = p^2/(2*m)            + hbar*delta/2;
H(5,5) = (p-hbar*k)^2/(2*m)   + hbar*delta/2;
H(6,6) = (p-2*hbar*k)^2/(2*m) + hbar*delta/2;

H(7,7) = p^2/(2*m)           + hbar*delta/2;
H(8,8) = (p-hbar*k)^2/(2*m)  + hbar*delta/2;
H(9,9) =(p-2*hbar*k)^2/(2*m) + hbar*delta/2;

H(10,10) = p^2/(2*m)            + hbar*delta/2;
H(11,11) = (p-hbar*k)^2/(2*m)   + hbar*delta/2;
H(12,12) = (p-2*hbar*k)^2/(2*m) + hbar*delta/2;

%Exited states states
H(13,13) = p^2/(2*m)              - hbar*delta/2 - 3*hbar*DeltaBexited/2  ;
H(14,14) = (p-hbar*k)^2/(2*m)     - hbar*delta/2 -3*hbar*DeltaBexited/2;
H(15,15) = (p - 2*hbar*k)^2/(2*m) - hbar*delta/2 - 3*hbar*DeltaBexited/2;

H(16,16) = p^2/(2*m)              - hbar*delta/2 - hbar*DeltaBexited/2  ;
H(17,17) = (p-hbar*k)^2/(2*m)     - hbar*delta/2 -hbar*DeltaBexited/2;
H(18,18) = (p - 2*hbar*k)^2/(2*m) - hbar*delta/2 - hbar*DeltaBexited/2;

H(19,19) = p^2/(2*m)              - hbar*delta/2 + hbar*DeltaBexited/2  ;
H(20,20) = (p-hbar*k)^2/(2*m)     - hbar*delta/2 + hbar*DeltaBexited/2;
H(21,21) = (p - 2*hbar*k)^2/(2*m) - hbar*delta/2 +  hbar*DeltaBexited/2;

H(22,22) = p^2/(2*m)              - hbar*delta/2 + 3*hbar*DeltaBexited/2  ;
H(23,23) = (p-hbar*k)^2/(2*m)     - hbar*delta/2 + 3*hbar*DeltaBexited/2;
H(24,24) = (p - 2*hbar*k)^2/(2*m) - hbar*delta/2 + 3*hbar*DeltaBexited/2;


%Interatction Matrix

Hod(1,2) = Poltab(2)*Strengh(-1.5,-1.5);
Hod(1,5) = Poltab(1)*Strengh(-1.5, -0.5);

Hod(2,1) = Poltab(2)*Strengh(-1.5,-1.5);
Hod(2,3) = Poltab(2)*Strengh(-1.5,-1.5);
Hod(2,4) = Poltab(1)*Strengh(-1.5,-0.5);
Hod(2,6) = Poltab(1)*Strengh(-1.5,-0.5);

Hod(3,2) = Poltab(2)*Strengh(-1.5,-1.5);
Hod(3,5) = Poltab(1)*Strengh(-1.5,-0.5);


Hod(4,2) = Poltab(3)*Strengh(-0.5,-1.5);
Hod(4,5) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(4,8) = Poltab(1)*Strengh(-0.5,0.5);

Hod(5,1) = Poltab(3)*Strengh(-0.5,-1.5);
Hod(5,3) = Poltab(3)*Strengh(-0.5,-1.5);
Hod(5,4) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(5,6) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(5,7) = Poltab(1)*Strengh(-0.5,+0.5);
Hod(5,9) = Poltab(1)*Strengh(-0.5,+0.5);

Hod(6,2) = Poltab(1)*Strengh(-0.5,-1.5);
Hod(6,5) = Poltab(2)*Strengh(-0.5,-0.5);
Hod(6,8) = Poltab(3)*Strengh(-0.5,+0.5);


Hod(7,5) = Poltab(3)*Strengh(0.5,-0.5);
Hod(7,8) = Poltab(2)*Strengh(0.5, 0.5);
Hod(7,10) = Poltab(1)*Strengh(0.5,1.5);


Hod(8,4) = Poltab(3)*Strengh(0.5,-0.5);
Hod(8,6) = Poltab(3)*Strengh(0.5,-0.5);
Hod(8,7) = Poltab(2)*Strengh(0.5,+0.5);
Hod(8,9) = Poltab(2)*Strengh(0.5,+0.5);
Hod(8,10) = Poltab(1)*Strengh(0.5,+1.5);
Hod(8,12) = Poltab(1)*Strengh(0.5,+1.5);


Hod(9,5) = Poltab(3)*Strengh(0.5,-0.5);
Hod(9,8) = Poltab(2)*Strengh(0.5, 0.5);
Hod(9,12) = Poltab(1)*Strengh(0.5,+1.5);

Hod(10,8) = Poltab(3)*Strengh(1.5, 0.5);
Hod(10,11) = Poltab(2)*Strengh(1.5,1.5);

Hod(11,7) = Poltab(3)*Strengh(1.5, 0.5);
Hod(11,9) = Poltab(3)*Strengh(1.5, 0.5);
Hod(11,10) = Poltab(2)*Strengh(1.5,+1.5);
Hod(11,12) = Poltab(2)*Strengh(1.5,+1.5);

Hod(12,8) = Poltab(3)*Strengh(1.5, 0.5);
Hod(12,11) = Poltab(2)*Strengh(1.5,1.5);

zerosmat = zeros(size(Hod));

Hod = Hod*hbar*Omega/2;
Hod = [   zerosmat Hod ; Hod' zerosmat ];
H = H + Hod;
% Off Diagonal elements for FP = 1/2 & F = 1/2 and polarization sigma +
% ,sigma -1
end

function Lt = getL1_2 (params,rho)
F = params.F;
Fp = params.Fp;
Gamma = params.Gamma;
auxMat = tril(ones(params.ProblemDim,params.ProblemDim));  

unos = ones(size(rho)/2);
ceros = zeros(size(rho)/2);

UpperRightMatrix = [ceros,-unos/2 ; ceros , ceros];
BottomLeft = [ceros,ceros ; ceros,-unos];
L1 = UpperRightMatrix.*rho;
L2 = BottomLeft.*rho;
Lt = L1 + L2;
Lt = triu(Lt);

Lt = (Lt + Lt'  - diag(diag(Lt)));
Strenghsq = @(mf,mfp) ClebschGordan(F,mf,1,mfp-mf,Fp,mfp)^2;

Lt(1,1) = Strenghsq(-1/2,-1/2)*rho(7,7)+ Strenghsq(-1/2,1/2)*rho(10,10);
Lt(2,2) = Strenghsq(-1/2,-1/2)*rho(8,8)+ Strenghsq(-1/2,1/2)*rho(11,11);
Lt(3,3) = Strenghsq(-1/2,-1/2)*rho(9,9)+ Strenghsq(-1/2,1/2)*rho(12,12);
Lt(4,4) = Strenghsq(1/2,-1/2)*rho(7,7)+ Strenghsq(1/2,1/2)*rho(10,10);
Lt(5,5) = Strenghsq(1/2,-1/2)*rho(8,8)+ Strenghsq(1/2,1/2)*rho(11,11);
Lt(6,6) = Strenghsq(1/2,-1/2)*rho(9,9)+ Strenghsq(1/2,1/2)*rho(12,12);

Lt = Lt*Gamma;

end

function Lt = getL3_2 (params,rho)
F = params.F;
Fp = params.Fp;
Gamma = params.Gamma; 

unos = ones(size(rho)/2);
ceros = zeros(size(rho)/2);

UpperRightMatrix = [ceros,-unos/2 ; ceros , ceros];
BottomLeft = [ceros,ceros ; ceros,-unos];
mat = triu(UpperRightMatrix + BottomLeft);
mat = mat+mat' - diag(diag(mat));
L1 = UpperRightMatrix.*rho;
L2 = BottomLeft.*rho;

Lt = triu(L1 + L2);
Lt = (Lt + Lt'  - diag(diag(Lt)));
Lt = mat.*rho;
Strenghsq = @(mf,mfp) ClebschGordan(F,mf,1,mfp-mf,Fp,mfp)^2;

% Lt(1,1) = Strenghsq(-3/2,-3/2)*rho(21,21)+ Strenghsq(-3/2,-1/2)*rho(26,26);
% Lt(2,2) = Strenghsq(-3/2,-3/2)*rho(22,22)+ Strenghsq(-3/2,-1/2)*rho(27,27);
% Lt(3,3) = Strenghsq(-3/2,-3/2)*rho(23,23)+ Strenghsq(-3/2,-1/2)*rho(28,28);
% Lt(4,4) = Strenghsq(-3/2,-3/2)*rho(24,24)+ Strenghsq(-3/2,-1/2)*rho(29,29);
% Lt(5,5) = Strenghsq(-3/2,-3/2)*rho(25,25)+ Strenghsq(-3/2,-1/2)*rho(30,30);
% 

%Upper bit can be replaced by 

rhodiag = diag(rho);
rho1 = [rhodiag(21:25),rhodiag(26:30)];
strenght1 = [Strenghsq(-3/2,-3/2),Strenghsq(-3/2,-1/2)];
values = rho1*strenght1';

rho2 = [rhodiag(21:25),rhodiag(26:30),rhodiag(31:35)];
strenght2 = [Strenghsq(-1/2,-3/2),Strenghsq(-1/2,-1/2),Strenghsq(-1/2,1/2)];
values2 = rho2*strenght2';

rho3 = [rhodiag(26:30),rhodiag(31:35),rhodiag(36:40)];
strenght3 = [Strenghsq(1/2,-1/2),Strenghsq(1/2,1/2),Strenghsq(1/2,3/2)];
values3 = rho3*strenght3';

rho4 = [rhodiag(31:35),rhodiag(36:40)];
strenght4 = [Strenghsq(3/2,1/2),Strenghsq(3/2,3/2)];
values4  = rho4*strenght4';

Ldiag2 = [values;values2;values3;values4];
Ldiag2 = [Ldiag2;zeros(size(Ldiag2))];

Lt = Lt +  diag(Ldiag2);
Lt = Lt*Gamma;

end

function DoPraFig4()
figure();
params = setBosonicSrparams(paramclass);
params = setPrAfig4Params(paramclass);
a=params.pstates;
HTimeIndependent  = ContructTimeIndependentHamilonian(params) ;
HtimeDependent = [eye(a),zeros(a);zeros(a),-eye(a)];
H= @(t) HTimeIndependent + 0.5*Sweep(t,params)*HtimeDependent;



t = linspace(0,params.Ts,10000);

Pmat = getPmat(params);

Tdelete1 = (1: floor(params.pstates/2))*2-1 + params.pstates;
Tdelete2 = (1: floor(params.pstates/2))*2;
Tdelete = [Tdelete1,Tdelete2];

Pmat(:,Tdelete) = [];
Pmat(Tdelete,:) = [];
Plottab = [];
vtab = zeros(size(Pmat,2),size(Pmat,2),10000);
count = 0;
    for i = t;
count = count +1;
        Hp = H(i);
        %Delete the states of the for ground and odd number of hbar k or extited
        %and even number of hbar k
        
        Hp(Tdelete ,:) = [];
        Hp(:,Tdelete) = [];
        [v,a]= eig(Hp);
        a= diag(a);
        Plottab = [Plottab,a];
        vtab(:,:,count) =v;
    end
    plot(t,Plottab);
    legend1 ={};
    legend2 = {};
    for i = 1:size(Pmat,2)/2
        legend1 =[legend1, {['|g, ','p  = ',num2str(Pmat(i,i)),'hbar*k>']}];
        legend2 = [legend2,{['|e, ','p  = ',num2str(Pmat(i+size(Pmat,2)/2,i+size(Pmat,2)/2)),'hbar*k>']}];
    end
    Serieslegend = [flip(legend1),flip(legend2)];       
    legend (Serieslegend)
    legend('Location','west')


end