function drho =  obe ( t,rhoVector,HTindependent,HtimeDependent,mat,sigmamult2,v,vfn,params)
global counter;
%Keep track of running time and estimate time to end    


if ( rem(counter,params.Evaluations)==0)

    timePerEvaluations = toc;
    percentage = t/(params.Ts*params.Nsweep);
    if (percentage ~= 0)
        EstimatedTotalNumberOfEval = counter/percentage;
        TimePerEvaluation =  timePerEvaluations/params.Evaluations;
        EstimatedTotalTime = EstimatedTotalNumberOfEval*TimePerEvaluation;
        display(['Estimated Completion time is ',num2str(EstimatedTotalTime/3600,'%-5.2f') ,' hours']);
        display(['Estimated time remaining is  ',num2str( (1-percentage)*EstimatedTotalTime/3600,'%-5.2f') ,' hours']);
    end
    tic
   
end
counter=counter +1;
% we only use top diagonal matrix. Solver gives vector of top diagonal
% elements. Here we map to matrix

rho= params.auxMat;
rho(rho==1)=rhoVector;
rho = (rho + rho'  - diag(diag(rho)));

% 
% L to model the decay rate.  Formula  ;

% L = sparse(params.ProblemDim,params.ProblemDim); 
% prefactor2 = diag(rho)'* vfn(:,1:size(v,2));
% for i = 1 : size(v,2)
%          L = prefactor2(i)* sigmamult2{i} +L;      
% end

%Optimized code. DOes the same as the comented bit from top


prefactor2 = vfn(:,1:size(v,2))'*diag(rho) ;
L = diag(sum(bsxfun(@times,sigmamult2,prefactor2),1)) + rho.*mat;


H= HTindependent + Sweep(t,params)*HtimeDependent;
drho = (rho*H -H*rho)  + L ;



drho  = drho(tril(true(size(drho))));





end

