(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     40559,       1072]
NotebookOptionsPosition[     36009,        988]
NotebookOutlinePosition[     36357,       1003]
CellTagsIndexPosition[     36314,       1000]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Fundamental constants", "Subsection",
 CellChangeTimes->{
  3.822553459721363*^9},ExpressionUUID->"566fc795-d233-4b50-bf8c-\
c53c6633276d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"hbar", " ", "=", " ", 
   RowBox[{"1.05", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "34"}]]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{"j", "*", "s"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"c", "=", "299792458"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]red", " ", "=", " ", 
   RowBox[{"689", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "9"}]]}]}], ";", 
  RowBox[{"(*", "m", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"\[Omega]red", " ", "=", 
   RowBox[{"2", "*", "\[Pi]", "*", 
    RowBox[{"c", "/", "\[Lambda]red"}]}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalGamma]red", " ", "=", " ", 
    RowBox[{"7.5", "*", 
     SuperscriptBox["10", "3"]}]}], ";", 
   RowBox[{"(*", "Hz", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"SrMass", " ", "=", " ", 
    RowBox[{"87.62", "*", "1.66054", "*", 
     SuperscriptBox["10", 
      RowBox[{"-", "27"}]]}]}], ";", 
   RowBox[{"(*", "Kg", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"KB", " ", "=", " ", 
    RowBox[{"1.38064852", "*", 
     SuperscriptBox["10", 
      RowBox[{"-", "23"}]]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"J", "/", "K"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kred", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2.", "\[Pi]"}], ")"}], "/", "\[Lambda]red"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Omega]r", " ", "=", " ", 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"hbar", "*", "kred"}], ")"}], "2"], 
    RowBox[{"2", "*", "SrMass", "*", "hbar"}]]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Mu]B", " ", "=", " ", 
   RowBox[{"9.27", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "24"}]], "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "4"}]]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{"J", "/", "Gauss"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.8225504903202915`*^9, 3.8225504908647385`*^9}, {
  3.8225534535029225`*^9, 3.8225534942478886`*^9}, {3.822555690140716*^9, 
  3.8225557342941*^9}},ExpressionUUID->"cc1c877f-6e87-4f07-9645-96d831acaa65"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fig3 -Magnetic field Shifts ", "Subsection",
 CellChangeTimes->{{3.8225555898390207`*^9, 
  3.822555605603386*^9}},ExpressionUUID->"1ce834f8-8fee-4341-8bb0-\
efbc6e7f3285"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"g92", "=", " ", 
   FractionBox["2", "33"]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g112", "=", " ", 
   RowBox[{"3", "/", "11"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B", " ", "=", " ", "2.4"}], ";"}], 
  RowBox[{"(*", "Gauss", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"\[CapitalDelta]B", "[", 
     RowBox[{"g_", ",", "B_", ",", "mf_"}], "]"}], "=", " ", 
    RowBox[{"g", "*", "\[Mu]B", "*", "B", "*", 
     RowBox[{"mf", "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", "\[Pi]", "*", "hbar"}], ")"}]}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<The shift of the F = 9/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)=-9/2 with \
a field of \>\"", ",", "B", ",", "\"\< Gauss is \>\"", ",", " ", 
   RowBox[{"\[CapitalDelta]B", "[", 
    RowBox[{"g92", ",", "B", ",", 
     RowBox[{
      RowBox[{"-", "9"}], "/", "2"}]}], "]"}], ",", "\"\<Hz\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<The shift of the F = 11/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)=-11/2 \
with a field of \>\"", ",", "B", ",", "\"\< Gauss is \>\"", ",", " ", 
   RowBox[{"\[CapitalDelta]B", "[", 
    RowBox[{"g112", ",", "B", ",", 
     RowBox[{
      RowBox[{"-", "11"}], "/", "2"}]}], "]"}], ",", "\"\<Hz\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.822555615543455*^9, 3.822555676042816*^9}, {
  3.822555739388625*^9, 
  3.822555944948625*^9}},ExpressionUUID->"6cc1de61-0358-4d1a-85f1-\
0512fd9330ac"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The shift of the F = 9/2 \\!\\(\\*SubscriptBox[\\(m\\), \
\\(F\\)]\\)=-9/2 with a field of \"\>", "\[InvisibleSpace]", "2.4`", 
   "\[InvisibleSpace]", "\<\" Gauss is \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "919708.8763398668`"}], "\[InvisibleSpace]", "\<\"Hz\"\>"}],
  SequenceForm[
  "The shift of the F = 9/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)=-9/2 with a \
field of ", 2.4, " Gauss is ", -919708.8763398668, "Hz"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225558982408257`*^9, 
  3.822555945586322*^9}},ExpressionUUID->"2b91188b-d40a-433a-8346-\
33c7c6e4d459"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The shift of the F = 11/2 \\!\\(\\*SubscriptBox[\\(m\\), \
\\(F\\)]\\)=-11/2 with a field of \"\>", "\[InvisibleSpace]", "2.4`", 
   "\[InvisibleSpace]", "\<\" Gauss is \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "5.058398819869266`*^6"}], "\[InvisibleSpace]", "\<\"Hz\"\>"}],
  SequenceForm[
  "The shift of the F = 11/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)=-11/2 with a \
field of ", 2.4, " Gauss is ", -5.058398819869266*^6, "Hz"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225558982408257`*^9, 
  3.8225559455893526`*^9}},ExpressionUUID->"b2a128a3-e39e-48c5-af11-\
8fe7bfe21382"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Fig4 - 2D red Swap molasses  average Rabbi frequency  --> Adiabaticity \
criterion \
\>", "Subsection",
 CellChangeTimes->{
  3.8225530619004064`*^9, {3.822553180068656*^9, 3.822553193938406*^9}, {
   3.8225532920892887`*^9, 3.822553304190612*^9}, 3.8225533653728247`*^9, 
   3.822555146858618*^9},ExpressionUUID->"d3c0f2bb-7917-4309-a3ca-\
2c49ad4c5cdf"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Omega]x", "  ", "=", 
   RowBox[{"18.2", "*", 
    RowBox[{
     SuperscriptBox["10", 
      RowBox[{"-", "3"}]], "/", "2"}]}]}], ";", 
  RowBox[{"(*", "m", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"\[Omega]y", " ", "=", 
   RowBox[{"45.6", "*", 
    RowBox[{
     SuperscriptBox["10", 
      RowBox[{"-", "3"}]], "/", "2"}]}]}], ";", 
  RowBox[{"(*", "m", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"PowerHigh", "=", 
   RowBox[{"7.6", "*", "2", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "3"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PowerLow", "=", 
   RowBox[{"7.1", "*", "2", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "3"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ts", " ", "=", " ", 
   RowBox[{
    RowBox[{"1", "/", "0.015"}], "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"(*", "s", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeltaSweep", " ", "=", " ", 
   RowBox[{"2", "*", "\[Pi]", "*", "2.2", "*", 
    SuperscriptBox["10", "6"]}]}], ";", 
  RowBox[{"(*", "Hz", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", " ", "=", " ", 
   RowBox[{"DeltaSweep", "/", "Ts"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8225530640140257`*^9, 3.822553072465845*^9}, {
  3.8225533228422976`*^9, 
  3.8225533272450075`*^9}},ExpressionUUID->"de547204-71a6-4c94-9aa2-\
25faaab70400"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"I0", "[", "P_", "]"}], ":=", 
   FractionBox[
    RowBox[{"2", "*", "P"}], 
    RowBox[{"\[Pi]", "*", "\[Omega]x", "*", "\[Omega]y"}]]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Is", "[", "\[CapitalGamma]_", "]"}], " ", ":=", " ", 
    FractionBox[
     RowBox[{"hbar", "*", 
      SuperscriptBox["\[Omega]red", "3"], "*", "\[CapitalGamma]"}], 
     RowBox[{"6", "*", 
      SuperscriptBox["c", "2"]}]]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"W", "/", 
    SuperscriptBox["m", "2"]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalOmega]rabi", "[", 
    RowBox[{"I_", ",", "\[CapitalGamma]_"}], "]"}], ":=", 
   RowBox[{"\[Sqrt]", 
    FractionBox[
     RowBox[{"I", " ", 
      SuperscriptBox["\[CapitalGamma]", "2"]}], 
     RowBox[{"2", "*", 
      RowBox[{"Is", "[", "\[CapitalGamma]", "]"}]}]]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Strenght", "[", 
    RowBox[{"mF_", ",", "mFp_"}], "]"}], "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"mF", "\[Equal]", "mFp"}], ",", 
     RowBox[{"ClebschGordan", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"9", "/", "2"}], ",", "mF"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"9", "/", "2"}], ",", "mFp"}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\t\t\t\t\t\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"mFp", "\[Equal]", 
        RowBox[{"mF", "+", "1"}]}], ",", 
       RowBox[{"ClebschGordan", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"9", "/", "2"}], ",", "mF"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"9", "/", "2"}], ",", "mFp"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "\t\t\t\t\t\t\t", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"mFp", "\[Equal]", 
          RowBox[{"mF", "-", "1"}]}], ",", 
         RowBox[{"ClebschGordan", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"9", "/", "2"}], ",", "mF"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"9", "/", "2"}], ",", "mFp"}], "}"}]}], "]"}], ",", 
         "0"}], "\[IndentingNewLine]", "]"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalGamma]Tab", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"\[CapitalGamma]red", "*", 
      SuperscriptBox[
       RowBox[{"Strenght", "[", 
        RowBox[{"j", ",", "i"}], "]"}], "2"]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"-", "9"}], "/", "2"}], ",", 
       RowBox[{"9", "/", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", 
       RowBox[{
        RowBox[{"-", "9"}], "/", "2"}], ",", 
       RowBox[{"9", "/", "2"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"polTab", "=", 
   RowBox[{"Normalize", "[", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", 
      RowBox[{"1", "/", "2"}], ",", 
      RowBox[{"1", "/", "2"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalOmega]RabiSigmaPlus", "[", "Power_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"j", "-", "1"}]}], ",", 
       RowBox[{"\[CapitalOmega]rabi", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"I0", "[", "Power", "]"}], "*", 
          RowBox[{
          "polTab", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{"\[CapitalGamma]Tab", "\[LeftDoubleBracket]", 
          RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]}], "]"}], ",", 
       "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalOmega]RabiSigmaMinus", "[", "Power_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", 
        RowBox[{"j", "+", "1"}]}], ",", 
       RowBox[{"\[CapitalOmega]rabi", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"I0", "[", "Power", "]"}], "*", 
          RowBox[{
          "polTab", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{"\[CapitalGamma]Tab", "\[LeftDoubleBracket]", 
          RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]}], "]"}], ",", 
       "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalOmega]RabipiT", "[", "Power_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"i", "\[Equal]", "j"}], ",", 
       RowBox[{"\[CapitalOmega]rabi", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"I0", "[", "Power", "]"}], "*", 
          RowBox[{
          "polTab", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
         ",", 
         RowBox[{"\[CapitalGamma]Tab", "\[LeftDoubleBracket]", 
          RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]}], "]"}], ",", 
       "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "10"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]avg", "[", "P_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Total", "[", 
    RowBox[{"Total", "[", 
     RowBox[{
      RowBox[{"\[CapitalOmega]RabiSigmaPlus", "[", "P", "]"}], "+", 
      RowBox[{"\[CapitalOmega]RabiSigmaMinus", "[", "P", "]"}], " ", "+", 
      RowBox[{"\[CapitalOmega]RabipiT", "[", "P", "]"}]}], "]"}], "]"}], "/", 
   "28"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Tau]e", "[", 
   RowBox[{"v_", ",", "freq_"}], "]"}], ":=", 
  RowBox[{"Abs", "[", 
   RowBox[{"2", "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"kred", "*", "v"}], " ", "-", " ", 
       RowBox[{"2", "*", "\[Omega]r"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"DeltaSweep", "*", "freq"}], ")"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"solutions", " ", "=", " ", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Tau]e", "[", 
       RowBox[{"0.2", ",", "freq"}], "]"}], " ", "\[Equal]", " ", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"2", "*", "\[Pi]", "*", "\[CapitalGamma]red"}], ")"}]}]}], 
     " ", ",", "freq"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"frequncy", " ", "=", " ", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"{", "freq", "}"}], "/.", "solutions"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  "\"\<Average rabbi frequencies and adiabaticirt criteria\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Sweep frequency (1/\[CapitalDelta]t) = \>\"", " ", ",", 
   RowBox[{"1", "/", "Ts"}], ",", "\"\<Hz\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<\[CapitalDelta]\[Omega] = \>\"", " ", ",", 
   RowBox[{
    RowBox[{"DeltaSweep", "/", "2"}], "/", "\[Pi]"}], ",", "\"\<Hz\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<For the low power beam\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<The average Rabi frequency across all the \[Sigma]+ \[Pi] and \
\[Sigma]- transitions is 2 \[Pi] * \>\"", ",", 
    RowBox[{
     RowBox[{"\[CapitalOmega]avg", "[", "PowerLow", "]"}], "*", 
     SuperscriptBox["10", 
      RowBox[{"-", "3"}]]}], ",", "\"\<  KHz\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<The adiavaticity criterion reads \!\(\*SuperscriptBox[\(\
\[CapitalOmega]\), \(2\)]\)/\[Kappa] = \>\"", ",", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"2", "*", "\[Pi]"}], ")"}], "2"], "*", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"\[CapitalOmega]avg", "[", "PowerHigh", "]"}], "2"], "/", 
      "\[Alpha]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<For the Low power beam\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<The average Rabi frequency across all the \[Sigma]+ \[Sigma]- and \
\[Pi] transitions is 2 \[Pi] * \>\"", ",", 
    RowBox[{
     RowBox[{"\[CapitalOmega]avg", "[", "PowerHigh", "]"}], "*", 
     SuperscriptBox["10", 
      RowBox[{"-", "3"}]]}], ",", "\"\<  KHz\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<The adiavaticity criterion reads \[Kappa] = \>\"", ",", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"2", "*", "\[Pi]"}], ")"}], "2"], "*", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"\[CapitalOmega]avg", "[", "PowerLow", "]"}], "2"], "/", 
      "\[Alpha]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Time on the existed state\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<For the sweep frequency (1/\[CapitalDelta]t) \>\"", " ", ",", 
   RowBox[{"frequncy", "[", 
    RowBox[{"[", "2", "]"}], "]"}], ",", 
   "\"\< Hz and the velocity of 0.2 m/s the time on the exited state is 1/\
\[CapitalGamma]\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.8225530886405773`*^9, 3.8225530926021357`*^9}, {
  3.8225532687080235`*^9, 3.822553319719034*^9}, {3.822553367437316*^9, 
  3.822553436758399*^9}, {3.82255350555116*^9, 3.8225536661474166`*^9}, {
  3.8225537521236625`*^9, 3.822553775791546*^9}, {3.822553805876187*^9, 
  3.8225538061729765`*^9}, {3.8225538626992245`*^9, 3.8225538629238462`*^9}, {
  3.822553897523836*^9, 3.822553984398264*^9}, {3.822555980422532*^9, 
  3.8225559894689083`*^9}},ExpressionUUID->"488c5cd3-ecb6-436c-b65c-\
346fb1a5cd85"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Average rabbi frequencies and adiabaticirt criteria\"\>"], \
"Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.822556527877895*^9},ExpressionUUID->"f8ebc425-99ca-41e0-9de9-\
051e77189d9a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Sweep frequency (1/\[CapitalDelta]t) = \"\>", 
   "\[InvisibleSpace]", "15000.`", "\[InvisibleSpace]", "\<\"Hz\"\>"}],
  SequenceForm["Sweep frequency (1/\[CapitalDelta]t) = ", 15000., "Hz"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.8225565278849125`*^9},ExpressionUUID->"712d454d-7a2c-428b-bd2d-\
0c0424ec57a7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"\[CapitalDelta]\[Omega] = \"\>", "\[InvisibleSpace]", 
   "2.2`*^6", "\[InvisibleSpace]", "\<\"Hz\"\>"}],
  SequenceForm["\[CapitalDelta]\[Omega] = ", 2.2*^6, "Hz"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.8225565278879213`*^9},ExpressionUUID->"d39e22c2-78d4-4f2d-a855-\
6db9484f615c"],

Cell[BoxData["\<\"For the low power beam\"\>"], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.8225565278919315`*^9},ExpressionUUID->"c73884d0-6f8f-46a7-bd56-\
1d7e628be39d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The average Rabi frequency across all the \[Sigma]+ \[Pi] and \
\[Sigma]- transitions is 2 \[Pi] * \"\>", "\[InvisibleSpace]", 
   "86.98085297320723`", "\[InvisibleSpace]", "\<\"  KHz\"\>"}],
  SequenceForm[
  "The average Rabi frequency across all the \[Sigma]+ \[Pi] and \[Sigma]- \
transitions is 2 \[Pi] * ", 86.98085297320723, "  KHz"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.822556527930068*^9},ExpressionUUID->"4cd94550-4f46-4bda-80cb-\
3044fe483ab9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The adiavaticity criterion reads \\!\\(\\*SuperscriptBox[\\(\
\[CapitalOmega]\\), \\(2\\)]\\)/\[Kappa] = \"\>", "\[InvisibleSpace]", 
   "1.5419436276625542`"}],
  SequenceForm[
  "The adiavaticity criterion reads \!\(\*SuperscriptBox[\(\[CapitalOmega]\), \
\(2\)]\)/\[Kappa] = ", 1.5419436276625542`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.82255652793407*^9},ExpressionUUID->"6498dda6-eb34-49f7-a6ea-\
35d4037e88c2"],

Cell[BoxData["\<\"For the Low power beam\"\>"], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.8225565279380813`*^9},ExpressionUUID->"da50b1df-b777-4f3c-995d-\
36050f1b0bcb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The average Rabi frequency across all the \[Sigma]+ \[Sigma]- \
and \[Pi] transitions is 2 \[Pi] * \"\>", "\[InvisibleSpace]", 
   "89.9914571516706`", "\[InvisibleSpace]", "\<\"  KHz\"\>"}],
  SequenceForm[
  "The average Rabi frequency across all the \[Sigma]+ \[Sigma]- and \[Pi] \
transitions is 2 \[Pi] * ", 89.9914571516706, "  KHz"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.822556527945072*^9},ExpressionUUID->"8057434c-31a0-4cb0-9a3d-\
ae42f63a405a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The adiavaticity criterion reads \[Kappa] = \"\>", 
   "\[InvisibleSpace]", "1.4404999679479125`"}],
  SequenceForm[
  "The adiavaticity criterion reads \[Kappa] = ", 1.4404999679479125`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.8225565279500904`*^9},ExpressionUUID->"60a0a98e-c592-4729-a99d-\
2e5a825214a0"],

Cell[BoxData["\<\"Time on the existed state\"\>"], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.822556527954096*^9},ExpressionUUID->"a438a1ba-810a-4f9e-91bb-\
f96df190d2eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"For the sweep frequency (1/\[CapitalDelta]t) \"\>", 
   "\[InvisibleSpace]", "12026.193086141044`", 
   "\[InvisibleSpace]", "\<\" Hz and the velocity of 0.2 m/s the time on the \
exited state is 1/\[CapitalGamma]\"\>"}],
  SequenceForm[
  "For the sweep frequency (1/\[CapitalDelta]t) ", 12026.193086141044`, 
   " Hz and the velocity of 0.2 m/s the time on the exited state is 1/\
\[CapitalGamma]"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822553328857029*^9, 3.822553343348744*^9}, {
   3.822553496696331*^9, 3.822553509024398*^9}, 3.8225535560933423`*^9, {
   3.8225536563439903`*^9, 3.82255366646624*^9}, {3.8225537679827657`*^9, 
   3.8225538044721737`*^9}, 3.822553864626376*^9, {3.822553923077839*^9, 
   3.822553984916279*^9}, 3.822555985274437*^9, 
   3.822556527959139*^9},ExpressionUUID->"cd780115-76e4-4238-aad1-\
3b0fe066cb35"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "Subsubsection",
 CellChangeTimes->{{3.8225551618192205`*^9, 3.822555178921704*^9}, 
   3.82255656492093*^9},ExpressionUUID->"9f303ffb-7462-4460-bbb5-\
e9721a06e921"],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8225552018543873`*^9, 3.8225552040682697`*^9}, {
   3.822555428203513*^9, 3.822555428382966*^9}, 
   3.8225565752844896`*^9},ExpressionUUID->"6f6498ba-f63f-4b8e-a4f8-\
2084474b48da"],

Cell[CellGroupData[{

Cell[BoxData["\<\"The average rabbi frequencies\"\>"], "Print",
 CellChangeTimes->{
  3.822555429016652*^9},ExpressionUUID->"a8b30d71-21db-4dc9-b260-\
375ebd9848bb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 60= \"\>", 
   "\[InvisibleSpace]", "91678.68691222103`", 
   "\[InvisibleSpace]", "\<\"Hz\"\>"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 60= ", 91678.68691222103, "Hz"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.8225554290196595`*^9},ExpressionUUID->"a072c6cb-e6f7-4723-817c-\
e1558fad3715"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 40= \"\>", 
   "\[InvisibleSpace]", "81484.18258638705`"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 40= ", 81484.18258638705],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.82255542902367*^9},ExpressionUUID->"2040b423-ee71-434c-bb15-3beaac4fb534"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 20= \"\>", 
   "\[InvisibleSpace]", "62551.28986743383`"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 20= ", 62551.28986743383],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.822555429026679*^9},ExpressionUUID->"934360ba-3887-4609-8e43-\
67ddd1a88e62"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 10= \"\>", 
   "\[InvisibleSpace]", "44230.44123722784`"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 10= ", 44230.44123722784],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.8225554290307026`*^9},ExpressionUUID->"77477041-dc15-4096-a752-\
8656847a1cd3"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell["Section III D", "Subsection",
 CellChangeTimes->{{3.822556171003364*^9, 3.822556172890202*^9}, {
  3.8225562227074986`*^9, 
  3.8225562272915983`*^9}},ExpressionUUID->"b647e67a-2647-4d83-ba74-\
19da26db511e"],

Cell[CellGroupData[{

Cell["Vc", "Subsection",
 CellChangeTimes->{{3.822556595626428*^9, 
  3.8225565961147585`*^9}},ExpressionUUID->"c71fd61c-beb3-4feb-8d28-\
5158f1938efc"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"solutions", " ", "=", " ", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Tau]e", "[", 
       RowBox[{"freq", ",", "15000"}], "]"}], " ", "\[Equal]", " ", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"2", "*", "\[Pi]", "*", "\[CapitalGamma]red"}], ")"}]}]}], 
     " ", ",", "freq"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"velocty", " ", "=", " ", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"{", "freq", "}"}], "/.", "solutions"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Time on the existed state\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<For the sweep frequency (1/\[CapitalDelta]t) \>\"", " ", ",", "15000", 
   " ", ",", 
   "\"\<the time on the exited state is 1/\[CapitalGamma] for a velocity of \
\>\"", ",", 
   RowBox[{"velocty", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   ",", "\"\< m/s\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.822556321308649*^9, 3.8225563374911146`*^9}, 
   3.822556513603155*^9},ExpressionUUID->"f7fda153-0269-4bc6-8ae6-\
5074527c2e31"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.23466597993602342`"}], ",", "0.24782814554136645`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.8225563378380375`*^9, 3.8225565147040806`*^9, 
  3.8225565875940886`*^9},ExpressionUUID->"524ea411-52a5-4a48-946d-\
6b42b954d7c2"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Time on the existed state\"\>"], "Print",
 CellChangeTimes->{3.8225565147080917`*^9, 
  3.822556587598072*^9},ExpressionUUID->"a3b4f268-7364-4261-9dfb-\
a25e043fc72b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"For the sweep frequency (1/\[CapitalDelta]t) \"\>", 
   "\[InvisibleSpace]", "15000", 
   "\[InvisibleSpace]", "\<\"the time on the exited state is \
1/\[CapitalGamma] for a velocity of \"\>", "\[InvisibleSpace]", 
   "0.24782814554136645`", "\[InvisibleSpace]", "\<\" m/s\"\>"}],
  SequenceForm[
  "For the sweep frequency (1/\[CapitalDelta]t) ", 15000, 
   "the time on the exited state is 1/\[CapitalGamma] for a velocity of ", 
   0.24782814554136645`, " m/s"],
  Editable->False]], "Print",
 CellChangeTimes->{3.8225565147080917`*^9, 
  3.822556587600077*^9},ExpressionUUID->"8bbee204-156a-422b-8844-\
560bdc3ec1c2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fig 5- Rabbi frequencies", "Subsection",
 CellChangeTimes->{
  3.822556572723678*^9},ExpressionUUID->"0a81198f-4ed2-4e52-a401-\
67165ac6abfe"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IGB", " ", "[", 
    RowBox[{"P_", ",", "x_", ",", "y_"}], "]"}], " ", "=", 
   RowBox[{
    FractionBox[
     RowBox[{"2", "*", "P"}], 
     RowBox[{"\[Pi]", "*", "\[Omega]x", "*", "\[Omega]y"}]], "*", 
    RowBox[{"Exp", "[", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "2"}], "*", 
       SuperscriptBox["x", "2"]}], 
      SuperscriptBox["\[Omega]x", "2"]], "]"}], "*", 
    RowBox[{"Exp", "[", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "2"}], "*", 
       SuperscriptBox["y", "2"]}], 
      SuperscriptBox["\[Omega]y", "2"]], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"I0Avg", "[", "P_", "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{"IGB", "[", 
       RowBox[{"P", ",", "x", ",", "y"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "\[Omega]x"}], ",", "\[Omega]x"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "\[Omega]y"}], ",", "\[Omega]y"}], "}"}]}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{"\[Pi]", "*", "\[Omega]x", "*", "\[Omega]y"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<The average rabbi frequencies\>\"", "]"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<The spatially average rabbi frequency  AOM 60= \>\"", ",", 
    RowBox[{"\[CapitalOmega]rabi", "[", 
     RowBox[{
      RowBox[{"I0Avg", "[", 
       RowBox[{
        RowBox[{"(", "6.38", ")"}], "*", 
        SuperscriptBox["10", 
         RowBox[{"-", "3"}]]}], "]"}], ",", 
      RowBox[{"7.5", "*", 
       SuperscriptBox["10", "3"]}]}], "]"}], ",", "\"\<Hz\>\""}], "]"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<The spatially average rabbi frequency  AOM 40= \>\"", ",", 
    RowBox[{"\[CapitalOmega]rabi", "[", 
     RowBox[{
      RowBox[{"I0Avg", "[", 
       RowBox[{
        RowBox[{"(", "5.04", ")"}], "*", 
        SuperscriptBox["10", 
         RowBox[{"-", "3"}]]}], "]"}], ",", 
      RowBox[{"7.5", "*", 
       SuperscriptBox["10", "3"]}]}], "]"}]}], "]"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<The spatially average rabbi frequency  AOM 20= \>\"", ",", 
    RowBox[{"\[CapitalOmega]rabi", "[", 
     RowBox[{
      RowBox[{"I0Avg", "[", 
       RowBox[{
        RowBox[{"(", "2.97", ")"}], "*", 
        SuperscriptBox["10", 
         RowBox[{"-", "3"}]]}], "]"}], ",", 
      RowBox[{"7.5", "*", 
       SuperscriptBox["10", "3"]}]}], "]"}]}], "]"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<The spatially average rabbi frequency  AOM 10= \>\"", ",", 
    RowBox[{"\[CapitalOmega]rabi", "[", 
     RowBox[{
      RowBox[{"I0Avg", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", "2.97", ")"}], "/", "2"}], "*", 
        SuperscriptBox["10", 
         RowBox[{"-", "3"}]]}], "]"}], ",", 
      RowBox[{"7.5", "*", 
       SuperscriptBox["10", "3"]}]}], "]"}]}], "]"}], ";"}]}], "Input",Express\
ionUUID->"1e6f3cbd-1037-4645-b9a4-b600bc87ba00"],

Cell[CellGroupData[{

Cell[BoxData["\<\"The average rabbi frequencies\"\>"], "Print",
 CellChangeTimes->{
  3.8225565892314167`*^9},ExpressionUUID->"d1551fda-2871-4e22-b25e-\
9e33a4a0c6f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 60= \"\>", 
   "\[InvisibleSpace]", "91678.68691222103`", 
   "\[InvisibleSpace]", "\<\"Hz\"\>"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 60= ", 91678.68691222103, "Hz"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.822556589233449*^9},ExpressionUUID->"63c388b9-e416-45a3-af1f-\
6d063b14e08c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 40= \"\>", 
   "\[InvisibleSpace]", "81484.18258638705`"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 40= ", 81484.18258638705],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.8225565892374697`*^9},ExpressionUUID->"f5247646-692d-456e-ba37-\
3abb061019cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 20= \"\>", 
   "\[InvisibleSpace]", "62551.28986743383`"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 20= ", 62551.28986743383],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.82255658923847*^9},ExpressionUUID->"02497bc7-42f4-48b6-b8d8-6a6fc8172208"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The spatially average rabbi frequency  AOM 10= \"\>", 
   "\[InvisibleSpace]", "44230.44123722784`"}],
  SequenceForm[
  "The spatially average rabbi frequency  AOM 10= ", 44230.44123722784],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.8225565892404747`*^9},ExpressionUUID->"cb345f58-6923-469b-92f4-\
b4ca8e517d64"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1280, 941},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 145, 3, 53, "Subsection",ExpressionUUID->"566fc795-d233-4b50-bf8c-c53c6633276d"],
Cell[728, 27, 2154, 60, 268, "Input",ExpressionUUID->"cc1c877f-6e87-4f07-9645-96d831acaa65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2919, 92, 178, 3, 53, "Subsection",ExpressionUUID->"1ce834f8-8fee-4341-8bb0-efbc6e7f3285"],
Cell[CellGroupData[{
Cell[3122, 99, 1590, 42, 169, "Input",ExpressionUUID->"6cc1de61-0358-4d1a-85f1-0512fd9330ac"],
Cell[CellGroupData[{
Cell[4737, 145, 630, 12, 22, "Print",ExpressionUUID->"2b91188b-d40a-433a-8346-33c7c6e4d459"],
Cell[5370, 159, 642, 12, 24, "Print",ExpressionUUID->"b2a128a3-e39e-48c5-af11-8fe7bfe21382"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6073, 178, 365, 8, 53, "Subsection",ExpressionUUID->"d3c0f2bb-7917-4309-a3ca-2c49ad4c5cdf"],
Cell[6441, 188, 1438, 41, 148, "Input",ExpressionUUID->"de547204-71a6-4c94-9aa2-25faaab70400"],
Cell[CellGroupData[{
Cell[7904, 233, 10591, 297, 659, "Input",ExpressionUUID->"488c5cd3-ecb6-436c-b65c-346fb1a5cd85"],
Cell[CellGroupData[{
Cell[18520, 534, 509, 8, 22, "Print",ExpressionUUID->"f8ebc425-99ca-41e0-9de9-051e77189d9a"],
Cell[19032, 544, 694, 12, 22, "Print",ExpressionUUID->"712d454d-7a2c-428b-bd2d-0c0424ec57a7"],
Cell[19729, 558, 668, 12, 24, "Print",ExpressionUUID->"d39e22c2-78d4-4f2d-a855-6db9484f615c"],
Cell[20400, 572, 480, 7, 22, "Print",ExpressionUUID->"c73884d0-6f8f-46a7-bd56-1d7e628be39d"],
Cell[20883, 581, 843, 15, 22, "Print",ExpressionUUID->"4cd94550-4f46-4bda-80cb-3044fe483ab9"],
Cell[21729, 598, 802, 15, 24, "Print",ExpressionUUID->"6498dda6-eb34-49f7-a6ea-35d4037e88c2"],
Cell[22534, 615, 480, 7, 22, "Print",ExpressionUUID->"da50b1df-b777-4f3c-995d-36050f1b0bcb"],
Cell[23017, 624, 841, 15, 22, "Print",ExpressionUUID->"8057434c-31a0-4cb0-9a3d-ae42f63a405a"],
Cell[23861, 641, 691, 13, 22, "Print",ExpressionUUID->"60a0a98e-c592-4729-a99d-2e5a825214a0"],
Cell[24555, 656, 481, 7, 22, "Print",ExpressionUUID->"a438a1ba-810a-4f9e-91bb-f96df190d2eb"],
Cell[25039, 665, 902, 17, 22, "Print",ExpressionUUID->"cd780115-76e4-4238-aad1-3b0fe066cb35"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25990, 688, 175, 3, 44, "Subsubsection",ExpressionUUID->"9f303ffb-7462-4460-bbb5-e9721a06e921"],
Cell[CellGroupData[{
Cell[26190, 695, 231, 4, 28, "Input",ExpressionUUID->"6f6498ba-f63f-4b8e-a4f8-2084474b48da"],
Cell[CellGroupData[{
Cell[26446, 703, 165, 3, 22, "Print",ExpressionUUID->"a8b30d71-21db-4dc9-b260-375ebd9848bb"],
Cell[26614, 708, 419, 10, 22, "Print",ExpressionUUID->"a072c6cb-e6f7-4723-817c-e1558fad3715"],
Cell[27036, 720, 369, 8, 22, "Print",ExpressionUUID->"2040b423-ee71-434c-bb15-3beaac4fb534"],
Cell[27408, 730, 372, 9, 22, "Print",ExpressionUUID->"934360ba-3887-4609-8e43-67ddd1a88e62"],
Cell[27783, 741, 374, 9, 22, "Print",ExpressionUUID->"77477041-dc15-4096-a752-8656847a1cd3"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[28208, 756, 214, 4, 53, "Subsection",ExpressionUUID->"b647e67a-2647-4d83-ba74-19da26db511e"],
Cell[CellGroupData[{
Cell[28447, 764, 152, 3, 37, "Subsection",ExpressionUUID->"c71fd61c-beb3-4feb-8d28-5158f1938efc"],
Cell[CellGroupData[{
Cell[28624, 771, 1155, 29, 86, "Input",ExpressionUUID->"f7fda153-0269-4bc6-8ae6-5074527c2e31"],
Cell[29782, 802, 285, 7, 32, "Output",ExpressionUUID->"524ea411-52a5-4a48-946d-6b42b954d7c2"],
Cell[CellGroupData[{
Cell[30092, 813, 185, 3, 22, "Print",ExpressionUUID->"a3b4f268-7364-4261-9dfb-a25e043fc72b"],
Cell[30280, 818, 670, 14, 22, "Print",ExpressionUUID->"8bbee204-156a-422b-8844-560bdc3ec1c2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31011, 839, 148, 3, 53, "Subsection",ExpressionUUID->"0a81198f-4ed2-4e52-a401-67165ac6abfe"],
Cell[CellGroupData[{
Cell[31184, 846, 3047, 86, 193, "Input",ExpressionUUID->"1e6f3cbd-1037-4645-b9a4-b600bc87ba00"],
Cell[CellGroupData[{
Cell[34256, 936, 167, 3, 22, "Print",ExpressionUUID->"d1551fda-2871-4e22-b25e-9e33a4a0c6f3"],
Cell[34426, 941, 417, 10, 22, "Print",ExpressionUUID->"63c388b9-e416-45a3-af1f-6d063b14e08c"],
Cell[34846, 953, 374, 9, 22, "Print",ExpressionUUID->"f5247646-692d-456e-ba37-3abb061019cc"],
Cell[35223, 964, 369, 8, 22, "Print",ExpressionUUID->"02497bc7-42f4-48b6-b8d8-6a6fc8172208"],
Cell[35595, 974, 374, 9, 22, "Print",ExpressionUUID->"cb345f58-6923-469b-92f4-b4ca8e517d64"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

