(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     60171,       1569]
NotebookOptionsPosition[     54755,       1475]
NotebookOutlinePosition[     55176,       1492]
CellTagsIndexPosition[     55133,       1489]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Fundamental constants", "Subsection",
 CellChangeTimes->{
  3.822553459721363*^9},ExpressionUUID->"8824b213-be2e-488f-a91f-\
dc027cfcfcc4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"hbar", " ", "=", " ", 
   RowBox[{"1.05", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "34"}]]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{"j", "*", "s"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"c", "=", "299792458"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]red", " ", "=", " ", 
   RowBox[{"689", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "9"}]]}]}], ";", 
  RowBox[{"(*", "m", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"\[Omega]red", " ", "=", 
   RowBox[{"2", "*", "\[Pi]", "*", 
    RowBox[{"c", "/", "\[Lambda]red"}]}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalGamma]red", " ", "=", " ", 
    RowBox[{"7.5", "*", 
     SuperscriptBox["10", "3"]}]}], ";", 
   RowBox[{"(*", "Hz", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"SrMass", " ", "=", " ", 
    RowBox[{"87.62", "*", "1.66054", "*", 
     SuperscriptBox["10", 
      RowBox[{"-", "27"}]]}]}], ";", 
   RowBox[{"(*", "Kg", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"KB", " ", "=", " ", 
    RowBox[{"1.38064852", "*", 
     SuperscriptBox["10", 
      RowBox[{"-", "23"}]]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"J", "/", "K"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kred", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2.", "\[Pi]"}], ")"}], "/", "\[Lambda]red"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Omega]r", " ", "=", " ", 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"hbar", "*", "kred"}], ")"}], "2"], 
    RowBox[{"2", "*", "SrMass", "*", "hbar"}]]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Mu]B", " ", "=", " ", 
   RowBox[{"9.27", "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "24"}]], "*", 
    SuperscriptBox["10", 
     RowBox[{"-", "4"}]]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{"J", "/", "Gauss"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.8225504903202915`*^9, 3.8225504908647385`*^9}, {
  3.8225534535029225`*^9, 3.8225534942478886`*^9}, {3.822555690140716*^9, 
  3.8225557342941*^9}},ExpressionUUID->"ad43ca6b-3b6a-49c2-a5ef-6e85e4bd3b85"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Incoming velocity", "Subsection",
 CellChangeTimes->{{3.822557003956683*^9, 3.822557010243331*^9}, {
  3.822557261621011*^9, 
  3.822557261858639*^9}},ExpressionUUID->"42363bff-32e8-4dfb-bd41-\
81712e99e00f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["V", 
   RowBox[{"i", " "}]], "=", "3"}], "\[IndentingNewLine]", 
 RowBox[{"y", " ", "=", " ", "0.4"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalDelta]y", "[", "t_", "]"}], "=", " ", 
   RowBox[{
    RowBox[{
     SubscriptBox["V", 
      RowBox[{"i", " "}]], "*", "t"}], "+", 
    FractionBox[
     RowBox[{"9.81", "*", 
      SuperscriptBox["t", "2"]}], "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"v", " ", "[", "t_", "]"}], " ", "=", " ", 
    RowBox[{
     SubscriptBox["V", 
      RowBox[{"i", " "}]], " ", "+", " ", 
     RowBox[{"9.81", "*", "t"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"times", " ", "=", " ", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]y", "[", "t", "]"}], "\[Equal]", "y"}], ",", 
     "t"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Velocities", " ", "=", " ", 
   RowBox[{
    RowBox[{"v", " ", "[", "t", "]"}], "/.", "times"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<The incoming velocity of atoms in the lower chamber is \>\"", " ", ",",
    " ", 
   RowBox[{
   "Velocities", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], " ", 
   ",", "\"\<m/s\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.8225570119278083`*^9, 
  3.822557313654186*^9}},ExpressionUUID->"82c26eb5-9563-4d0f-ada1-\
9e32f6c23b4f"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{
  3.822557033002404*^9, {3.8225571097742453`*^9, 3.8225571983212757`*^9}, {
   3.8225572319763193`*^9, 3.8225572592878*^9}, {3.82255728976171*^9, 
   3.8225573141295567`*^9}, {3.8225580686766233`*^9, 
   3.82255809466749*^9}},ExpressionUUID->"1aacd0d0-ab49-417f-96c8-\
a535babf2ae0"],

Cell[BoxData["0.4`"], "Output",
 CellChangeTimes->{
  3.822557033002404*^9, {3.8225571097742453`*^9, 3.8225571983212757`*^9}, {
   3.8225572319763193`*^9, 3.8225572592878*^9}, {3.82255728976171*^9, 
   3.8225573141295567`*^9}, {3.8225580686766233`*^9, 
   3.8225580946744785`*^9}},ExpressionUUID->"e63812ab-7dca-495f-a650-\
6fb7ebe69023"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The incoming velocity of atoms in the lower chamber is \"\>", 
   "\[InvisibleSpace]", "4.104631530356897`", 
   "\[InvisibleSpace]", "\<\"m/s\"\>"}],
  SequenceForm[
  "The incoming velocity of atoms in the lower chamber is ", 
   4.104631530356897, "m/s"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225572319823647`*^9, 3.8225572592948303`*^9}, {
  3.8225572897717266`*^9, 3.822557314139982*^9}, {3.8225580686846704`*^9, 
  3.822558094679249*^9}},ExpressionUUID->"3d0267d1-f01b-40e3-8ef4-\
bd8087080f98"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Capture Velocity", "Subsection",
 CellChangeTimes->{{3.822556698946568*^9, 
  3.822556702667342*^9}},ExpressionUUID->"1acf4816-5485-4854-84bb-\
1c322e9b184d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Mu]trapping", " ", "=", " ", 
    RowBox[{"382", " ", "*", 
     SuperscriptBox["10", "3"]}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Hz", "/", "Gauss"}], "/", "mf"}], "*)"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Mu]stirring", " ", "=", " ", 
   RowBox[{"85", " ", "*", 
    SuperscriptBox["10", "3"]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Hz", "/", "Gauss"}], "/", "mf"}], "*)"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bmax", " ", "=", " ", "2"}], 
  RowBox[{"(*", "Gaus", "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Delta]1", " ", "=", " ", 
   RowBox[{"3.5", "*", 
    SuperscriptBox["10", "6"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mFTestTab", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"i", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"-", "11"}], "/", "2"}], ",", 
       RowBox[{"11", "/", "2"}], ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Vcapture", "[", 
    RowBox[{"mf_", ",", "\[Mu]_"}], "]"}], " ", ":=", " ", 
   RowBox[{"2", "*", "\[Pi]", "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[Delta]1", "+", 
       RowBox[{"Bmax", "*", "mf", "*", "\[Mu]"}]}], ")"}], "/", "kred"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"vcapStirring", " ", "=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Vcapture", "[", 
      RowBox[{"#", ",", "\[Mu]stirring"}], "]"}], "&"}], ",", 
    RowBox[{"mFTestTab", "[", 
     RowBox[{"[", 
      RowBox[{"2", ";;", "11"}], "]"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vcapTrapping", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Vcapture", "[", 
       RowBox[{"#", ",", "\[Mu]trapping"}], "]"}], "&"}], ",", "mFTestTab"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", " ", "[", 
  RowBox[{
  "\"\<For the states with F= 11/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)= \>\"", 
   ",", 
   RowBox[{"mFTestTab", "\[LeftDoubleBracket]", 
    RowBox[{"2", ";;", "12"}], "\[RightDoubleBracket]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", " ", "[", 
  RowBox[{
  "\"\<The Capture velocities are \>\"", ",", "vcapTrapping", ",", 
   "\"\< m/s\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", " ", "[", 
  RowBox[{
  "\"\<For the states with F= 9/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)= \>\"", 
   ",", 
   RowBox[{"mFTestTab", "\[LeftDoubleBracket]", 
    RowBox[{"2", ";;", "11"}], "\[RightDoubleBracket]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", " ", "[", 
  RowBox[{
  "\"\<The Capture velocities are \>\"", ",", "vcapStirring", ",", 
   "\"\< m/s\>\""}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8225567035195913`*^9, 3.822556710644561*^9}, {
  3.8225567599326725`*^9, 
  3.8225569616061153`*^9}},ExpressionUUID->"fd4ca399-2ed6-4a02-92b2-\
558ac00bb117"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.884415`", ",", "2.0015449999999997`", ",", "2.118675`", ",", "2.235805`",
    ",", "2.352935`", ",", "2.470065`", ",", "2.587195`", ",", "2.704325`", 
   ",", "2.821455`", ",", "2.938585`"}], "}"}]], "Output",
 CellChangeTimes->{{3.822556766893154*^9, 3.822556816386131*^9}, {
  3.8225568617554455`*^9, 3.822556962139538*^9}, {3.8225580687664804`*^9, 
  3.822558094720274*^9}},ExpressionUUID->"363ed689-7c2a-46f2-bd18-\
73c17a8863b6"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"For the states with F= 11/2 \\!\\(\\*SubscriptBox[\\(m\\), \
\\(F\\)]\\)= \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["9", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["7", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["5", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}], ",", 
     FractionBox["1", "2"], ",", 
     FractionBox["3", "2"], ",", 
     FractionBox["5", "2"], ",", 
     FractionBox["7", "2"], ",", 
     FractionBox["9", "2"], ",", 
     FractionBox["11", "2"]}], "}"}]}],
  SequenceForm[
  "For the states with F= 11/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)= ", {
    Rational[-9, 2], 
    Rational[-7, 2], 
    Rational[-5, 2], 
    Rational[-3, 2], 
    Rational[-1, 2], 
    Rational[1, 2], 
    Rational[3, 2], 
    Rational[5, 2], 
    Rational[7, 2], 
    Rational[9, 2], 
    Rational[11, 2]}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225568618055816`*^9, 3.822556962143545*^9}, {
  3.822558068772485*^9, 
  3.822558094724284*^9}},ExpressionUUID->"605adf66-5f16-4f72-bf48-\
0fa128672127"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The Capture velocities are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.48367799999999994`"}], ",", "0.042718`", ",", 
     "0.5691139999999999`", ",", "1.09551`", ",", "1.621906`", ",", 
     "2.1483019999999997`", ",", "2.674698`", ",", "3.2010939999999994`", ",",
      "3.72749`", ",", "4.2538860000000005`", ",", "4.780282`", ",", 
     "5.306678`"}], "}"}], "\[InvisibleSpace]", "\<\" m/s\"\>"}],
  SequenceForm[
  "The Capture velocities are ", {-0.48367799999999994`, 0.042718, 
   0.5691139999999999, 1.09551, 1.621906, 2.1483019999999997`, 2.674698, 
   3.2010939999999994`, 3.72749, 4.2538860000000005`, 4.780282, 5.306678}, 
   " m/s"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225568618055816`*^9, 3.822556962143545*^9}, {
  3.822558068772485*^9, 
  3.822558094730301*^9}},ExpressionUUID->"80990275-ccaf-4084-9d93-\
2c21efb145cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"For the states with F= 9/2 \\!\\(\\*SubscriptBox[\\(m\\), \\(F\
\\)]\\)= \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["9", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["7", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["5", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["3", "2"]}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}], ",", 
     FractionBox["1", "2"], ",", 
     FractionBox["3", "2"], ",", 
     FractionBox["5", "2"], ",", 
     FractionBox["7", "2"], ",", 
     FractionBox["9", "2"]}], "}"}]}],
  SequenceForm[
  "For the states with F= 9/2 \!\(\*SubscriptBox[\(m\), \(F\)]\)= ", {
    Rational[-9, 2], 
    Rational[-7, 2], 
    Rational[-5, 2], 
    Rational[-3, 2], 
    Rational[-1, 2], 
    Rational[1, 2], 
    Rational[3, 2], 
    Rational[5, 2], 
    Rational[7, 2], 
    Rational[9, 2]}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225568618055816`*^9, 3.822556962143545*^9}, {
  3.822558068772485*^9, 
  3.8225580947353463`*^9}},ExpressionUUID->"7494f322-14c5-4338-84db-\
44a2d022b619"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The Capture velocities are \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.884415`", ",", "2.0015449999999997`", ",", "2.118675`", ",", 
     "2.235805`", ",", "2.352935`", ",", "2.470065`", ",", "2.587195`", ",", 
     "2.704325`", ",", "2.821455`", ",", "2.938585`"}], "}"}], 
   "\[InvisibleSpace]", "\<\" m/s\"\>"}],
  SequenceForm[
  "The Capture velocities are ", {1.884415, 2.0015449999999997`, 2.118675, 
   2.235805, 2.352935, 2.470065, 2.587195, 2.704325, 2.821455, 2.938585}, 
   " m/s"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.8225568618055816`*^9, 3.822556962143545*^9}, {
  3.822558068772485*^9, 
  3.8225580947423325`*^9}},ExpressionUUID->"1035591f-8146-4334-9a62-\
aae36ef35e94"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Spin Flips", "Subsection",
 CellChangeTimes->{{3.8225581947396884`*^9, 
  3.8225582068920774`*^9}},ExpressionUUID->"10bb9976-ac82-4f03-97e5-\
cf4cdc5a4992"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Gamma]I", " ", "=", " ", 
    RowBox[{"2", "*", "\[Pi]", "*", "183"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Hz", "/", "gauss"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ygradient", " ", "=", " ", "0.32"}], 
  RowBox[{"(*", 
   RowBox[{"Gauss", "/", "cm"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vfall", " ", "=", " ", "0.5"}], 
  RowBox[{"(*", 
   RowBox[{"Meter", "/", "second"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", "=", " ", 
   RowBox[{"\[Sqrt]", 
    RowBox[{"(", 
     RowBox[{"vfall", "/", 
      RowBox[{"(", 
       RowBox[{"\[Gamma]I", "*", "ygradient"}], ")"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<If atoms fall closer to the quadrupole center than : \>\"", ",", 
   RowBox[{"r", "*", "100"}], ",", "\"\< cm \>\"", ",", 
   "\"\<Then non-adiabatic spin flips are likely\>\""}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.82255820783455*^9, 
  3.822558368331168*^9}},ExpressionUUID->"ea789dda-aeaf-42f0-824e-\
a46b5dd44879"],

Cell[BoxData["0.32`"], "Output",
 CellChangeTimes->{
  3.822558300016868*^9, {3.8225583638149815`*^9, 
   3.8225583693240304`*^9}},ExpressionUUID->"596a5b08-0982-4f17-aa75-\
6a5da8face57"],

Cell[BoxData["0.5`"], "Output",
 CellChangeTimes->{
  3.822558300016868*^9, {3.8225583638149815`*^9, 
   3.822558369330047*^9}},ExpressionUUID->"d2ae6ac7-68ec-447a-896a-\
101431e75474"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"If atoms fall closer to the quadrupole center than : \"\>", 
   "\[InvisibleSpace]", "3.686332744448283`", 
   "\[InvisibleSpace]", "\<\" cm \"\>", 
   "\[InvisibleSpace]", "\<\"Then non-adiabatic spin flips are likely\"\>"}],
  SequenceForm[
  "If atoms fall closer to the quadrupole center than : ", 3.686332744448283, 
   " cm ", "Then non-adiabatic spin flips are likely"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558363825008*^9, 
  3.8225583693330545`*^9}},ExpressionUUID->"4594dd50-6408-41a4-811e-\
b62815499624"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["off resonant optical pumping", "Subsection",
 CellChangeTimes->{{3.8225573922742558`*^9, 
  3.8225574010550694`*^9}},ExpressionUUID->"97489219-505c-440c-aa22-\
aadeaae0b43e"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SetDirectory", "[", 
  "\"\<I:\\\\qgases\\\\groups\\\\strontium\\\\SrCAL\\\\Papers\\\\Fermionic \
MOT\\\\Math\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quiet", "[", 
  RowBox[{"<<", "BaseUsefulConstants`"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quiet", "[", 
  RowBox[{"<<", "BaseStrontium`"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quiet", "[", 
  RowBox[{"<<", "BaseRubidium`"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Quiet", "[", 
  RowBox[{"<<", "BaseFunctions`"}], "]"}]}], "Input",
 CellChangeTimes->{{3.82255743391652*^9, 
  3.822557434133097*^9}},ExpressionUUID->"17fac16d-5e36-4b63-8804-\
a240cb449dd8"],

Cell[BoxData["\<\"I:\\\\qgases\\\\groups\\\\strontium\\\\SrCAL\\\\Papers\\\\\
Fermionic MOT\\\\Math\"\>"], "Output",
 CellChangeTimes->{{3.8225574317292204`*^9, 3.822557434567251*^9}, {
  3.822558068834682*^9, 
  3.8225580947824397`*^9}},ExpressionUUID->"39b77670-3dcd-461d-af15-\
ea1fa617fdb1"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.8225576211254115`*^9},
 NumberMarks->False,ExpressionUUID->"720079c6-e23f-4b4f-a15b-82d508476b1c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FFprime", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"7", "/", "2"}], ",", 
     RowBox[{"9", "/", "2"}], ",", 
     RowBox[{"11", "/", "2"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IIprime", " ", "=", " ", 
   RowBox[{"9", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SSprime", " ", "=", " ", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LLprime", " ", "=", " ", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"JJprime", " ", "=", " ", "1"}], ";"}]}], "Input",ExpressionUUID->\
"5a5512ab-508a-4aa8-9842-8b5de02c2ce0"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{
  3.8225576730053864`*^9},ExpressionUUID->"2986443a-3167-4ccd-8ebb-\
0d8725c15227"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"gradientBRedMOT", " ", "=", " ", 
    RowBox[{"0.32", "*", " ", 
     RowBox[{"(", 
      RowBox[{"100.", "/", " ", "10000"}], ")"}]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"T", "/", "m"}], " ", "*)"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"0.32", " ", 
    RowBox[{"G", "/", "cm"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BfieldFun", "[", "y_", "]"}], ":=", 
   RowBox[{"gradientBRedMOT", "*", "y", "*", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"y", "^", "2"}]}], "/", 
      RowBox[{"0.15", "^", "2"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"BfieldFun", "[", "y", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", "0.4"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.822557674868365*^9, 
  3.8225576953715243`*^9}},ExpressionUUID->"ee138bea-44ba-4e12-8118-\
81c79c54073e"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwV13lYTN8fB/BEotKiokILLdOVJFuWzlsLyjcJpUVIijaEvlS2QklalCgl
+iYhbZOWaaY9KmlfZ9KmvYiSUMTv/v6a5/Wc+5w7z+d8zvucq2R/ep8jPx8f
n84sPr7//8aP5HpU39QjuzMGG+pYebou/NJFGVKKaNM4vPWdVTT5LuOdHiql
hcAg9v4QqySyNSGZcUVqG7ruzSk8ZsUmXcNvHP6VMkPXRNDEMqtKwgxq4D8j
ZQfbxStEN1m2EblObv0pKXe4+Qr0FewfITVzbXNPSvlg7WrLg4Pbp4nUh93W
wcV3IDyAhHZFYZzRjukV6I+CwyZNsZMdkpD3uD1aezoOajnnKl1zZTF95ujf
5NIE7Jhf17rjsQJS1UVlYqqfQ9r/c4Kj6XJYzmncIauZAj+FMdm+dGUEejhd
M0YKpl2ehgTlKqOgbybfyywFVYF/7VeXKEP5DWN929kUbODJKTs0KuOr35UV
MTkpSCkqb7s1qYwQQYpvmV4qrmosz32to4IyId9cRfM02P36whplqyAmYPEi
qfx0OErKqxanqILx+YuFzJt0rDhYfcY7UxXZ+yvuLa1OR0hcZYgmRxV18l7S
Kh3pCB08v+lmhSrmZrVJbZhJR5S295bpHlWc/RAraaXLRFnLq50Di9RgvFlZ
4mE+E1vNSu7We6uh5fFvs7g3TOw/1f6o10cNDgLNdxKqmVhWs8VxzF8NV+r8
xFM6mFg4eFtpOlwNmccHxQpmmGBfVjeuSVKD4t0k0W7dDMzUend78tTw46OW
iHJBBjop0++N2gxU+q53ay7LgOCFbgGmDgOPFm+u8q/NwF75soabhAFDA4Og
4e4MfDvyKX75LgbCoy1E0ma/wrrALokFRxnQMPYW2Wz8Cv8eHG7PDGbAPrFU
xKzpFfaccdxh2sPAhq0VbrM6XkG1xtDZfpCB+Q1VVRn9r2Ce4q/n/omB9Jnm
IOkfr+Bk2yvh9Z2BGfMhkfeymahKcdWCkDqiZi9YcPxIJtoHQ+xitdRRY3dg
waWRTET87P76n6c6pBOcQh98zYSz8p/pJ5fUYTvoLZEznYm6J7duxfmoY+Tk
Y+mvQlnQU8zafCtAHXMvDi1zWpmFc5f+mZCJUgfueWuau9HjavITa7LVkf72
0R6Nz1nwNGTpmnxWxw8RZr3xd/r5Kv4Hj8fVQcxK95/4kwUD0f9ujH5TR1XL
oGW8aDasjcJFvX6pY6hXy05mdTaOihVPmc6joPinxH2Oezbm18lGflekEKY9
GNY+no1LHPEYHVMKWxOOr6+fysYGk4mUejMKQ9ID3DezcqCaOB7puJ8CmepT
SJPIgS4/e+KyFYVPhT0pvmtykNe5rN3dnoLR7s63qmfo8X9j+O3+pfCt4NDJ
JV45wMizpsQLFB5rdYiL++bA3Ms1YMiLwnfJdsupOzm4ePR7pO0VCgltvP53
6TkQyw9wFbxJgc+pedaZsRzsNFwZ7BRJIZln/tTxZw52LJ9qPPSAguU/TUY2
fCyoS6fMM42hkKrZGGogzsJz8flQeEzBdrJu2SItFmoyXn2/kUiBda1qE+c0
C7VLuvcczqTg8O2fjrQLLHx2/Mjjz6YgdvydT8JVFv7U3z0Sn0PhuHFleXAo
C9M7Dh9tYFOQEq+wsEtjYc5IjNX3IgrusaVnBL6wIO0dO2RaRcEep9c/+8GC
YMNKq6JqCvs/yE0Z8eVC34Q5vrKWwgaVsz5BErkYESh4Nl5P4VeyYqjkulyc
7ZU03NhK19O0al/W1lzoMq+peXMpdI5dWGS5PRdzn5ojh0ehaF1tbPSBXCzc
fFlCsZ2Cf97lZCWvXKjsqXJM7qbgeVjdvdQ3Fz+b1iws/kDBma95rWNgLsK3
9M7U9lAwMdTgPI/Jhdn1kqj2PgoLq9reri7IxZS+8BzmEIU5p/yD68tycSPV
piFymMKkmPbec7W5CBmw+ug5QoG7/xY3uzsX20Y2zKY+UYh9v3FQdzYbrx9m
Tez8QiHkcm9SlzAbJClp26wxCj4Koad8pdgwFVXvy6Rtf2xg8rUKGy4SDeuE
v1IwFwjPPa7JxkXr+f0ptLc/0708byMb13b2ju+aoMD4GDHHxIiNqH3Jah7f
KMgFb6sYNWPDLCR7P98kBeHVn26HWrORlPSgx5/257MGko0ubIydXbf6+ncK
3VJfWjzOsXEiQHrsJ+367OjoRZfY6DFdLuf8g0Lm9LiSTTAbSzeqpOv8pJD4
MLb/1z021Hr2KUTRjiTGL2IfsbHYdMmfcdoB3d/c8IyNJ4/kTXdMUfC+Fqf1
IY2NrMw/4vdouyqbfLvGYuOPxhGjTtq2ZT9ylIvZeHa4f1JpmoKp05OLZW/Z
GLLWWWJHG0J74NTARtoAHzuKtlbyNL/QezY2Xh9ufEd7uWli2cteNtLtH7lM
0ZYc2xu4+xMbba7VV5V+0esVPrP7yzc24jaqShvS/r72hUTYDBt5YjYaR2kP
Nps3a8/lwGx0Sbknbe4FvgdNohxcvqA4GEi7UjbZ9vxiDgT55UMiaa92dtS/
ocDBz6dWpx7RjmDJM8LVONBblxwcR3tKkLsgbjUHD9N8RmNpH7YMm0jZyMHd
gwi9T7s0cRePAw6ucPZ5/H9+xvfZhW93chAepvrIi3bI9vyE1j0c1HWoiTrQ
nog4H9hvyYFEx+s3xrSt+la7TxzhYN68k2UU7YK1wxaznDjQXRgmIUh7xfX4
LWLuHIgMxz/vpOsR0HBQaZknBy8ypIOZtEeVpAVX+nAgX32o6CrtfWdqPukE
cLCjeszAmPZScT2WeRQH2zob9Wro9fE9Mh1rH8fBByXpwlu0B1JfXXd/zkFN
6vXwbbTTd6vuCWJxwFvH1Yuj1186tmtddBEHwl9Yisa0vT9FyT2voN9/Nu/g
KN1PhreFB0q5HJw6oPlJjfaLttfv6rs5uNAfZ1hA958odYXZNUQ//4D83UOb
WzF26ddPDp7Gif/nSPfvybktkmtl8+C4tK/Ymu7/BovQqW1KeTgXe+nAO3p/
6Dw16jJVz0NtQIC1Dm1+Q06Sy6Y8+B5fx5wzTuG+b5xevHUeiu6mNRz/TOdL
nbVa+tE8pL1LnZs5SsFOUXJBgXMeBkUzsn7T+5cq9OPyvPJgJL78ts9Hut6/
XU5LROehwvvstn10HqwwUbZQiM/D/Xpzr4uDdL1jOjavSsrDM/mFm+MG6Ppu
NptrzM7DsYux1v/Pk8EL62N92vKQfp9JFOj8EZ/4W/lFLh9iFmIL6+k845zt
r0takY/R3SVHY+i8O/61ssVRIx8cv6N37Foo5I3f63mvm4/u23x33zdScBpb
OV1ul4913mYuETV0/o1aqscl5kNbUnGXZCm9307qrj6Ylo+uTc+Cg4opLBpd
vn4RKx/oVWnko/PZ7dPotqC3+fBznXZry6Mg8/G6lecnen6Rdrl9dN67D6Xd
NNMugOWBCzYWzykscboXLLylAAUs/aqr9HlRNuh9t8ygAOMRVg5PE+j+Gdz+
eKtFAcrr48V74ihU9L/PZngWwMEyOVqJPo8UewUH+AoK8DxW04cTQOdNxxFD
pnEh3mR+UnN1oPPodoarwb5CDNgnmAvR5+XYJoG7zTaFGIn/vOzpEbo/7id9
mHItxNwDl0Krbei8Np28oh9SiKNKXqtH6PO4oiAwt7GhEClzCk6ab6Xnq7VZ
/GtVEfzzax1nxOjzWnXOSkPtIvTdr0yXWkDPfzmFBG8oQuqmv71qQhT+ruQ7
roAi5MsUiujPoSAf8DTTwKwI4blHX27/Sd9Xto3tDTpbhFdaebpBXepoTfcL
WpZTBI1jYR1qL+n7T+d65lJOEUheIfvXM3XYiAw0LyksQufVtyZVCeroPLFD
Qa68CCrb/SOPPVJHn7xgxqLWImgxbPlcw9QxFhTQKvajCHrjXgOd59Uh5Hx7
Of/GYvzRCdvjDHVsVQpjDWQXQxvxkxfLGVA8YXlyK6cYJTLVXRtLGRBIWbY8
vLAYws4hfmMFDNToJN3WrSiGxrprolbZDNiZlR6O4BXjX/9pO76nDNy4OjlH
/3cxfmprHmH5MlDVYb03Vq8E0kYVPlz6fnkoevnI/qoSZN3qiz/9SA2Txc6H
tteWIuwDX6vZMVX883VDS9vga/AdMZqs+6wMzS8vLpn/eoOXw1PBsa4r4B/d
4LDvdxlCh4nw1R9KeGjqu+/bwgocvHsmzc5OEQxmv6/c4rdYczKuXbZ2GfS7
v3QqL6rEgY8Tfjtn5CAr46PXSL3DyPbr104Iy+DEnzf9AquqYL/wpPLIKWmc
Gw0LbTeshrz2dhPJ8oUQeTH7RKRlDR7f6v3gckgccpIrfVosa1Fx5ukljygR
TOi71bZvqENoom/5Tr95iGiMvXqHVYdD1iUX98sK4NKu+B3ZG+vRpSHxZqkM
P0rfOIunFtdj5dp7CwRc/5DtMiK/Tug34DC1y20iY4qonD4zNFHdAA1TBflw
vUmyLZb5Xc+sETyXswfep42TeObrJfx1jRA58lpP1naUHKuMNoiwacLSvBX9
ZQ2DZHlIfsQD2yZ0GssIDhYOkp693f2PDjchRv9whWTKILHnqQS8sG+C33Sr
2N2btIfSqwpc6PFjEbMZurTnllsMezdh/it/ocSkAXJUf+IEiWlCuuedjeUh
/eQI+5+gofdNiC/v1t/p3Uu0Ar1UZDub0P5l3lUh517Cb/OswLi7CY+Tg0va
LHtJwhT/eFJfEx5Q1/Xi1/eSER22xcnRJsyxPWVSNd5DzucwFL7+aYKz1AtB
f7ceEpQpkPFLqRl7N68Rs3X9QNipha2iTs24bHRPbEK2iyhXGm1a79IMxmb7
2wv+dJLQ/vrog27NEDwonqDb00kclvYdeu7ejEoPwwudSZ1ENHBen55XM3Qf
eK5T0u0k9o57xzwCm+F+0yPisWMHEV7aO+99cjPuiulrqZS9J7a35m5+Nt6M
L+5h7sElXKIsLpnwfKIZHSIRi9amcMnH+wqiSZPNaPZ7UTUUySXeCTo9yVPN
KMsW0r9xkkuiCl0CM2a1gLnzuJ63LJc0Tta05Uu0gJtautTGo5Xsso+82LSm
BRbaI7aJ61vIpi2M/FlnW8DRjpU73tdIFtbgtKZHCxJtRG4a1zeSETtLpYPn
W3C9d0ZWt6CRPPT398v0bkFx5TV/86hGwtfQt/vE9RbU3P2+zWB3I6lw+q+z
KqIF+1LGri9iN5AD9+X4onJaUKn4MXrn43riMS5ioDlDv0+z6h++lbUk6cuz
mfV/W/CefXjDFtFa0j2qz9Kd1YqixaIpweM1xGTEc9VugVZckNX748mqISt6
+xa7LWiF3A6VUyd21pCGprxPL5a1IsjCJPSeczVZzXK7r0JaEVP+ua6i4B0Z
uVI1vPRqK/obGF3rXlSQ3IoSNznfVrBu7FhuGl5BAhbmfll8vRXvdiyy975Y
QVQTn04uvNkKoXHbeGHTCmJffWXW/NBWDHwVZIp9Kye8JWtkJx+1oqF+2Cvc
oJxUsO4ZVRe0wl7DuVht7A159vXws8t/WmGd+02i7lIpCTCyO5vIx8WY7SYR
plMpcXp0VLeWn4v9P7XTE8xLCWOXQ6OiIBdX71XllmqUkqT/nP+WinHxsHbP
+q6OEpJq5mEppMRF1EGjqSsGJSQr9ZZgpAEXZkP1n38vKSalLpkn0gO40Od7
sq9xJp/waWzakhnIxbn+dGeqO5+Q0XxRVhAXGbrisx+W5BPW6fKswjtc5L9x
c6m5mU9SPdpm10Zx4Z0zv+akZD6JusIXN/qci0SHDhW/1XnkVLgJl3rLRcLE
04hAbzZJ3l//UvMdF2UX4vmF7dhkWOrAVe1qLm5/1PF8sp1NHCKPqG6u58L6
upzmUgk2sX541sOYx8Xvcy8yqBe5xDAxStxpmIu9E6ezX3awiBy7z+jpfB52
TVrw8ixzyMzlOXL9wjx8zFD+fVA3h3TrKX9UFuXBcc3HtYtW5JDEt8eCExby
oCDQ5PP+czZZy+upf7KEh0hvreHEm9nE5Ge3TfwqHjQH7X6sLMgilzd0uD3e
y6O/m2SKdpFMYjf9W7drPw97JTl35NUyiWHBUjGFAzw0rLp9W0g8kwjtsGU+
suFBTbErkep5Re5bvJ+MPcZD8O9VQrduvqLrxbvy8F8ePNuFnV+2ZJAwnak9
7Rd4ON+89v6Pogzi8VtGaak3Dz2ub8JsXmaQzTesSmOu8CBVf/6xg08GKb/b
Khhzk4crUe3l/iszSJLlD27bLR7sGp7L3VyUQUKWLE6SC+IhRZgRETsrg5g/
OWASfYf+/7sin4twmWTjifPL2sJ5OLPvoJxjKZPIrbz/WfYeD3q7ve0aU5lk
5nNWoXUkD2la/scto5mkO6P5zoMHPCzpVJQZ92OS/wHpZWnk
       "]]},
     Annotation[#, "Charting`Private`Tag$212540#1"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 0.4}, {0., 0.00020586333160857627`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.8225576932381973`*^9, 3.8225576958057337`*^9}, {
  3.8225580692397275`*^9, 
  3.82255809520356*^9}},ExpressionUUID->"6c49260c-6ee6-4e14-8350-\
5cc9295fd17b"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gJ", " ", "=", " ", 
   RowBox[{"1", "+", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"JJprime", 
        RowBox[{"(", 
         RowBox[{"JJprime", "+", "1"}], ")"}]}], " ", "+", " ", 
       RowBox[{"SSprime", 
        RowBox[{"(", 
         RowBox[{"SSprime", "+", "1"}], ")"}]}], "-", 
       RowBox[{"LLprime", 
        RowBox[{"(", 
         RowBox[{"LLprime", "+", "1"}], ")"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"2", " ", "*", "JJprime", 
       RowBox[{"(", 
        RowBox[{"JJprime", "+", "1"}], ")"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gFTab", " ", "=", 
   RowBox[{"gJ", " ", "*", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"FFprime", "*", 
        RowBox[{"(", 
         RowBox[{"FFprime", "+", "1"}], ")"}]}], "+", 
       RowBox[{"JJprime", 
        RowBox[{"(", 
         RowBox[{"JJprime", "+", "1"}], ")"}]}], " ", "-", " ", 
       RowBox[{"IIprime", 
        RowBox[{"(", 
         RowBox[{"IIprime", "+", "1"}], ")"}]}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"2", "*", "FFprime", "*", 
       RowBox[{"(", 
        RowBox[{"FFprime", "+", "1"}], ")"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gF11Half", " ", "=", " ", 
   RowBox[{"gFTab", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gF9Half", " ", "=", " ", 
   RowBox[{"gFTab", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8225576120831113`*^9, 
  3.822557636756095*^9}},ExpressionUUID->"16fa1001-6581-464f-87f2-\
ae8ea6a0cf07"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]\[Omega]1", " ", "=", " ", 
   RowBox[{
    RowBox[{"-", "2"}], "*", "Pi", "*", "0.9", "*", 
    SuperscriptBox["10", "6"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalDelta]\[Omega]2", " ", "=", " ", 
   RowBox[{
    RowBox[{"-", "2"}], "*", "Pi", "*", "3.5", "*", 
    SuperscriptBox["10", "6"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PowerYMOT", " ", "=", 
   RowBox[{"9.2", "*", 
    RowBox[{"10", "^", 
     RowBox[{"(", 
      RowBox[{"-", "3"}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PowerYStirring", " ", "=", 
   RowBox[{"6.6", "*", 
    RowBox[{"10", "^", 
     RowBox[{"(", 
      RowBox[{"-", "3"}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"waistYMOT", " ", "=", " ", 
   RowBox[{
    RowBox[{"68.", "/", "2."}], "*", 
    RowBox[{"10", "^", 
     RowBox[{"(", 
      RowBox[{"-", "3"}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"waistYStirring", " ", "=", " ", "waistYMOT"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"kMom", " ", "=", " ", 
    RowBox[{"2.", "*", 
     RowBox[{"Pi", "/", "\[Lambda]1S0to3P1"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IYMOT", " ", "=", " ", 
   RowBox[{"IFun", "[", 
    RowBox[{"PowerYMOT", ",", "waistYMOT", ",", "waistYMOT"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IYStirring", " ", "=", " ", 
   RowBox[{"IFun", "[", 
    RowBox[{"PowerYStirring", ",", "waistYStirring", ",", "waistYStirring"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Isat", " ", "=", " ", 
   RowBox[{"IsatFun", "[", 
    RowBox[{"\[CapitalGamma]1S0to3P1", ",", "\[Lambda]1S0to3P1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"waistFun", "[", "y_", "]"}], ":=", " ", 
    RowBox[{"waistYMOT", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"y", "/", "0.2"}]}], ")"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"satParYMOT", " ", "=", " ", 
   RowBox[{"IYMOT", "/", "Isat"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"satParYStirring", " ", "=", " ", 
    RowBox[{"IYStirring", "/", "Isat"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.8225574766534095`*^9, 3.8225575411508026`*^9}, {
   3.822557915060624*^9, 3.8225579460995817`*^9}, 
   3.8225580325208635`*^9},ExpressionUUID->"e2647fea-4abe-4d02-a449-\
aec62e55b20c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtom", " ", "=", " ", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dopplerInitShift", " ", "=", "    ", 
   RowBox[{"kMom", " ", "*", " ", "vAtom"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mFTestTab", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"i", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"-", "11"}], "/", "2"}], ",", 
       RowBox[{"11", "/", "2"}], ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mFTestTab", "[", 
   RowBox[{"[", 
    RowBox[{"2", ";;", "11"}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scatRateStirr", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"scatRateFun", "[", 
           RowBox[{"\[CapitalGamma]1S0to3P1", ",", " ", 
            RowBox[{
             RowBox[{"IFun", "[", 
              RowBox[{"PowerYStirring", ",", 
               RowBox[{"waistFun", "[", "y", "]"}], ",", 
               RowBox[{"waistFun", "[", "y", "]"}]}], "]"}], "/", "Isat"}], 
            ",", 
            RowBox[{
            "dopplerInitShift", "+", "\[CapitalDelta]\[Omega]", "-", " ", 
             RowBox[{"(", " ", 
              RowBox[{"gF9Half", "*", " ", "#", "*", "\[Mu]B", "*", 
               RowBox[{
                RowBox[{"BfieldFun", "[", "y", "]"}], "/", "hbarre"}]}], 
              ")"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "\[CapitalDelta]\[Omega]", ",", "\[CapitalDelta]\[Omega]1", ",", 
            "\[CapitalDelta]\[Omega]2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "0.05", ",", "0.15"}], "}"}]}], "]"}], " ", "/", 
        " ", 
        RowBox[{"(", 
         RowBox[{
         "\[CapitalDelta]\[Omega]2", "-", "\[CapitalDelta]\[Omega]1"}], 
         ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"0.15", "-", "0.05"}], ")"}]}], "&"}], ",", 
     RowBox[{"mFTestTab", "[", 
      RowBox[{"[", 
       RowBox[{"2", ";;", "11"}], "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scatRateCool", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"scatRateFun", "[", 
           RowBox[{"\[CapitalGamma]1S0to3P1", ",", " ", 
            RowBox[{
             RowBox[{"IFun", "[", 
              RowBox[{"PowerYMOT", ",", 
               RowBox[{"waistFun", "[", "y", "]"}], ",", 
               RowBox[{"waistFun", "[", "y", "]"}]}], "]"}], "/", "Isat"}], 
            ",", 
            RowBox[{
            "dopplerInitShift", "+", "\[CapitalDelta]\[Omega]", "-", " ", 
             RowBox[{"(", " ", 
              RowBox[{"gF11Half", "*", " ", "#", "*", "\[Mu]B", "*", 
               RowBox[{
                RowBox[{"BfieldFun", "[", "y", "]"}], "/", "hbarre"}]}], 
              ")"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "\[CapitalDelta]\[Omega]", ",", "\[CapitalDelta]\[Omega]1", ",", 
            "\[CapitalDelta]\[Omega]2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "0.05", ",", "0.15"}], "}"}]}], "]"}], " ", "/", 
        " ", 
        RowBox[{"(", 
         RowBox[{
         "\[CapitalDelta]\[Omega]2", "-", "\[CapitalDelta]\[Omega]1"}], 
         ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"0.15", "-", "0.05"}], ")"}]}], "&"}], ",", "mFTestTab"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeScatStirr", " ", "=", " ", 
   RowBox[{"1.", "/", "scatRateStirr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeScatCool", " ", "=", " ", 
   RowBox[{"1.", "/", "scatRateCool"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fallingDist", " ", "=", " ", "0.1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeIllum", " ", "=", " ", 
   RowBox[{"fallingDist", "/", "vAtom"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NscatStirr", " ", "=", " ", 
   RowBox[{"timeIllum", "/", "timeScatStirr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NscatCool", " ", "=", " ", 
   RowBox[{"timeIllum", "/", "timeScatCool"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8225579732848682`*^9, 3.822557983108241*^9}, {
  3.8225580341562424`*^9, 
  3.8225580373096004`*^9}},ExpressionUUID->"8297ed64-5f09-4fbc-9ff7-\
55ae01491edd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{"\"\<For v  =\>\"", " ", ",", "vAtom", ",", "  ", "\"\< m/s\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Typical off-resonant scattering time for stirring beam: \>\"", ",", 
   RowBox[{"timeScatStirr", "*", 
    RowBox[{"10", "^", "3"}]}], ",", "\"\< ms\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Typical off-resonant scattering time for cooling beam: \>\"", ",", 
   RowBox[{"timeScatCool", "*", 
    RowBox[{"10", "^", "3"}]}], ",", "\"\< ms\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Time spent by atoms while illuminated by off resonant ZS beam: \>\"", 
   ",", 
   RowBox[{"timeIllum", "*", 
    RowBox[{"10", "^", "3"}]}], ",", "\"\< ms\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Max number of scattering events for stirring beam: \>\"", ",", 
   "NscatStirr"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Max number of scattering events for cooling beam: \>\"", ",", 
   "NscatCool"}], "]"}]}], "Input",
 CellChangeTimes->{{3.822557993007905*^9, 3.82255802991096*^9}, {
  3.8225580665640025`*^9, 
  3.8225580919051104`*^9}},ExpressionUUID->"572e9778-1c8f-4b1a-951b-\
4f0d60c9fa1b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"For v  =\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\" m/s\"\>"}],
  SequenceForm["For v  =", 4, " m/s"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.82255799358143*^9, 3.8225580179093685`*^9}, {
  3.8225580700177984`*^9, 
  3.8225580959725876`*^9}},ExpressionUUID->"afae0a36-547f-4280-9412-\
81aac65b958a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Typical off-resonant scattering time for stirring beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "80.01633136906617`", ",", "73.56314642013832`", ",", 
     "67.35380698213784`", ",", "61.38828269533479`", ",", 
     "55.666529210577075`", ",", "50.18848233620476`", ",", 
     "44.95404936573514`", ",", "39.96309587905426`", ",", 
     "35.21542520865188`", ",", "30.71074530267661`"}], "}"}], 
   "\[InvisibleSpace]", "\<\" ms\"\>"}],
  SequenceForm[
  "Typical off-resonant scattering time for stirring beam: ", {
   80.01633136906617, 73.56314642013832, 67.35380698213784, 61.38828269533479,
    55.666529210577075`, 50.18848233620476, 44.95404936573514, 
   39.96309587905426, 35.21542520865188, 30.71074530267661}, " ms"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.82255799358143*^9, 3.8225580179093685`*^9}, {
  3.8225580700177984`*^9, 
  3.822558095981779*^9}},ExpressionUUID->"ef04c9f0-b917-408b-9884-\
bab7f0178f67"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Typical off-resonant scattering time for cooling beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "188.8109759286027`", ",", "153.4137624380909`", ",", 
     "121.55905297172225`", ",", "93.24717541816499`", ",", 
     "68.47844852898216`", ",", "47.25295451194632`", ",", 
     "29.56958226912272`", ",", "15.421079213492481`", ",", 
     "4.748522049646409`", ",", "0.42822984485969695`", ",", 
     "0.35187220656901647`", ",", "0.3531879914753804`"}], "}"}], 
   "\[InvisibleSpace]", "\<\" ms\"\>"}],
  SequenceForm[
  "Typical off-resonant scattering time for cooling beam: ", {
   188.8109759286027, 153.4137624380909, 121.55905297172225`, 
   93.24717541816499, 68.47844852898216, 47.25295451194632, 29.56958226912272,
    15.421079213492481`, 4.748522049646409, 0.42822984485969695`, 
   0.35187220656901647`, 0.3531879914753804}, " ms"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.82255799358143*^9, 3.8225580179093685`*^9}, {
  3.8225580700177984`*^9, 
  3.822558095988798*^9}},ExpressionUUID->"8be589da-f81c-4db3-bc0f-\
107df467ecd4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Time spent by atoms while illuminated by off resonant ZS beam: \
\"\>", "\[InvisibleSpace]", "25.`", "\[InvisibleSpace]", "\<\" ms\"\>"}],
  SequenceForm[
  "Time spent by atoms while illuminated by off resonant ZS beam: ", 25., 
   " ms"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.82255799358143*^9, 3.8225580179093685`*^9}, {
  3.8225580700177984`*^9, 
  3.822558095992841*^9}},ExpressionUUID->"8e5ec033-3806-462f-b03d-\
f1c4821ff1eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Max number of scattering events for stirring beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.31243621861005305`", ",", "0.33984408248688114`", ",", 
     "0.3711742679464276`", ",", "0.4072438403933375`", ",", 
     "0.44910290536399755`", ",", "0.4981222550729653`", ",", 
     "0.5561234272046578`", ",", "0.6255771593787652`", ",", 
     "0.7099161759903411`", ",", "0.8140473229681311`"}], "}"}]}],
  SequenceForm[
  "Max number of scattering events for stirring beam: ", {
   0.31243621861005305`, 0.33984408248688114`, 0.3711742679464276, 
   0.4072438403933375, 0.44910290536399755`, 0.4981222550729653, 
   0.5561234272046578, 0.6255771593787652, 0.7099161759903411, 
   0.8140473229681311}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.82255799358143*^9, 3.8225580179093685`*^9}, {
  3.8225580700177984`*^9, 
  3.822558095997836*^9}},ExpressionUUID->"6983d223-dc46-457b-8906-\
19d53e0e19e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Max number of scattering events for cooling beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.13240755669550452`", ",", "0.16295800065583155`", ",", 
     "0.20566135872920663`", ",", "0.26810463574781784`", ",", 
     "0.3650783646101334`", ",", "0.5290674468551928`", ",", 
     "0.8454634148181935`", ",", "1.6211576150991147`", ",", 
     "5.264796022556447`", ",", "58.379863757956606`", ",", 
     "71.04852140430842`", ",", "70.78383354871981`"}], "}"}]}],
  SequenceForm[
  "Max number of scattering events for cooling beam: ", {0.13240755669550452`,
    0.16295800065583155`, 0.20566135872920663`, 0.26810463574781784`, 
   0.3650783646101334, 0.5290674468551928, 0.8454634148181935, 
   1.6211576150991147`, 5.264796022556447, 58.379863757956606`, 
   71.04852140430842, 70.78383354871981}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.82255799358143*^9, 3.8225580179093685`*^9}, {
  3.8225580700177984`*^9, 
  3.8225580960018597`*^9}},ExpressionUUID->"43116167-40bf-4141-8414-\
75efa7060924"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vAtom", " ", "=", " ", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dopplerInitShift", " ", "=", "    ", 
   RowBox[{"kMom", " ", "*", " ", "vAtom"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mFTestTab", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"i", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"-", "11"}], "/", "2"}], ",", 
       RowBox[{"11", "/", "2"}], ",", "1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mFTestTab", "[", 
   RowBox[{"[", 
    RowBox[{"2", ";;", "11"}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scatRateStirr", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"scatRateFun", "[", 
           RowBox[{"\[CapitalGamma]1S0to3P1", ",", " ", 
            RowBox[{
             RowBox[{"IFun", "[", 
              RowBox[{"PowerYStirring", ",", 
               RowBox[{"waistFun", "[", "y", "]"}], ",", 
               RowBox[{"waistFun", "[", "y", "]"}]}], "]"}], "/", "Isat"}], 
            ",", 
            RowBox[{
            "dopplerInitShift", "+", "\[CapitalDelta]\[Omega]", "-", " ", 
             RowBox[{"(", " ", 
              RowBox[{"gF9Half", "*", " ", "#", "*", "\[Mu]B", "*", 
               RowBox[{
                RowBox[{"BfieldFun", "[", "y", "]"}], "/", "hbarre"}]}], 
              ")"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "\[CapitalDelta]\[Omega]", ",", "\[CapitalDelta]\[Omega]1", ",", 
            "\[CapitalDelta]\[Omega]2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "0.05", ",", "0.15"}], "}"}]}], "]"}], " ", "/", 
        " ", 
        RowBox[{"(", 
         RowBox[{
         "\[CapitalDelta]\[Omega]2", "-", "\[CapitalDelta]\[Omega]1"}], 
         ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"0.15", "-", "0.05"}], ")"}]}], "&"}], ",", 
     RowBox[{"mFTestTab", "[", 
      RowBox[{"[", 
       RowBox[{"2", ";;", "11"}], "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scatRateCool", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"scatRateFun", "[", 
           RowBox[{"\[CapitalGamma]1S0to3P1", ",", " ", 
            RowBox[{
             RowBox[{"IFun", "[", 
              RowBox[{"PowerYMOT", ",", 
               RowBox[{"waistFun", "[", "y", "]"}], ",", 
               RowBox[{"waistFun", "[", "y", "]"}]}], "]"}], "/", "Isat"}], 
            ",", 
            RowBox[{
            "dopplerInitShift", "+", "\[CapitalDelta]\[Omega]", "-", " ", 
             RowBox[{"(", " ", 
              RowBox[{"gF11Half", "*", " ", "#", "*", "\[Mu]B", "*", 
               RowBox[{
                RowBox[{"BfieldFun", "[", "y", "]"}], "/", "hbarre"}]}], 
              ")"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "\[CapitalDelta]\[Omega]", ",", "\[CapitalDelta]\[Omega]1", ",", 
            "\[CapitalDelta]\[Omega]2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "0.05", ",", "0.15"}], "}"}]}], "]"}], " ", "/", 
        " ", 
        RowBox[{"(", 
         RowBox[{
         "\[CapitalDelta]\[Omega]2", "-", "\[CapitalDelta]\[Omega]1"}], 
         ")"}]}], "/", 
       RowBox[{"(", 
        RowBox[{"0.15", "-", "0.05"}], ")"}]}], "&"}], ",", "mFTestTab"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeScatStirr", " ", "=", " ", 
   RowBox[{"1.", "/", "scatRateStirr"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeScatCool", " ", "=", " ", 
   RowBox[{"1.", "/", "scatRateCool"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fallingDist", " ", "=", " ", "0.1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeIllum", " ", "=", " ", 
   RowBox[{"fallingDist", "/", "vAtom"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NscatStirr", " ", "=", " ", 
   RowBox[{"timeIllum", "/", "timeScatStirr"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NscatCool", " ", "=", " ", 
   RowBox[{"timeIllum", "/", "timeScatCool"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<For v  =\>\"", " ", ",", "vAtom", ",", "  ", "\"\< m/s\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Typical off-resonant scattering time for stirring beam: \>\"", ",", 
   RowBox[{"timeScatStirr", "*", 
    RowBox[{"10", "^", "3"}]}], ",", "\"\< ms\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Typical off-resonant scattering time for cooling beam: \>\"", ",", 
   RowBox[{"timeScatCool", "*", 
    RowBox[{"10", "^", "3"}]}], ",", "\"\< ms\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Time spent by atoms while illuminated by off resonant ZS beam: \>\"", 
   ",", 
   RowBox[{"timeIllum", "*", 
    RowBox[{"10", "^", "3"}]}], ",", "\"\< ms\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Max number of scattering events for stirring beam: \>\"", ",", 
   "NscatStirr"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Max number of scattering events for cooling beam: \>\"", ",", 
   "NscatCool"}], "]"}]}], "Input",
 CellChangeTimes->{{3.8225580418687267`*^9, 
  3.8225580871827183`*^9}},ExpressionUUID->"010e3341-fe0f-40b6-8825-\
5878aea8b18a"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"For v  =\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\" m/s\"\>"}],
  SequenceForm["For v  =", 2, " m/s"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558070939389*^9, 
  3.822558096884179*^9}},ExpressionUUID->"642bee52-f63c-4605-b4b4-\
de763df34258"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Typical off-resonant scattering time for stirring beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.792439857112705`", ",", "0.6778247416914553`", ",", 
     "0.4656849366760602`", ",", "0.4324543289182748`", ",", 
     "0.42059770356474013`", ",", "0.4148070543419636`", ",", 
     "0.4116009116104664`", ",", "0.40979004457995055`", ",", 
     "0.4088862675308756`", ",", "0.40869001903966773`"}], "}"}], 
   "\[InvisibleSpace]", "\<\" ms\"\>"}],
  SequenceForm[
  "Typical off-resonant scattering time for stirring beam: ", {
   1.792439857112705, 0.6778247416914553, 0.4656849366760602, 
   0.4324543289182748, 0.42059770356474013`, 0.4148070543419636, 
   0.4116009116104664, 0.40979004457995055`, 0.4088862675308756, 
   0.40869001903966773`}, " ms"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558070939389*^9, 
  3.8225580968872137`*^9}},ExpressionUUID->"7a218fc8-d2d0-49bc-b2cd-\
812635cdd77e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Typical off-resonant scattering time for cooling beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "68.45037976829435`", ",", "47.30765943193584`", ",", 
     "29.70900914657536`", ",", "15.658797822051929`", ",", 
     "5.180520847800039`", ",", "0.3936565569912269`", ",", 
     "0.3507672374206578`", ",", "0.3515144486435648`", ",", 
     "0.4396045977004161`", ",", "4.312730789575694`", ",", 
     "16.051228279968846`", ",", "30.402822615923228`"}], "}"}], 
   "\[InvisibleSpace]", "\<\" ms\"\>"}],
  SequenceForm[
  "Typical off-resonant scattering time for cooling beam: ", {
   68.45037976829435, 47.30765943193584, 29.70900914657536, 
   15.658797822051929`, 5.180520847800039, 0.3936565569912269, 
   0.3507672374206578, 0.3515144486435648, 0.4396045977004161, 
   4.312730789575694, 16.051228279968846`, 30.402822615923228`}, " ms"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558070939389*^9, 
  3.822558096890237*^9}},ExpressionUUID->"fbbe0c63-240c-44ee-8d70-\
dd2b381c4820"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Time spent by atoms while illuminated by off resonant ZS beam: \
\"\>", "\[InvisibleSpace]", "50.`", "\[InvisibleSpace]", "\<\" ms\"\>"}],
  SequenceForm[
  "Time spent by atoms while illuminated by off resonant ZS beam: ", 50., 
   " ms"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558070939389*^9, 
  3.8225580968962116`*^9}},ExpressionUUID->"bef5a775-0bdc-4d69-af7b-\
5cc4b406136a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Max number of scattering events for stirring beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "27.894938734815305`", ",", "73.76538052480815`", ",", 
     "107.36872950387271`", ",", "115.6191455524752`", ",", 
     "118.87844269293258`", ",", "120.53796934412885`", ",", 
     "121.47689324682383`", ",", "122.01370106795002`", ",", 
     "122.28339264591328`", ",", "122.3421117978097`"}], "}"}]}],
  SequenceForm[
  "Max number of scattering events for stirring beam: ", {27.894938734815305`,
    73.76538052480815, 107.36872950387271`, 115.6191455524752, 
   118.87844269293258`, 120.53796934412885`, 121.47689324682383`, 
   122.01370106795002`, 122.28339264591328`, 122.3421117978097}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558070939389*^9, 
  3.8225580969002223`*^9}},ExpressionUUID->"66bea4ec-2a33-4acc-ae1f-\
7843efc77bf8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Max number of scattering events for cooling beam: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "0.7304561372668905`", ",", "1.05691130359002`", ",", 
     "1.6829911678748681`", ",", "3.1930931459876275`", ",", 
     "9.651539192479655`", ",", "127.01426944887471`", ",", 
     "142.5446697008292`", ",", "142.24166372944725`", ",", 
     "113.73857384920767`", ",", "11.593582451484117`", ",", 
     "3.1150264096858913`", ",", "1.6445841437700233`"}], "}"}]}],
  SequenceForm[
  "Max number of scattering events for cooling beam: ", {0.7304561372668905, 
   1.05691130359002, 1.6829911678748681`, 3.1930931459876275`, 
   9.651539192479655, 127.01426944887471`, 142.5446697008292, 
   142.24166372944725`, 113.73857384920767`, 11.593582451484117`, 
   3.1150264096858913`, 1.6445841437700233`}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.822558070939389*^9, 
  3.8225580969042683`*^9}},ExpressionUUID->"fcbf5ac8-db91-407e-8cfc-\
b33f092d8ec6"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8225580253849063`*^9, 
  3.822558047534798*^9}},ExpressionUUID->"a3f636bf-9321-42c2-94a0-\
7fcc34e5644d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["11", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["9", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["7", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["5", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["3", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], ",", 
   FractionBox["1", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["5", "2"], ",", 
   FractionBox["7", "2"], ",", 
   FractionBox["9", "2"], ",", 
   FractionBox["11", "2"]}], "}"}]], "Input",
 NumberMarks->False,ExpressionUUID->"306bfe9c-5714-4d60-a53b-96a0a0120eb3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["11", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["9", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["7", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["5", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["3", "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], ",", 
   FractionBox["1", "2"], ",", 
   FractionBox["3", "2"], ",", 
   FractionBox["5", "2"], ",", 
   FractionBox["7", "2"], ",", 
   FractionBox["9", "2"], ",", 
   FractionBox["11", "2"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.822557499099742*^9, {3.8225580711409073`*^9, 
   3.822558097080513*^9}},ExpressionUUID->"206c4499-d2a2-47a0-a52f-\
234cd43e174f"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.822557438776791*^9, 
  3.822557442052484*^9}},ExpressionUUID->"812682ae-2184-4d30-9053-\
5020b3e8dafb"]
}, Open  ]]
},
WindowSize->{1280, 941},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
PrintingPageRange->{Automatic, Automatic},
Magnification:>1.1 Inherited,
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 145, 3, 59, "Subsection",ExpressionUUID->"8824b213-be2e-488f-a91f-dc027cfcfcc4"],
Cell[728, 27, 2154, 60, 314, "Input",ExpressionUUID->"ad43ca6b-3b6a-49c2-a5ef-6e85e4bd3b85"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2919, 92, 214, 4, 59, "Subsection",ExpressionUUID->"42363bff-32e8-4dfb-bd41-81712e99e00f"],
Cell[CellGroupData[{
Cell[3158, 100, 1497, 45, 219, "Input",ExpressionUUID->"82c26eb5-9563-4d0f-ada1-9e32f6c23b4f"],
Cell[4658, 147, 332, 6, 36, "Output",ExpressionUUID->"1aacd0d0-ab49-417f-96c8-a535babf2ae0"],
Cell[4993, 155, 338, 6, 36, "Output",ExpressionUUID->"e63812ab-7dca-495f-a650-6fb7ebe69023"],
Cell[5334, 163, 566, 12, 23, "Print",ExpressionUUID->"3d0267d1-f01b-40e3-8ef4-bd8087080f98"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5949, 181, 164, 3, 59, "Subsection",ExpressionUUID->"1acf4816-5485-4854-84bb-1c322e9b184d"],
Cell[CellGroupData[{
Cell[6138, 188, 3013, 88, 301, "Input",ExpressionUUID->"fd4ca399-2ed6-4a02-92b2-558ac00bb117"],
Cell[9154, 278, 479, 9, 35, "Output",ExpressionUUID->"363ed689-7c2a-46f2-bd18-73c17a8863b6"],
Cell[CellGroupData[{
Cell[9658, 291, 1204, 39, 51, "Print",ExpressionUUID->"605adf66-5f16-4f72-bf48-0fa128672127"],
Cell[10865, 332, 939, 19, 24, "Print",ExpressionUUID->"80990275-ccaf-4084-9d93-2c21efb145cc"],
Cell[11807, 353, 1147, 37, 51, "Print",ExpressionUUID->"7494f322-14c5-4338-84db-44a2d022b619"],
Cell[12957, 392, 775, 17, 24, "Print",ExpressionUUID->"1035591f-8146-4334-9a62-aae36ef35e94"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13793, 416, 162, 3, 58, "Subsection",ExpressionUUID->"10bb9976-ac82-4f03-97e5-cf4cdc5a4992"],
Cell[CellGroupData[{
Cell[13980, 423, 1117, 31, 138, "Input",ExpressionUUID->"ea789dda-aeaf-42f0-824e-a46b5dd44879"],
Cell[15100, 456, 188, 4, 35, "Output",ExpressionUUID->"596a5b08-0982-4f17-aa75-6a5da8face57"],
Cell[15291, 462, 185, 4, 35, "Output",ExpressionUUID->"d2ae6ac7-68ec-447a-896a-101431e75474"],
Cell[15479, 468, 584, 12, 24, "Print",ExpressionUUID->"4594dd50-6408-41a4-811e-b62815499624"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16112, 486, 180, 3, 58, "Subsection",ExpressionUUID->"97489219-505c-440c-aa22-aadeaae0b43e"],
Cell[CellGroupData[{
Cell[16317, 493, 652, 14, 115, "Input",ExpressionUUID->"17fac16d-5e36-4b63-8804-a240cb449dd8"],
Cell[16972, 509, 295, 5, 35, "Output",ExpressionUUID->"39b77670-3dcd-461d-af15-ea1fa617fdb1"]
}, Open  ]],
Cell[17282, 517, 146, 2, 30, "Input",ExpressionUUID->"720079c6-e23f-4b4f-a15b-82d508476b1c"],
Cell[17431, 521, 635, 17, 115, "Input",ExpressionUUID->"5a5512ab-508a-4aa8-9842-8b5de02c2ce0"],
Cell[18069, 540, 130, 3, 30, "Input",ExpressionUUID->"2986443a-3167-4ccd-8ebb-0d8725c15227"],
Cell[CellGroupData[{
Cell[18224, 547, 977, 28, 73, "Input",ExpressionUUID->"ee138bea-44ba-4e12-8118-81c79c54073e"],
Cell[19204, 577, 8031, 150, 246, "Output",ExpressionUUID->"6c49260c-6ee6-4e14-8350-5cc9295fd17b"]
}, Open  ]],
Cell[27250, 730, 1669, 51, 94, "Input",ExpressionUUID->"16fa1001-6581-464f-87f2-ae8ea6a0cf07"],
Cell[28922, 783, 2598, 74, 366, "Input",ExpressionUUID->"e2647fea-4abe-4d02-a449-aec62e55b20c"],
Cell[31523, 859, 4518, 120, 282, "Input",ExpressionUUID->"8297ed64-5f09-4fbc-9ff7-55ae01491edd"],
Cell[CellGroupData[{
Cell[36066, 983, 1329, 34, 136, "Input",ExpressionUUID->"572e9778-1c8f-4b1a-951b-4f0d60c9fa1b"],
Cell[CellGroupData[{
Cell[37420, 1021, 381, 9, 24, "Print",ExpressionUUID->"afae0a36-547f-4280-9412-81aac65b958a"],
Cell[37804, 1032, 1012, 21, 24, "Print",ExpressionUUID->"ef04c9f0-b917-408b-9884-bab7f0178f67"],
Cell[38819, 1055, 1127, 23, 24, "Print",ExpressionUUID->"8be589da-f81c-4db3-bc0f-107df467ecd4"],
Cell[39949, 1080, 497, 11, 24, "Print",ExpressionUUID->"8e5ec033-3806-462f-b03d-f1c4821ff1eb"],
Cell[40449, 1093, 985, 21, 24, "Print",ExpressionUUID->"6983d223-dc46-457b-8906-19d53e0e19e1"],
Cell[41437, 1116, 1086, 22, 24, "Print",ExpressionUUID->"43116167-40bf-4141-8414-75efa7060924"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42572, 1144, 5617, 149, 408, "Input",ExpressionUUID->"010e3341-fe0f-40b6-8825-5878aea8b18a"],
Cell[CellGroupData[{
Cell[48214, 1297, 327, 8, 24, "Print",ExpressionUUID->"642bee52-f63c-4605-b4b4-de763df34258"],
Cell[48544, 1307, 990, 21, 24, "Print",ExpressionUUID->"7a218fc8-d2d0-49bc-b2cd-812635cdd77e"],
Cell[49537, 1330, 1074, 22, 24, "Print",ExpressionUUID->"fbbe0c63-240c-44ee-8d70-dd2b381c4820"],
Cell[50614, 1354, 447, 10, 24, "Print",ExpressionUUID->"bef5a775-0bdc-4d69-af7b-5cc4b406136a"],
Cell[51064, 1366, 923, 19, 24, "Print",ExpressionUUID->"66bea4ec-2a33-4acc-ae1f-7843efc77bf8"],
Cell[51990, 1387, 1026, 21, 24, "Print",ExpressionUUID->"fcbf5ac8-db91-407e-8cfc-b33f092d8ec6"]
}, Open  ]]
}, Open  ]],
Cell[53043, 1412, 154, 3, 30, "Input",ExpressionUUID->"a3f636bf-9321-42c2-94a0-7fcc34e5644d"],
Cell[CellGroupData[{
Cell[53222, 1419, 634, 21, 56, "Input",ExpressionUUID->"306bfe9c-5714-4d60-a53b-96a0a0120eb3"],
Cell[53859, 1442, 713, 24, 60, "Output",ExpressionUUID->"206c4499-d2a2-47a0-a52f-234cd43e174f"]
}, Open  ]],
Cell[54587, 1469, 152, 3, 30, "Input",ExpressionUUID->"812682ae-2184-4d30-9053-5020b3e8dafb"]
}, Open  ]]
}
]
*)

